"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ANIMATION_DURATION = 300;

var CollapseTransition = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CollapseTransition, _Component);

  var _super = _createSuper(CollapseTransition);

  function CollapseTransition() {
    var _this;

    (0, _classCallCheck2.default)(this, CollapseTransition);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.cssWrapper = void 0;
    _this.leaveTimer = void 0;
    _this.enterTimer = void 0;
    _this.oldOverflow = void 0;
    return _this;
  }

  (0, _createClass2.default)(CollapseTransition, [{
    key: "componentDidMount",
    value:
    /** */
    function componentDidMount() {
      this.beforeEnter();

      if (this.props.isShow) {
        this.enter();
      }
    }
    /** */

  }, {
    key: "componentWillUnMount",
    value: function componentWillUnMount() {
      this.beforeLeave();
      this.leave();
    }
    /** */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.isShow !== prevProps.isShow) {
        this.triggerChange(this.props.isShow);
      }
    }
    /** */

  }, {
    key: "triggerChange",
    value: function triggerChange(isShow) {
      clearTimeout(this.enterTimer);
      clearTimeout(this.leaveTimer);

      if (isShow) {
        this.beforeEnter();
        this.enter();
      } else {
        this.beforeLeave();
        this.leave();
      }
    }
    /** */

  }, {
    key: "beforeEnter",
    value: function beforeEnter() {
      var el = this.cssWrapper;
      this.oldOverflow = el.style.overflow;
      el.style.height = '0';
    }
    /** */

  }, {
    key: "enter",
    value: function enter() {
      var _this2 = this;

      var el = this.cssWrapper;
      el.style.display = 'block';

      if (el.scrollHeight !== 0) {
        el.style.height = el.scrollHeight + 'px';
      } else {
        el.style.height = '';
      }

      el.style.overflow = 'hidden';
      this.enterTimer = setTimeout(function () {
        return _this2.afterEnter();
      }, ANIMATION_DURATION);
    }
    /** */

  }, {
    key: "afterEnter",
    value: function afterEnter() {
      var el = this.cssWrapper;

      if (el) {
        el.style.display = 'block';
        el.style.height = ''; // el.style.overflow = this.oldOverflow;

        el.style.overflow = 'visible';
      }
    }
    /** */

  }, {
    key: "beforeLeave",
    value: function beforeLeave() {
      var el = this.cssWrapper;
      this.oldOverflow = el.style.overflow;
      el.style.display = 'block';

      if (el.scrollHeight !== 0) {
        el.style.height = el.scrollHeight + 'px';
      }

      el.style.overflow = 'hidden';
    }
    /** */

  }, {
    key: "leave",
    value: function leave() {
      var _this3 = this;

      var el = this.cssWrapper;

      if (el.scrollHeight !== 0) {
        el.style.height = '0';
      }

      this.leaveTimer = setTimeout(function () {
        return _this3.afterLeave();
      }, ANIMATION_DURATION);
    }
    /** */

  }, {
    key: "afterLeave",
    value: function afterLeave() {
      var el = this.cssWrapper;

      if (!el) {
        return;
      }

      el.style.display = 'none';
      el.style.height = '';
      el.style.overflow = this.oldOverflow;
    }
    /** */

  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "collapse-transition",
        style: {
          overflow: 'hidden'
        },
        ref: function ref(e) {
          return _this4.cssWrapper = e;
        }
      }, this.props.children);
    }
  }]);
  return CollapseTransition;
}(_react.Component);

exports.default = CollapseTransition;