"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = debounce;

/**函数防抖*/
function debounce(delay) {
  return function (target, methodName, desc) {
    var func = desc.value;

    desc.value = function () {
      var _this = this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      this.__timer = this.__timer || new Map(); // 返回一个函数，这个函数会在一个时间区间结束后的 delay 毫秒时执行 fn 函数
      // 每次这个返回的函数被调用，就清除定时器，以保证不执行 fn

      clearTimeout(this.__timer.get(func)); // 当返回的函数被最后一次调用后（也就是用户停止了某个连续的操作），
      // 再过 delay 毫秒就执行 fn

      var timer = setTimeout(function () {
        func.apply(_this, args);
      }, delay);

      this.__timer.set(func, timer);
    };
  };
}