/**
 * 定时器任务暂停
 */
export declare function pause(componentName: string, funName: string): void;
/**
 * 定时器任务恢复
 */
export declare function resume(componentName: string, funName: string): void;
/**
 * 定时器任务清除
 */
export declare function clear(componentName: string, funName: string): void;
/**
 * 对class组件内的方法这么装饰 @loop()
 * @param startFunName 装载启动定时器的方法名称
 * @param timeout 定时器时间
 */
export declare function loop<T>(startFunName: string, timeout: number): (target: T, key: PropertyKey, desc: PropertyDescriptor) => void;
/**
 *对class组件内的方法这么装饰 @loop
 * 默认时间为3000
 * 默认装载启动定时器的方法为componentDidMount
 * @param target
 * @param key
 * @param desc
 */
export declare function loop<T>(target: T, key: PropertyKey, desc: PropertyDescriptor): void;
/***
 * 消息轮询
 * 可以对组件内的方法
 * 默认轮询时间为3000ms
 * 默认在componentDidMount中立即执行一次等到返回结果后然后在轮询时间后再次执行
 * ps 不可用于有2个同名的class
 * @param params
 */
declare function loop<T>(...params: any[]): any;
declare namespace loop {
    var clear: typeof import("./loop").clear;
    var resume: typeof import("./loop").resume;
    var pause: typeof import("./loop").pause;
}
export default loop;
