"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clear = clear;
exports.default = loop;
exports.pause = pause;
exports.resume = resume;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var React = _interopRequireWildcard(require("react"));

var _warning = _interopRequireDefault(require("./warning"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable @typescript-eslint/ban-types */
var Interval = /*#__PURE__*/function () {
  function Interval() {
    (0, _classCallCheck2.default)(this, Interval);
  }

  (0, _createClass2.default)(Interval, null, [{
    key: "setInterval",
    value:
    /**
     *模仿window的定时器 只不过是必须返回结果才会开始定时器
     * @param fn
     * @param time
     * @returns {*}
     */
    function setInterval(fn, time) {
      var symbol = Symbol(new Date().getTime());
      Interval.task[symbol] = symbol;
      /**
       *内部的定时器
       * @param callback
       * @param t
       * @returns {*}
       */

      var innerInterval = /*#__PURE__*/function () {
        var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(callback, t) {
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!Interval.task[symbol]) {
                    _context.next = 12;
                    break;
                  }

                  _context.prev = 1;
                  _context.next = 4;
                  return callback();

                case 4:
                  _context.next = 9;
                  break;

                case 6:
                  _context.prev = 6;
                  _context.t0 = _context["catch"](1);
                  console.error(_context.t0);

                case 9:
                  _context.prev = 9;
                  setTimeout(function () {
                    innerInterval(callback, t);
                  }, time);
                  return _context.finish(9);

                case 12:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[1, 6, 9, 12]]);
        }));

        return function innerInterval(_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }();

      innerInterval(fn, time);
      return symbol;
    }
    /**
     * 清除定时器
     * @param symbol
     */

  }, {
    key: "clearInterval",
    value: function clearInterval(symbol) {
      Interval.task[symbol] = undefined;
      return undefined;
    }
  }]);
  return Interval;
}();

Interval.task = {};
var timerArray = {};
/**
 *
 */

function dealLoop() {
  var funName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'componentDidMount';
  var fn = arguments.length > 1 ? arguments[1] : undefined;
  var key = arguments.length > 2 ? arguments[2] : undefined;
  var timeout = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 3000;
  var instance = arguments.length > 4 ? arguments[4] : undefined;
  var timer;
  var componentName = instance.constructor.name || instance.constructor.displayName;
  var originFn = instance[funName];

  if (!timerArray[componentName]) {
    timerArray[componentName] = {};
  }

  instance[funName] = function () {
    for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
      params[_key] = arguments[_key];
    }

    originFn && originFn.apply(this, params); //fn.apply(this);

    timer = Interval.setInterval(fn.bind(this), timeout);
    timerArray[componentName][key] = {
      timer: timer,
      fn: fn,
      timeout: timeout,
      _this: this
    };
  };

  var componentWillUnmount = instance.componentWillUnmount;

  instance['componentWillUnmount'] = function () {
    for (var _len2 = arguments.length, params = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      params[_key2] = arguments[_key2];
    }

    componentWillUnmount && componentWillUnmount.apply(this, params);
    Interval.clearInterval(timer);
    timerArray[componentName][key] = undefined;
    delete timerArray[componentName][key];
  };
}
/**
 *
 * @param componentName
 * @param funName
 */


function warnAssert(componentName, funName) {
  if (!timerArray[componentName]) {
    (0, _warning.default)(false, 'loop', "\u8BE5".concat(componentName, "\u7EC4\u4EF6\u8FD8\u672A\u5B9E\u4F8B\u5316\u6216\u8005\u4E0D\u5B58\u5728"));
    return false;
  } else if (!timerArray[componentName][funName]) {
    (0, _warning.default)(false, 'loop', "\u8BE5".concat(componentName, "\u7EC4\u4EF6\u4E0D\u5B58\u5728").concat(funName, "\u65B9\u6CD5\u6216\u8005\u8BE5\u65B9\u6CD5\u5DF2\u88AB\u6E05\u9664"));
    return false;
  }

  return true;
}
/**
 * 定时器任务暂停
 */


function pause(componentName, funName) {
  var res = warnAssert(componentName, funName);

  if (!res) {
    return;
  }

  Interval.clearInterval(timerArray[componentName][funName].timer);
}
/**
 * 定时器任务恢复
 */


function resume(componentName, funName) {
  var res = warnAssert(componentName, funName);

  if (!res) {
    return;
  }

  var _ = timerArray[componentName][funName];
  timerArray[componentName][funName].timer = Interval.setInterval(_.fn.bind(_._this), _.timeout);
}
/**
 * 定时器任务清除
 */


function clear(componentName, funName) {
  var res = warnAssert(componentName, funName);

  if (!res) {
    return;
  }

  Interval.clearInterval(timerArray[componentName][funName].timer);
  timerArray[componentName][funName] = undefined;
  delete timerArray[componentName][funName];
}
/**
 * 对class组件内的方法这么装饰 @loop()
 * @param startFunName 装载启动定时器的方法名称
 * @param timeout 定时器时间
 */


/***
 * 消息轮询
 * 可以对组件内的方法
 * 默认轮询时间为3000ms
 * 默认在componentDidMount中立即执行一次等到返回结果后然后在轮询时间后再次执行
 * ps 不可用于有2个同名的class
 * @param params
 */
function loop() {
  for (var _len3 = arguments.length, params = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    params[_key3] = arguments[_key3];
  }

  var target = params[0];

  if (target && target instanceof React.Component) {
    var fn = params[2].value;

    if (typeof fn !== 'function') {
      throw new SyntaxError("@loop can only be used on functions, not: ".concat(fn));
    }

    dealLoop('componentDidMount', fn, params[1], 3000, params[0]);
  } else {
    return function (target, key, desc) {
      var fn = desc.value;

      if (typeof fn !== 'function') {
        throw new SyntaxError("@loop can only be used on functions, not: ".concat(fn));
      }

      dealLoop(params[0], fn, key, params[1], target);
    };
  }
}

loop.clear = clear;
loop.resume = resume;
loop.pause = pause;