"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = throttle;

/**函数防抖*/
function throttle(delay) {
  return function (target, methodName, desc) {
    var func = desc.value;

    desc.value = function () {
      var _this = this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      this.__flags = this.__flags || new Map();

      var val = this.__flags.get(func);

      var flag = val === undefined ? true : val;

      if (!flag) {
        return;
      }

      this.__flags.set(func, false);

      setTimeout(function () {
        func.apply(_this, args);

        _this.__flags.set(func, true);
      }, delay);
    };
  };
}