/// <reference types="react" />
export declare type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>;
export declare const tuple: <T extends string[] | number[]>(...args: T) => T;
declare const SizeTuple: ["large", "medium", "small"];
declare const TypeTuple: ["success", "info", "warning", "error"];
/**
 * 限制为对象类型
 */
export interface ObjectType {
    [key: string]: any;
}
/**
 * 尺寸类型限制
 */
export declare type Size = typeof SizeTuple[number];
/**
 * 提示框类型限制
 */
export declare type InfoType = typeof TypeTuple[number];
export interface Base {
    style?: React.CSSProperties;
    className?: string;
}
export interface ForwardRef {
    forwardRef?: React.RefObject<any>;
}
export interface RefObject<T> {
    current: T | null;
}
export {};
