"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JSXToText = JSXToText;
exports.default = renderToString;
exports.toComponentString = toComponentString;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _omit = _interopRequireDefault(require("../omit"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
var REACT_ELEMENT_TYPE = 0xeac7;
var REACT_PORTAL_TYPE = 0xeaca;
var REACT_FRAGMENT_TYPE = 0xeacb;
var REACT_STRICT_MODE_TYPE = 0xeacc;
var REACT_PROFILER_TYPE = 0xead2;
var REACT_PROVIDER_TYPE = 0xeacd;
var REACT_CONTEXT_TYPE = 0xeace;
var REACT_FORWARD_REF_TYPE = 0xead0;
var REACT_SUSPENSE_TYPE = 0xead1;
var REACT_MEMO_TYPE = 0xead3;
var REACT_LAZY_TYPE = 0xead4;

if (typeof Symbol === 'function' && Symbol.for) {
  var symbolFor = Symbol.for;
  REACT_ELEMENT_TYPE = symbolFor('react.element');
  REACT_PORTAL_TYPE = symbolFor('react.portal');
  REACT_FRAGMENT_TYPE = symbolFor('react.fragment');
  REACT_STRICT_MODE_TYPE = symbolFor('react.strict_mode');
  REACT_PROFILER_TYPE = symbolFor('react.profiler');
  REACT_PROVIDER_TYPE = symbolFor('react.provider');
  REACT_CONTEXT_TYPE = symbolFor('react.context');
  REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
  REACT_SUSPENSE_TYPE = symbolFor('react.suspense');
  REACT_MEMO_TYPE = symbolFor('react.memo');
  REACT_LAZY_TYPE = symbolFor('react.lazy');
}

var uppercasePattern = /([A-Z])/g;
var msPattern = /^ms-/;
/**
 * Hyphenates a camelcased CSS property name, for example:
 *
 *   > hyphenateStyleName('backgroundColor')
 *   < "background-color"
 *   > hyphenateStyleName('MozTransition')
 *   < "-moz-transition"
 *   > hyphenateStyleName('msTransition')
 *   < "-ms-transition"
 */

function hyphenateStyleName(name) {
  return name.replace(uppercasePattern, '-$1').toLowerCase().replace(msPattern, '-ms-');
}
/**
 * 将对象转成dom属性的字符串
 * @param obj
 * @param split
 */


function getAttr(obj) {
  var split = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '=';
  var attr = '';

  for (var key in obj) {
    if (key === 'style') {
      attr += key + split + getAttr(obj[key], ':');
    } else {
      if (obj[key] !== undefined) {
        attr += "".concat(key).concat(split, "\"").concat(obj[key], "\" ");
      } else {
        attr += key;
      }
    }
  }

  return attr !== '' ? ' ' + attr : attr;
}
/**
 * 处理原始类型
 * @param element
 * @param options
 * @constructor
 */


function handlerNativeElement(element, options) {
  var widthTag = options.widthTag,
      endFirstNativeTag = options.endFirstNativeTag;
  var str = endFirstNativeTag ? '' : _renderToString(element.props.children, options);

  if (widthTag) {
    var otherProps = (0, _omit.default)(element.props, ['children', 'className', 'style']);
    var _style = element.props.style;
    var attributes = {};

    if (element.props.className !== undefined) {
      attributes.class = element.props.className;
    }

    if (_style !== undefined) {
      var style = {};

      for (var key in _style) {
        var value = _style[key];
        style[hyphenateStyleName(key)] = typeof value === 'number' ? "".concat(value, "px") : value;
      }

      attributes.style = style;
    }

    attributes = _objectSpread(_objectSpread({}, attributes), otherProps);

    if (endFirstNativeTag) {
      options.firstTag = {
        tag: element.type,
        props: _objectSpread({
          style: {}
        }, element.props)
      };
    }

    return "<".concat(element.type).concat(getAttr(attributes), ">").concat(str, "</").concat(element.type, ">");
  } else {
    return str;
  }
}
/***
 * 处理Portal类型
 * @param element
 * @param options
 */


function handlerPortal(element, options) {
  options.portal.push(_renderToString(element.children, options));
  return '';
}
/***
 * 处理provide类型
 * @param element
 * @param options
 */


function handlerProvider(element, options) {
  var context = element.type._context;
  context._currentValue = _objectSpread({}, element.props.value);
  context._currentValue2 = _objectSpread({}, element.props.value);
  return _renderToString(element.props.children, options);
}
/***
 * 处理Consumer类型
 * @param element
 * @param options
 */


function handlerConsumer(element, options) {
  var renderFn = element.props.children;
  var context = element.type._context;
  var ast = renderFn.call(this, context._currentValue);
  return _renderToString(ast, options);
}
/**
 * 处理转发类型
 * @param element
 * @param options
 */


function handlerForwardRef(element, options) {
  return _renderToString(element.type.render(element.props, element.ref), options);
}
/**
 * 处理memo类型
 * @param element
 * @param options
 */


function handlerMemo(element, options) {
  return _renderToString(element.type.type(element.props), options);
}
/**
 * 处理函数类型
 * @param element
 * @param options
 */


function handlerFunction(element, options) {
  var render = element.type.call(this, element.props);
  return _renderToString(render, options);
}
/**
 * 处理类类型
 * @param element
 * @param options
 */


function handlerClass(element, options) {
  var Ins = element.type;

  var renderProps = _objectSpread(_objectSpread({}, Ins.defaultProps), element.props);

  var instance = new Ins(renderProps);

  if (Ins.getDerivedStateFromProps) {
    var initState = instance.state;

    if (initState) {
      instance.state = _objectSpread(_objectSpread({}, initState), Ins.getDerivedStateFromProps(renderProps, undefined));
    }
  }

  var render = instance.render();
  return _renderToString(render, options);
}
/***
 * 处理函数或者类类型
 * @param element
 * @param options
 */


function handlerFunctionOrClass(element, options) {
  if (Object.getPrototypeOf(element.type.prototype).render instanceof Function) {
    return handlerClass(element, options);
  } else {
    return handlerFunction(element, options);
  }
}

/**
 * @param element
 * @param options
 */
function _renderToString() {
  var element = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var options = arguments.length > 1 ? arguments[1] : undefined;
  element = element === null ? '' : element;
  element = element === false ? '' : element;

  if ((0, _typeof2.default)(element) !== 'object') {
    return element;
  } else if (Array.isArray(element)) {
    return element.reduce(function (al, item) {
      return al + _renderToString(item, options);
    }, '');
  } else if (element.$$typeof === REACT_ELEMENT_TYPE) {
    if (typeof element.type === 'string') {
      return handlerNativeElement(element, options);
    } else if (element.type instanceof Function) {
      return handlerFunctionOrClass(element, options);
    } else if ((0, _typeof2.default)(element.type) === 'symbol') {
      if (element.type === REACT_FRAGMENT_TYPE) {
        return element.props.children.reduce(function (al, item) {
          return al + _renderToString(item, options);
        }, '');
      } else if (element.type === REACT_SUSPENSE_TYPE) {
        var fallback = element.props.fallback;
        return _renderToString(fallback, options);
      } else if (element.type === REACT_STRICT_MODE_TYPE) {
        return _renderToString(element.props.children, options);
      } else if (element.type === REACT_PROFILER_TYPE) {
        return _renderToString(element.props.children, options);
      } else {
        console.error("not-support-symbol-type:".concat(element.type));
      }
    } else if (element.type.$$typeof === REACT_PROVIDER_TYPE) {
      return handlerProvider(element, options);
    } else if (element.type.$$typeof === REACT_CONTEXT_TYPE) {
      return handlerConsumer(element, options);
    } else if (element.type.$$typeof === REACT_FORWARD_REF_TYPE) {
      return handlerForwardRef(element, options);
    } else if (element.type.$$typeof === REACT_MEMO_TYPE) {
      return handlerMemo(element, options);
    } else if (element.type.$$typeof === REACT_LAZY_TYPE) {
      console.error("not-support-type:".concat(element.$$typeof));
    } else {
      console.error("not-support-type:".concat(element.type.$$typeof));
    }
  } else {
    if (element.$$typeof === REACT_PORTAL_TYPE) {
      return handlerPortal(element, options);
    } else {
      console.error("not-support-type:".concat(element.$$typeof));
    }
  }
}
/**
 * 将抽象语法树转成text
 * @param element
 * @constructor
 */


function JSXToText(element) {
  return renderToString(element, {
    widthTag: false
  });
}
/**
 * 在react hook中保证代码不会出错
 * @param params
 */


function noop() {
  return undefined;
}

var Dispatcher = {
  readContext: noop,
  useContext: function useContext(context) {
    return context._currentValue;
  },
  useMemo: noop,
  useReducer: noop,
  useRef: function useRef() {
    return /*#__PURE__*/React.createRef();
  },
  useState: function useState(initState) {
    return [initState, function (state) {
      initState = state;
    }];
  },
  useLayoutEffect: noop,
  useCallback: noop,
  // useImperativeHandle is not run in the server environment
  useImperativeHandle: noop,
  // Effects are not run in the server environment.
  useEffect: noop,
  // Debugging effect
  useDebugValue: noop,
  useDeferredValue: noop,
  useTransition: noop,
  useOpaqueIdentifier: noop,
  // Subscriptions are not setup in a server environment.
  useMutableSource: noop
};
/**
 *将ReactElement 转成string
 * @param element
 * @param options
 */

function renderToString() {
  var element = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    widthTag: true
  };

  if (options.widthTag === undefined) {
    options.widthTag = true;
  }

  options.portal = [];
  /**以前的react运行环境**/

  var prevDispatcher = ReactCurrentDispatcher.current;
  /**为hook准备环境**/

  ReactCurrentDispatcher.current = Dispatcher;
  var result;

  try {
    result = _renderToString(element, options);
  } catch (e) {
    result = '';
  } finally {
    /**还原以前的react运行环境**/
    ReactCurrentDispatcher.current = prevDispatcher;
  }

  if (options.portal.length !== 0) {
    var portal = options.portal.map(function (item) {
      return "[".concat(item, "]");
    });
    return "[".concat(result).concat(portal, "]");
  }

  return result;
}
/**
 *组件层面的转成字符串
 */


function toComponentString(ast) {
  var resStr = '';

  if ((0, _typeof2.default)(ast) !== 'object' || ast === null) {
    resStr += ast || '';
  } else if ( /*#__PURE__*/React.isValidElement(ast)) {
    var propsStr = '';
    var props = (0, _omit.default)(ast.props, ['children']);

    for (var prop in props) {
      var value = props[prop];
      propsStr += "".concat(prop, "={").concat(toComponentString(value), "} ");
    }

    resStr += "<".concat(ast.type, " ").concat(propsStr, " >").concat(toComponentString(ast.props.children), "</").concat(ast.type, "> ");
  } else {
    var _propsStr = '{';

    for (var _prop in ast) {
      var _value = ast[_prop];
      _propsStr += "".concat(_prop, ":").concat((0, _typeof2.default)(_value) === 'object' && _value !== null ? "{".concat(toComponentString(_value), "}") : _value, ", ");
    }

    resStr += _propsStr + '}';
  }

  return resStr;
}