import { ObjectType, RefObject } from "../types";
/**
 *
 * @param el
 * @param event
 * @param handler
 * @param useCapture
 */
export declare function addEvent(el: any, event: string, handler: (e: any) => void, useCapture?: boolean): void;
/**
 *
 * @param el
 * @param event
 * @param handler
 * @param useCapture
 */
export declare function removeEvent(el: any, event: string, handler: (e: any) => void, useCapture?: boolean): void;
/**
 * 根据浏览器自动给str设置前缀
 * @param str
 */
export declare function setPrefix(str?: string): string;
/**
 * 节流
 * @param fn
 * @param delay
 */
export declare function throttle(fn: (...params: any) => void, delay?: number): (...args: any) => void;
/**
 * 防抖函数
 * @param fn
 * @param delay
 */
export declare function debounce(fn: (...params: any) => void, delay: number): (...args: any) => void;
/**
 *
 * @param suffixCls
 * @param customPrefixCls
 */
export declare function getPrefixCls(suffixCls: string, customPrefixCls?: string): string;
/**
 * 类似于dom的classList
 *
 */
export declare function classList(dom: HTMLElement): Pick<DOMTokenList, 'add' | 'remove' | 'toggle' | 'contains'>;
/**
 * 克隆
 * @returns {Array}
 * @param origin
 * @param target
 */
export declare function deepClone(obj: any): any;
/**
 * 判断是否是ie9环境
 */
export declare function isIE9(): boolean;
/**
 * 取出arg类型的类型 比如 1 会得到'number' '1'会得到String
 * @param arg
 */
export declare function classType(arg: any): string;
/**
 * 判断元素是否display:none
 * @param node
 */
export declare function isDisplayNone(node: HTMLElement): boolean;
/**
 * 只执行一次fn
 * @param fn
 * @param context
 */
export declare function once(fn: (...params: any) => void, context?: any): (...params: any[]) => any;
/**
 * 随机生成UUID
 */
export declare function UUID(): any;
/**
 * 合并函数形式的ref和对象形式的ref
 * @param props
 * @param forceDom 是否将结果统一转成原始Dom
 */
export declare function combineRef<T>(props: any, forceDom?: boolean): RefObject<T>;
/**
 * 判断是否存在
 * @param value
 */
export declare function isExist(value: null | undefined | boolean | number | string | ObjectType): boolean;
/**判断是否是ie环境**/
export declare const isIE: boolean;
