"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = watch;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * 监听props属性变化 该装饰用于方法上比如
 * @watch('value')
 * watchValue(): void {} 这个的意思是value变化后就会执行watchValue方法
 * @param args
 */
function watch() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return function (target, methodName, desc) {
    var getDerivedStateFromProps = target.constructor.getDerivedStateFromProps;

    target.constructor.getDerivedStateFromProps = function (nextProps, prevState) {
      var res = getDerivedStateFromProps && getDerivedStateFromProps(nextProps, prevState);
      var _res = {};
      args.forEach(function (arg) {
        if (nextProps[arg] !== undefined && nextProps[arg] !== prevState[arg]) {
          /**判断nextProps与之前存的props的值是否有改变**/
          if (prevState._prevProps !== nextProps) {
            _res[arg] = nextProps[arg];
            /**将本次nextProps的值存在state中去**/

            _res._prevProps = nextProps;
          }
        }
      });

      if (!res && Object.keys(_res).length === 0) {
        return {
          _prevProps: nextProps
        };
      } else {
        return _objectSpread(_objectSpread({}, res), _res);
      }
    };

    var componentDidUpdate = target.componentDidUpdate;

    target.componentDidUpdate = function (prevProps, prevState, snapshot) {
      var _this = this;

      componentDidUpdate && componentDidUpdate.apply(this, [prevProps, prevState, snapshot]);
      args.forEach(function (arg) {
        if (prevProps[arg] !== _this.props[arg]) {
          desc.value.apply(_this, [prevProps[arg], _this.props[arg]]);
        }
      });
    };
  };
}