import React from 'react';
import { InfoType } from '../../libs/types';
interface AlertState {
    visible: boolean;
}
interface AlertProps {
    onClose?: () => void;
    onDetails?: (e: React.MouseEvent) => void;
    style?: React.CSSProperties;
    className?: string;
    type?: InfoType;
    showIcon?: boolean;
    icon?: React.ReactNode;
    description?: React.ReactNode;
    title?: React.ReactNode;
    closable?: boolean;
    detailsText?: React.ReactNode;
    detailsPosition?: 'inner' | 'right';
    detailsClassName?: string;
    /**过度动画名称**/
    transitionName?: string;
}
export default class Alert extends React.Component<AlertProps, AlertState> {
    static defaultProps: {
        type: string;
        showIcon: boolean;
        closable: boolean;
        detailsPosition: string;
        transitionName: string;
    };
    /**
     *
     * @param props
     */
    constructor(props: AlertProps);
    /**
   *关闭回调
   * @param props
   */
    handleClose(): void;
    /**
     * 点击详情
     */
    handleDetails(e: React.MouseEvent<HTMLSpanElement>): void;
    /**
     * 关闭或查看详情
     */
    closeDetailRender(): React.ReactNode;
    /**
*
* @param props
*/
    render(): React.ReactNode;
}
export {};
