"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Close = _interopRequireDefault(require("net-design-icons/lib/icons/Close"));

var _RadioSelect = _interopRequireDefault(require("net-design-icons/lib/icons/RadioSelect"));

var _RemindLine = _interopRequireDefault(require("net-design-icons/lib/icons/RemindLine"));

var _ReminderPlane = _interopRequireDefault(require("net-design-icons/lib/icons/ReminderPlane"));

var _ClosePlane = _interopRequireDefault(require("net-design-icons/lib/icons/ClosePlane"));

var _CompleteCircle = _interopRequireDefault(require("net-design-icons/lib/icons/CompleteCircle"));

var _CloseLine = _interopRequireDefault(require("net-design-icons/lib/icons/CloseLine"));

var _HelpPlane = _interopRequireDefault(require("net-design-icons/lib/icons/HelpPlane"));

var _transition = _interopRequireDefault(require("../transition"));

var _class, _class2;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 不同类型默认显示图标
 */
var TYPE_CLASSES_MAP = {
  'success': /*#__PURE__*/_react.default.createElement(_RadioSelect.default, null),
  'info': /*#__PURE__*/_react.default.createElement(_HelpPlane.default, null),
  'warning': /*#__PURE__*/_react.default.createElement(_ReminderPlane.default, null),
  'error': /*#__PURE__*/_react.default.createElement(_ClosePlane.default, null)
};
var TYPE_CLASSES_MAP_TITLE = {
  'success': /*#__PURE__*/_react.default.createElement(_CompleteCircle.default, null),
  'info': /*#__PURE__*/_react.default.createElement(_RemindLine.default, null),
  'warning': /*#__PURE__*/_react.default.createElement(_RemindLine.default, null),
  'error': /*#__PURE__*/_react.default.createElement(_CloseLine.default, null)
};

var Alert = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Alert, _React$Component);

  var _super = _createSuper(Alert);

  // 默认props值

  /**
   *
   * @param props
   */
  function Alert(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Alert);
    _this = _super.call(this, props);
    _this.state = {
      visible: true
    };
    return _this;
  }
  /**
  *关闭回调
  * @param props
  */


  (0, _createClass2.default)(Alert, [{
    key: "handleClose",
    value: function handleClose() {
      this.setState({
        visible: false
      });
      var onClose = this.props.onClose;
      onClose && onClose();
    }
    /**
     * 点击详情
     */

  }, {
    key: "handleDetails",
    value: function handleDetails(e) {
      var onDetails = this.props.onDetails;
      onDetails && onDetails(e);
    }
    /**
     * 关闭或查看详情
     */

  }, {
    key: "closeDetailRender",
    value: function closeDetailRender() {
      var _this$props = this.props,
          closable = _this$props.closable,
          detailsPosition = _this$props.detailsPosition;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, closable && detailsPosition !== 'right' && /*#__PURE__*/_react.default.createElement("i", {
        className: (0, _classnames.default)('rd-alert__closebtn'),
        onClick: this.handleClose
      }, /*#__PURE__*/_react.default.createElement(_Close.default, {
        style: {
          verticalAlign: 'middle'
        }
      })));
    }
    /**
    *
    * @param props
    */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          style = _this$props2.style,
          type = _this$props2.type,
          showIcon = _this$props2.showIcon,
          icon = _this$props2.icon,
          description = _this$props2.description,
          title = _this$props2.title,
          closable = _this$props2.closable,
          detailsText = _this$props2.detailsText,
          detailsPosition = _this$props2.detailsPosition,
          className = _this$props2.className,
          detailsClassName = _this$props2.detailsClassName,
          transitionName = _this$props2.transitionName;
      var visible = this.state.visible;
      var ICON_MAP = title ? TYPE_CLASSES_MAP_TITLE : TYPE_CLASSES_MAP;
      return /*#__PURE__*/_react.default.createElement(_transition.default, {
        name: transitionName
      }, visible && /*#__PURE__*/_react.default.createElement("div", {
        style: style,
        className: (0, _classnames.default)(className, 'rd-alert', "rd-alert--".concat(type))
      }, showIcon && /*#__PURE__*/_react.default.createElement("i", {
        className: (0, _classnames.default)('rd-alert__icon', {
          "is-title": title
        })
      }, icon || ICON_MAP[type]), /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)('rd-alert__content', {
          'is-icon': showIcon,
          'is-closable': closable,
          "is-title": title
        })
      }, title && /*#__PURE__*/_react.default.createElement("span", {
        className: (0, _classnames.default)('rd-alert__title', {
          'is-bold': description
        })
      }, title), description && /*#__PURE__*/_react.default.createElement("p", {
        className: "rd-alert__description"
      }, /*#__PURE__*/_react.default.createElement("span", null, description), detailsText && /*#__PURE__*/_react.default.createElement("span", {
        className: (0, _classnames.default)(detailsClassName, 'rd-alert__detailsbtn', detailsPosition === 'right' && 'rd-alert__closebtn'),
        onClick: this.handleDetails
      }, detailsText))), this.closeDetailRender()));
    }
  }]);
  return Alert;
}(_react.default.Component), _class2.defaultProps = {
  type: 'success',
  showIcon: true,
  closable: true,
  detailsPosition: 'inner',
  transitionName: 'fade-in-linear'
}, _class2)) || _class;

exports.default = Alert;