"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _types = require("../../libs/types");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var StatusType = (0, _types.tuple)('success', 'warning', 'error', 'default');

var Badge = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Badge, _React$PureComponent);

  var _super = _createSuper(Badge);

  function Badge() {
    var _this;

    (0, _classCallCheck2.default)(this, Badge);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      count: 0
    };
    return _this;
  }

  (0, _createClass2.default)(Badge, [{
    key: "isDot",
    value:
    /**判断是否为小圆点样式 */
    function isDot(status, dot) {
      return !!status || dot;
    }
    /**获取实际显示的count值 */

  }, {
    key: "getCount",
    value: function getCount(isDot, count) {
      if (!isDot) {
        if (typeof count === 'number') {
          var _this$props = this.props,
              showZero = _this$props.showZero,
              maxCount = _this$props.maxCount;

          if (count === 0 && !showZero) {
            return '';
          }

          if (count > maxCount) {
            return "".concat(maxCount, "+");
          }
        } else {
          //没有count属性，也没有dot属性
          return '';
        }
      }

      return count;
    }
    /**生成徽标内容 */

  }, {
    key: "generateBadge",
    value: function generateBadge(isDot, isBadgeWrapper, badgeContentStyle, count, badgeClassName) {
      var badgeNode = null;
      var badgeText = '';

      if (!isDot) {
        if (count === '') {
          return null;
        }

        badgeText = count;
      }

      if (isBadgeWrapper) {
        badgeNode = /*#__PURE__*/React.createElement("sup", {
          className: badgeClassName,
          style: badgeContentStyle
        }, badgeText);
      } else {
        badgeNode = /*#__PURE__*/React.createElement("span", {
          className: badgeClassName,
          style: badgeContentStyle
        }, badgeText);
      }

      return badgeNode;
    }
    /**是否显示dot的text信息 */

  }, {
    key: "showText",
    value: function showText(isDot, text, isBadgeWrapper) {
      return isDot && !!text && !isBadgeWrapper;
    }
    /**生成JSX */

  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          count = _this$state.count,
          status = _this$state.status;
      var _this$props2 = this.props,
          dot = _this$props2.dot,
          offset = _this$props2.offset,
          text = _this$props2.text,
          style = _this$props2.style,
          badgeStyle = _this$props2.badgeStyle,
          className = _this$props2.className,
          children = _this$props2.children,
          customPrefixCls = _this$props2.prefixCls;
      var isDot = this.isDot(status, dot); //是否在右上角

      var isBadgeWrapper = children ? true : false;
      var prefixCls = (0, _util.getPrefixCls)('badge', customPrefixCls); //若realCount为''则不显示徽标

      var realCount = this.getCount(isDot, count); //如果count为element，则badge-content的样式需要改变

      var classNameString = (0, _classnames.default)(className, isDot && status && "is-".concat(status), {
        'is-badge-dot': isDot,
        'is-badge-wrapper': isBadgeWrapper,
        'is-badge-icon': !isDot && (0, _typeof2.default)(realCount) === 'object'
      }, prefixCls);

      var badgeContentStyle = _objectSpread({}, badgeStyle);

      if (isBadgeWrapper && offset) {
        badgeContentStyle.right = -offset[0];
        badgeContentStyle.top = offset[1];
      }

      return /*#__PURE__*/React.createElement("span", {
        className: classNameString,
        style: style
      }, isBadgeWrapper && children, this.generateBadge(isDot, isBadgeWrapper, badgeContentStyle, realCount, "".concat(prefixCls, "-content")), this.showText(isDot, text, isBadgeWrapper) && /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-dot-text")
      }, text));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**监听属性是否有改变 */
    function getDerivedStateFromProps(nextProps, prevState) {
      var count = nextProps.count,
          status = nextProps.status;
      var stateCount = prevState.count,
          stateStatus = prevState.status;

      if (count !== stateCount || status !== stateStatus) {
        return {
          count: count,
          status: status
        };
      }

      return null;
    }
  }]);
  return Badge;
}(React.PureComponent), _class2.defaultProps = {
  showZero: false,
  maxCount: 99
}, _class2)) || _class;

exports.default = Badge;