import * as React from 'react';
import { Size } from '../../libs/types';
import ButtonGroup from './ButtonGroup';
declare const ButtonTypes: ["default", "primary", "success", "warning", "danger", "info"];
export declare type ButtonType = typeof ButtonTypes[number];
declare const ButtonHTMLTypes: ["submit", "button", "reset"];
declare type ButtonHTMLType = typeof ButtonHTMLTypes[number];
export interface ButtonProps {
    text?: boolean;
    type?: ButtonType;
    size?: Size;
    suffixIcon?: React.ReactNode;
    prefixIcon?: React.ReactNode;
    nativeType?: ButtonHTMLType;
    loading?: boolean | React.ReactNode;
    disabled?: boolean;
    plain?: boolean;
    style?: React.CSSProperties;
    round?: boolean;
    circle?: boolean;
    block?: boolean;
    className?: string;
    borderDotted?: boolean;
    customColor?: boolean;
    onClick?: (e: React.MouseEvent<HTMLElement>) => void;
}
export default class Button extends React.Component<ButtonProps> {
    static defaultProps: {
        type: string;
        nativeType: "button" | "reset" | "submit";
    };
    static Group: typeof ButtonGroup;
    /**
     * 点击
     * @param e
     */
    handleClick(e: React.MouseEvent<HTMLButtonElement> | React.MouseEvent<HTMLDivElement>): void;
    /**
     * 图标渲染
     */
    iconRender(flag: string): React.ReactNode;
    /**loading渲染 */
    loadingRender(): React.ReactNode;
    /**
     * 渲染
     */
    render(): React.ReactNode;
}
export {};
