"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _types = require("../../libs/types");

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _LoaderLine = _interopRequireDefault(require("net-design-icons/lib/icons/LoaderLine"));

var _RotateIcon = _interopRequireDefault(require("../spin/RotateIcon"));

var _FormContext = require("../form/FormContext");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ButtonTypes = (0, _types.tuple)('default', 'primary', 'success', 'warning', 'danger', 'info');
var ButtonHTMLTypes = (0, _types.tuple)('submit', 'button', 'reset');

var Button = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Button, _React$Component);

  var _super = _createSuper(Button);

  function Button() {
    (0, _classCallCheck2.default)(this, Button);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(Button, [{
    key: "handleClick",
    value: //定义props默认值
    // group类型沿用ButtonGroup

    /**
     * 点击
     * @param e
     */
    function handleClick(e) {
      var _this$props = this.props,
          loading = _this$props.loading,
          onClick = _this$props.onClick;

      if (!loading) {
        onClick && onClick(e);
      }
    }
    /**
     * 图标渲染
     */

  }, {
    key: "iconRender",
    value: function iconRender(flag) {
      var loading = this.props.loading;
      var loadComp = null;

      if (typeof loading === 'boolean') {
        loadComp = /*#__PURE__*/React.createElement(_LoaderLine.default, {
          className: 'rd-button__loading'
        });
      } else {
        {
          /* 如果自定义图标，居中需要添加 className={'rd-button__loading'} */
        }
        loadComp = loading;
      }

      var prefixSuffixStr = "".concat(flag, "Icon");
      return /*#__PURE__*/React.createElement("span", {
        className: (0, _classnames.default)('rd-button__icon', "rd-button__icon-".concat(flag), 'rd-button__flex')
      }, flag === 'loading' ? /*#__PURE__*/React.createElement(_RotateIcon.default, {
        loading: !!loading
      }, loadComp) : this.props[prefixSuffixStr]);
    }
    /**loading渲染 */

  }, {
    key: "loadingRender",
    value: function loadingRender() {
      var _this$props2 = this.props,
          loading = _this$props2.loading,
          prefixIcon = _this$props2.prefixIcon,
          suffixIcon = _this$props2.suffixIcon,
          children = _this$props2.children;
      return /*#__PURE__*/React.createElement(React.Fragment, null, loading && this.iconRender('loading'), prefixIcon && this.iconRender('prefix'), children && /*#__PURE__*/React.createElement("span", {
        className: (0, _classnames.default)('rd-button__children')
      }, children), suffixIcon && this.iconRender('suffix'));
    }
    /**
     * 渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props3 = this.props,
          type = _this$props3.type,
          style = _this$props3.style,
          disabled = _this$props3.disabled,
          loading = _this$props3.loading,
          plain = _this$props3.plain,
          nativeType = _this$props3.nativeType,
          round = _this$props3.round,
          circle = _this$props3.circle,
          block = _this$props3.block,
          className = _this$props3.className,
          borderDotted = _this$props3.borderDotted,
          text = _this$props3.text,
          customColor = _this$props3.customColor;
      return /*#__PURE__*/React.createElement(_FormContext.SizeContext.Consumer, null, function () {
        var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            contextSize = _ref.size;

        var size = _this.props.size || contextSize || 'medium';
        var clsName = (0, _classnames.default)(className, 'rd-button', 'rd-button__flex', 'rd-button__content', customColor && "rd-button__custom", !customColor && type && "rd-button--".concat(type), size && "rd-button--".concat(size), {
          'is-text': text,
          'is-disabled': disabled,
          'is-loading': loading,
          'is-plain': plain,
          'is-round': round,
          'is-circle': circle,
          'is-block': block,
          'is-dotted': borderDotted
        });
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("button", {
          style: _objectSpread({}, style),
          className: "".concat(clsName, " rd-button__inner"),
          disabled: disabled,
          type: nativeType,
          onClick: _this.handleClick
        }, _this.loadingRender()));
      });
    }
  }]);
  return Button;
}(React.Component), _class2.defaultProps = {
  type: 'default',
  nativeType: 'button'
}, _class2.Group = void 0, _class2)) || _class;

exports.default = Button;