import * as React from 'react';
import { Size } from "../../libs/types";
import { InputProps } from "../input/Input";
import { PlacementType } from "../popover/Popover";
import { GetContainer } from "../portal/Portal";
export interface ItemOption {
    label?: string;
    value?: any;
    disabled?: boolean;
    children?: Array<ItemOption>;
}
export interface CascadeProps extends Omit<InputProps, 'value' | 'onChange'> {
    className?: string;
    style?: React.CSSProperties;
    size?: Size;
    value?: Array<string>;
    separator?: string;
    placeholder?: string;
    offset?: [number, number];
    useCustomScrollBar?: boolean;
    /** Option的容器 默认为body**/
    getContainer?: GetContainer;
    /**放置位置**/
    placement?: PlacementType;
    /**是否允许选择任意一级的选项**/
    changeOnSelect?: boolean;
    dataSource?: Array<ItemOption>;
    /**次级菜单的展开方式**/
    expandTrigger?: 'click' | 'hover';
    onChange?: (data: Array<string>, e: React.MouseEvent<HTMLElement>) => void;
    onLoadData?: (option: ItemOption, setChildren: (children: Array<ItemOption>) => Promise<Array<ItemOption>>) => void;
}
export interface CascadeState {
    value?: Array<string>;
    visible?: boolean;
}
export default class Cascade extends React.Component<CascadeProps, CascadeState> {
    state: CascadeState;
    ref: React.RefObject<unknown>;
    static defaultProps: CascadeProps;
    private el;
    /**
     *
     */
    watchValue(): void;
    /***
     * 处理打开或者关闭
     */
    handleOpenClose(visible: boolean): void;
    /**
     * 处理改变
     * @param data
     * @param e
     */
    private handleChange;
    /**
     *
     */
    private handleChooseEnd;
    /**
     *渲染函数
     */
    render(): React.ReactElement | string;
}
