import * as React from 'react';
export interface ItemOption {
    label?: string;
    value?: any;
    disabled?: boolean;
    children?: Array<ItemOption>;
}
export interface CascadeListProps {
    className?: string;
    style?: React.CSSProperties;
    /**数据源，其中的数据将会被渲染到左边一栏中**/
    options?: Array<ItemOption>;
    index?: number;
}
export interface CascadeListState {
    _prevProps?: CascadeListProps;
    loadingOption?: ItemOption;
    value?: Array<{
        label: string;
        id: string | number;
    }>;
    maxHeight?: string;
}
export interface CascadeListItemProps {
    option?: ItemOption;
    rootIndex?: number;
    loadingOption?: ItemOption;
    value?: Array<{
        label: string;
        id: string | number;
    }>;
}
export default class CascadeList extends React.Component<CascadeListProps, CascadeListState> {
    state: CascadeListState;
    static defaultProps: CascadeListProps;
    static contextType: React.Context<any>;
    /***
     * 是否已经卸载
     */
    private isUnmounted;
    private el;
    /**获取css属性高度 */
    componentDidMount(): void;
    /***
     * 异步加载数据
     */
    asyncLoadData(option: ItemOption, callback?: () => void): void;
    /**
     * 组件卸载
     */
    componentWillUnmount(): void;
    /**
     * 处理li点击
     */
    private handleClick;
    /**
     * 处理选择
     */
    handleCheck(option: ItemOption, e: React.MouseEvent<HTMLElement>, expandTrigger: string): void;
    /**
     * 处理鼠标hover
     * @param e
     */
    private handleMouseOver;
    /**
     * 委托ul点击
     */
    private handleUlClick;
    /**
     *渲染函数
     */
    render(): React.ReactElement | string;
}
