"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Right = _interopRequireDefault(require("net-design-icons/lib/icons/Right"));

var _CascadeContext = require("./CascadeContext");

var _spin = _interopRequireDefault(require("../spin"));

var _scrollBar = _interopRequireDefault(require("../scroll-bar"));

var _class, _class2, _class3;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CascadeListItem = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(CascadeListItem, _React$PureComponent);

  var _super = _createSuper(CascadeListItem);

  function CascadeListItem() {
    (0, _classCallCheck2.default)(this, CascadeListItem);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(CascadeListItem, [{
    key: "render",
    value:
    /**
     *
     */
    function render() {
      var _option$children;

      var _this$props = this.props,
          option = _this$props.option,
          value = _this$props.value,
          rootIndex = _this$props.rootIndex,
          loadingOption = _this$props.loadingOption;
      var loading = loadingOption && loadingOption === option;
      return /*#__PURE__*/React.createElement("div", {
        "data-label": JSON.stringify(option.label),
        "data-value": JSON.stringify(option.value),
        className: (0, _classnames.default)('rd-cascade-menu__item', {
          'is-selected': value[rootIndex] === (option.value === undefined ? option.label : option.value),
          'is-disabled': option.disabled
        }),
        role: 'cascade-menu-item'
      }, /*#__PURE__*/React.createElement("span", null, option.label), !loading && option.children && ((_option$children = option.children) === null || _option$children === void 0 ? void 0 : _option$children.length) > 0 && /*#__PURE__*/React.createElement(_Right.default, null), loading && /*#__PURE__*/React.createElement(_spin.default, {
        loading: true
      }));
    }
  }]);
  return CascadeListItem;
}(React.PureComponent)) || _class;

var CascadeList = (0, _autoBind.default)(_class2 = (_class3 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(CascadeList, _React$Component);

  var _super2 = _createSuper(CascadeList);

  function CascadeList() {
    var _this;

    (0, _classCallCheck2.default)(this, CascadeList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super2.call.apply(_super2, [this].concat(args));
    _this.state = {
      value: [],
      loadingOption: null
    };
    _this.isUnmounted = void 0;
    _this.el = /*#__PURE__*/React.createRef();
    return _this;
  }

  (0, _createClass2.default)(CascadeList, [{
    key: "componentDidMount",
    value:
    /**获取css属性高度 */
    function componentDidMount() {
      var useCustomScrollBar = this.context.useCustomScrollBar;

      if (useCustomScrollBar && this.el.current) {
        var computedStyle = getComputedStyle(this.el.current);
        this.setState({
          maxHeight: computedStyle.height
        });
      }
    }
    /***
     * 异步加载数据
     */

  }, {
    key: "asyncLoadData",
    value: function asyncLoadData(option, callback) {
      var _this2 = this;

      var _ref = this.context || {},
          onLoadData = _ref.onLoadData,
          options = _ref.options;

      if (onLoadData) {
        this.setState({
          loadingOption: option
        });
        onLoadData(option, function (children) {
          option.children = children;
          return new Promise(function (resolve, reject) {
            if (!_this2.isUnmounted) {
              _this2.setState({
                loadingOption: null
              });

              callback && callback();
              resolve(options);
            }
          });
        });
      }
    }
    /**
     * 组件卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.isUnmounted = true;
    }
    /**
     * 处理li点击
     */

  }, {
    key: "handleClick",
    value: function handleClick(option, e, expandTrigger) {
      var index = this.props.index;

      var _ref2 = this.context || {},
          set = _ref2.set,
          onLoadData = _ref2.onLoadData;

      if (option.children && option.children.length) {
        set && set(option, index, e, expandTrigger);
        this.asyncLoadData(option);
      } else {
        if (onLoadData) {
          this.asyncLoadData(option, function () {
            set && set(option, index, e, expandTrigger);
          });
        } else {
          this.handleCheck(option, e, expandTrigger);
          set && set(option, index, e, expandTrigger);
        }
      }
    }
    /**
     * 处理选择
     */

  }, {
    key: "handleCheck",
    value: function handleCheck(option, e, expandTrigger) {
      var index = this.props.index;

      var _ref3 = this.context || {},
          onChange = _ref3.onChange;

      onChange && onChange(option, index, e, expandTrigger);
    }
    /**
     * 处理鼠标hover
     * @param e
     */

  }, {
    key: "handleMouseOver",
    value: function handleMouseOver(e) {
      var _ref4 = this.context || {},
          expandTrigger = _ref4.expandTrigger;

      if (expandTrigger === 'hover') {
        this.handleUlClick(e, 'hover');
      }
    }
    /**
     * 委托ul点击
     */

  }, {
    key: "handleUlClick",
    value: function handleUlClick(e, expandTrigger) {
      var options = this.props.options;
      var target = e.target; //const toLowerCaseNodeName = target.nodeName.toLowerCase();

      var role = target.getAttribute('role');

      var findOption = function findOption(target) {
        var value = target ? JSON.parse(target.getAttribute('data-value')) : {};
        var label = target ? JSON.parse(target.getAttribute('data-label')) : {};
        return options.find(function (item) {
          return item.label === label && item.value === value;
        });
      };

      var loopFindParentLi = function loopFindParentLi(target) {
        var tryTimes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 4;
        var res = null;
        var times = 0;

        var innerLoop = function innerLoop(target) {
          if (times < tryTimes) {
            if (target && target.parentElement) {
              if (target.parentElement.getAttribute('role') === 'cascade-menu-item') {
                res = target.parentElement;
              } else {
                innerLoop(target.parentElement);
              }
            }
          }

          times = times + 1;
        };

        innerLoop(target);
        return res;
      };

      if (role === 'cascade-menu-item') {
        var option = findOption(target);

        if (option && !option.disabled) {
          this.handleClick(option, e, expandTrigger);
        }
      } else if (role !== 'cascade-menu') {
        var _option = findOption(loopFindParentLi(target));

        if (_option && !_option.disabled) {
          this.handleClick(_option, e, expandTrigger);
        }
      }
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          options = _this$props2.options,
          rootIndex = _this$props2.index;

      var _ref5 = this.context || {},
          value = _ref5.value,
          useCustomScrollBar = _ref5.useCustomScrollBar;

      var loadingOption = this.state.loadingOption;
      var classes = (0, _classnames.default)(className, 'rd-cascade-menu', {
        'is-custom-scroll': useCustomScrollBar
      });
      var maxHeight = this.state.maxHeight;

      if (useCustomScrollBar) {
        return /*#__PURE__*/React.createElement("div", {
          ref: this.el,
          role: "cascade-menu",
          className: classes,
          onClick: function onClick(e) {
            return _this3.handleUlClick(e, 'click');
          },
          onMouseOver: this.handleMouseOver
        }, /*#__PURE__*/React.createElement(_scrollBar.default, {
          autoHeight: true,
          autoHeightMax: maxHeight,
          style: {
            maxHeight: maxHeight
          }
        }, options.map(function (item, index) {
          return /*#__PURE__*/React.createElement(CascadeListItem, {
            key: "".concat(item.label).concat(item.value).concat(index),
            value: value,
            option: item,
            loadingOption: loadingOption,
            rootIndex: rootIndex
          });
        })));
      } else {
        return /*#__PURE__*/React.createElement("div", {
          role: "cascade-menu",
          className: classes,
          onClick: function onClick(e) {
            return _this3.handleUlClick(e, 'click');
          },
          onMouseOver: this.handleMouseOver
        }, options.map(function (item, index) {
          return /*#__PURE__*/React.createElement(CascadeListItem, {
            key: "".concat(item.label).concat(item.value).concat(index),
            value: value,
            option: item,
            loadingOption: loadingOption,
            rootIndex: rootIndex
          });
        }));
      }
    }
  }]);
  return CascadeList;
}(React.Component), _class3.defaultProps = {
  options: []
}, _class3.contextType = _CascadeContext.CascadeContext, _class3)) || _class2;

exports.default = CascadeList;