import * as React from 'react';
import { Size } from "../../libs/types";
export interface ItemOption {
    label?: string;
    value?: any;
    disabled?: boolean;
    children?: Array<ItemOption>;
}
export interface CascadePanelProps {
    className?: string;
    style?: React.CSSProperties;
    size?: Size;
    value?: Array<string>;
    useCustomScrollBar?: boolean;
    /**次级菜单的展开方式**/
    expandTrigger?: 'click' | 'hover';
    /**是否允许选择任意一级的选项**/
    changeOnSelect?: boolean;
    options?: Array<ItemOption>;
    onChange?: (data: Array<string>, e: React.MouseEvent<HTMLElement>) => void;
    onChooseEnd?: () => void;
    onLoadData?: (option: ItemOption, setChildren: (children: Array<ItemOption>) => Promise<Array<ItemOption>>) => void;
}
export interface CascadePanelState {
    _prevProps?: CascadePanelProps;
    options?: Array<Array<ItemOption>>;
    value?: Array<string>;
}
export default class CascadePanel extends React.Component<CascadePanelProps, CascadePanelState> {
    state: CascadePanelState;
    static defaultProps: CascadePanelProps;
    /**
     *
     * @param value
     * @param options
     */
    static getStateOptionsByValue(value: Array<string>, options: Array<ItemOption>): Array<Array<ItemOption>>;
    /**
     *
     * @param nextProps
     * @param prevState
     */
    static getDerivedStateFromProps(nextProps: CascadePanelProps, prevState: CascadePanelState): CascadePanelState;
    /***
     *
     * @param option
     * @param index
     * @param e
     * @param expandTrigger
     */
    handleChange(option: ItemOption, index: number, e: React.MouseEvent<HTMLElement>, expandTrigger: string): void;
    /**
     *渲染函数
     */
    render(): React.ReactElement | string;
}
