import * as React from 'react';
import CheckboxGroup from './CheckboxGroup';
import CheckboxButton from './CheckboxButton';
import CheckboxWeek from './CheckboxWeek';
import { CheckboxProps, CheckboxState, CheckboxValueType } from '../radio/interface';
export default class Checkbox extends React.Component<CheckboxProps, CheckboxState> {
    static Group: typeof CheckboxGroup;
    static Button: typeof CheckboxButton;
    static Week: typeof CheckboxWeek;
    static defaultProps: {
        size: string;
        checked: boolean;
    };
    static contextType: React.Context<any>;
    /**
     * 父级的引用
     */
    parent(): CheckboxGroup;
    /**
 * 构造函数
 * @param props
 */
    constructor(props: CheckboxProps);
    /**
     * 更新
     * @param nextProps
     * @param prevState
     */
    static getDerivedStateFromProps(nextProps: CheckboxProps, prevState: CheckboxState): CheckboxState;
    /**
     * 判断是否选中,主要判断来自父级的value是否包含当前value值
     * @param props
     */
    static getChecked(nextProps: CheckboxProps): boolean;
    /**
       * 改变事件
       * @param e
       */
    handleChange(value: CheckboxValueType, e: React.ChangeEvent<HTMLInputElement>): void;
    /**
       * 聚焦失去焦点只是控制样式
       */
    handleFocus(e: React.ChangeEvent<HTMLInputElement>): void;
    /**
       * 聚焦失去焦点只是控制样式
       */
    handleBlur(e: React.ChangeEvent<HTMLInputElement>): void;
    /**
       * 渲染
       */
    render(): React.ReactNode;
}
