"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _CheckboxContext = _interopRequireDefault(require("./CheckboxContext"));

var _Complete = _interopRequireDefault(require("net-design-icons/lib/icons/Complete"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _excluded = ["disabled", "value", "size", "style", "label", "children", "name", "indeterminate", "className", "onLabelClick"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Checkbox = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Checkbox, _React$Component);

  var _super = _createSuper(Checkbox);

  /**
  * 构造函数
  * @param props
  */
  function Checkbox(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Checkbox);
    _this = _super.call(this, props);
    _this.state = {
      focus: false
    };
    return _this;
  }
  /**
   * 更新
   * @param nextProps
   * @param prevState
   */


  (0, _createClass2.default)(Checkbox, [{
    key: "parent",
    value: // 默认尺寸

    /**
     * 父级的引用
     */
    function parent() {
      return this.context && this.context.component;
    }
  }, {
    key: "handleChange",
    value:
    /**
       * 改变事件
       * @param e
       */
    function handleChange(value, e) {
      if (e.target instanceof HTMLInputElement) {
        var checked = e.target.checked;
        var _this$props = this.props,
            onChange = _this$props.onChange,
            disabled = _this$props.disabled;

        if (!disabled) {
          onChange && onChange(value, e);
          this.setState({
            checked: checked
          });
        }
      }
    }
    /**
       * 聚焦失去焦点只是控制样式
       */

  }, {
    key: "handleFocus",
    value: function handleFocus(e) {
      this.setState({
        focus: true
      });
      var onFocus = this.props.onFocus;
      onFocus && onFocus(e);
    }
    /**
       * 聚焦失去焦点只是控制样式
       */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      this.setState({
        focus: false
      });
      var onBlur = this.props.onBlur;
      onBlur && onBlur(e);
    }
    /**
       * 渲染
       */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          checked = _this$state.checked,
          focus = _this$state.focus;
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          value = _this$props2.value,
          size = _this$props2.size,
          style = _this$props2.style,
          label = _this$props2.label,
          children = _this$props2.children,
          name = _this$props2.name,
          indeterminate = _this$props2.indeterminate,
          className = _this$props2.className,
          onLabelClick = _this$props2.onLabelClick,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, _excluded); // 没有value是,可将label值作为value

      var newValue = value;

      if (value === undefined) {
        newValue = label;
      }

      var otherProps = (0, _omit.default)(rest, ['fill', 'textColor', 'options']);
      var labelText = children || label;
      return /*#__PURE__*/React.createElement("label", {
        style: style,
        onClick: function onClick(e) {
          e.stopPropagation();
          onLabelClick && onLabelClick(e);
        },
        className: (0, _classnames.default)(className, 'rd-checkbox', size && "rd-checkbox--".concat(size), {
          'is-checked': checked
        })
      }, /*#__PURE__*/React.createElement("span", {
        className: (0, _classnames.default)({
          'rd-checkbox__input': true,
          'is-disabled': disabled,
          'is-indeterminate': indeterminate,
          'is-checked': checked,
          'is-focus': focus
        })
      }, /*#__PURE__*/React.createElement("span", {
        className: (0, _classnames.default)('rd-checkbox__inner', {
          'is-disabled': disabled
        })
      }, checked && /*#__PURE__*/React.createElement(_Complete.default, {
        className: (0, _classnames.default)('rd-checkbox__icon')
      })), /*#__PURE__*/React.createElement("input", (0, _extends2.default)({}, otherProps, {
        type: "checkbox",
        className: "rd-checkbox__original" // 解决React 中受控组件和非受控组件的问题
        ,
        checked: checked === undefined ? false : checked,
        disabled: disabled,
        name: name,
        value: value,
        onChange: function onChange(e) {
          return _this2.handleChange(newValue, e);
        },
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      }))), labelText && /*#__PURE__*/React.createElement("span", {
        className: "rd-checkbox__label"
      }, labelText));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newChecked = nextProps.options ? Checkbox.getChecked(nextProps) : nextProps.checked;

      if (prevState._prevProps && prevState._prevProps.checked === nextProps.checked) {
        newChecked = nextProps.options ? Checkbox.getChecked(nextProps) : prevState.checked;
      }

      return {
        _prevProps: nextProps,
        checked: newChecked
      };
    }
    /**
     * 判断是否选中,主要判断来自父级的value是否包含当前value值
     * @param props
     */

  }, {
    key: "getChecked",
    value: function getChecked(nextProps) {
      return nextProps.options.includes(nextProps.value !== undefined ? nextProps.value : nextProps.label);
    }
  }]);
  return Checkbox;
}(React.Component), _class2.Group = void 0, _class2.Button = void 0, _class2.Week = void 0, _class2.defaultProps = {
  size: 'medium',
  checked: false
}, _class2.contextType = _CheckboxContext.default, _class2)) || _class;

exports.default = Checkbox;