import * as React from 'react';
import Checkbox from './Checkbox';
import { CheckboxProps, CheckboxState } from '../radio/interface';
export default class CheckboxButton extends Checkbox {
    static contextType: React.Context<any>;
    state: CheckboxProps;
    static defaultProps: {
        size: string;
        checked: boolean;
    };
    /**
     * 更新
     * @param nextProps
     * @param prevState
     */
    static getDerivedStateFromProps(nextProps: CheckboxProps, prevState: CheckboxState): CheckboxState;
    /**
      * 获取父级尺寸
      */
    size(): string;
    /**
     * 获取填充颜色
     */
    activeStyle(): {
        backgroundColor: string;
        borderColor: string;
        color: string;
        boxShadow: string;
    };
    /**
         * button渲染
         */
    buttonRender(): React.ReactNode;
    /**
         * 渲染
         */
    render(): React.ReactNode;
}
