"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CheckboxContext = _interopRequireDefault(require("./CheckboxContext"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormElement = require("../form/FormElement");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CheckboxGroup = (_dec = (0, _FormElement.createFormElement)(true), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(CheckboxGroup, _React$Component);

  var _super = _createSuper(CheckboxGroup);

  /**
   * 构造函数
   * @param props
   */
  function CheckboxGroup(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CheckboxGroup);
    _this = _super.call(this, props);
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(CheckboxGroup, [{
    key: "onChange",
    value:
    /**
     * group上点击事件
     * @param value
     * @param checked
     */
    function onChange(value, e) {
      var _this2 = this;

      var options = this.state.options;
      var newOptions = options;
      var checked = e.target.checked;
      var event = e;
      var index = options.indexOf(value); // 如果勾选且选中数组里面没有当前选中的值，则添加到选中队列中，反之从队列中删除

      if (checked) {
        if (index === -1) {
          newOptions.push(value);
        }
      } else if (index !== -1) {
        newOptions.splice(index, 1);
      }

      this.setState({
        options: newOptions
      }, function () {
        var onChange = _this2.props.onChange;
        onChange && onChange(newOptions, event);
      });
    }
    /**
     *
     */

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          style = _this$props.style,
          size = _this$props.size,
          className = _this$props.className;
      var options = this.state.options;
      var children = React.Children.map(this.props.children, function (child) {
        return child && /*#__PURE__*/React.cloneElement(child, Object.assign({}, child.props, {
          onChange: _this3.onChange,
          options: options,
          size: size //直接覆盖下面的size和border,方面一组数据统一大小和边框

        }));
      });
      return /*#__PURE__*/React.createElement(_CheckboxContext.default.Provider, {
        value: {
          component: this
        }
      }, /*#__PURE__*/React.createElement("div", {
        style: style,
        className: (0, _classnames.default)(className, 'rd-checkbox-group')
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**
    * 更新父级
    * @param nextProps
    * @param prevState
    */
    function getDerivedStateFromProps(nextProps, prevState) {
      var newOptions = nextProps.value;

      if (prevState._prevProps) {
        if (nextProps.value === prevState._prevProps.value) {
          newOptions = prevState.options;
        }
      }

      return {
        _prevProps: nextProps,
        options: newOptions || []
      };
    }
  }]);
  return CheckboxGroup;
}(React.Component), _class2.defaultProps = {
  size: 'medium'
}, _class2)) || _class) || _class);
exports.default = CheckboxGroup;