import * as React from 'react';
import { CheckProps, CheckboxProps, CheckboxValueType } from '../radio/interface';
declare const WeekPositionTypes: ["inner", "outer"];
declare type WeekPositionType = typeof WeekPositionTypes[number];
declare const WeekTypes: ["default", "button"];
declare type WeekType = typeof WeekTypes[number];
interface CheckboxWeekProps extends CheckProps {
    /**周一到周天的配置参数 */
    options: Array<CheckboxProps>;
    /**全选的配置参数 */
    indeterminateOption: CheckboxProps;
    /**全选的位置 */
    position?: WeekPositionType;
    /**全选的class类名 */
    indeterminateClassName?: string;
    /**周一到周天group的class类名 */
    itemClassName?: string;
    /**按钮样式还是普通checkbox样式 */
    type?: WeekType;
    /**全选按钮是否选中 */
    checkedAll?: boolean;
    value?: Array<CheckboxValueType>;
}
interface CheckboxWeekState extends CheckboxProps {
    checkArr?: Array<CheckboxValueType>;
    _prevProps?: CheckboxWeekProps;
    checkedAll?: boolean;
    /**周一到周天的ke配置参数 */
    optionArr?: Array<CheckboxProps>;
    /**不能操作且选中的长度 */
    disabledLength?: number;
}
export default class CheckboxWeek extends React.Component<CheckboxWeekProps, CheckboxWeekState> {
    static defaultProps: {
        type: string;
        position: string;
    };
    /**
     *
     * @param props
     */
    constructor(props: CheckboxWeekProps);
    /**
     * 判断是否为半选状态
     * @param nextProps
     * @param prevState
     */
    static getIndeterminate(optionArr: Array<CheckboxProps>, checkArr: Array<CheckboxValueType>): {
        indeterminate: boolean;
        checkedAll: boolean;
    };
    /**
     * 更新父级
     * @param nextProps
     * @param prevState
     */
    static getDerivedStateFromProps(nextProps: CheckboxWeekProps, prevState: CheckboxWeekState): CheckboxWeekState;
    /**
     * 周一到周天点击改变事件
     */
    handleChange(value: Array<number | string>): void;
    /**
     * 全选
     */
    handleClickAll(value: number | string, e: React.ChangeEvent<HTMLInputElement>): void;
    /**
     * 判断显示checkbox类型
     */
    checkboxRender(): React.ReactNode;
    /**
     *渲染
     */
    render(): React.ReactNode;
}
export {};
