import * as React from 'react';
import { clickParam } from './CollapseContext';
import CollapsePanel from './CollapsePanel';
declare const IconPosition: ["left", "right"];
declare const CollapseType: ["bordered", "ghost"];
export interface CollapseProps {
    /**默认展开的index集合 */
    defaultOpenKeys?: Array<string | number>;
    /**展开的index集合，若上级传递了此属性，则后续此数据表示由用户自己维护 */
    openKeys?: Array<string | number>;
    /**是否只保持一个子菜单的展开 */
    openUnique?: boolean;
    /**带边框的折叠面板 or  折叠面板透明，无边框*/
    collapseType?: typeof CollapseType[number];
    /**展开图标所在位置 */
    expandIconPosition?: typeof IconPosition[number];
    className?: string;
    style?: React.CSSProperties;
    prefixCls?: string;
    /**切换面板的回调 */
    onChange?: (params: clickParam) => void;
    /**生成展开或折叠的图标方法 */
    expandIcon?: (isExpaned: boolean) => React.ReactNode;
}
interface CollapseState {
    openKeys?: Array<string | number>;
}
export default class Collapse extends React.Component<CollapseProps, CollapseState> {
    static defaultProps: CollapseProps;
    static Panel: typeof CollapsePanel;
    /** */
    constructor(props: CollapseProps);
    /**
     * 根据上级传下的openKeys改变当前菜单的展开效果
     * @param nextProps
     */
    static getDerivedStateFromProps(nextProps: CollapseProps): CollapseState;
    /**
     * 默认展开图标
     * @param isExpand
     */
    expandIcon(isExpand: boolean): React.ReactNode;
    /**点击Panel的回调方法 */
    handlePanel(params: clickParam): void;
    /** */
    render(): React.ReactNode;
}
export {};
