"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _CollapseContext = _interopRequireDefault(require("./CollapseContext"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _collapse = _interopRequireDefault(require("../../libs/collapse"));

var _excluded = ["index", "disabled", "showArrows", "header", "className", "style", "children", "prefixCls"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CollapsePanel = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(CollapsePanel, _React$Component);

  var _super = _createSuper(CollapsePanel);

  function CollapsePanel() {
    var _this;

    (0, _classCallCheck2.default)(this, CollapsePanel);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.headerRef = void 0;
    return _this;
  }

  (0, _createClass2.default)(CollapsePanel, [{
    key: "renderCollapsePanel",
    value:
    /**生成DOM */
    function renderCollapsePanel(context) {
      var _this2 = this;

      var _this$props = this.props,
          index = _this$props.index,
          disabled = _this$props.disabled,
          showArrows = _this$props.showArrows,
          header = _this$props.header,
          className = _this$props.className,
          style = _this$props.style,
          children = _this$props.children,
          customizePrefixCls = _this$props.prefixCls,
          others = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var openKeys = context.openKeys,
          expandIcon = context.expandIcon,
          handlePanel = context.handlePanel;
      var prefixCls = (0, _util.getPrefixCls)('collapse-panel', customizePrefixCls);
      var isActive = openKeys.includes(index);

      var panelStyle = _objectSpread({}, style);

      var classString = (0, _classnames.default)("".concat(prefixCls), {
        'is-active': isActive
      }, className);
      var classHeadString = (0, _classnames.default)("".concat(prefixCls, "__header"), {
        'is-disabled': disabled,
        'has-arrows': showArrows
      });
      var classContentString = (0, _classnames.default)("".concat(prefixCls, "__content"));
      return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        className: classString,
        style: panelStyle
      }, others), /*#__PURE__*/React.createElement("div", {
        ref: function ref(div) {
          _this2.headerRef = div;
        },
        className: classHeadString,
        onClick: function onClick(e) {
          return !disabled && handlePanel({
            index: index,
            e: e,
            panelElement: _this2.headerRef
          });
        }
      }, showArrows && expandIcon(isActive), header), /*#__PURE__*/React.createElement(_collapse.default, {
        isShow: isActive
      }, /*#__PURE__*/React.createElement("div", {
        className: classContentString
      }, children)));
    }
    /**
     * 
     */

  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(_CollapseContext.default.Consumer, null, this.renderCollapsePanel);
    }
  }]);
  return CollapsePanel;
}(React.Component), _class2.defaultProps = {
  disabled: false,
  showArrows: true
}, _class2)) || _class;

exports.default = CollapsePanel;