import * as React from 'react';
import { Types, TimePickerProps, DatePickerProps } from './Types';
import Dropdown from '../dropdown';
declare type Props<D, S> = TimePickerProps<D, S> & DatePickerProps<D, S>;
declare type State<D, S> = {
    value?: D;
    text?: S;
    isShowClose?: boolean;
};
export default class BasePicker<D, S> extends React.Component<Props<D, S>, State<D, S>> {
    type: Types;
    dropdown: Dropdown;
    /**
     * 提供外部方法，将string转成Date格式传入组件
     * @param str
     * @param format
     * @returns
     */
    static toDate(text: string, format: string): Date;
    /**
     *
     * @param params
     * @returns
     */
    static toString(date: Date, format: string): string;
    /**默认改变回调 */
    handleChange(...params: any): void;
    /** 展开显示面板默认值为null*/
    pickerPanel(): React.ReactNode;
    /** input渲染 */
    inputRender(args: any): React.ReactElement;
    /**
     * 默认props值
     */
    static get defaultProps(): any;
    /**
     *
     */
    componentDidMount(): void;
    /**
     * 更新
     */
    componentDidUpdate(prevProps: Props<D, S>): void;
    /**
     * 是否为date格式
     */
    isDateFormat(): boolean;
    /**关闭下拉框 */
    closeDropDown(isKeepPannel?: boolean): void;
    /**
     * 用于展开面板调用
     *
     * @param value: Date|Date[]|null
     * @param isKeepPannel: boolean = false 是否关闭下拉框
     */
    handlePicker(value: any, isKeepPannel?: boolean): void;
    /**
     * date转成string，需要的格式
     * @param date Date
     */
    dateToStr(date: any): any;
    /**
     * string转成date格式
     * @param str
     */
    parseDate(str: any): any;
    /**
     * 获取面板格式化string
     */
    getFormat(): string;
    /**
     * @param value Date|Date[]
     */
    propsToState(value: D): any;
    /**
     * input聚焦事件
     */
    handleFocus(): void;
    /**
     * input失去焦点事件
     */
    handleBlur(): void;
    /**
     * 键盘处理，如果为tab，收起面板
     * @param evt
     */
    handleKeydown(evt: React.KeyboardEvent<HTMLInputElement>): void;
    /**
     * 验证数据是否合法
     * @param date Date
     */
    isDateValid(date: D): boolean;
    /**
     * input输入框检测数据是否合法
     * @param value string
     * return boolean
     */
    isInputValid(value: string): boolean;
    /**
     * 点击icon图标 清除input数据 只读和禁用不能清除数据
     */
    handleClickIcon(): void;
    /**
     * date-picker渲染
     */
    render(): React.ReactNode;
}
export {};
