import * as React from 'react';
import BasePicker from './BasePicker';
import { DatePickerProps, D, S } from './Types';
import { InputProps } from '../input/Input';
declare type Props = DatePickerProps<D, S>;
declare type State = {
    text?: S;
    value?: D;
    isShowClose?: boolean;
};
export default class DatePicker extends BasePicker<D, S> {
    state: State;
    /**
    * 默认props数据
    */
    static get defaultProps(): Props;
    /**
      *
      * @param props 构造函数
      */
    constructor(props: Props);
    /**
    * 日期选择器面板
    * @param state
    * @param props
    */
    pickerPanel(): React.ReactNode;
    /**
* input渲染
* @returns
*/
    inputRender(args: InputProps): React.ReactElement;
    /**
    * input值改变时的回调
    * params为input的e或者Interval的value值
    */
    handleChange(e: React.ChangeEvent<HTMLInputElement>): void;
}
export {};
