import * as React from 'react';
import BasePicker from './BasePicker';
import { DatePickerProps, DS, SS } from './Types';
import { IntervalProps } from '../interval/interval';
declare type D = DS;
declare type S = SS;
declare type Props = DatePickerProps<D, S>;
declare type State = {
    text?: S;
    value?: D;
    isShowClose?: boolean;
};
export default class DateRangePicker extends BasePicker<D, S> {
    props: Props;
    state: State;
    /**
    * 默认props数据
    */
    static get defaultProps(): Props;
    /**
        *
        * @param props 构造函数
        */
    constructor(props: Props);
    /**
       * 日期范围选择器面板
       * @param state
       * @param props
       */
    pickerPanel(): React.ReactNode;
    /**
* input渲染
* @returns
*/
    inputRender(args: IntervalProps): React.ReactElement;
    /**
    * input值改变时的回调
    * params为input的e或者Interval的value值
    */
    handleChange(...params: [Array<string>, React.ChangeEvent<HTMLInputElement>, number]): void;
}
export {};
