/**
 * 单个时间选择器
 */
import * as React from 'react';
import BasePicker from './BasePicker';
import { TimePickerProps, D, S } from './Types';
import { InputProps } from '../input/Input';
declare type Props = TimePickerProps<D, S>;
declare type State = {
    text?: S;
    value?: D;
};
export default class TimePicker extends BasePicker<D, S> {
    state: State;
    /**
     * 默认props数据
     */
    static get defaultProps(): Props;
    /**
     *
     * @param props 构造函数
     */
    constructor(props: Props);
    /**
     * 时间选择器面板
     * @param state
     * @param props
     */
    pickerPanel(): React.ReactNode;
    /**
 * input渲染
 * @returns
 */
    inputRender(args: InputProps): React.ReactElement;
    /**
    * input值改变时的回调
    * params为input的e或者Interval的value值
    */
    handleChange(e: React.ChangeEvent<HTMLInputElement>): void;
}
export {};
