/**
 * 时间范围选择器
 */
import * as React from 'react';
import BasePicker from './BasePicker';
import { DS, SS, TimePickerProps } from './Types';
import { IntervalProps } from '../interval/interval';
declare type D = DS;
declare type S = SS;
declare type Props = TimePickerProps<D, S>;
declare type State = {
    text?: S;
    value?: D;
};
export default class TimeRangePicker extends BasePicker<D, S> {
    props: Props;
    state: State;
    /**
     * 默认props值
     */
    static get defaultProps(): Props;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: Props);
    /**
     * 时间范围选择器的
     * @param state
     * @param props
     */
    pickerPanel(): React.ReactNode;
    /**
* input渲染
* @returns
*/
    inputRender(args: IntervalProps): React.ReactElement;
    /**
    * input值改变时的回调
    * params为input的e或者Interval的value值
    */
    handleChange(params: [Array<string>, React.ChangeEvent<HTMLInputElement>, number]): void;
}
export {};
