/**
 * 日期表格
 * selectMode为day或者week时调用
 */
import * as React from 'react';
import { D, Types, SelectionMode } from '../Types';
import { RangeState } from '../panel/DateRangePanel';
declare type Props = RangeState & {
    value?: D;
    type?: Types;
    format?: string;
    /**周起始日 1 到 7	默认 7 */
    firstDayOfWeek?: number;
    /**是否显示时间 有时间的情况下显示确定按钮 */
    showTime?: boolean;
    disabledDate?: (date: D) => boolean;
    selectionMode?: SelectionMode;
    onChangeRange?: ({ endDate }: {
        endDate: Date;
    }) => void;
    onPicked?: (value: any, isClose: boolean) => void;
};
declare type State = {};
export default class DateTable extends React.Component<Props, State> {
    /**
     * 构造函数
     * @param props
     */
    constructor(props: Props);
    static defaultProps: {
        /**周起始数，默认周末开头 */
        firstDayOfWeek: number;
    };
    /**
     * 组装周数显示顺序
     */
    WEEKS(): string[];
    /**
     * 获取起始周偏移值
     */
    getOffsetWeek(): number;
    /**
     * 获取第一个面板的开始日期
     */
    getStartDate(): Date;
    /**
     * 构建tableDate数据
     */
    getRows(): any[];
    /**
     * 范围选择器class
     * @param cell
     */
    inRangeClass(cell: any, classes: string[]): any;
    /**
     * 计算单元格样式
     * @param cell
     */
    getCellClasses(cell: any): any;
    /**
     * 获取rows
     */
    getMarkedRangeRows(): any[];
    /**
     * 周是否处于选中状态
     * @param cell
     */
    isWeekActive(cell: any): boolean;
    /**
     * 鼠标移动显示范围内日期
     * @param event
     */
    handleMouseMove(event: any): void;
    /**
     * 单元格禁止点击的场景
     * @param target
     */
    disabledClick(target: any): boolean;
    /**
     * 单元格点击处理数据
     */
    dealDate(target: any): Date;
    /**
     * 单元格点击
     * @param event
     */
    handleClick(event: any): void;
    /**
     * 日期表格渲染
     */
    render(): React.ReactNode;
}
export {};
