"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _utils = require("../utils");

var _locale = _interopRequireDefault(require("../../locale"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 是否是函数
 * @param func
 */
function isFunction(func) {
  return typeof func === 'function';
}
/**
 * 清除时间（时，分，秒，毫秒）
 * @param time
 */


var clearHours = function clearHours(time) {
  var cloneDate = new Date(time);
  cloneDate.setHours(0, 0, 0, 0);
  return cloneDate.getTime();
};
/**周一到周日，查询语言包翻译 */


var _WEEKS = ['sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat'];

var DateTable = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(DateTable, _React$Component);

  var _super = _createSuper(DateTable);

  /**
   * 构造函数
   * @param props
   */
  function DateTable(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DateTable);
    _this = _super.call(this, props);
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(DateTable, [{
    key: "WEEKS",
    value:
    /**
     * 组装周数显示顺序
     */
    function WEEKS() {
      // 1-7
      var week = this.getOffsetWeek();
      return [].concat((0, _toConsumableArray2.default)(_WEEKS.slice(week)), (0, _toConsumableArray2.default)(_WEEKS.slice(0, week)));
    }
    /**
     * 获取起始周偏移值
     */

  }, {
    key: "getOffsetWeek",
    value: function getOffsetWeek() {
      return this.props.firstDayOfWeek % 7;
    }
    /**
     * 获取第一个面板的开始日期
     */

  }, {
    key: "getStartDate",
    value: function getStartDate() {
      var ds = (0, _utils.deconstructDate)(this.props.date);
      return (0, _utils.getStartDateOfMonth)(ds.year, ds.month, this.getOffsetWeek());
    }
    /**
     * 构建tableDate数据
     */

  }, {
    key: "getRows",
    value: function getRows() {
      var _this2 = this;

      var _this$props = this.props,
          date = _this$props.date,
          disabledDate = _this$props.disabledDate,
          minDate = _this$props.minDate,
          maxDate = _this$props.maxDate,
          type = _this$props.type,
          firstDayOfWeek = _this$props.firstDayOfWeek;
      /**初始化表格数据结构 */

      var rows = [[], [], [], [], [], []];
      var ndate = new Date(date.getTime()); // 获取面板第一天处于周几

      var day = (0, _utils.getFirstDayOfMonth)(ndate); //获取当前月的天数

      var dateCountOfMonth = (0, _utils.getDayCountOfMonth)(ndate.getFullYear(), ndate.getMonth()); // 获取最后一个月的天数，因12月每年都是31天，所以不需要额外计算

      var dateCountOfLastMonth = (0, _utils.getDayCountOfMonth)(ndate.getFullYear(), ndate.getMonth() === 0 ? 11 : ndate.getMonth() - 1); //获取当前天的周偏移量

      var offsetDaysToWeekOrigin = (0, _utils.getOffsetToWeekOrigin)(day, firstDayOfWeek);
      var count = 1;
      var firstDayPosition;
      var startDate = this.getStartDate();
      var now = clearHours(new Date());

      var _loop = function _loop(i) {
        // rows
        var row = rows[i];

        var _loop2 = function _loop2(j) {
          // columns
          var cell = row[j];
          var index = i * 7 + j; //current date offset

          var time = startDate.getTime() + _utils.DAY_DURATION * index;
          var isToday = time === now;

          if (!cell) {
            row[j] = {
              row: i,
              column: j,
              type: 'normal',
              inRange: false,
              start: false,
              end: false
            };
            cell = row[j];
          }

          cell.type = 'normal';

          if (isToday) {
            cell.type = 'today';
          }

          var getCell = function getCell(cell) {
            cell.inRange = time >= clearHours(minDate) && time <= clearHours(maxDate);
            cell.start = minDate && time === clearHours(minDate);
            cell.end = maxDate && time === clearHours(maxDate);

            if (i === 0) {
              //handle first row of date, this row only contains all or some pre-month dates
              if (j >= offsetDaysToWeekOrigin) {
                cell.text = count++;

                if (count === 2) {
                  firstDayPosition = i * 7 + j;
                }
              } else {
                cell.text = dateCountOfLastMonth - offsetDaysToWeekOrigin + j + 1;
                cell.type = 'prev-month';
              }
            } else {
              if (count <= dateCountOfMonth) {
                //in current dates
                cell.text = count++;

                if (count === 2) {
                  firstDayPosition = i * 7 + j;
                }
              } else {
                // next month
                cell.text = count++ - dateCountOfMonth;
                cell.type = 'next-month';
              }
            }

            return cell;
          };

          cell = getCell(cell);
          cell.disabled = isFunction(disabledDate) && disabledDate(new Date(time));
        };

        for (var j = 0; j < 7; j++) {
          _loop2(j);
        }

        if (type === _utils.SELECTION_MODES.WEEK) {
          var start = 0;
          var end = 6;

          var isWeekActive = _this2.isWeekActive(row[start + 1]);

          row[start].inRange = isWeekActive;
          row[start].start = isWeekActive;
          row[end].inRange = isWeekActive;
          row[end].end = isWeekActive;
          row.isWeekActive = isWeekActive;
        }
      };

      for (var i = 0; i < 6; i++) {
        _loop(i);
      }

      rows.firstDayPosition = firstDayPosition;
      return rows;
    }
    /**
     * 范围选择器class
     * @param cell
     */

  }, {
    key: "inRangeClass",
    value: function inRangeClass(cell, classes) {
      var type = this.props.type;

      if (cell.inRange && (cell.type === 'normal' || cell.type === 'today' || type === 'week')) {
        classes.push('in-range');

        if (cell.start) {
          classes.push('start-date');
        }

        if (cell.end) {
          classes.push('end-date');
        }
      }

      return classes;
    }
    /**
     * 计算单元格样式
     * @param cell
     */

  }, {
    key: "getCellClasses",
    value: function getCellClasses(cell) {
      var _this$props2 = this.props,
          type = _this$props2.type,
          date = _this$props2.date;
      var classes = [];

      if ((cell.type === 'normal' || cell.type === 'today') && !cell.disabled) {
        classes.push('available');

        if (cell.type === 'today') {
          classes.push('today');
        }
      } else {
        classes.push(cell.type);
      }

      if (type === 'date' && (cell.type === 'normal' || cell.type === 'today') && date.getDate() === +cell.text) {
        classes.push('current');
      }

      classes = this.inRangeClass(cell, classes);

      if (cell.disabled) {
        classes.push('disabled');
      }

      return classes.join(' ');
    }
    /**
     * 获取rows
     */

  }, {
    key: "getMarkedRangeRows",
    value: function getMarkedRangeRows() {
      var _this$props3 = this.props,
          minDate = _this$props3.minDate,
          type = _this$props3.type,
          rangeState = _this$props3.rangeState,
          maxDate = _this$props3.maxDate;
      var rows = this.getRows();

      if (!(type === _utils.SELECTION_MODES.RANGE && rangeState.endDate instanceof Date)) {
        return rows;
      }

      for (var i = 0, k = rows.length; i < k; i++) {
        var row = rows[i];

        for (var j = 0, l = row.length; j < l; j++) {
          var cell = row[j];
          var index = i * 7 + j + 0;
          var time = this.getStartDate().getTime() + _utils.DAY_DURATION * index;
          cell.inRange = minDate && time >= clearHours(minDate) && time <= clearHours(maxDate);
          cell.start = minDate && time === clearHours(minDate.getTime());
          cell.end = maxDate && time === clearHours(maxDate.getTime());
        }
      }

      return rows;
    }
    /**
     * 周是否处于选中状态
     * @param cell
     */

  }, {
    key: "isWeekActive",
    value: function isWeekActive(cell) {
      if (this.props.type !== _utils.SELECTION_MODES.WEEK) {
        return false;
      }

      if (!this.props.value) {
        return false;
      }

      var newDate = new Date(this.props.date.getTime()); // date view

      var year = newDate.getFullYear();
      var month = newDate.getMonth();

      if (cell.type === 'prev-month') {
        newDate.setMonth(month === 0 ? 11 : month - 1);
        newDate.setFullYear(month === 0 ? year - 1 : year);
      }

      if (cell.type === 'next-month') {
        newDate.setMonth(month === 11 ? 0 : month + 1);
        newDate.setFullYear(month === 11 ? year + 1 : year);
      }

      newDate.setDate(parseInt(cell.text, 10)); // current date value

      return (0, _utils.getWeekNumber)(newDate) === (0, _utils.deconstructDate)(this.props.value).week;
    }
    /**
     * 鼠标移动显示范围内日期
     * @param event
     */

  }, {
    key: "handleMouseMove",
    value: function handleMouseMove(event) {
      var _this3 = this;

      var _this$props4 = this.props,
          onChangeRange = _this$props4.onChangeRange,
          rangeState = _this$props4.rangeState,
          type = _this$props4.type;

      var getDateOfCell = function getDateOfCell(row, column) {
        var startDate = _this3.getStartDate();

        return new Date(startDate.getTime() + (row * 7 + column) * _utils.DAY_DURATION);
      };

      if (!(type === _utils.SELECTION_MODES.RANGE)) {
        return;
      }

      var target = event.target;

      if (target.tagName !== 'SPAN') {
        return;
      }

      var column = target.parentNode.parentNode.cellIndex;
      var row = target.parentNode.parentNode.parentNode.rowIndex - 1;
      rangeState.endDate = getDateOfCell(row, column);
      onChangeRange(rangeState);
    }
    /**
     * 单元格禁止点击的场景
     * @param target
     */

  }, {
    key: "disabledClick",
    value: function disabledClick(target) {
      if (target.tagName !== 'SPAN') {
        return true;
      }

      if ((0, _utils.hasClass)(target, 'disabled') || (0, _utils.hasClass)(target, 'week')) {
        return true;
      }

      return false;
    }
    /**
     * 单元格点击处理数据
     */

  }, {
    key: "dealDate",
    value: function dealDate(target) {
      var date = this.props.date;

      var _deconstructDate = (0, _utils.deconstructDate)(date),
          year = _deconstructDate.year,
          month = _deconstructDate.month;

      var newDate = new Date(year, month, 1);
      var cellIndex = target.parentNode.parentNode.cellIndex;
      var rowIndex = target.parentNode.parentNode.parentNode.rowIndex - 1;
      var cell = this.getRows()[rowIndex][cellIndex];
      var text = cell.text,
          type = cell.type;

      if (type.indexOf('prev-month') !== -1) {
        if (month === 0) {
          newDate.setFullYear(year - 1);
          newDate.setMonth(11);
        } else {
          newDate.setMonth(month - 1);
        }
      } else if (type.indexOf('next-month') !== -1) {
        if (month === 11) {
          newDate.setFullYear(year + 1);
          newDate.setMonth(0);
        } else {
          newDate.setMonth(month + 1);
        }
      }

      newDate.setDate(parseInt(text, 10));
      return newDate;
    }
    /**
     * 单元格点击
     * @param event
     */

  }, {
    key: "handleClick",
    value: function handleClick(event) {
      var target = event.target;

      if (this.disabledClick(target)) {
        return;
      }

      var _this$props5 = this.props,
          type = _this$props5.type,
          rangeState = _this$props5.rangeState,
          showTime = _this$props5.showTime,
          onPicked = _this$props5.onPicked,
          minDate = _this$props5.minDate,
          maxDate = _this$props5.maxDate;
      var newDate = this.dealDate(target);
      /**
       * 没有时间选择器时，选中之后自动收起,如果是范围选择，选中两个之后收起，如果不是，直接收起
       */

      if (type === _utils.SELECTION_MODES.RANGE) {
        if (!rangeState.selecting) {
          onPicked({
            minDate: (0, _utils.toDate)(newDate),
            maxDate: null
          }, typeof showTime === 'boolean' ? showTime : false);
        } else {
          onPicked({
            minDate: minDate,
            maxDate: maxDate
          }, typeof showTime === 'boolean' ? showTime : true);
        }
      } else if (type === _utils.SELECTION_MODES.DATE || type === _utils.SELECTION_MODES.WEEK) {
        onPicked({
          date: newDate
        }, typeof showTime === 'boolean' ? showTime : false);
      }
    }
    /**
     * 日期表格渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var type = this.props.type;
      return /*#__PURE__*/React.createElement("table", {
        cellSpacing: "0",
        cellPadding: "0",
        onClick: this.handleClick,
        onMouseMove: this.handleMouseMove,
        className: (0, _classnames.default)('rd-date-table', {
          'is-week-mode': type === 'week'
        })
      }, /*#__PURE__*/React.createElement("tbody", null, /*#__PURE__*/React.createElement("tr", null, this.WEEKS().map(function (e, idx) {
        return /*#__PURE__*/React.createElement("th", {
          key: idx
        }, _locale.default.t("rd.datepicker.weeks.".concat(e)));
      })), this.getMarkedRangeRows().map(function (row, idx) {
        return /*#__PURE__*/React.createElement("tr", {
          key: idx,
          className: (0, _classnames.default)('rd-date-table__row', {
            'current': row.isWeekActive
          })
        }, row.map(function (cell, idx) {
          return /*#__PURE__*/React.createElement("td", {
            className: _this4.getCellClasses(cell),
            key: idx
          }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", {
            className: (0, _classnames.default)({
              'disabled': cell.disabled
            })
          }, cell.text)));
        }));
      })));
    }
  }]);
  return DateTable;
}(React.Component), _class2.defaultProps = {
  /**周起始数，默认周末开头 */
  firstDayOfWeek: 7
}, _class2)) || _class;

exports.default = DateTable;