"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _utils = require("../utils");

var _locale = _interopRequireDefault(require("../../locale"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MonthTable = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(MonthTable, _React$Component);

  var _super = _createSuper(MonthTable);

  /**
   * 构造函数
   * @param props 
   */
  function MonthTable(props) {
    (0, _classCallCheck2.default)(this, MonthTable);
    return _super.call(this, props);
  }
  /**
   * 单元格样式
   * @param month 
   */


  (0, _createClass2.default)(MonthTable, [{
    key: "getCellStyle",
    value: function getCellStyle(month) {
      var _this$props = this.props,
          date = _this$props.date,
          disabledDate = _this$props.disabledDate,
          value = _this$props.value;
      var style = {};
      var ndate = new Date(date);
      ndate.setMonth(month);
      style.disabled = typeof disabledDate === 'function' && disabledDate(ndate);
      style.current = value && (0, _utils.deconstructDate)(value).year === (0, _utils.deconstructDate)(ndate).year && (0, _utils.deconstructDate)(value).month === month;
      return style;
    }
    /**
     * 单元格点击
     * @param event 
     */

  }, {
    key: "handleMonthTableClick",
    value: function handleMonthTableClick(event) {
      var target = event.target;

      if (target.tagName !== 'A') {
        return;
      }

      if ((0, _utils.hasClass)(target.parentNode.parentNode, 'disabled')) {
        return;
      }

      var column = target.parentNode.parentNode.cellIndex;
      var row = target.parentNode.parentNode.parentNode.rowIndex;
      var month = row * 4 + column;
      this.props.onPicked(month);
    }
    /**
     * 月表格渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var months = ['jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul', 'aug', 'sep', 'oct', 'nov', 'dec'];
      var now = new Date();
      var date = this.props.date;
      return /*#__PURE__*/React.createElement("table", {
        onClick: this.handleMonthTableClick,
        className: "rd-month-table"
      }, /*#__PURE__*/React.createElement("tbody", null, months.map(function (key, idx) {
        var isToday = false;

        if (now.getMonth() === idx && now.getFullYear() === date.getFullYear()) {
          isToday = true;
        }

        return /*#__PURE__*/React.createElement("td", {
          className: (0, _classnames.default)(_this.getCellStyle(idx), {
            'today': isToday
          }),
          key: idx
        }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("a", {
          className: "cell"
        }, _locale.default.t("rd.datepicker.months.".concat(key)))));
      }).reduce(function (col, item) {
        if (!(Array.isArray(col[0]) && col[0].length !== 4)) {
          col.unshift([]);
        }

        var tararr = col[0];
        tararr.push(item);
        return col;
      }, []).reverse().map(function (e, idx) {
        return /*#__PURE__*/React.createElement("tr", {
          key: idx
        }, e);
      })));
    }
  }]);
  return MonthTable;
}(React.Component)) || _class;

exports.default = MonthTable;