/**
 * 时间选中面板内容
 */
import * as React from 'react';
import { D, S, TimePickerProps, TimeType, TimeStr } from '../Types';
export declare type TimeSpinnerTypes = TimePickerProps<D, S> & {
    range?: Array<Date>;
    onChanged?: (date: TimeType) => void;
    hours?: number;
    minutes?: number;
    seconds?: number;
    showSeconds?: boolean;
};
declare type State = {
    hoursList?: boolean[];
    minutesList?: boolean[];
    secondsList?: boolean[];
    hours?: number;
    minutes?: number;
    seconds?: number;
};
export default class TimeSpinner extends React.Component<TimeSpinnerTypes, State> {
    private hours;
    private minutes;
    private seconds;
    /**
     * 默认props值
     */
    static get defaultProps(): TimeSpinnerTypes;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: TimeSpinnerTypes);
    /**
     * 第一次渲染快速跳至时间刻度，不用显示动画效果，动画时间缩短为10
     */
    componentDidMount(): void;
    /**
     * 对象比较
     * @param a
     * @param b
     */
    objComparise(a: any, b: any): boolean;
    /**
        * 更新完成后滚动时间刻度
        */
    componentDidUpdate(prevProps: TimeSpinnerTypes, prevState: State): void;
    /**
     * 更新render
     * @returns any
     */
    propsToState(): State;
    /**
     * 计算滚动的距离
     * @param value number 处于第几个li 32为每个li的高度
     * @returns number
     */
    calcScrollTop(value: number): number;
    /**
     * 时分秒改变的函数
     * @param type type: hours, minutes, seconds
     * @param value
     * @param disabled
     */
    handleChange(type: TimeStr, value: number, disabled?: boolean): void;
    /**
     * 时分秒滚动执行函数
     * @param param0
     * @param duration
     */
    ajustScrollTop({ hours, minutes, seconds }: {
        hours?: number;
        minutes?: number;
        seconds?: number;
    }, duration?: number): void;
    /**
     * 时间选择渲染
     */
    render(): React.ReactNode;
}
export {};
