"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _class;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var YearTable = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(YearTable, _React$Component);

  var _super = _createSuper(YearTable);

  function YearTable() {
    (0, _classCallCheck2.default)(this, YearTable);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(YearTable, [{
    key: "getCellStyle",
    value:
    /**
     * 单元格样式
     * 添加是否(禁用，当前选中，今天)样式
     * @param year
     */
    function getCellStyle(year) {
      var _this$props = this.props,
          disabledDate = _this$props.disabledDate,
          value = _this$props.value,
          date = _this$props.date;
      var style = {};
      var ndate = new Date(date);
      ndate.setFullYear(year);
      style.disabled = typeof disabledDate === 'function' && disabledDate(ndate);
      style.current = value && (0, _utils.deconstructDate)(value).year === year;
      style.today = (0, _utils.deconstructDate)(new Date()).year === year;
      return style;
    }
    /**
      * 单元格点击，如果a标签上存在disabled样式，则不能点击
      * @param event
      */

  }, {
    key: "handleYearTableClick",
    value: function handleYearTableClick(event) {
      var tag = event.target;

      if (tag.tagName === 'A') {
        if ((0, _utils.hasClass)(tag.parentNode.parentNode, 'disabled')) {
          return;
        }

        var year = tag.textContent || tag.innerText;
        var onPicked = this.props.onPicked; //+year强制转换成number类型

        onPicked(+year);
      }
    }
    /**
     * 年表格渲染
     */

  }, {
    key: "render",
    value: function render() {
      var date = this.props.date;
      /**取0-9的十年 */

      var startYear = Math.floor((0, _utils.deconstructDate)(date).year / 10) * 10;
      return /*#__PURE__*/_react.default.createElement("table", {
        onClick: this.handleYearTableClick,
        className: "rd-year-table"
      }, /*#__PURE__*/_react.default.createElement("tbody", null, /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 0))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear)), /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 1))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 1)), /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 2))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 2)), /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 3))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 3))), /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 4))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 4)), /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 5))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 5)), /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 6))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 6)), /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 7))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 7))), /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 8))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 8)), /*#__PURE__*/_react.default.createElement("td", {
        className: (0, _classnames.default)('available', this.getCellStyle(startYear + 9))
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "cell"
      }, startYear + 9)), /*#__PURE__*/_react.default.createElement("td", null), /*#__PURE__*/_react.default.createElement("td", null))));
    }
  }]);
  return YearTable;
}(_react.default.Component)) || _class;

exports.default = YearTable;