import React from 'react';
import { D, DatePickerProps, S } from '../Types';
declare type Props = DatePickerProps<D, S> & {
    showTime?: boolean;
    onPicked: (value: D, isKeepPannel?: boolean) => void;
};
declare type State = {
    date: Date;
    currentView?: string;
    timePickerVisible?: boolean;
    _prevProps?: Props;
};
export default class DatePanel extends React.Component<Props, State> {
    date: Date;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: Props);
    /**
 * props更新同步
 * @param nextProps
 */
    static getDerivedStateFromProps(nextProps: Props, prevState: State): State;
    /**
     * 重置数据
     */
    resetDate(): void;
    /**
     * 显示月表格面板
     */
    showMonthPicker(): void;
    /**
     * 显示年表格面板
     */
    showYearPicker(): void;
    /**
     * 上个月回调计算
     */
    prevMonth(): void;
    /**
     * 下个月回调计算
     */
    nextMonth(): void;
    /**
     * 下一年计算
     */
    nextYear(): void;
    /**
     * 上一年计算
     */
    prevYear(): void;
    /**
     * 时间选择器点击回调
     * @param pickedDate
     * @param isKeepPanel
     */
    handleTimePick(pickedDate: Date, isKeepPanel: boolean): void;
    /**
     * 月面板点击回调
     * @param month
     */
    handleMonthPick(month: number): void;
    /**
     * 日期面板点击回调
     * @param value
     */
    handleDatePick(value: any): void;
    /**
     * 年面板点击回调
     */
    handleYearPick(year: number): void;
    /**
     * 点击确认回调
     */
    confirm(): void;
    /**
     * 清空面板选择数据
     */
    clear(): void;
    /**重置面板数据 */
    resetView(): void;
    /**
     * 年顶部显示数据
     */
    yearLabel(): string;
    /**
     * 切换时间显示隐藏函数
     */
    timePickerVisibleChange(): void;
    /**
     * 获取显示时间
     */
    get visibleTime(): string;
    /**
     * 设置显示时间
     * return Date
     */
    set visibleTime(val: string);
    /**
     * 获取显示日期
     */
    get visibleDate(): string;
    /**
     * 设置显示日期
     */
    set visibleDate(val: string);
    /**
     * 获取时间格式化数据
     */
    get timeFormat(): string;
    /**
     * 获取日期格式化数据
     */
    get dateFormat(): string;
    /**
     * 面板具体显示内容
     */
    _pickerContent(): React.ReactNode;
    /**
     * 日期面板渲染
     */
    render(): React.ReactNode;
}
export {};
