"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _locale = _interopRequireDefault(require("../../locale"));

var _TimePanel = _interopRequireDefault(require("./TimePanel"));

var _utils = require("../utils");

var _basic = require("../basic");

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _button = _interopRequireDefault(require("../../button"));

var _class;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var PICKER_VIEWS = {
  YEAR: 'year',
  MONTH: 'month',
  DATE: 'date'
};

var DatePanel = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(DatePanel, _React$Component);

  var _super = _createSuper(DatePanel);

  /**
   * 构造函数
   * @param props 
   */
  function DatePanel(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DatePanel);
    _this = _super.call(this, props);
    _this.date = void 0;
    var currentView = PICKER_VIEWS.DATE;

    switch (props.type) {
      case _utils.SELECTION_MODES.MONTH:
        currentView = PICKER_VIEWS.MONTH;
        break;

      case _utils.SELECTION_MODES.YEAR:
        currentView = PICKER_VIEWS.YEAR;
        break;
    }

    var date = (0, _utils.getDefaultDate)();

    if (props.value) {
      date = new Date(props.value);
    }

    _this.state = {
      currentView: currentView,
      timePickerVisible: false,
      date: date
    };
    return _this;
  }
  /**
  * props更新同步
  * @param nextProps 
  */


  (0, _createClass2.default)(DatePanel, [{
    key: "resetDate",
    value:
    /**
     * 重置数据
     */
    function resetDate() {
      this.date = new Date(this.date);
    }
    /**
     * 显示月表格面板
     */

  }, {
    key: "showMonthPicker",
    value: function showMonthPicker() {
      this.setState({
        currentView: PICKER_VIEWS.MONTH
      });
    }
    /**
     * 显示年表格面板
     */

  }, {
    key: "showYearPicker",
    value: function showYearPicker() {
      this.setState({
        currentView: PICKER_VIEWS.YEAR
      });
    }
    /**
     * 上个月回调计算
     */

  }, {
    key: "prevMonth",
    value: function prevMonth() {
      var date = this.state.date;

      var _deconstructDate = (0, _utils.deconstructDate)(date),
          month = _deconstructDate.month,
          year = _deconstructDate.year;

      date.setMonth(month, 1);

      if (month === 0) {
        date.setFullYear(year - 1);
        date.setMonth(11);
      } else {
        date.setMonth(month - 1);
      }

      this.setState({
        date: date
      });
    }
    /**
     * 下个月回调计算
     */

  }, {
    key: "nextMonth",
    value: function nextMonth() {
      var date = this.state.date;

      var _deconstructDate2 = (0, _utils.deconstructDate)(date),
          month = _deconstructDate2.month,
          year = _deconstructDate2.year;

      date.setMonth(month, 1);

      if (month === 11) {
        date.setFullYear(year + 1);
        date.setMonth(0);
      } else {
        date.setMonth(month + 1);
      }

      this.setState({
        date: date
      });
    }
    /**
     * 下一年计算
     */

  }, {
    key: "nextYear",
    value: function nextYear() {
      var _this$state = this.state,
          date = _this$state.date,
          currentView = _this$state.currentView;

      var _deconstructDate3 = (0, _utils.deconstructDate)(date),
          year = _deconstructDate3.year;

      if (currentView === 'year') {
        date.setFullYear(year + 10);
      } else {
        date.setFullYear(year + 1);
      }

      this.setState({
        date: date
      });
    }
    /**
     * 上一年计算
     */

  }, {
    key: "prevYear",
    value: function prevYear() {
      var _this$state2 = this.state,
          date = _this$state2.date,
          currentView = _this$state2.currentView;

      var _deconstructDate4 = (0, _utils.deconstructDate)(date),
          year = _deconstructDate4.year;

      if (currentView === 'year') {
        date.setFullYear(year - 10);
      } else {
        date.setFullYear(year - 1);
      }

      this.setState({
        date: date
      });
    }
    /**
     * 时间选择器点击回调
     * @param pickedDate 
     * @param isKeepPanel 
     */

  }, {
    key: "handleTimePick",
    value: function handleTimePick(pickedDate, isKeepPanel) {
      var state = this.state;

      if (pickedDate) {
        var oldDate = this.state.date;
        oldDate.setHours(pickedDate.getHours());
        oldDate.setMinutes(pickedDate.getMinutes());
        oldDate.setSeconds(pickedDate.getSeconds());
      }

      this.setState(_objectSpread(_objectSpread({}, state), {}, {
        timePickerVisible: isKeepPanel
      }));
    }
    /**
     * 月面板点击回调
     * @param month 
     */

  }, {
    key: "handleMonthPick",
    value: function handleMonthPick(month) {
      var date = this.state.date;
      var _this$props = this.props,
          type = _this$props.type,
          onPicked = _this$props.onPicked;

      var _deconstructDate5 = (0, _utils.deconstructDate)(date),
          year = _deconstructDate5.year;

      if (type !== _utils.SELECTION_MODES.MONTH) {
        date.setMonth(month);
        this.setState({
          date: date,
          currentView: PICKER_VIEWS.DATE
        });
      } else {
        date.setMonth(month);
        date.setFullYear(year);
        onPicked(new Date(year, month, 1));
      }
    }
    /**
     * 日期面板点击回调
     * @param value 
     */

  }, {
    key: "handleDatePick",
    value: function handleDatePick(value) {
      var state = this.state;
      var date = state.date;
      var _this$props2 = this.props,
          type = _this$props2.type,
          showTime = _this$props2.showTime,
          onPicked = _this$props2.onPicked;
      var pdate = value.date;

      if (type === _utils.SELECTION_MODES.DATE) {
        onPicked(pdate, showTime);
        date.setTime(pdate.getTime());
      } else if (type === _utils.SELECTION_MODES.WEEK) {
        onPicked(pdate, showTime);
      }

      this.setState(_objectSpread({}, state));
    }
    /**
     * 年面板点击回调
     */

  }, {
    key: "handleYearPick",
    value: function handleYearPick(year) {
      var state = this.state;
      var _this$props3 = this.props,
          onPicked = _this$props3.onPicked,
          type = _this$props3.type;
      var date = state.date;
      date.setFullYear(year);

      if (type === _utils.SELECTION_MODES.YEAR) {
        onPicked(new Date(year, 0));
      } else {
        this.setState({
          currentView: PICKER_VIEWS.MONTH
        });
      }
    }
    /**
     * 点击确认回调
     */

  }, {
    key: "confirm",
    value: function confirm() {
      this.props.onPicked(new Date(this.state.date.getTime()));
    }
    /**
     * 清空面板选择数据
     */

  }, {
    key: "clear",
    value: function clear() {
      this.props.onPicked(null);
    }
    /**重置面板数据 */

  }, {
    key: "resetView",
    value: function resetView() {
      var type = this.props.type;
      var state = this.state;
      var newCurrentView = state.currentView;

      if (type === _utils.SELECTION_MODES.MONTH) {
        newCurrentView = PICKER_VIEWS.MONTH;
      } else if (type === _utils.SELECTION_MODES.YEAR) {
        newCurrentView = PICKER_VIEWS.YEAR;
      } else {
        newCurrentView = PICKER_VIEWS.DATE;
      }

      this.setState({
        currentView: newCurrentView
      });
    }
    /**
     * 年顶部显示数据
     */

  }, {
    key: "yearLabel",
    value: function yearLabel() {
      var _this$state3 = this.state,
          currentView = _this$state3.currentView,
          date = _this$state3.date;

      var _deconstructDate6 = (0, _utils.deconstructDate)(date),
          year = _deconstructDate6.year;

      var yearTranslation = _locale.default.t('rd.datepicker.year');

      if (currentView === 'year') {
        var startYear = Math.floor(year / 10) * 10;

        if (yearTranslation) {
          return startYear + ' ' + yearTranslation + '-' + (startYear + 9) + ' ' + yearTranslation;
        }

        return startYear + ' - ' + (startYear + 9);
      }

      return year + ' ' + yearTranslation;
    }
    /**
     * 切换时间显示隐藏函数
     */

  }, {
    key: "timePickerVisibleChange",
    value: function timePickerVisibleChange() {
      this.setState({
        timePickerVisible: !this.state.timePickerVisible
      });
    }
    /**
     * 获取显示时间
     */

  }, {
    key: "visibleTime",
    get: function get() {
      return (0, _utils.formatDate)(this.state.date, this.timeFormat);
    }
    /**
     * 设置显示时间
     * return Date
     */
    ,
    set: function set(val) {
      if (val) {
        var ndate = (0, _utils.parseDate)(val, this.timeFormat);
        var date = this.state.date;

        if (ndate) {
          ndate.setFullYear(date.getFullYear());
          ndate.setMonth(date.getMonth());
          ndate.setDate(date.getDate());
          this.setState({
            date: ndate,
            timePickerVisible: false
          });
        }
      }
    }
    /**
     * 获取显示日期
     */

  }, {
    key: "visibleDate",
    get: function get() {
      return (0, _utils.formatDate)(this.state.date, this.dateFormat);
    }
    /**
     * 设置显示日期
     */
    ,
    set: function set(val) {
      var ndate = (0, _utils.parseDate)(val, this.dateFormat);

      if (!ndate) {
        return;
      }

      var disabledDate = this.props.disabledDate;
      var date = this.state.date;

      if (typeof disabledDate === 'function' && disabledDate(ndate)) {
        return;
      }

      ndate.setHours(date.getHours());
      ndate.setMinutes(date.getMinutes());
      ndate.setSeconds(date.getSeconds());
      this.setState({
        date: ndate
      });
      this.resetView();
    }
    /**
     * 获取时间格式化数据
     */

  }, {
    key: "timeFormat",
    get: function get() {
      var format = this.props.format;

      if (format && format.indexOf('ss') === -1) {
        return 'HH:mm';
      } else {
        return 'HH:mm:ss';
      }
    }
    /**
     * 获取日期格式化数据
     */

  }, {
    key: "dateFormat",
    get: function get() {
      if (this.props.format) {
        return this.props.format.replace('HH:mm', '').replace(':ss', '').trim();
      } else {
        return 'yyyy-MM-dd';
      }
    }
    /**
     * 面板具体显示内容
     */

  }, {
    key: "_pickerContent",
    value: function _pickerContent() {
      var _this$props4 = this.props,
          value = _this$props4.value,
          type = _this$props4.type,
          disabledDate = _this$props4.disabledDate,
          firstDayOfWeek = _this$props4.firstDayOfWeek;
      var date = this.state.date;
      var currentView = this.state.currentView;
      var result = null;

      switch (currentView) {
        case PICKER_VIEWS.DATE:
          result = /*#__PURE__*/_react.default.createElement(_basic.DateTable, (0, _extends2.default)({}, this.props, {
            onPicked: this.handleDatePick,
            date: date,
            value: value,
            type: type,
            disabledDate: disabledDate,
            firstDayOfWeek: firstDayOfWeek
          }));
          break;

        case PICKER_VIEWS.YEAR:
          result = /*#__PURE__*/_react.default.createElement(_basic.YearTable, (0, _extends2.default)({}, this.props, {
            value: value,
            date: date,
            onPicked: this.handleYearPick,
            disabledDate: disabledDate
          }));
          break;

        case PICKER_VIEWS.MONTH:
          result = /*#__PURE__*/_react.default.createElement(_basic.MonthTable, (0, _extends2.default)({}, this.props, {
            value: value,
            date: date,
            onPicked: this.handleMonthPick,
            disabledDate: disabledDate
          }));
          break;

        default:
          throw new Error('invalid currentView value');
      }

      return result;
    }
    /**
     * 日期面板渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          showTime = _this$props5.showTime,
          showTopText = _this$props5.showTopText;
      var _this$state4 = this.state,
          currentView = _this$state4.currentView,
          date = _this$state4.date,
          timePickerVisible = _this$state4.timePickerVisible;

      var _deconstructDate7 = (0, _utils.deconstructDate)(date),
          month = _deconstructDate7.month;

      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, timePickerVisible && /*#__PURE__*/_react.default.createElement(_TimePanel.default, {
        currentDate: new Date(date.getTime()),
        onPicked: this.handleTimePick,
        format: this.timeFormat,
        showTime: true,
        visibleChange: this.timePickerVisibleChange,
        onCancel: function onCancel() {
          return _this2.setState({
            timePickerVisible: false
          });
        }
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)('rd-picker-panel rd-date-picker', {
          'has-time': showTime,
          'is-hide': timePickerVisible
        })
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-picker-panel__body-wrapper"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-picker-panel__body"
      }, currentView !== 'time' && /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-date-picker__header"
      }, /*#__PURE__*/_react.default.createElement("button", {
        type: "button",
        onClick: this.prevYear,
        className: "rd-picker-panel__icon-btn rd-date-picker__prev-btn rd-icon-d-arrow-left"
      }, "\xAB"), currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react.default.createElement("button", {
        type: "button",
        onClick: this.prevMonth,
        className: "rd-picker-panel__icon-btn rd-date-picker__prev-btn rd-icon-arrow-left"
      }, "\u2039"), /*#__PURE__*/_react.default.createElement("span", {
        onClick: this.showYearPicker,
        className: "rd-date-picker__header-label"
      }, this.yearLabel()), currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react.default.createElement("span", {
        onClick: this.showMonthPicker,
        className: (0, _classnames.default)('rd-date-picker__header-label', {
          active: currentView === 'month'
        })
      }, _locale.default.t("rd.datepicker.month".concat(month + 1))), /*#__PURE__*/_react.default.createElement("button", {
        type: "button",
        onClick: this.nextYear,
        className: "rd-picker-panel__icon-btn rd-date-picker__next-btn rd-icon-d-arrow-right"
      }, "\xBB"), currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react.default.createElement("button", {
        type: "button",
        onClick: this.nextMonth,
        className: "rd-picker-panel__icon-btn rd-date-picker__next-btn rd-icon-arrow-right"
      }, "\u203A")), /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)('rd-picker-panel__content')
      }, this._pickerContent()))), showTime && currentView === PICKER_VIEWS.DATE && /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-picker-panel__footer"
      }, showTopText && /*#__PURE__*/_react.default.createElement(_button.default, {
        text: true,
        className: "rd-picker-panel__choose",
        onClick: this.timePickerVisibleChange
      }, _locale.default.t('rd.datepicker.selectTime')), /*#__PURE__*/_react.default.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        onClick: function onClick() {
          return _this2.clear();
        }
      }, _locale.default.t('rd.datepicker.clear')), /*#__PURE__*/_react.default.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        type: "primary",
        onClick: function onClick() {
          return _this2.confirm();
        }
      }, _locale.default.t('rd.datepicker.confirm')))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newDate = (0, _utils.toDate)(nextProps.value || (0, _utils.getDefaultDate)());

      if (prevState._prevProps && prevState._prevProps.value === nextProps.value) {
        newDate = prevState.date;
      }

      return _objectSpread(_objectSpread({}, nextProps), {}, {
        date: newDate,
        _prevProps: nextProps
      });
    }
  }]);
  return DatePanel;
}(_react.default.Component)) || _class;

exports.default = DatePanel;