import * as React from 'react';
import { DatePickerProps, DS, SS } from '../Types';
declare type Props = DatePickerProps<DS, SS> & {
    showTime?: boolean;
    onPicked: (value: DS, isKeepPannel: boolean) => void;
};
export declare type RangeState = {
    date?: Date;
    rightDate?: Date;
    minDate?: Date;
    maxDate?: Date;
    rangeState?: {
        endDate: Date;
        selecting?: boolean;
    };
    timePickerVisible?: boolean;
};
export default class DateRangePanel extends React.Component<Props, RangeState> {
    minDate: Date;
    maxDate: Date;
    minDay: Date;
    panelClickMinDate: Date;
    /**
     *
     * @param props 构造函数
     */
    constructor(props: Props);
    /**
     *
     */
    componentDidMount(): void;
    /**
     * 范围面板点击回调
     */
    handleRangePick({ minDate, maxDate }: {
        minDate: Date;
        maxDate: Date;
    }, isClose: boolean): void;
    /**
     * 上一年计算
     */
    prevYear(flag?: null | 'date' | 'rightDate'): void;
    /**
     * 下一年计算
     * @param flag
     */
    nextYear(flag?: null | 'date' | 'rightDate'): void;
    /**
     * 上个月计算
     * @param flag
     */
    prevMonth(flag?: null | 'date' | 'rightDate'): void;
    /**
     *
     * @param flag 下个月计算
     */
    nextMonth(flag?: null | 'date' | 'rightDate'): void;
    /**
     * 获取右边面板数据
     */
    get rightDate(): Date;
    /**
     * 获取时间格式化
     */
    get timeFormat(): string;
    /**
     *
     * @param param0 范围改变的回调
     */
    handleChangeRange({ endDate }: {
        endDate: Date;
    }): void;
    /**
     * 获取最小数据
     */
    get minVisibleDate(): string;
    /**
     * 获取最大数据
     */
    get maxVisibleDate(): string;
    /**
     * 获取最小时间
     */
    get minVisibleTime(): string;
    /**
     * 获取最大时间
     */
    get maxVisibleTime(): string;
    /**
     * 按钮是否可点击
     */
    get btnDisabled(): boolean;
    /**
     * 设置时间
     * @param date
     * @param value
     */
    setTime(date: Date, value: Date): Date;
    /**
     * 时间面板点击的回调
     * @param pickedDate
     * @param isKeepPanel
     */
    handleTimePick(pickedDate: Date[], isKeepPanel: boolean): void;
    /**
     * 清除按钮点击的回调
     */
    handleClear(): void;
    /**
     * 点击确认的回调
     */
    handleConfirm(): void;
    /**
     * 月按钮是否可点击
     */
    enableMonthArrow(): boolean;
    /**
     * 年按钮是否可点击
     */
    enableYearArrow(): boolean;
    /**
     * 时间面板的显示隐藏切换
     */
    timePickerVisibleChange(): void;
    /**
     * 范围时间选择器渲染
     */
    render(): React.ReactNode;
}
export {};
