"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _locale = _interopRequireDefault(require("../../locale"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("../utils");

var _basic = require("../basic");

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _button = _interopRequireDefault(require("../../button"));

var _TimeRangePanel = _interopRequireDefault(require("./TimeRangePanel"));

var _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * 上一年
 * @param date 
 */
var _prevYear = function prevYear(date) {
  var d = (0, _utils.toDate)(date);
  d.setFullYear(date.getFullYear() - 1);
  return d;
};
/**
 * 下一年
 * @param date 
 */


var _nextYear = function nextYear(date) {
  var d = (0, _utils.toDate)(date);
  d.setFullYear(date.getFullYear() + 1);
  return d;
};
/**
 * props=》state
 * @param props 
 */


var mapPropsToState = function mapPropsToState(props) {
  var value = props.value;
  var state = {
    rangeState: {
      endDate: null
    }
  };

  if (!value) {
    state = _objectSpread(_objectSpread({}, state), {
      minDate: null,
      maxDate: null,
      date: new Date()
    });
  } else {
    if (value[0] && value[1]) {
      state.minDate = (0, _utils.toDate)(value[0]);
      state.maxDate = (0, _utils.toDate)(value[1]);
    }

    if (value[0]) {
      state.date = (0, _utils.toDate)(value[0]);
    } else {
      state.date = new Date();
    }
  }

  return state;
};

var DateRangePanel = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(DateRangePanel, _React$Component);

  var _super = _createSuper(DateRangePanel);

  /**
   * 
   * @param props 构造函数
   */
  function DateRangePanel(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DateRangePanel);
    _this = _super.call(this, props);
    _this.minDate = void 0;
    _this.maxDate = void 0;
    _this.minDay = void 0;
    _this.panelClickMinDate = void 0;
    _this.state = _objectSpread(_objectSpread({}, {
      timePickerVisible: false
    }), mapPropsToState(props));
    return _this;
  }
  /**
   * 
   */


  (0, _createClass2.default)(DateRangePanel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState({
        rightDate: (0, _utils.nextMonth)(this.state.date)
      });
    }
    /**
     * 范围面板点击回调
     */

  }, {
    key: "handleRangePick",
    value: function handleRangePick(_ref, isClose) {
      var minDate = _ref.minDate,
          maxDate = _ref.maxDate;
      var _this$props = this.props,
          showTime = _this$props.showTime,
          onPicked = _this$props.onPicked;
      /**当第一次点击面板时，设置最小值或者最大值 */

      if (!maxDate) {
        this.panelClickMinDate = minDate;
        this.setState({
          rangeState: {
            endDate: maxDate,
            selecting: true
          },
          minDate: minDate,
          maxDate: maxDate
        });
      } else {
        this.setState({
          rangeState: {
            endDate: maxDate,
            selecting: false
          },
          minDate: minDate,
          maxDate: maxDate
        });
      }

      if (!isClose) {
        return;
      }

      if (!showTime) {
        onPicked([minDate, maxDate], false);
      }
    }
    /**
     * 上一年计算
     */

  }, {
    key: "prevYear",
    value: function prevYear(flag) {
      flag = flag || 'date';
      this.setState((0, _defineProperty2.default)({}, flag, _prevYear(this.state[flag])));
    }
    /**
     * 下一年计算
     * @param flag 
     */

  }, {
    key: "nextYear",
    value: function nextYear(flag) {
      flag = flag || 'date';
      this.setState((0, _defineProperty2.default)({}, flag, _nextYear(this.state[flag])));
    }
    /**
     * 上个月计算
     * @param flag 
     */

  }, {
    key: "prevMonth",
    value: function prevMonth(flag) {
      flag = flag || 'date';
      this.setState((0, _defineProperty2.default)({}, flag, (0, _utils.prevMonth)(this.state[flag])));
    }
    /**
     * 
     * @param flag 下个月计算
     */

  }, {
    key: "nextMonth",
    value: function nextMonth(flag) {
      flag = flag || 'date';
      this.setState((0, _defineProperty2.default)({}, flag, (0, _utils.nextMonth)(this.state[flag])));
    }
    /**
     * 获取右边面板数据
     */

  }, {
    key: "rightDate",
    get: function get() {
      var rightDate = this.state.rightDate;
      return rightDate || (0, _utils.nextMonth)(this.state.date);
    }
    /**
     * 获取时间格式化
     */

  }, {
    key: "timeFormat",
    get: function get() {
      var format = this.props.format;

      if (format && format.indexOf('ss') === -1) {
        return 'HH:mm';
      } else {
        return 'HH:mm:ss';
      }
    }
    /**
     * 
     * @param param0 范围改变的回调
     */

  }, {
    key: "handleChangeRange",
    value: function handleChangeRange(_ref2) {
      var endDate = _ref2.endDate;
      var rangeState = this.state.rangeState;
      var minDate = this.panelClickMinDate;

      if (minDate && rangeState.selecting) {
        var startDate = minDate;

        if (endDate < minDate) {
          startDate = endDate;
          endDate = minDate;
        }

        rangeState.endDate = endDate;
        this.setState({
          minDate: startDate,
          maxDate: endDate
        });
      }
    }
    /**
     * 获取最小数据
     */

  }, {
    key: "minVisibleDate",
    get: function get() {
      var minDate = this.state.minDate;
      return minDate ? (0, _utils.formatDate)(minDate) : '';
    }
    /**
     * 获取最大数据
     */

  }, {
    key: "maxVisibleDate",
    get: function get() {
      var _this$state = this.state,
          maxDate = _this$state.maxDate,
          minDate = _this$state.minDate;
      var d = maxDate || minDate;
      return d ? (0, _utils.formatDate)(d) : '';
    }
    /**
     * 获取最小时间
     */

  }, {
    key: "minVisibleTime",
    get: function get() {
      var minDate = this.state.minDate;
      return minDate ? (0, _utils.formatDate)(minDate, 'HH:mm:ss') : '';
    }
    /**
     * 获取最大时间
     */

  }, {
    key: "maxVisibleTime",
    get: function get() {
      var _this$state2 = this.state,
          maxDate = _this$state2.maxDate,
          minDate = _this$state2.minDate;
      var d = maxDate || minDate;
      return d ? (0, _utils.formatDate)(d, 'HH:mm:ss') : '';
    }
    /**
     * 按钮是否可点击
     */

  }, {
    key: "btnDisabled",
    get: function get() {
      var _this$state3 = this.state,
          minDate = _this$state3.minDate,
          maxDate = _this$state3.maxDate;
      return !(minDate && maxDate);
    }
    /**
     * 设置时间
     * @param date 
     * @param value 
     */

  }, {
    key: "setTime",
    value: function setTime(date, value) {
      var oldDate = new Date(date.getTime());
      var hour = value.getHours();
      var minute = value.getMinutes();
      var second = value.getSeconds();
      oldDate.setHours(hour);
      oldDate.setMinutes(minute);
      oldDate.setSeconds(second);
      return new Date(oldDate.getTime());
    }
    /**
     * 时间面板点击的回调
     * @param pickedDate 
     * @param isKeepPanel 
     */

  }, {
    key: "handleTimePick",
    value: function handleTimePick(pickedDate, isKeepPanel) {
      var minDate = this.state.minDate || new Date();
      var maxDate = this.state.maxDate || new Date();

      if (pickedDate) {
        minDate = this.setTime(minDate, pickedDate[0]);
        maxDate = this.setTime(maxDate, pickedDate[1]);
      }
      /**点击time确认后保存在当前示例上 minDate，maxDate */


      this.setState({
        minDate: minDate,
        maxDate: maxDate,
        timePickerVisible: isKeepPanel
      });
    }
    /**
     * 清除按钮点击的回调
     */

  }, {
    key: "handleClear",
    value: function handleClear() {
      var onPicked = this.props.onPicked;
      var minDate = null,
          maxDate = null,
          date = new Date();
      this.setState({
        minDate: minDate,
        maxDate: maxDate,
        date: date
      });
      onPicked([], false);
    }
    /**
     * 点击确认的回调
     */

  }, {
    key: "handleConfirm",
    value: function handleConfirm() {
      var _this$state4 = this.state,
          minDate = _this$state4.minDate,
          maxDate = _this$state4.maxDate;
      this.props.onPicked([minDate, maxDate], false);
    }
    /**
     * 月按钮是否可点击
     */

  }, {
    key: "enableMonthArrow",
    value: function enableMonthArrow() {
      var date = this.state.date;
      var rightDate = this.rightDate;
      var leftMonth = date.getMonth();
      var leftYear = date.getFullYear();
      var rightYear = rightDate.getFullYear();
      var rightMonth = rightDate.getMonth();
      var nextMonth = (leftMonth + 1) % 12;
      var yearOffset = leftMonth + 1 >= 12 ? 1 : 0;
      return new Date(leftYear + yearOffset, nextMonth) < new Date(rightYear, rightMonth);
    }
    /**
     * 年按钮是否可点击
     */

  }, {
    key: "enableYearArrow",
    value: function enableYearArrow() {
      var date = this.state.date;
      var rightDate = this.rightDate;
      var leftMonth = date.getMonth();
      var leftYear = date.getFullYear();
      var rightYear = rightDate.getFullYear();
      var rightMonth = rightDate.getMonth();
      return rightYear * 12 + rightMonth - (leftYear * 12 + leftMonth + 1) >= 12;
    }
    /**
     * 时间面板的显示隐藏切换
     */

  }, {
    key: "timePickerVisibleChange",
    value: function timePickerVisibleChange() {
      this.setState({
        timePickerVisible: !this.state.timePickerVisible
      });
    }
    /**
     * 范围时间选择器渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          disabledDate = _this$props2.disabledDate,
          firstDayOfWeek = _this$props2.firstDayOfWeek,
          showTime = _this$props2.showTime,
          showTopText = _this$props2.showTopText;
      var _this$state5 = this.state,
          date = _this$state5.date,
          rangeState = _this$state5.rangeState,
          minDate = _this$state5.minDate,
          maxDate = _this$state5.maxDate,
          timePickerVisible = _this$state5.timePickerVisible;
      var rightDate = this.rightDate;

      var leftLabel = "".concat(date.getFullYear(), " ").concat(_locale.default.t('rd.datepicker.year'), " ") + _locale.default.t("rd.datepicker.month".concat(date.getMonth() + 1));

      var rightLabel = "".concat(rightDate.getFullYear(), " ").concat(_locale.default.t('rd.datepicker.year'), " ") + _locale.default.t("rd.datepicker.month".concat(rightDate.getMonth() + 1));

      var enableMonthArrow = this.enableMonthArrow();
      var enableYearArrow = this.enableYearArrow();
      return /*#__PURE__*/React.createElement(React.Fragment, null, timePickerVisible && /*#__PURE__*/React.createElement(_TimeRangePanel.default, (0, _extends2.default)({}, this.props, {
        currentDates: [minDate, maxDate],
        onPicked: this.handleTimePick,
        showTime: true,
        visibleChange: this.timePickerVisibleChange,
        onCancel: function onCancel() {
          return _this2.setState({
            timePickerVisible: false
          });
        }
      })), /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-picker-panel rd-date-range-picker', {
          'has-time': showTime,
          'is-hide': timePickerVisible
        })
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-picker-panel__body-wrapper"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-picker-panel__body"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-picker-panel__content rd-date-range-picker__content is-left"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-date-range-picker__header"
      }, /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.prevYear();
        },
        className: "rd-picker-panel__icon-btn rd-icon-d-arrow-left"
      }, "\xAB"), /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.prevMonth();
        },
        className: "rd-picker-panel__icon-btn rd-icon-arrow-left"
      }, "\u2039"), /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.nextYear();
        },
        disabled: !enableYearArrow,
        className: (0, _classnames.default)("rd-picker-panel__icon-btn", "rd-icon-d-arrow-right", {
          'is-disabled': !enableYearArrow
        })
      }, "\xBB"), /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.nextMonth();
        },
        disabled: !enableMonthArrow,
        className: (0, _classnames.default)("rd-picker-panel__icon-btn", "rd-icon-arrow-right", {
          'is-disabled': !enableMonthArrow
        })
      }, "\u203A"), /*#__PURE__*/React.createElement("div", null, leftLabel)), /*#__PURE__*/React.createElement(_basic.DateTable, (0, _extends2.default)({}, this.props, {
        selectionMode: _utils.SELECTION_MODES.RANGE,
        date: date,
        value: minDate,
        minDate: minDate,
        maxDate: maxDate,
        rangeState: rangeState,
        disabledDate: disabledDate,
        onChangeRange: this.handleChangeRange,
        onPicked: this.handleRangePick,
        firstDayOfWeek: firstDayOfWeek
      }))), /*#__PURE__*/React.createElement("div", {
        className: "rd-picker-panel__content rd-date-range-picker__content is-right"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-date-range-picker__header"
      }, /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.prevYear('rightDate');
        },
        disabled: !enableYearArrow,
        className: (0, _classnames.default)("rd-picker-panel__icon-btn", "rd-icon-d-arrow-left", {
          'is-disabled': !enableYearArrow
        })
      }, "\xAB"), /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.prevMonth('rightDate');
        },
        disabled: !enableMonthArrow,
        className: (0, _classnames.default)("rd-picker-panel__icon-btn", "rd-icon-arrow-left", {
          'is-disabled': !enableMonthArrow
        })
      }, "\u2039"), /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.nextYear('rightDate');
        },
        className: "rd-picker-panel__icon-btn rd-icon-d-arrow-right"
      }, "\xBB"), /*#__PURE__*/React.createElement("button", {
        onClick: function onClick() {
          return _this2.nextMonth('rightDate');
        },
        className: "rd-picker-panel__icon-btn rd-icon-arrow-right"
      }, "\u203A"), /*#__PURE__*/React.createElement("div", null, rightLabel)), /*#__PURE__*/React.createElement(_basic.DateTable, (0, _extends2.default)({}, this.props, {
        selectionMode: _utils.SELECTION_MODES.RANGE,
        date: rightDate,
        value: maxDate,
        minDate: minDate,
        maxDate: maxDate,
        rangeState: rangeState,
        disabledDate: disabledDate,
        onChangeRange: this.handleChangeRange,
        onPicked: this.handleRangePick,
        firstDayOfWeek: firstDayOfWeek
      }))))), showTime && /*#__PURE__*/React.createElement("div", {
        className: "rd-picker-panel__footer"
      }, showTopText && /*#__PURE__*/React.createElement(_button.default, {
        text: true,
        className: "rd-picker-panel__choose",
        onClick: this.timePickerVisibleChange
      }, _locale.default.t('rd.datepicker.selectTime')), /*#__PURE__*/React.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        onClick: this.handleClear
      }, _locale.default.t('rd.datepicker.clear')), /*#__PURE__*/React.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        type: "primary",
        disabled: this.btnDisabled,
        onClick: this.handleConfirm
      }, _locale.default.t('rd.datepicker.confirm')))));
    }
  }]);
  return DateRangePanel;
}(React.Component)) || _class;

exports.default = DateRangePanel;