import React from 'react';
import TimeSpinner from '../basic/TimeSpinner';
import { D, S, TimePickerProps, TimeType } from '../Types';
declare type Props = TimePickerProps<D, S> & {
    showTime?: boolean;
    timeHide?: boolean;
    currentDate?: D;
    visibleChange?: () => void;
    onPicked: (value: D, isKeepPannel: boolean) => void;
};
declare type State = TimePickerProps<D, S> & {
    currentDate?: Date;
    showSeconds?: boolean;
};
export default class TimePanel extends React.Component<Props, State> {
    spinner: TimeSpinner;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: Props);
    /**
     * props更新同步
     * @param nextProps
     */
    static getDerivedStateFromProps(nextProps: Props): State;
    /**
     * 改变回调
     * @param date
     */
    handleChange(date: TimeType): void;
    /**
     * 点击确认的回调
     * @param isKeepPannelOpen
     */
    handleConfirm(isKeepPannelOpen?: boolean): void;
    /**清空函数 */
    handleCancel(): void;
    /**
     * 时间渲染
     */
    render(): React.ReactNode;
}
export {};
