"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _TimeSpinner = _interopRequireDefault(require("../basic/TimeSpinner"));

var _locale = _interopRequireDefault(require("../../locale"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _button = _interopRequireDefault(require("../../button"));

var _class;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var mapPropsToState = function mapPropsToState(props) {
  var state = {
    format: props.format || 'HH:mm:ss',
    currentDate: props.currentDate || (0, _utils.getDefaultDate)()
  };
  state.showSeconds = (state.format || '').indexOf('ss') !== -1;
  return state;
};

var TimePanel = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TimePanel, _React$Component);

  var _super = _createSuper(TimePanel);

  /**
   * 构造函数
   * @param props
   */
  function TimePanel(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TimePanel);
    _this = _super.call(this, props);
    _this.spinner = void 0;
    _this.state = _objectSpread({
      currentDate: null
    }, mapPropsToState(props));
    return _this;
  }
  /**
   * props更新同步
   * @param nextProps
   */


  (0, _createClass2.default)(TimePanel, [{
    key: "handleChange",
    value:
    /**
     * 改变回调
     * @param date
     */
    function handleChange(date) {
      var currentDate = this.state.currentDate;

      if (date.hours !== undefined) {
        currentDate.setHours(date.hours);
      }

      if (date.minutes !== undefined) {
        currentDate.setMinutes(date.minutes);
      }

      if (date.seconds !== undefined) {
        currentDate.setSeconds(date.seconds);
      }

      this.handleConfirm(true);
    }
    /**
     * 点击确认的回调
     * @param isKeepPannelOpen
     */

  }, {
    key: "handleConfirm",
    value: function handleConfirm(isKeepPannelOpen) {
      isKeepPannelOpen = isKeepPannelOpen || false;
      var currentDate = this.state.currentDate;
      var onPicked = this.props.onPicked;
      onPicked(currentDate, isKeepPannelOpen);
    }
    /**清空函数 */

  }, {
    key: "handleCancel",
    value: function handleCancel() {
      var defaultDate = (0, _utils.getDefaultDate)();
      this.setState({
        currentDate: defaultDate
      });
      var onCancel = this.props.onCancel;
      onCancel && onCancel();
      var onPicked = this.props.onPicked;
      onPicked(defaultDate, true);
    }
    /**
     * 时间渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          showSeconds = _this$state.showSeconds,
          currentDate = _this$state.currentDate,
          showTime = _this$state.showTime;
      var _this$props = this.props,
          visibleChange = _this$props.visibleChange,
          showTopText = _this$props.showTopText;
      var hours = null;
      var minutes = null;
      var seconds = null;

      if (this.props.currentDate) {
        hours = currentDate.getHours();
        minutes = currentDate.getMinutes();
        seconds = currentDate.getSeconds();
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-panel"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)('rd-time-panel__content', {
          'has-seconds': showSeconds
        })
      }, /*#__PURE__*/_react.default.createElement(_TimeSpinner.default, (0, _extends2.default)({}, this.props, {
        ref: function ref(_ref) {
          return _this2.spinner = _ref;
        },
        onChanged: this.handleChange,
        showSeconds: showSeconds,
        hours: hours,
        minutes: minutes,
        seconds: seconds // range={selectableRange[0]}

      }))), showTime && /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-panel__footer"
      }, showTopText && /*#__PURE__*/_react.default.createElement(_button.default, {
        text: true,
        size: "small",
        className: "rd-picker-panel__choose",
        onClick: visibleChange
      }, _locale.default.t('rd.datepicker.selectTime')), /*#__PURE__*/_react.default.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        onClick: this.handleCancel
      }, _locale.default.t('rd.datepicker.clear')), /*#__PURE__*/_react.default.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        type: "primary",
        onClick: function onClick() {
          return _this2.handleConfirm();
        }
      }, _locale.default.t('rd.datepicker.confirm'))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      return _objectSpread(_objectSpread({}, nextProps), mapPropsToState(nextProps));
    }
  }]);
  return TimePanel;
}(_react.default.Component)) || _class;

exports.default = TimePanel;