import React from 'react';
import { D, DS, SS, TimePickerProps } from '../Types';
declare type Props = TimePickerProps<DS, SS> & {
    showTime?: boolean;
    visibleChange?: () => void;
    currentDates?: DS;
    onPicked?: (value: DS, isKeepPannel?: boolean) => void;
};
declare type State = Props & {
    minTime?: D;
    maxTime?: D;
    btnDisabled?: boolean;
    currentDate?: D;
    showSeconds?: boolean;
};
export default class TimeRangePanel extends React.Component<Props, State> {
    state: any;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: Props);
    /**
     * 时间改变回调
     * @param date
     * @param field
     */
    handleChange(date: {
        hours?: number;
        minutes?: number;
        seconds?: number;
    }, field: string): void;
    /**
     * 点击确认回调
     * @param isKeepPannelOpen
     */
    handleConfirm(state?: State, isKeepPannelOpen?: boolean): void;
    /**
     * 渲染
     */
    render(): React.ReactNode;
}
export {};
