"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _TimeSpinner = _interopRequireDefault(require("../basic/TimeSpinner"));

var _locale = _interopRequireDefault(require("../../locale"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _button = _interopRequireDefault(require("../../button"));

var _excluded = ["showTopText", "showTime", "currentDates", "onCancel", "visibleChange", "placeholder", "value", "onChange", "onPick"];

var _class;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MIN_TIME = (0, _utils.parseDate)('00:00:00', 'HH:mm:ss');
var MAX_TIME = (0, _utils.parseDate)('23:59:59', 'HH:mm:ss');

var disabled = function disabled(minTime, maxTime) {
  var minValue = minTime.getHours() * 3600 + minTime.getMinutes() * 60 + minTime.getSeconds();
  var maxValue = maxTime.getHours() * 3600 + maxTime.getMinutes() * 60 + maxTime.getSeconds();
  return minValue > maxValue;
};

var calcTime = function calcTime(time) {
  time = Array.isArray(time) ? time : [time];
  var minTime = time[0] || (0, _utils.getDefaultDate)();
  var date = (0, _utils.getDefaultDate)();
  var maxTime = time[1] || date;
  return {
    minTime: minTime,
    maxTime: maxTime
  };
};

var mapPropsToState = function mapPropsToState(props) {
  var currentDates = props.currentDates,
      format = props.format;

  var _calcTime = calcTime(currentDates),
      minTime = _calcTime.minTime,
      maxTime = _calcTime.maxTime;

  var state = {
    format: format || 'HH:mm:ss',
    minTime: minTime,
    maxTime: maxTime,
    // minSelectableRange: [MIN_TIME, maxTime],
    // maxSelectableRange: [minTime, MAX_TIME],
    btnDisabled: disabled(minTime, maxTime)
  };
  state.showSeconds = (state.format || '').indexOf('ss') !== -1;
  return state;
};

var TimeRangePanel = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TimeRangePanel, _React$Component);

  var _super = _createSuper(TimeRangePanel);

  /**
   * 构造函数
   * @param props
   */
  function TimeRangePanel(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TimeRangePanel);
    _this = _super.call(this, props);
    _this.state = {};
    _this.state = Object.assign({
      visible: false,
      width: 0
    }, mapPropsToState(props));
    return _this;
  }
  /**
   * 时间改变回调
   * @param date
   * @param field
   */


  (0, _createClass2.default)(TimeRangePanel, [{
    key: "handleChange",
    value: function handleChange(date, field) {
      var ndate = this.state[field];

      if (date.hours !== undefined) {
        ndate.setHours(date.hours);
      }

      if (date.minutes !== undefined) {
        ndate.setMinutes(date.minutes);
      }

      if (date.seconds !== undefined) {
        ndate.setSeconds(date.seconds);
      }

      var state = (0, _defineProperty2.default)({}, field, ndate);
      this.handleConfirm(state, true);
    }
    /**
     * 点击确认回调
     * @param isKeepPannelOpen
     */

  }, {
    key: "handleConfirm",
    value: function handleConfirm(state, isKeepPannelOpen) {
      isKeepPannelOpen = isKeepPannelOpen || false;
      var currentDates = this.props.currentDates;

      var _ref = state || this.state,
          minTime = _ref.minTime,
          maxTime = _ref.maxTime;

      var newTimes = calcTime([minTime || currentDates && currentDates[0], maxTime || currentDates && currentDates[1]]);
      this.setState({
        minTime: newTimes.minTime,
        maxTime: newTimes.maxTime // minSelectableRange: [MIN_TIME, newTimes.maxTime],
        // maxSelectableRange: [newTimes.minTime, MAX_TIME],

      });
      var onPicked = this.props.onPicked;
      onPicked([newTimes.minTime, newTimes.maxTime], isKeepPannelOpen);
    }
    /**
     * 渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          showSeconds = _this$state.showSeconds,
          minTime = _this$state.minTime,
          maxTime = _this$state.maxTime,
          btnDisabled = _this$state.btnDisabled;
      var _this$props = this.props,
          showTopText = _this$props.showTopText,
          showTime = _this$props.showTime,
          currentDates = _this$props.currentDates,
          onCancel = _this$props.onCancel,
          visibleChange = _this$props.visibleChange,
          placeholder = _this$props.placeholder,
          value = _this$props.value,
          onChange = _this$props.onChange,
          onPick = _this$props.onPick,
          rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var maxHours = null;
      var maxMinutes = null;
      var maxSeconds = null;
      var minHours = null;
      var minMinutes = null;
      var minSeconds = null;

      if (currentDates) {
        maxHours = maxTime.getHours();
        maxMinutes = maxTime.getMinutes();
        maxSeconds = maxTime.getSeconds();
        minHours = minTime.getHours();
        minMinutes = minTime.getMinutes();
        minSeconds = minTime.getSeconds();
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-range-picker rd-picker-panel",
        style: {
          minWidth: '330px'
        }
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-range-picker__content"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-range-picker__cell"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-range-picker__header"
      }, _locale.default.t('rd.datepicker.startTime')), /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)('rd-time-range-picker__body rd-time-panel__content', {
          'has-seconds': showSeconds
        })
      }, /*#__PURE__*/_react.default.createElement(_TimeSpinner.default, (0, _extends2.default)({}, rest, {
        onChanged: function onChanged(date) {
          return _this2.handleChange(date, 'minTime');
        },
        showSeconds: showSeconds,
        hours: minHours,
        minutes: minMinutes,
        seconds: minSeconds // range={minSelectableRange}

      })))), /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-range-picker__cell"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-range-picker__header"
      }, _locale.default.t('rd.datepicker.endTime')), /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)('rd-time-range-picker__body rd-time-panel__content', {
          'has-seconds': showSeconds
        })
      }, /*#__PURE__*/_react.default.createElement(_TimeSpinner.default, (0, _extends2.default)({}, rest, {
        onChanged: function onChanged(date) {
          return _this2.handleChange(date, 'maxTime');
        },
        showSeconds: showSeconds,
        hours: maxHours,
        minutes: maxMinutes,
        seconds: maxSeconds // range={maxSelectableRange}

      }))))), showTime && /*#__PURE__*/_react.default.createElement("div", {
        className: "rd-time-panel__footer"
      }, showTopText && /*#__PURE__*/_react.default.createElement(_button.default, {
        text: true,
        className: "rd-picker-panel__choose",
        onClick: visibleChange
      }, _locale.default.t('rd.datepicker.selectDate')), /*#__PURE__*/_react.default.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        disabled: btnDisabled,
        onClick: onCancel
      }, _locale.default.t('rd.datepicker.clear')), /*#__PURE__*/_react.default.createElement(_button.default, {
        size: "small",
        className: "rd-picker-panel__btn",
        type: "primary",
        onClick: function onClick() {
          return _this2.handleConfirm(_this2.state);
        }
      }, _locale.default.t('rd.datepicker.confirm'))));
    }
  }]);
  return TimeRangePanel;
}(_react.default.Component)) || _class;

exports.default = TimeRangePanel;