/**
 * 转成date格式
 * @param date
 */
export declare function toDate(date: Date): Date;
/**
 * 判断是否为Date
 * @param date
 */
export declare function isDate(date: Date): boolean;
/**
 * 格式化date
 * @param date Date
 * @param format 格式化string
 * @returns string
 */
export declare function formatDate(date: Date, format?: string): string;
/**
 * string==>date
 * @param string
 * @param format
 */
export declare function parseDate(string: string, format: string): Date;
/**
 * 获取每月的天数
 * @param year 年 number
 * @param month 月 number
 */
export declare function getDayCountOfMonth(year: number, month: number): number;
/**
 * 每个月第一天开始的周数，如3.1号返回1（周一）
 * @param date
 */
export declare function getFirstDayOfMonth(date: Date): number;
/**一天的毫秒数 */
export declare const DAY_DURATION = 86400000;
/**
 * 获取当月第一天的周期偏差
 * @param year
 * @param month
 * @param offsetWeek
 */
export declare function getStartDateOfMonth(year: number, month: number, offsetWeek?: number): Date;
/**
 * 获取周偏移量
 * @export
 * @param {any} day , first day of current month, 1 - 7
 * @param {number} 默认为7周日开头
 * @returns
 */
export declare function getOffsetToWeekOrigin(day: number, offsetWeek?: number): number;
/**
 * 获取当前日期在一年中处于第几周
 * @param src
 */
export declare function getWeekNumber(src: Date): number;
/**
 * 根据周数来计算日期
 *  http://stackoverflow.com/questions/16590500/javascript-calculate-date-from-week-number
 * @param w 周数 number
 * @param y 年 number
 */
export declare function getDateOfISOWeek(w: number, y: number): Date;
/**
 * 上个月计算
 * @param src
 */
export declare function prevMonth(src: Date): Date;
/**
 * 下个月计算
 * @param src
 */
export declare function nextMonth(src: Date): Date;
/**
 * 获取小时 boolean[]格式 false表示不可点击
 * @param ranges
 */
/**
 * 创建数组
 */
export declare function newArray(start: number, end: number): Array<number>;
/**创建小时数组  格式[boolean, boolean,.....] */
export declare function getRangeHours(range: Array<Date>): Array<boolean>;
/**
 * 设置时间范围（分钟）
 * @param arr
 * @param start
 * @param end
 * @param value
 * @returns
 */
export declare function setRangeData(arr: Array<boolean>, start: number, end: number, value: boolean): Array<boolean>;
/**创建分钟数组  格式 [boolean,boolean,....]*/
export declare function getRangeMinutes(range: Array<Date>, hour: number): Array<boolean>;
/**创建分钟数组  格式 [boolean,boolean,....]*/
export declare function getRangeSeconds(range: Array<Date>, hour: number, minute: number): Array<boolean>;
/**
 * 节点中是否存在classname
 * @param target
 * @param classname
 */
export declare function hasClass(target: HTMLElement, classname: string): boolean;
/**
 * 面板模式
 */
export declare const SELECTION_MODES: {
    YEAR: string;
    MONTH: string;
    WEEK: string;
    DATE: string;
    RANGE: string;
};
/**
 * 将date格式转成年月周格式
 * @param date Date
 */
export declare function deconstructDate(date: Date): {
    year: number;
    month: number;
    week: number;
};
/**
 * 时间条滚动缓冲
 * @param element
 * @param to
 * @param duration
 */
export declare function scrollTo(element: HTMLElement, to: number, duration: number): void;
/**
 * 设置默认时间
 * @returns Date
 */
export declare function getDefaultDate(): Date;
