"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _transition = _interopRequireDefault(require("../transition"));

var _types = require("../../libs/types");

var _Portal = _interopRequireDefault(require("../portal/Portal"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DrawerDirectionTypes = (0, _types.tuple)('left', 'top', 'bottom', 'right');

var Drawer = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Drawer, _React$Component);

  var _super = _createSuper(Drawer);

  /**
   *构造函数
   * @param props
   */
  function Drawer(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Drawer);
    _this = _super.call(this, props);
    _this.state = {
      visible: props.visible,
      maskVisible: props.visible,
      container: typeof props.getContainer === 'function' ? null : document.body
    };
    return _this;
  }
  /**
   * 当props变化或者state变化时向state中合并属性
   * @param nextProps
   */


  (0, _createClass2.default)(Drawer, [{
    key: "componentDidMount",
    value:
    /**
     * 第一次挂载
     */
    function componentDidMount() {
      (0, _util.addEvent)(document, 'keydown', this.handleKeyDown);
    }
    /**
     * 卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _util.removeEvent)(document, 'keydown', this.handleKeyDown);
    }
    /**
     * 关闭
     * @param e
     */

  }, {
    key: "handleClose",
    value: function handleClose(e) {
      var _this$props = this.props,
          onClose = _this$props.onClose,
          onChange = _this$props.onChange;
      this.setState({
        visible: false
      });
      onClose && onClose(e);
      onChange && onChange(false);
    }
    /**
     *keydown事件处理
     * @param e
     */

  }, {
    key: "handleKeyDown",
    value: function handleKeyDown(e) {
      var closeOnPressEscape = this.props.closeOnPressEscape;

      if (closeOnPressEscape && e.keyCode === 27) {
        this.handleClose(e);
      }
    }
    /**
     * 重置Container
     */

  }, {
    key: "resetContainer",
    value: function resetContainer(container, originStyle) {
      var maskVisible = this.state.maskVisible;

      if (originStyle) {
        container.setAttribute('style', "".concat(originStyle));
      } else {
        container.removeAttribute('style');
      }

      if (maskVisible) {
        this.setState({
          maskVisible: false
        });
      }
    }
    /**
     * mask点击关闭
     * @param e
     */

  }, {
    key: "handleMaskClose",
    value: function handleMaskClose(e) {
      var _this$props2 = this.props,
          closeOnClickMask = _this$props2.closeOnClickMask,
          onClose = _this$props2.onClose,
          onChange = _this$props2.onChange;
      this.setState({
        visible: false
      });
      closeOnClickMask && onClose && onClose(e);
      closeOnClickMask && onChange && onChange(false);
    }
    /**
     * trigger的点击事件
     * @param e
     */

  }, {
    key: "handleTrigger",
    value: function handleTrigger(e) {
      var _this$props3 = this.props,
          trigger = _this$props3.trigger,
          onChange = _this$props3.onChange;
      var onClick = trigger.props.onClick;
      onClick && onClick(e);
      onChange && onChange(true);
      this.setState({
        visible: true,
        maskVisible: true
      });
    }
    /**
     * 处理动画离开事件
     */

  }, {
    key: "handleLeave",
    value: function handleLeave() {
      this.setState({
        maskVisible: false
      });
    }
    /**
     * 处理mask动画离开事件
     */

  }, {
    key: "handleMaskLeave",
    value: function handleMaskLeave(container, originStyle) {
      this.resetContainer(container, originStyle);
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          children = _this$props4.children,
          width = _this$props4.width,
          height = _this$props4.height,
          style = _this$props4.style,
          className = _this$props4.className,
          trigger = _this$props4.trigger,
          direction = _this$props4.direction,
          getContainer = _this$props4.getContainer,
          lockScroll = _this$props4.lockScroll,
          maskTransitionName = _this$props4.maskTransitionName,
          transitionPrefix = _this$props4.transitionPrefix;
      var _this$state = this.state,
          visible = _this$state.visible,
          maskVisible = _this$state.maskVisible;
      var calcWidth, calcHeight;
      /**
       * 降低圈复杂度
       * @param value
       * @param defaultValue
       */

      var getDefaultValue = function getDefaultValue(value, defaultValue) {
        return value ? value : defaultValue;
      };

      if (direction === 'top' || direction === 'bottom') {
        calcWidth = getDefaultValue(width, '100%');
        calcHeight = getDefaultValue(height, '40%');
      } else {
        calcWidth = getDefaultValue(width, '40%');
        calcHeight = getDefaultValue(height, '100%');
      }

      return /*#__PURE__*/React.createElement(React.Fragment, null, trigger && /*#__PURE__*/React.cloneElement(trigger, {
        onClick: this.handleTrigger
      }), /*#__PURE__*/React.createElement(_Portal.default, {
        getContainer: getContainer
      }, function (container) {
        var originStyle = container.hasAttribute('data-lock') ? container.getAttribute('data-lock') : container.getAttribute('style') || '';
        container.setAttribute('data-lock', "".concat(originStyle));

        if (container !== document.body) {
          if (maskVisible) {
            container.style.position = 'relative';
          }
        }

        if (lockScroll) {
          if (maskVisible) {
            container.style.overflow = 'hidden';
          }
        }

        return /*#__PURE__*/React.createElement(_transition.default, {
          name: maskTransitionName,
          onAfterLeave: function onAfterLeave() {
            return _this2.handleMaskLeave(container, originStyle);
          }
        }, maskVisible && /*#__PURE__*/React.createElement("div", {
          className: "rd-drawer__wrapper",
          style: {
            position: container !== document.body ? 'absolute' : undefined
          },
          onClick: _this2.handleMaskClose
        }, /*#__PURE__*/React.createElement(_transition.default, {
          name: "".concat(transitionPrefix, "-").concat(direction),
          appear: true,
          onAfterLeave: _this2.handleLeave
        }, visible && /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames.default)('rd-drawer', className),
          style: _objectSpread((0, _defineProperty2.default)({
            width: calcWidth,
            height: calcHeight
          }, direction, 0), style),
          onClick: function onClick(e) {
            return e.stopPropagation();
          }
        }, children))));
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      //说明是从上级传下来visible且visible 改变了
      if (nextProps.visible !== undefined) {
        if (nextProps.visible) {
          return {
            visible: nextProps.visible,
            maskVisible: true
          };
        }

        return {
          visible: nextProps.visible
        };
      }

      return null;
    }
  }]);
  return Drawer;
}(React.Component), _class2.defaultProps = {
  showClose: true,
  closeOnClickMask: true,
  closeOnPressEscape: true,
  direction: 'right',
  getContainer: document.body,
  lockScroll: true,
  transitionPrefix: 'drawer-fade',
  maskTransitionName: 'fade-in-linear'
}, _class2)) || _class;

exports.default = Drawer;