"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _classnames = _interopRequireDefault(require("classnames"));

var _popover = _interopRequireDefault(require("../popover"));

var _DropdownContext = _interopRequireDefault(require("./DropdownContext"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Dropdown = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Dropdown, _React$PureComponent);

  var _super = _createSuper(Dropdown);

  function Dropdown() {
    var _this;

    (0, _classCallCheck2.default)(this, Dropdown);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      visible: false
    };
    _this.el = /*#__PURE__*/React.createRef();
    _this.keysOption = {};
    return _this;
  }

  (0, _createClass2.default)(Dropdown, [{
    key: "handleItemClick",
    value:
    /**
     * 该方法留给子类调用
     * @param e
     * @param childProp
     */
    function handleItemClick(e, childProp) {
      e.persist();
      var _this$props = this.props,
          hideOnClick = _this$props.hideOnClick,
          onItemClick = _this$props.onItemClick;

      if (hideOnClick) {
        this.setState({
          visible: false
        });
      }

      onItemClick && onItemClick(e, childProp);
    }
    /**
     * 主动关闭弹出框供外部调用
     */

  }, {
    key: "emitClose",
    value: function emitClose() {
      var onClose = this.props.onClose;
      onClose && onClose();
      this.el.current.emitClose();
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var visible = this.state.visible;
      var _this$props2 = this.props,
          children = _this$props2.children,
          size = _this$props2.size,
          overlay = _this$props2.overlay,
          className = _this$props2.className,
          trigger = _this$props2.trigger,
          offset = _this$props2.offset,
          getContainer = _this$props2.getContainer,
          placement = _this$props2.placement,
          getOptions = _this$props2.getOptions,
          style = _this$props2.style,
          disabled = _this$props2.disabled,
          clickTriggerRevert = _this$props2.clickTriggerRevert,
          clickPopperHidden = _this$props2.clickPopperHidden,
          popperWidthSameWithChildren = _this$props2.popperWidthSameWithChildren,
          onClose = _this$props2.onClose,
          flipEnabled = _this$props2.flipEnabled,
          strategy = _this$props2.strategy,
          onOpen = _this$props2.onOpen,
          visibleArrow = _this$props2.visibleArrow,
          firstRender = _this$props2.firstRender;
      var classes = (0, _classnames.default)(className, 'rd-dropdown', size && "rd-dropdown--".concat(size));

      var _children = /*#__PURE__*/React.cloneElement(children, children.props);
      /**为了拿到children的option的值--结束**/


      var popover = /*#__PURE__*/React.createElement(_popover.default, {
        ref: this.el,
        visible: visible,
        onVisibleChange: function onVisibleChange(visible) {
          if (visible) {
            onOpen && onOpen();
          } else {
            onClose && onClose();
          }

          _this2.setState({
            visible: visible
          });
        },
        strategy: strategy,
        flipEnabled: flipEnabled,
        clickTriggerRevert: clickTriggerRevert,
        overlay: overlay,
        className: classes,
        style: style,
        trigger: trigger,
        needWrapper: false,
        firstRender: firstRender,
        enterAble: true,
        visibleArrow: visibleArrow,
        offset: offset,
        placement: placement,
        getContainer: getContainer,
        clickPopperHidden: clickPopperHidden,
        popperWidthSameWithChildren: popperWidthSameWithChildren
      }, _children);
      return /*#__PURE__*/React.createElement(_DropdownContext.default.Provider, {
        value: {
          onItemClick: this.handleItemClick
        }
      }, getOptions && /*#__PURE__*/React.createElement(_DropdownContext.default.Provider, {
        value: {
          renderFake: true,
          set: function set(params) {
            _this2.keysOption[params.key] = params.option;
            getOptions(Object.values(_this2.keysOption));
          }
        }
      }, overlay), disabled ? _children : popover);
    }
  }]);
  return Dropdown;
}(React.PureComponent), _class2.defaultProps = {
  trigger: 'click',
  clickTriggerRevert: true,
  hideOnClick: true,
  flipEnabled: false,
  placement: 'bottom-start',
  visibleArrow: false
}, _class2.Menu = void 0, _class2.Item = void 0, _class2)) || _class;

exports.default = Dropdown;