"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _DropdownContext = _interopRequireWildcard(require("./DropdownContext"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _excluded = ["children", "style", "className", "disabled", "divided"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DropdownItem = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(DropdownItem, _React$Component);

  var _super = _createSuper(DropdownItem);

  /**
   * 构造函数
   * @param props
   * @param context
   */
  function DropdownItem(props, context) {
    var _this;

    (0, _classCallCheck2.default)(this, DropdownItem);
    _this = _super.call(this, props);
    _this.key = void 0;
    _this.key = (0, _util.UUID)();

    if (context && context.set) {
      context.set({
        key: _this.key,
        option: _this.props
      });
    }

    return _this;
  }
  /**
   * 更新后
   */


  (0, _createClass2.default)(DropdownItem, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.context && this.context.set) {
        this.context.set({
          key: this.key,
          option: this.props
        });
      }
    }
    /**
     * 将要卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.context && this.context.remove) {
        this.context.remove(this.key);
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          style = _this$props.style,
          className = _this$props.className,
          disabled = _this$props.disabled,
          divided = _this$props.divided,
          rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var classes = (0, _classnames.default)('rd-dropdown-menu__item', className, {
        'is-disabled': disabled,
        'is-divided': divided
      });
      var otherProps = (0, _omit.default)(rest, ['data']);
      return /*#__PURE__*/React.createElement(_DropdownContext.default.Consumer, null, function (_ref) {
        var renderFake = _ref.renderFake,
            set = _ref.set;

        if (renderFake) {
          set({
            key: _this2.key,
            option: _this2.props
          });
          return null;
        } else {
          return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
            role: "dropdown-menu-item",
            ref: function ref(_ref2) {
              if (_ref2) {
                _ref2._UUID = _this2.key;
                _ref2._disabled = disabled;
              }
            },
            style: _objectSpread({}, style),
            className: classes
          }, otherProps), children);
        }
      });
    }
  }]);
  return DropdownItem;
}(React.Component), _class2.defaultProps = {}, _class2.contextType = _DropdownContext.DropdownMenuContext, _class2)) || _class;

exports.default = DropdownItem;