import * as React from 'react';
import { DataTypes } from '../table/Types';
export declare type DynamicListProps = React.HTMLAttributes<HTMLDivElement> & {
    listView?: {
        num: number;
    } | boolean;
    itemHeight: number;
    height: number;
    data: any[];
    num?: number;
    onScroll?: (e: React.UIEvent, data?: any[]) => void;
};
declare type State = DynamicListProps;
export default class DynamicList extends React.Component<DynamicListProps, State> {
    scrollRef: HTMLElement;
    prevScrollTop: number;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: DynamicListProps);
    /**
     * 获取动态数据
     * @param data
     */
    getDynamicData(dataSource?: Array<DataTypes>, scrollTop?: number, average?: number, _num?: number): any[];
    /**
     * 获取日期高度
     */
    getHeight(): number;
    /**
     * 滚动回调
     * @param e
     */
    handleScroll(e: React.UIEvent): void;
    /**
     *渲染
    */
    render(): React.ReactNode;
}
export {};
