"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ScrollBar = _interopRequireDefault(require("../scroll-bar/ScrollBar"));

var _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DynamicList = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(DynamicList, _React$Component);

  var _super = _createSuper(DynamicList);

  /**
   * 构造函数
   * @param props 
   */
  function DynamicList(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DynamicList);
    _this = _super.call(this, props);
    _this.scrollRef = void 0;
    _this.prevScrollTop = 0;
    _this.state = {
      itemHeight: 0,
      height: 0,
      data: []
    };
    return _this;
  }
  /**
   * 获取动态数据
   * @param data 
   */


  (0, _createClass2.default)(DynamicList, [{
    key: "getDynamicData",
    value: function getDynamicData(dataSource, scrollTop, average, _num) {
      var data = dataSource || this.props.data;
      var _this$props = this.props,
          itemHeight = _this$props.itemHeight,
          height = _this$props.height,
          num = _this$props.num;

      if (scrollTop === undefined) {
        // eslint-disable-next-line prefer-destructuring
        scrollTop = this.scrollRef.scrollTop;
        _num = Math.ceil(height / itemHeight);
        var showNum = num || Math.ceil(_num * 2);
        average = Math.round((showNum - _num) / 2);
      }

      var startPos = Math.floor(scrollTop / itemHeight);
      /**加上缓冲区数据，下标位置往上移 */

      var start = startPos - average;
      /**真正开始的下标为加上缓冲区的下标，如果加上缓冲区小于0 ，则开始从0计算 */

      var startIndex = start < 0 ? 0 : start; // 同理 结束下标为开始下标+滚动区域能够容纳的条数+下面缓冲区条数

      var end = startPos + average + _num;
      /**真正结束的下标为加上缓冲区的下标，如果加上缓冲区大于总条数 ，则开始从data长度计算 */

      var endIndex = end > data.length ? data.length : end; // 计算显示条数

      var viewListData = data.slice(startIndex, endIndex);
      var prefixHeight = itemHeight * startIndex;
      var suffixHeight = itemHeight * (data.length - endIndex);
      viewListData = viewListData.map(function (item, index) {
        return _objectSpread(_objectSpread({}, item), {}, {
          index: index
        });
      });
      viewListData.unshift({
        key: 'prefixPlaceholder',
        data: {
          height: prefixHeight
        }
      });
      viewListData.push({
        key: 'suffixPlaceholder',
        data: {
          height: suffixHeight
        }
      });
      return viewListData;
    }
    /**
     * 获取日期高度
     */

  }, {
    key: "getHeight",
    value: function getHeight() {
      return this.scrollRef.clientHeight;
    }
    /**
     * 滚动回调
     * @param e 
     */

  }, {
    key: "handleScroll",
    value: function handleScroll(e) {
      var _this$props2 = this.props,
          listView = _this$props2.listView,
          height = _this$props2.height,
          onScroll = _this$props2.onScroll;

      if (!height) {
        onScroll && onScroll(e);
        return;
      }

      if (!listView) {
        return;
      }

      var _ref = e.target,
          scrollTop = _ref.scrollTop;
      var _this$props3 = this.props,
          itemHeight = _this$props3.itemHeight,
          num = _this$props3.num;
      var prevScrollTop = this.prevScrollTop; // 计算显示条数

      var _num = Math.ceil(height / itemHeight);

      var showNum = num || Math.ceil(_num * 2);
      var average = Math.round((showNum - _num) / 2);

      if (Math.abs(scrollTop - prevScrollTop) >= average * itemHeight && height) {
        var _data = this.props.data;
        var viewListData = this.getDynamicData(_data, scrollTop, average, _num);
        onScroll && onScroll(e, viewListData);
        this.prevScrollTop = scrollTop;
      } else {
        onScroll && onScroll(e);
      }
    }
    /**
     *渲染
    */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          children = _this$props4.children,
          className = _this$props4.className,
          height = _this$props4.height;
      return /*#__PURE__*/React.createElement(_ScrollBar.default, {
        hoverShowTrack: true,
        autoHide: true,
        autoHeight: true,
        onScroll: this.handleScroll,
        autoHeightMax: height
      }, /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)(className, 'rd-dynamic-list'),
        ref: function ref(_ref2) {
          return _this2.scrollRef = _ref2;
        }
      }, children));
    }
  }]);
  return DynamicList;
}(React.Component)) || _class;

exports.default = DynamicList;