import * as React from 'react';
import { Size } from "../../libs/types";
/**函数形式只有在theme=custom 支持**/
declare type FunctionChildren = ((value: string) => React.ReactNode);
export interface FilePickerProps {
    children?: React.ReactNode | FunctionChildren;
    className?: string;
    style?: React.CSSProperties;
    size?: Size;
    value?: string;
    theme?: 'native' | 'input-button' | 'custom';
    renderPlaceholder?: (fileName: string) => string | string;
    buttonRender?: (size: Size) => React.ReactElement;
    name?: string;
    onFile?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onChange?: (value: string) => void;
    onClick?: React.MouseEventHandler<HTMLDivElement>;
}
export interface FilePickerState {
    _prevProps?: FilePickerProps;
    value?: string;
    UUID?: number;
}
export default class FilePicker extends React.Component<FilePickerProps, FilePickerState> {
    private fileInput;
    static defaultProps: {
        theme: string;
        size: string;
        renderPlaceholder: string;
        buttonRender: (size: Size) => React.ReactElement;
    };
    state: FilePickerState;
    private value;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: FilePickerProps);
    /**
     * 统一处理change*/
    handleUnifiedChange(e: string): void;
    /**
     *点击触发对象
     */
    handleClick(e: React.MouseEvent<HTMLDivElement>): void;
    /**
     *选中文件
     */
    handleFileChange(e: React.ChangeEvent<HTMLInputElement>): void;
    /***
     * 渲染placeholder
     */
    renderPlaceholder(value: string): string;
    /**
     *渲染函数
     */
    render(): React.ReactElement;
}
export {};
