"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _button = _interopRequireDefault(require("../button"));

var _input = _interopRequireDefault(require("../input"));

var _classnames = _interopRequireDefault(require("classnames"));

var _locale = _interopRequireDefault(require("../locale"));

var _util = require("../../libs/utils/util");

var _FormElement = require("../form/FormElement");

var _Span = _interopRequireDefault(require("../span/Span"));

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FilePicker = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(FilePicker, _React$Component);

  var _super = _createSuper(FilePicker);

  /**
   * 构造函数
   * @param props
   */
  function FilePicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, FilePicker);
    _this = _super.call(this, props);
    _this.fileInput = void 0;
    _this.state = {
      UUID: 0
    };
    _this.value = void 0;
    _this.state = {
      UUID: (0, _util.UUID)()
    };
    return _this;
  }
  /**
   * 统一处理change*/


  (0, _createClass2.default)(FilePicker, [{
    key: "handleUnifiedChange",
    value: function handleUnifiedChange(e) {
      var _this$props = this.props,
          value = _this$props.value,
          onChange = _this$props.onChange;

      if (value === undefined) {
        this.value = e;

        if (onChange) {
          onChange(e);
        } else {
          this.forceUpdate();
        }
      } else {
        onChange && onChange(e);
      }
    }
    /**
     *点击触发对象
     */

  }, {
    key: "handleClick",
    value: function handleClick(e) {
      if (_util.isIE) {
        var onClick = this.props.onClick;
        onClick && onClick(e);
      } else {
        e.stopPropagation();
        this.fileInput.click();
      }
    }
    /**
     *选中文件
     */

  }, {
    key: "handleFileChange",
    value: function handleFileChange(e) {
      var onFile = this.props.onFile;
      var value = e.target.value;
      var fileName;

      try {
        fileName = value.match(/[^\\]+$/)[0];
      } catch (e) {
        fileName = value;
      }

      onFile && onFile(e);
      this.handleUnifiedChange(fileName);
    }
    /***
     * 渲染placeholder
     */

  }, {
    key: "renderPlaceholder",
    value: function renderPlaceholder(value) {
      var renderPlaceholder = this.props.renderPlaceholder;

      if (typeof renderPlaceholder === 'function') {
        return renderPlaceholder(value);
      } else {
        return renderPlaceholder;
      }
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          children = _this$props2.children,
          name = _this$props2.name,
          theme = _this$props2.theme,
          propValue = _this$props2.value,
          size = _this$props2.size,
          buttonRender = _this$props2.buttonRender,
          style = _this$props2.style,
          className = _this$props2.className;
      var UUID = this.state.UUID;
      var value = propValue === undefined ? this.value : propValue;
      var classes = (0, _classnames.default)(className, 'rd-upload__label', size && "rd-upload__label--".concat(size));
      var placeholder = this.renderPlaceholder(value);
      var Config = {
        'custom': function custom() {
          return /*#__PURE__*/React.createElement("span", {
            onClick: _this2.handleClick
          }, typeof children === 'function' ? children(value) : children);
        },
        'input-button': function inputButton() {
          return /*#__PURE__*/React.createElement("span", {
            onClick: _this2.handleClick
          }, /*#__PURE__*/React.createElement(_input.default, {
            readOnly: true,
            placeholder: placeholder,
            value: value,
            size: size,
            suffix: buttonRender(size)
          }));
        },
        'native': function native() {
          return /*#__PURE__*/React.createElement("span", {
            onClick: _this2.handleClick
          }, buttonRender(size), /*#__PURE__*/React.createElement("span", {
            className: "hint",
            style: {
              marginLeft: 5
            }
          }, value === undefined || value === '' ? placeholder : value));
        }
      };

      if (_util.isIE) {
        return /*#__PURE__*/React.createElement("label", {
          className: classes,
          style: _objectSpread({}, style),
          htmlFor: "file__".concat(UUID)
        }, Config[theme].apply(this), /*#__PURE__*/React.createElement(_Span.default, {
          title: value
        }, /*#__PURE__*/React.createElement("input", {
          onClick: this.handleClick,
          type: "file",
          id: "file__".concat(UUID),
          name: name,
          title: '',
          style: {
            opacity: 0,
            overflow: 'hidden',
            width: '100%',
            height: '100%',
            position: 'absolute',
            left: 0,
            top: 0,
            cursor: 'pointer',
            fontSize: 9999
          },
          ref: function ref(_ref) {
            return _this2.fileInput = _ref;
          },
          onChange: this.handleFileChange
        })));
      }
      /**兼容safari 解决在safari中 title会显示2次的bug***/


      return /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread({}, style)
      }, /*#__PURE__*/React.createElement(_Span.default, {
        title: value
      }, Config[theme].apply(this), /*#__PURE__*/React.createElement("input", {
        onClick: this.handleClick,
        type: "file",
        name: name,
        title: '',
        style: {
          display: 'none'
        },
        ref: function ref(_ref2) {
          return _this2.fileInput = _ref2;
        },
        onChange: this.handleFileChange
      })));
    }
  }]);
  return FilePicker;
}(React.Component), _class2.defaultProps = {
  theme: 'native',
  size: 'medium',
  renderPlaceholder: _locale.default.t('rd.upload.notSelected'),
  buttonRender: function buttonRender(size) {
    return /*#__PURE__*/React.createElement(_button.default, {
      nativeType: "button",
      size: size
    }, _locale.default.t('rd.upload.selectFile'));
  }
}, _class2)) || _class) || _class);
exports.default = FilePicker;