import * as React from 'react';
interface FocusWithinProps {
    children: React.ReactElement;
    disabled?: boolean;
    focusClassName?: string;
}
/***
 * 该组件的功能是类似于css伪类:focus-within
 * 即当前组件包裹的children的子组件获得焦点、那么当前组件包裹的children就会添加is-focus类
 */
export default class FocusWithin extends React.PureComponent<FocusWithinProps> {
    state: {
        focus: boolean;
    };
    private el;
    static defaultProps: {
        focusClassName: string;
    };
    /**
     * 组件挂载完成
     */
    componentDidMount(): void;
    /**
     * 处理聚焦
     */
    private handleFocus;
    /**
     * 处理失去焦点
     */
    private handleBlur;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
