"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _handler = _interopRequireDefault(require("../handler"));

var _util = require("../../libs/utils/util");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FocusWithin =
/***
 * 该组件的功能是类似于css伪类:focus-within
 * 即当前组件包裹的children的子组件获得焦点、那么当前组件包裹的children就会添加is-focus类
 */
(0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(FocusWithin, _React$PureComponent);

  var _super = _createSuper(FocusWithin);

  function FocusWithin() {
    var _this;

    (0, _classCallCheck2.default)(this, FocusWithin);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      focus: false
    };
    _this.el = /*#__PURE__*/React.createRef();
    return _this;
  }

  (0, _createClass2.default)(FocusWithin, [{
    key: "componentDidMount",
    value:
    /**
     * 组件挂载完成
     */
    function componentDidMount() {
      var keys = Object.keys(this.props).filter(function (key) {
        return key !== 'children' && key !== 'disabled' && key !== 'focusClassName';
      }).map(function (key) {
        return key + '属性无效，';
      });
      (0, _warning.default)(keys.length === 0, 'FocusWithin', keys + 'FocusWithin组件只支持children、disabled、focusClassName属性');
    }
    /**
     * 处理聚焦
     */

  }, {
    key: "handleFocus",
    value: function handleFocus() {
      var _this$props = this.props,
          disabled = _this$props.disabled,
          focusClassName = _this$props.focusClassName;

      if (!disabled) {
        (0, _util.classList)(this.el.current).add(focusClassName);
      }
    }
    /**
     * 处理失去焦点
     */

  }, {
    key: "handleBlur",
    value: function handleBlur() {
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          focusClassName = _this$props2.focusClassName;

      if (!disabled) {
        (0, _util.classList)(this.el.current).remove(focusClassName);
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      return /*#__PURE__*/React.createElement(_handler.default, {
        ref: this.el,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      }, children);
    }
  }]);
  return FocusWithin;
}(React.PureComponent), _class2.defaultProps = {
  focusClassName: 'is-focus'
}, _class2)) || _class;

exports.default = FocusWithin;