"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormContext = require("./FormContext");

var _util = require("../../libs/utils/util");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DynamicFormList = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(DynamicFormList, _React$Component);

  var _super = _createSuper(DynamicFormList);

  /**
   * 构造函数
   * @param props
   */
  function DynamicFormList(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DynamicFormList);
    _this = _super.call(this, props);
    var defaultFields = props.defaultFields;
    var fields = defaultFields.map(function (item) {
      if (item.key === undefined) {
        item.key = (0, _util.UUID)();
      }

      return item;
    });
    _this.state = {
      dynamicFields: fields
    };
    return _this;
  }
  /**
   * 新增
   * @param defaultValue
   * @param insertIndex
   */


  (0, _createClass2.default)(DynamicFormList, [{
    key: "_add",
    value: function _add(defaultValue, insertIndex) {
      var dynamicFields = this.state.dynamicFields;
      /**查找最大的index**/

      var max = -1;
      /**实际插入的位置索引**/

      var acIndex;
      dynamicFields.forEach(function (field, index) {
        if (field.index > max) {
          max = field.index;
        }

        if (insertIndex !== undefined && field.index === insertIndex) {
          acIndex = index;
        }
      });

      if (acIndex === undefined) {
        acIndex = dynamicFields.length;
      }

      dynamicFields.splice(acIndex, 0, {
        key: (0, _util.UUID)(),
        index: max + 1
      });
      this.setState({
        dynamicFields: dynamicFields
      });
    }
    /**
     * 移除
     * @param index
     */

  }, {
    key: "_remove",
    value: function _remove(index) {
      var dynamicFields = this.state.dynamicFields;

      if (index === undefined) {
        var max = 0;
        dynamicFields.forEach(function (field) {
          if (field.index > max) {
            max = field.index;
          }
        });
        index = max - 1;
      }

      if (!Array.isArray(index)) {
        index = [index];
      }

      var _dynamicFields = dynamicFields.filter(function (field) {
        return !index.includes(field.index);
      });

      this.setState({
        dynamicFields: _dynamicFields
      });
    }
    /**
     *
     */

  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var dynamicFields = this.state.dynamicFields;
      return /*#__PURE__*/React.createElement(_FormContext.DynamicFormContext.Provider, {
        value: {
          fields: dynamicFields,
          add: this._add,
          remove: this._remove
        }
      }, /*#__PURE__*/React.createElement(_FormContext.DynamicFormContext.Consumer, null, children));
    }
  }]);
  return DynamicFormList;
}(React.Component), _class2.defaultProps = {
  defaultFields: new Array()
}, _class2)) || _class;

exports.default = DynamicFormList;