"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var React = _interopRequireWildcard(require("react"));

var _FormContext = require("./FormContext");

var _event = _interopRequireDefault(require("../../libs/event"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactDom = require("react-dom");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _locale = _interopRequireDefault(require("../locale"));

var _util = require("../../libs/utils/util");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * 将数组去重
 * @param array
 */
function getSetArray(array) {
  return Array.from(new Set(array));
}
/***
 * 判断defaultModel 是否是对象
 */


function warningDefaultModel(defaultModel) {
  (0, _warning.default)(defaultModel === undefined || (0, _util.classType)(defaultModel) === 'Object', 'Form', "defaultModel\u5E94\u8BE5\u662F\u4E00\u4E2A\u5BF9\u8C61,\u4F60\u4F20\u5165\u7684\u662F".concat((0, _util.classType)(defaultModel)));
}
/**
 *
 * @param defaultModel
 */


function defineCreator(defaultModel) {
  warningDefaultModel(defaultModel);
  var res = {
    ref: null,
    _defaultModel: defaultModel,
    data: {},
    setData: function setData(val) {
      res.data = val;
    }
  };
  var data = {};
  Object.defineProperty(res, 'data', {
    configurable: true,
    enumerable: true,
    get: function get() {
      return data;
    },
    set: function set(v) {
      if ((0, _typeof2.default)(v) === 'object') {
        data = _objectSpread(_objectSpread({}, data), v);
      } else {
        (0, _warning.default)(false, 'Form', 'data属性应该是一个对象');
      }
    }
  });
  return res;
}

var Form = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Form, _React$PureComponent);

  var _super = _createSuper(Form);

  /**
   * 构造函数
   * @param props
   */
  function Form(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Form);
    _this = _super.call(this, props);
    _this.propArrays = [];
    _this.state = {};
    _this.fields = new Array();
    _this._submit = void 0;
    _this.event = {
      target: new _event.default()
    };
    _this.formRef = /*#__PURE__*/React.createRef();
    _this.defaultModelCopy = void 0;
    _this.model = {};
    _this._model = {};
    _this.initVal = void 0;
    _this.state.UUID = props.target !== undefined ? props.target : (0, _util.UUID)();
    warningDefaultModel(props.defaultModel);
    return _this;
  }
  /**
   * 根据defaultModel初始化值
   */


  (0, _createClass2.default)(Form, [{
    key: "_batchUpdateModel",
    value: function _batchUpdateModel() {
      var _this2 = this;

      var defaultModelCopy = this.defaultModelCopy,
          _this$initVal = this.initVal,
          initVal = _this$initVal === void 0 ? {} : _this$initVal;
      /**合并defaultModel和还没挂载就setData的值**/

      var renderValue = _objectSpread(_objectSpread({}, defaultModelCopy), initVal);
      /**
       * 填充占位
       * 比如 输入[1,2] 而这个时候实际上formItem上是有3个元素
       * 这个时候回返回 [1,2,'']或者[1,2,[]] 第三个元素的值取决于formElement的默认值
       * @param _value
       * @param modelValue
       */


      var fillTheBlankValue = function fillTheBlankValue(_value, modelValue) {
        if (Array.isArray(_value) && Array.isArray(modelValue)) {
          _value = modelValue.map(function (item, index) {
            if (index + 1 <= _value.length) {
              return _value[index];
            }

            return item.value;
          });
        }

        return _value;
      };
      /**
       * 因为在formItem中设置了观察 给 this.calcModel 设置的值会自动格式化并给this.model赋值
       */


      Object.keys(renderValue).forEach(function (key) {
        _this2._model[key] = fillTheBlankValue(renderValue[key], _this2.model[key]);
      });
    }
    /**
     * 当props变化和state变化时会将props中的数据合并到state中
     * @param nextProps
     */

  }, {
    key: "componentDidMount",
    value:
    /**
     * 初始化后
     */
    function componentDidMount() {
      var initObserve = this.props.initObserve;
      var _this$props = this.props,
          useForm = _this$props.useForm,
          defaultModel = _this$props.defaultModel;

      if (useForm) {
        initObserve = useForm;
      }

      if (defaultModel && initObserve && initObserve._defaultModel) {
        (0, _warning.default)(false, 'Form', '使用createForm(defaultModel)传入值后不能使用props.defaultModel');
      }

      this.defaultModelCopy = (0, _util.deepClone)(this.props.defaultModel || initObserve && initObserve._defaultModel || {});
      this.initVal = (0, _util.deepClone)(initObserve && initObserve.data || {});

      this._batchUpdateModel();

      if (initObserve) {
        if (typeof initObserve === 'function') {
          //旧的 用法，在后续新版本中会被弃用，使用函数，于使用对象方式不一致，赋值对象也不一致
          initObserve(this._model);
        } else if ((0, _typeof2.default)(initObserve) === 'object') {
          initObserve.ref = this;
          initObserve.data = this._model;

          initObserve.setData = function (obj) {
            initObserve.data = obj;
          };

          var data = this._model;
          Object.defineProperty(initObserve, 'data', {
            configurable: true,
            enumerable: true,
            get: function get() {
              return data;
            },
            set: function set(v) {
              if ((0, _typeof2.default)(v) === 'object') {
                Object.keys(data).forEach(function (key) {
                  if (v.hasOwnProperty(key)) {
                    data[key] = v[key];
                  }
                });
                Object.keys(v).forEach(function (key) {
                  if (!data.hasOwnProperty(key)) {
                    data[key] = v[key];
                  }
                });
              } else {
                (0, _warning.default)(false, 'Form', 'data属性应该是一个对象');
              }
            }
          });
        }
      }
    }
    /**
     * 往fields中添加FormItem
     * @param child
     */

  }, {
    key: "_addField",
    value: function _addField(child) {
      var fields = (0, _toConsumableArray2.default)(this.fields);
      var prop = child.props.prop;

      if (prop) {
        var have = fields.find(function (field) {
          return field.props.prop === prop;
        });
        (0, _warning.default)(!have, 'FormItem', "FormItem \u7684prop\u5C5E\u6027\u4E0D\u5141\u8BB8\u91CD\u590D \u5F53\u524D\u91CD\u590D\u7684\u662F".concat(prop, ",\u8BF7\u68C0\u67E5\uFF01"));
      }

      fields.push(child);
      this.fields = fields;
    }
    /**
     * 移除FormItem
     * @param field
     */

  }, {
    key: "_removeField",
    value: function _removeField(field) {
      if (field.props.prop) {
        var fields = this.fields;

        var _fields = (0, _toConsumableArray2.default)(fields);

        _fields.splice(this.fields.indexOf(field), 1);

        this.fields = _fields;
      }
    }
    /**
     * 重置Form 只支持重置校验状态
     * propList  是一个prop构成的数组
     */

  }, {
    key: "resetFields",
    value: function resetFields(propList) {
      this.fields.forEach(function (field) {
        if (propList && Array.isArray(propList) && propList.includes(field.props.prop)) {
          field.resetField();
        }

        if (propList === undefined) {
          field.resetField();
        }
      });
    }
    /**
     * 得到最终渲染的model
     */

  }, {
    key: "_getValidateModel",
    value: function _getValidateModel(propList) {
      var res = {};
      var fieldsValue = this.getFieldsValue(getSetArray(propList ? propList : this.propArrays));
      fieldsValue.forEach(function (field) {
        res[field.prop] = field.value;
      });
      return res;
    }
    /**
     * 表单校验的方法
     * @param callback
     */

  }, {
    key: "validate",
    value: function validate(callback) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        var valid = true;
        var itemResultList = [];
        var count = 0; // 如果需要验证的fields为空，调用验证时立刻返回callback

        if (_this3.fields.length === 0 && callback) {
          if (callback && callback instanceof Function) {
            callback({
              valid: true
            });
          } else {
            resolve({
              valid: true
            });
          }
        }

        _this3.fields.forEach( /*#__PURE__*/function () {
          var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(field) {
            var haveRule, haveProp, haveSelfRule, haveChildren, itemResult, _model;

            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    haveProp = field.props.prop !== undefined && field.props.prop !== '';

                    if (haveProp) {
                      haveSelfRule = field.props.rules && field.props.rules.length !== 0;
                      haveRule = _this3.props.rules[field.props.prop] !== undefined || haveSelfRule;
                    }

                    haveChildren = !!field.props.children;

                    if (!(haveRule && haveProp && haveChildren)) {
                      _context.next = 15;
                      break;
                    }

                    _context.prev = 4;
                    _context.next = 7;
                    return field.validate('');

                  case 7:
                    itemResult = _context.sent;
                    _context.next = 13;
                    break;

                  case 10:
                    _context.prev = 10;
                    _context.t0 = _context["catch"](4);
                    itemResult = _context.t0;

                  case 13:
                    itemResultList.push(itemResult);

                    if (!itemResult.valid) {
                      valid = false;
                    }

                  case 15:
                    if (++count === _this3.fields.length) {
                      _model = _this3._getValidateModel();

                      if (callback && callback instanceof Function) {
                        callback({
                          valid: valid,
                          result: itemResultList,
                          model: _model
                        });
                      } else {
                        if (valid) {
                          resolve({
                            valid: valid,
                            model: _model
                          });
                        } else {
                          reject({
                            valid: valid,
                            result: itemResultList,
                            model: _model
                          });
                        }
                      }
                    }

                  case 16:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, null, [[4, 10]]);
          }));

          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }());
      });
    }
    /**
     * 获取一组字段名对应的值
     * @param keys
     */

  }, {
    key: "getFieldsValue",
    value: function getFieldsValue() {
      var _this4 = this;

      var keys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getSetArray(this.propArrays);
      var res = [];
      keys.forEach(function (key) {
        if (getSetArray(_this4.propArrays).includes(key)) {
          res.push({
            prop: key,
            value: _this4.getFieldValue(key)
          });
        }
      });
      return res;
    }
    /**
     * 获取字段名对应的值
     * @param prop
     */

  }, {
    key: "getFieldValue",
    value: function getFieldValue(prop) {
      if (!getSetArray(this.propArrays).includes(prop)) {
        return '';
      }

      var value = this._model[prop];
      return value !== undefined ? value : '';
    }
    /**
     * 设置一组字段名对应的值
     * @param fieldData
     */

  }, {
    key: "setFieldsValue",
    value: function setFieldsValue() {
      var _this5 = this;

      var fieldData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var setValue = function setValue(prop, value) {
        _this5._model[prop] = value;
      };

      fieldData.forEach(function (item) {
        /***
         * 传入的fieldData数据是这样的[{prop:'name',value:'tyu'},{prop:'age',value:'18'}]
         * 或者[{prop:'name',value:['jack','rose']},{prop:'age',value:'18'}]
         */
        if ((0, _util.classType)(item) === 'Object' && item.prop !== undefined && item.value !== undefined) {
          var prop = item.prop,
              value = item.value;

          if (getSetArray(_this5.propArrays).includes(prop)) {
            setValue(prop, value);
          }
        }
        /***
         * 传入的fieldData数据是这样的[['name'，'tyu'],['age'，'18']]
         */


        if ((0, _util.classType)(item) === 'Array' && item.length > 0) {
          if (item.length === 1) {
            item[1] = '';
          }

          if (getSetArray(_this5.propArrays).includes(item[0])) {
            setValue(item[0], item[1]);
          }
        }
      });
    }
    /**
     * 设置字段名对应的值
     * @param prop
     * @param value
     */

  }, {
    key: "setFieldValue",
    value: function setFieldValue(prop, value) {
      this._model[prop] = value;
    }
    /**
     * 校验某个表单域
     * @param prop
     * @param cb
     */

  }, {
    key: "validateField",
    value: function validateField(prop, cb) {
      var field = this.fields.filter(function (field) {
        return field.props.prop === prop;
      })[0];

      if (!field) {
        throw new Error(_locale.default.t('rd.form.propNotValid'));
      }

      return field.validate('', cb);
    }
    /**
     * 校验某个表单域
     * @param propList
     * @param allFinished
     */

  }, {
    key: "validateFields",
    value: function validateFields(propList, allFinished) {
      var _this6 = this;

      var fields = this.fields.filter(function (field) {
        return propList.find(function (item) {
          return item === field.props.prop;
        });
      });

      if (!fields) {
        throw new Error(_locale.default.t('rd.form.propNotValid'));
      }

      var promises = fields.map(function (field) {
        return field.validate('');
      });
      return new Promise(function (resolve, reject) {
        Promise.allSettled(promises).then(function (result) {
          var valid = true;
          var _result = [];
          result.forEach(function (item) {
            if (item.status === "rejected") {
              valid = false;

              _result.push(item.reason);
            } else {
              _result.push(item.value);
            }
          });

          var model = _this6._getValidateModel(propList);

          if (allFinished instanceof Function) {
            allFinished({
              valid: valid,
              result: _result,
              model: model
            });
          } else {
            if (valid) {
              resolve({
                valid: valid,
                result: _result,
                model: model
              });
            } else {
              reject({
                valid: valid,
                result: _result,
                model: model
              });
            }
          }
        });
      });
    }
    /**
     * 获取iframe的document
     * @param frame
     */

  }, {
    key: "submit",
    value:
    /***
     *供原始表单提交
     */
    function submit() {
      var onSubmit = this.props.onSubmit;
      this.formRef.current.submit();
      this._submit = true;
      onSubmit && onSubmit();
    }
    /**
     *处理正常结果
     */

  }, {
    key: "_handleResult",
    value: function _handleResult(e) {
      if (!this._submit) {
        return;
      }

      this._submit = false;
      var _this$props2 = this.props,
          onSuccess = _this$props2.onSuccess,
          onError = _this$props2.onError;
      var doc = Form.getDoc(e.target);

      if (!doc) {
        onError && onError('server abort');
        return;
      }

      if (doc.readyState === 'complete' || doc.readyState === 'interactive') {
        var docRoot = doc.body ? doc.body : doc.documentElement;
        var responseText = docRoot ? docRoot.innerText : '{}';

        var _response;

        try {
          _response = JSON.parse(responseText);
        } catch (e) {
          _response = responseText;
        }

        onSuccess && onSuccess(_response);
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this7 = this;

      var _this$props3 = this.props,
          _onSubmit = _this$props3.onSubmit,
          action = _this$props3.action,
          responseFromIframe = _this$props3.responseFromIframe,
          method = _this$props3.method,
          className = _this$props3.className,
          style = _this$props3.style,
          encType = _this$props3.encType,
          inline = _this$props3.inline,
          children = _this$props3.children,
          defaultModel = _this$props3.defaultModel,
          rules = _this$props3.rules,
          labelPosition = _this$props3.labelPosition,
          labelWidth = _this$props3.labelWidth,
          statusIcon = _this$props3.statusIcon,
          labelSuffix = _this$props3.labelSuffix,
          _onFieldChange = _this$props3.onFieldChange,
          extraData = _this$props3.extraData,
          size = _this$props3.size;
      var UUID = this.state.UUID;
      var classes = (0, _classnames.default)('rd-form', className, inline && 'rd-form--inline', "rd-form--".concat(size));
      return /*#__PURE__*/React.createElement(_FormContext.FormContext.Provider, {
        value: {
          defaultModel: defaultModel,
          rules: rules,
          onFieldChange: function onFieldChange(e, name, index) {
            _onFieldChange && _onFieldChange(e, name, index, _this7._model[name]);
          },
          labelPosition: labelPosition,
          statusIcon: statusIcon,
          labelWidth: labelWidth,
          labelSuffix: labelSuffix,
          model: this.model,
          _model: this._model,
          //modelAction: this.modelAction,
          event: this.event,
          push: function push(item) {
            _this7.propArrays.push(item);
          },
          remove: function remove(key) {
            _this7.propArrays = _this7.propArrays.filter(function (item) {
              return item !== key;
            });
          },
          resetModel: function resetModel() {
            return _this7._batchUpdateModel();
          },
          addField: function addField(field) {
            return _this7._addField(field);
          },
          removeField: function removeField(field) {
            return _this7._removeField(field);
          }
        }
      }, /*#__PURE__*/React.createElement("form", {
        onSubmit: function onSubmit(e) {
          _this7._submit = true;
          _onSubmit && _onSubmit(e);
        },
        ref: this.formRef,
        encType: encType,
        method: method,
        action: action,
        className: classes,
        style: style,
        target: "".concat(UUID)
      }, extraData && (0, _typeof2.default)(extraData) === 'object' && Object.entries(extraData).map(function (_ref2) {
        var _ref3 = (0, _slicedToArray2.default)(_ref2, 2),
            key = _ref3[0],
            value = _ref3[1];

        return /*#__PURE__*/React.createElement("input", {
          key: key,
          type: "hidden",
          style: {
            display: 'none'
          },
          name: key,
          value: value
        });
      }), children), responseFromIframe && /*#__PURE__*/(0, _reactDom.createPortal)( /*#__PURE__*/React.createElement("iframe", {
        style: {
          display: 'none'
        },
        name: "".concat(UUID),
        onLoad: this._handleResult
      }), document.body));
    }
  }], [{
    key: "createObserver",
    value:
    /**存放prop的数组的**/

    /**创建observer
     * @deprecated 使用createForm 代替
     */
    function createObserver(defaultModel) {
      return defineCreator(defaultModel);
    }
    /**
     * @param defaultModel 默认值
     * ref创建Form引用
     * data 表单域的值
     * setData 给表单域赋值
     */

  }, {
    key: "createForm",
    value: function createForm(defaultModel) {
      return defineCreator(defaultModel);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      return _objectSpread({}, nextProps);
    }
  }, {
    key: "getDoc",
    value: function getDoc(frame) {
      var doc = null;

      try {
        // simply checking may throw in ie8 under ssl or mismatched protocol
        doc = frame.contentDocument ? frame.contentDocument : frame.document;
      } catch (err) {
        (0, _warning.default)(false, 'Upload', 'cannot get iframe.contentDocument: ' + err);
        doc = frame.document;
      }

      return doc;
    }
  }]);
  return Form;
}(React.PureComponent), _class2.defaultProps = {
  labelSuffix: '',
  encType: 'multipart/form-data',
  method: 'POST',
  responseFromIframe: false,
  size: 'medium'
}, _class2.Item = void 0, _class2.DynamicFormList = void 0, _class2.List = void 0, _class2.createFormElement = void 0, _class2)) || _class;

exports.default = Form;