import * as React from 'react';
import { FormItemProps } from "./FormItem";
import { createFormElement } from "../../libs/createFormElement";
import { ObjectType } from "../../libs/types";
import EventTarget from '../../libs/event';
export interface FormElementProp extends FormItemProps {
    isArray?: boolean;
    name?: string;
    children?: React.ReactElement;
}
interface Event {
    target?: EventTarget;
    type?: symbol | string;
    callback?: (event: any) => void;
    [key: string]: any;
}
/**私有变量**/
declare class Reactive {
    private readonly _event;
    /**
     * 绑定model
     */
    makeReactive(model: ObjectType, calcModel: ObjectType, prop: string, isArray: boolean, index: number, forceUpdate: () => void): void;
    /**
     * event操作
     */
    event(): Event;
    /**
     * 移除event
     */
    removeEvent(): void;
}
export default class FormElement extends React.Component<FormElementProp> {
    static contextType: React.Context<any>;
    /**唯一标识**/
    private readonly key;
    /**用于标识当前的formElement在formItem中排第几 方便后面赋值**/
    private _index;
    reactive: Reactive;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: FormElementProp, context: any);
    /**
     * 得到FormItem onBlur的引用
     */
    getOnBlur(): () => void;
    /**
     * 得到FormItem onBlur的引用
     */
    getOnChange(): () => void;
    /**
     * 得到Form的引用
     */
    status(): React.ReactElement;
    /**
     *组件更新后
     */
    componentDidUpdate(): void;
    /**
     * 组件将要卸载
     */
    componentWillUnmount(): void;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export { createFormElement };
