"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "createFormElement", {
  enumerable: true,
  get: function get() {
    return _createFormElement.createFormElement;
  }
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormContext = require("./FormContext");

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _createFormElement = require("../../libs/createFormElement");

var _event = _interopRequireDefault(require("../../libs/event"));

var _class, _class3, _class4;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**私有变量**/
var Reactive = (0, _autoBind.default)(_class = /*#__PURE__*/function () {
  function Reactive() {
    (0, _classCallCheck2.default)(this, Reactive);
    this._event = {};
  }

  (0, _createClass2.default)(Reactive, [{
    key: "makeReactive",
    value:
    /**
     * 绑定model
     */
    function makeReactive(model, calcModel, prop, isArray, index, forceUpdate) {
      if (prop === undefined) {
        return;
      }
      /**缓存的当前model中对应prop的的值**/


      var value = model[prop];

      if (!value) {
        model[prop] = [];
        value = model[prop];
      }

      if ((0, _typeof2.default)(value) !== 'object') {
        model[prop] = [value];
        value = model[prop];
      }

      var _val = value[index];
      var event = this.event();
      event.target = new _event.default();
      event.type = String("item-update");

      event.callback = function () {
        forceUpdate();
      };

      event.target.addEventListener(event.type, event.callback);
      /**计算后的model中对应的prop的值**/

      Object.defineProperty(calcModel, prop, {
        configurable: true,
        enumerable: true,
        get: function get() {
          if (model[prop].length === 1) {
            return isArray ? model[prop] : model[prop][0];
          } else {
            return model[prop];
          }
        },
        set: function set(v) {
          if (Array.isArray(v)) {
            v.forEach(function (item, index) {
              value[index] = item;
            });
          } else {
            value[0] = v;
          }
        }
      });
      Object.defineProperty(value, index, {
        configurable: true,
        enumerable: true,
        get: function get() {
          return _val;
        },
        set: function set(v) {
          _val = v;
          /**通知页面刷新**/

          event.target.dispatchEvent(event.type);
        }
      });
    }
    /**
     * event操作
     */

  }, {
    key: "event",
    value: function event() {
      return this._event;
    }
    /**
     * 移除event
     */

  }, {
    key: "removeEvent",
    value: function removeEvent() {
      this.event().target.removeEventListener(this.event().type, this.event().callback);
    }
  }]);
  return Reactive;
}()) || _class;

var FormElement = (0, _autoBind.default)(_class3 = (_class4 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(FormElement, _React$Component);

  var _super = _createSuper(FormElement);

  /**唯一标识**/

  /**用于标识当前的formElement在formItem中排第几 方便后面赋值**/

  /**
   * 构造函数
   * @param props
   */
  function FormElement(props, context) {
    var _this;

    (0, _classCallCheck2.default)(this, FormElement);
    _this = _super.call(this, props);
    _this.key = void 0;
    _this._index = void 0;
    _this.reactive = new Reactive();
    _this.key = (0, _util.UUID)();
    var keyList = context === null || context === void 0 ? void 0 : context.keys;

    if (keyList) {
      var _ref = context || {},
          prop = _ref.prop,
          model = _ref.model,
          _model = _ref._model;

      _this._index = keyList.length();
      /**formItem每次初始化完后parent的_index应该+1**/

      keyList.add(_this.key);

      if (prop !== undefined && prop !== '') {
        if (_model[prop] === undefined) {
          model[prop] = model[prop] !== undefined ? model[prop] : [];
        } else {
          model[prop] = _model[prop];
        }

        _this.reactive.makeReactive(model, _model, prop, props.isArray, _this._index, _this.forceUpdate.bind((0, _assertThisInitialized2.default)(_this)));
      }
    }

    return _this;
  }
  /**
   * 得到FormItem onBlur的引用
   */


  (0, _createClass2.default)(FormElement, [{
    key: "getOnBlur",
    value: function getOnBlur() {
      var _this$context;

      return (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.onBlur;
    }
    /**
     * 得到FormItem onBlur的引用
     */

  }, {
    key: "getOnChange",
    value: function getOnChange() {
      var _this$context2;

      return (_this$context2 = this.context) === null || _this$context2 === void 0 ? void 0 : _this$context2.onChange;
    }
    /**
     * 得到Form的引用
     */

  }, {
    key: "status",
    value: function status() {
      var _this$context3;

      return (_this$context3 = this.context) === null || _this$context3 === void 0 ? void 0 : _this$context3.status;
    }
    /**
     *组件更新后
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this$context4, _this$context4$keys;

      this._index = (_this$context4 = this.context) === null || _this$context4 === void 0 ? void 0 : (_this$context4$keys = _this$context4.keys) === null || _this$context4$keys === void 0 ? void 0 : _this$context4$keys.index(this.key);
    }
    /**
     * 组件将要卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.context) {
        var _ref2 = this.context || {},
            prop = _ref2.prop,
            remove = _ref2.remove,
            keys = _ref2.keys,
            resetState = _ref2.resetState;

        if (prop !== undefined && prop !== '') {
          var length = this.context.keys.length();
          var index = this.context.keys.index(this.key);
          /**说明是最后一个**/

          if (index === length - 1) {
            resetState();
          }

          this.reactive.removeEvent();
        }

        remove && remove(this.key);
        /**组件销毁的时候移除掉*/

        keys === null || keys === void 0 ? void 0 : keys.remove(this.key);
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          isArray = _this$props.isArray;

      var _ref3 = this.context || {},
          prop = _ref3.prop,
          model = _ref3.model;

      var _props = _objectSpread({}, children.props);
      /**连续嵌套 例如select中就包含了Input**/


      if (_props.status === undefined) {
        _props.status = this.status();
      }
      /**如果没有写name 那么name=prop**/


      if (_props.name === undefined) {
        _props.name = prop;
      }

      if (prop !== undefined) {
        (0, _warning.default)(_props.value === undefined, 'FormItem->FormElement', '在表单中请不要绑定value 使用defaultValue代替 ');
        (0, _warning.default)(_props.onChange === undefined, 'FormItem->FormElement', '在表单中请不要绑定onChange ');
        _props.value = model[prop][this._index];
        _props.value === undefined && (_props.value = isArray ? [] : '');

        _props.onChange = function (e) {
          var _e$target;

          var value = e === null || e === void 0 ? void 0 : (_e$target = e.target) === null || _e$target === void 0 ? void 0 : _e$target.value;

          if (value === undefined) {
            value = e;
          }

          model[prop][_this2._index] = value;
          /**formItem 上面的change校验**/

          var onChange = _this2.getOnChange();

          onChange && onChange();

          var _ref4 = _this2.context || {},
              onFieldChange = _ref4.onFieldChange;

          onFieldChange && onFieldChange(e, prop, _this2._index);
        };

        var selfBlur = _props.onBlur;
        /**拦截onBlur**/

        _props.onBlur = function () {
          selfBlur && selfBlur.apply(void 0, arguments);
          /**formItem 上面的blur校验**/

          var onBlur = _this2.getOnBlur();

          onBlur && onBlur();
        };
      }
      /**这里用FormItemContext。provider是想阻断provider 也就是不想在FormElement中再次去消费**/


      return /*#__PURE__*/React.createElement(_FormContext.FormItemContext.Provider, {
        value: {}
      }, /*#__PURE__*/React.cloneElement(children, _props, _props.children));
    }
  }]);
  return FormElement;
}(React.Component), _class4.contextType = _FormContext.FormItemContext, _class4)) || _class3;

exports.default = FormElement;