"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _FormContext = require("./FormContext");

var _asyncValidator = _interopRequireDefault(require("async-validator"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _debounce = _interopRequireDefault(require("../../libs/debounce"));

var _CloseLine = _interopRequireDefault(require("net-design-icons/lib/icons/CloseLine"));

var _CompleteCircle = _interopRequireDefault(require("net-design-icons/lib/icons/CompleteCircle"));

var _LoaderLefTopLine = _interopRequireDefault(require("net-design-icons/lib/icons/LoaderLefTopLine"));

var _RemindLine = _interopRequireDefault(require("net-design-icons/lib/icons/RemindLine"));

var _validator = require("../../libs/utils/validator");

var _util = require("../../libs/utils/util");

var _classnames = _interopRequireDefault(require("classnames"));

var _spin = _interopRequireDefault(require("../spin"));

var _class, _dec, _class3, _class4, _class5;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FormItemLabel = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(FormItemLabel, _React$PureComponent);

  var _super = _createSuper(FormItemLabel);

  /**标识上一次渲染是否有children*/

  /**
   * 构造函数
   * @param props
   */
  function FormItemLabel(props) {
    var _this;

    (0, _classCallCheck2.default)(this, FormItemLabel);
    _this = _super.call(this, props);
    _this.key = void 0;
    _this.eventType = String("getMaxLabelWidth");
    _this.prevChildren = void 0;
    _this.label = void 0;
    _this.labelRoot = void 0;
    _this.state = {};
    _this.key = (0, _util.UUID)();
    return _this;
  }

  (0, _createClass2.default)(FormItemLabel, [{
    key: "getWidth",
    value:
    /**
     * 获取自适应的宽度
     */
    function getWidth() {
      var rootLabelWidth = 0;
      var clientRect = {
        width: 0
      };

      if (this.label) {
        this.label.style.width = 'auto';
        clientRect = this.label.getBoundingClientRect();
        var computedStyle = getComputedStyle(this.labelRoot);
        rootLabelWidth = parseFloat(computedStyle.paddingLeft) + parseFloat(computedStyle.paddingRight);
      }

      return clientRect.width + rootLabelWidth;
    }
    /**
     * 获取最大的label
     * @param event
     */

  }, {
    key: "setMaxLabelWidth",
    value: function setMaxLabelWidth(event) {
      this.setState({
        maxLabelWidth: Math.max.apply(Math, (0, _toConsumableArray2.default)(event.labelWidthList.map(function (item) {
          return item.labelWidth;
        })))
      });
      return 0;
    }
    /**
     *组件成功挂载
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          haveChildren = _this$props.haveChildren,
          labelWidth = _this$props.labelWidth;

      if (labelWidth !== undefined) {
        return;
      }

      if (!haveChildren) {
        return;
      } else {
        this.prevChildren = true;
        this.mountedChildren();
      }
    }
    /**
     *组件更新后
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this$props2 = this.props,
          haveChildren = _this$props2.haveChildren,
          labelWidth = _this$props2.labelWidth;

      if (labelWidth !== undefined) {
        return;
      }

      if (this.prevChildren && !haveChildren) {
        this.prevChildren = false;
        /**没有children那么就应该卸载掉*/

        this.unMountedChildren();
        return;
      } else if (!this.prevChildren && haveChildren) {
        this.prevChildren = true;
        /**之前没有children 现在有children*/

        this.mountedChildren();
        return;
      } else {
        this.updateChildren();
      }
    }
    /***
     * 组件将要卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var labelWidth = this.props.labelWidth;

      if (labelWidth !== undefined) {
        return;
      }

      this.unMountedChildren();
    }
    /**
     *children 更新相关逻辑
     */

  }, {
    key: "updateChildren",
    value: function updateChildren() {
      var _this2 = this;

      var _this$props3 = this.props,
          event = _this$props3.event,
          autoComputeMaxLabel = _this$props3.autoComputeMaxLabel;

      if (!autoComputeMaxLabel) {
        this.setMaxLabelWidth({
          labelWidthList: [{
            labelWidth: this.getWidth()
          }]
        });
        return;
      }

      event.labelWidthList = event.labelWidthList.map(function (item) {
        if (item.key === _this2.key) {
          item.labelWidth = _this2.getWidth();
        }

        return item;
      });
      /**通知刷新**/

      event.target.dispatchEvent(this.eventType, event);
    }
    /**
     *children挂载相关逻辑
     */

  }, {
    key: "mountedChildren",
    value: function mountedChildren() {
      var _this$props4 = this.props,
          event = _this$props4.event,
          autoComputeMaxLabel = _this$props4.autoComputeMaxLabel;

      if (!autoComputeMaxLabel) {
        this.setMaxLabelWidth({
          labelWidthList: [{
            labelWidth: this.getWidth()
          }]
        });
        return;
      }

      if (!event.labelWidthList) {
        event.labelWidthList = [];
      }

      event.target.addEventListener(this.eventType, this.setMaxLabelWidth);
      event.labelWidthList.push({
        key: this.key,
        labelWidth: this.getWidth()
      });
      /**通知刷新**/

      event.target.dispatchEvent(this.eventType, event);
    }
    /**
     * children卸载相关逻辑
     */

  }, {
    key: "unMountedChildren",
    value: function unMountedChildren() {
      var _this3 = this;

      var _this$props5 = this.props,
          event = _this$props5.event,
          autoComputeMaxLabel = _this$props5.autoComputeMaxLabel;

      if (!autoComputeMaxLabel) {
        return;
      } // 需要有个默认值，否则可能会出现labelWidthList为undefined的情况


      var _event$labelWidthList = event.labelWidthList,
          labelWidthList = _event$labelWidthList === void 0 ? [] : _event$labelWidthList;
      event.labelWidthList = labelWidthList.filter(function (item) {
        return item.key !== _this3.key;
      });
      event.target.removeEventListener(this.eventType, this.setMaxLabelWidth);
      /**通知刷新**/

      event.target.dispatchEvent(this.eventType, event);
    }
    /**
     * 得到label的宽度
     */

  }, {
    key: "labelWidth",
    value: function labelWidth() {
      var _this$props6 = this.props,
          label = _this$props6.label,
          labelPosition = _this$props6.labelPosition,
          labelWidth = _this$props6.labelWidth;

      if (!label) {
        return undefined;
      }

      if (labelPosition === 'top') {
        return undefined;
      }

      var _labelWidth;

      if (labelWidth) {
        return labelWidth;
      } else {
        _labelWidth = this.state.maxLabelWidth;
      }

      if (_labelWidth) {
        /**不同浏览器对小数处理不一样所以这里处理下**/
        return Math.ceil(_labelWidth * 100) / 100;
      }
    }
    /**
     * label的文本位置
     */
    // textAlign(): React.CSSProperties {
    //     const {labelPosition} = this.props;
    //     if (labelPosition === 'top') {
    //         return {
    //             textAlign: 'left',
    //             wordWrap: 'break-word',
    //             wordBreak: 'normal',
    //             display: 'block'
    //         }
    //     } else {
    //         return {
    //             textAlign: labelPosition
    //         }
    //     }
    // }

    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props7 = this.props,
          labelPosition = _this$props7.labelPosition,
          labelSuffix = _this$props7.labelSuffix,
          label = _this$props7.label,
          isRequired = _this$props7.isRequired;

      if (!label) {
        return '';
      } //如果labelPosition为top，则需要添加类名


      var labelWidth = this.labelWidth();
      var labelClassNames = (0, _classnames.default)('rd-form-item__label', "rd-form-item__label--".concat(labelPosition));
      return /*#__PURE__*/React.createElement("div", {
        className: labelClassNames,
        ref: function ref(_ref2) {
          return _this4.labelRoot = _ref2;
        },
        style: {
          width: labelWidth
        }
      }, /*#__PURE__*/React.createElement("label", {
        className: "rd-form-item__label-inner",
        ref: function ref(_ref) {
          return _this4.label = _ref;
        },
        style: {
          width: labelWidth,
          whiteSpace: labelPosition === 'top' ? 'normal' : 'nowrap'
        }
      }, isRequired && /*#__PURE__*/React.createElement("label", {
        className: "rd-form-item__label-required"
      }, "*"), typeof label === 'string' ? label + labelSuffix : label));
    }
  }]);
  return FormItemLabel;
}(React.PureComponent)) || _class;

var FormItem = (_dec = (0, _debounce.default)(50), (0, _autoBind.default)(_class3 = (_class4 = (_class5 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(FormItem, _React$Component);

  var _super2 = _createSuper(FormItem);

  function FormItem() {
    var _this5;

    (0, _classCallCheck2.default)(this, FormItem);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this5 = _super2.call.apply(_super2, [this].concat(args));
    _this5.state = {
      error: '',
      valid: false,
      validated: false,
      validating: false
    };
    _this5.label = void 0;
    _this5._keyList = [];
    _this5._isMounted = void 0;
    return _this5;
  }

  (0, _createClass2.default)(FormItem, [{
    key: "safeSetState",
    value:
    /**
     * 安全的设置state
     * @param state
     * @param callback
     */
    function safeSetState(state, callback) {
      this._isMounted && this.setState(state, callback);
    }
    /**
     * 第一次挂载
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _ref3 = this.context || {},
          addField = _ref3.addField,
          push = _ref3.push;

      var prop = this.props.prop;
      addField && addField(this);

      if (prop) {
        push && push(prop);
      }

      this._isMounted = true;
    }
    /**
     * 组件卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _ref4 = this.context || {},
          removeField = _ref4.removeField,
          remove = _ref4.remove;

      removeField && removeField(this);
      var prop = this.props.prop;

      if (prop) {
        remove && remove(prop);
      }

      this._isMounted = false;
    }
    /**
     * 在FormItem失去焦点时
     */

  }, {
    key: "handleFieldBlur",
    value: function () {
      var _handleFieldBlur = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return this.validate('blur');

              case 3:
                _context.next = 7;
                break;

              case 5:
                _context.prev = 5;
                _context.t0 = _context["catch"](0);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 5]]);
      }));

      function handleFieldBlur() {
        return _handleFieldBlur.apply(this, arguments);
      }

      return handleFieldBlur;
    }()
    /**
     * 在FormItem中的input等值改变时
     */

  }, {
    key: "handleFieldInput",
    value: function () {
      var _handleFieldInput = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2() {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return this.validate('change');

              case 3:
                _context2.next = 7;
                break;

              case 5:
                _context2.prev = 5;
                _context2.t0 = _context2["catch"](0);

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[0, 5]]);
      }));

      function handleFieldInput() {
        return _handleFieldInput.apply(this, arguments);
      }

      return handleFieldInput;
    }()
    /**
     * 得到规则
     */

  }, {
    key: "getRules",
    value: function getRules() {
      var _ref5 = this.context || {},
          rules = _ref5.rules;

      var formRule = rules;
      var selfRule = this.props.rules;
      /**先从Form上取 Form上没有在从自身上取**/

      var formRules = formRule ? formRule[this.props.prop] : [];
      return [].concat(selfRule || formRules || []);
    }
    /**
     *根据触发类型得到指定的rule
     * @param trigger
     */

  }, {
    key: "getFilteredRule",
    value: function getFilteredRule(trigger) {
      var rules = this.getRules();
      return rules.filter(function (rule) {
        if (!rule.trigger || trigger === '') {
          return true;
        }

        if (Array.isArray(rule.trigger)) {
          return rule.trigger.indexOf(trigger) > -1;
        } else {
          return rule.trigger === trigger;
        }
      }).map(function (rule) {
        return Object.assign({}, rule);
      });
    }
    /**
     * 重置当前FormItem
     */

  }, {
    key: "resetField",
    value: function resetField() {
      var valid = true;
      var validated = false;
      var error = '';

      var _ref6 = this.context || {},
          resetModel = _ref6.resetModel;

      resetModel && resetModel();
      this.safeSetState({
        valid: valid,
        error: error,
        validated: validated
      });
    }
    /**
     * 添加自定义的规则
     * @param rules
     */

  }, {
    key: "componentDidUpdate",
    value:
    /**
     * 更新校验
     * @param prevProps 
     * @param prevState 
     */
    function componentDidUpdate(prevProps, prevState) {
      var _prevProps$children, _prevProps$children$p, _props;

      var _this$props8 = this.props,
          disabled = _this$props8.disabled,
          children = _this$props8.children;

      if (prevProps.disabled !== disabled) {
        this.validate('blur');
      } else if (((_prevProps$children = prevProps.children) === null || _prevProps$children === void 0 ? void 0 : (_prevProps$children$p = _prevProps$children.props) === null || _prevProps$children$p === void 0 ? void 0 : _prevProps$children$p.disabled) !== (children === null || children === void 0 ? void 0 : (_props = children.props) === null || _props === void 0 ? void 0 : _props.disabled)) {
        this.validate('blur');
      }
    }
    /**
     * 当前FormItem验证
     * @param trigger
     * @param cb
     */

  }, {
    key: "validate",
    value: function validate(trigger, cb) {
      var _props2,
          _this6 = this;

      if (!this._isMounted) {
        return new Promise(function (resolve, reject) {
          reject(new Error('component already unMounted'));
        });
      }

      var _this$props9 = this.props,
          prop = _this$props9.prop,
          validateMessage = _this$props9.validateMessage,
          disabled = _this$props9.disabled,
          children = _this$props9.children;
      /**
       * by xm
       * formItem为禁用时，不校验
       * 当formItem只有一个子集且为disabled为true时，不进行校验
       */

      if (disabled || children !== null && children !== void 0 && (_props2 = children.props) !== null && _props2 !== void 0 && _props2.disabled) {
        this.safeSetState({
          error: '',
          validating: false,
          validated: true,
          valid: true
        });
        return Promise.resolve({
          valid: true,
          field: prop
        });
      }

      var value = this.fieldValue();
      var rules = this.getFilteredRule(trigger);
      rules = FormItem.addCustomRules(rules, value);

      if (!rules || rules.length === 0) {
        if (cb && cb instanceof Function) {
          cb({
            valid: true,
            field: prop
          });
        } else {
          return Promise.resolve({
            valid: true,
            field: prop
          });
        }
      }

      this.safeSetState({
        validating: true
      });
      var descriptor = (0, _defineProperty2.default)({}, prop, rules);
      var validator = new _asyncValidator.default(descriptor);
      var model = (0, _defineProperty2.default)({}, prop, value);
      return new Promise(function (resolve, reject) {
        validator.validate(model, {
          firstFields: true
        }, function (errors) {
          if (validateMessage) {
            errors = [{
              message: validateMessage,
              field: prop
            }];
          }

          _this6.safeSetState({
            error: errors ? errors[0].message : '',
            validating: false,
            validated: true,
            valid: !errors
          }, function () {
            if (cb instanceof Function) {
              var err = errors ? errors[0] : {};
              cb(_objectSpread({
                valid: !errors
              }, err));
            } else {
              if (errors) {
                reject(_objectSpread({
                  valid: false
                }, errors[0]));
              } else {
                resolve({
                  valid: true,
                  field: prop
                });
              }
            }
          });
        });
      });
    }
    /**
     * 得到当前name指定的值
     */

  }, {
    key: "fieldValue",
    value: function fieldValue() {
      var _ref7 = this.context || {},
          _model = _ref7._model;

      var prop = this.props.prop;

      if (!_model || !prop) {
        return;
      } //当前只能有这么一层
      //prop使用对象的时候：a.b
      //prop使用数组：a.0
      //冒号应该是.,但是如果要用可以写成:, 后期可以更改


      var temp = prop.split(':');
      var modelAny = _model;
      return temp.length > 1 ? modelAny[temp[0]][temp[1]] : modelAny[prop];
    }
    /**
     * 是否是需要的
     */

  }, {
    key: "isRequired",
    value: function isRequired() {
      var rules = this.getRules();
      var isRequired = false;

      if (rules && rules.length) {
        rules.every(function (rule) {
          if (rule.required) {
            isRequired = true;
            return false;
          }

          return true;
        });
      }

      return isRequired;
    }
    /**
     * 获取labelPosition
     */

  }, {
    key: "getLabelPosition",
    value: function getLabelPosition() {
      var _ref8 = this.context || {},
          labelPosition = _ref8.labelPosition;

      var _labelPosition = labelPosition || this.props.labelPosition;

      if (!_labelPosition) {
        _labelPosition = 'right';
      }

      return _labelPosition;
    }
    /***
     * 根据validateStatus 生成icon
     */

  }, {
    key: "getIconByValidateStatus",
    value: function getIconByValidateStatus() {
      var icon;
      var validateStatus = this.props.validateStatus;

      if (validateStatus === 'success') {
        icon = /*#__PURE__*/React.createElement(_CompleteCircle.default, null);
      } else if (validateStatus === 'warning') {
        icon = /*#__PURE__*/React.createElement(_RemindLine.default, null);
      } else if (validateStatus === 'error') {
        icon = /*#__PURE__*/React.createElement(_CloseLine.default, null);
      } else if (validateStatus === 'validating') {
        icon = /*#__PURE__*/React.createElement(_spin.default, {
          loading: true,
          icon: function icon() {
            return /*#__PURE__*/React.createElement(_LoaderLefTopLine.default, null);
          }
        });
      }

      return icon;
    }
    /**
     * 渲染suffix
     */

  }, {
    key: "renderSuffix",
    value: function renderSuffix() {
      var _this$state = this.state,
          validated = _this$state.validated,
          validating = _this$state.validating;

      var _ref9 = this.context || {},
          statusIcon = _ref9.statusIcon;

      var error = this.state.error;
      var _this$props10 = this.props,
          validateMessage = _this$props10.validateMessage,
          validateStatus = _this$props10.validateStatus;
      error = validateMessage ? validateMessage : error;

      if (!statusIcon) {
        return undefined;
      }

      if (!validated) {
        return undefined;
      }

      var icon = error ? /*#__PURE__*/React.createElement(_CloseLine.default, null) : /*#__PURE__*/React.createElement(_CompleteCircle.default, null);

      if (validating) {
        icon = /*#__PURE__*/React.createElement(_spin.default, {
          loading: true,
          icon: function icon() {
            return /*#__PURE__*/React.createElement(_LoaderLefTopLine.default, null);
          }
        });
      }

      if (validateStatus) {
        icon = this.getIconByValidateStatus();
      }

      return {
        className: 'rd-input__status',
        children: icon
      };
    }
    /**
     * 计算className
     */

  }, {
    key: "getClassNames",
    value: function getClassNames(isRequired) {
      var _this$state2 = this.state,
          validating = _this$state2.validating,
          validated = _this$state2.validated;
      var _this$props11 = this.props,
          className = _this$props11.className,
          validateStatus = _this$props11.validateStatus,
          validateMessage = _this$props11.validateMessage;
      var error = this.state.error;
      error = validateMessage ? validateMessage : error;
      return (0, _classnames.default)(className, 'rd-form-item', {
        'is-error': validateStatus ? validateStatus === 'error' : error !== '',
        'is-validating': validateStatus ? validateStatus === 'validating' : validating,
        'is-success': validateStatus ? validateStatus === 'success' : validated && error === '',
        'is-warning': validateStatus && validateStatus === 'warning',
        'is-required': isRequired
      });
    }
    /**
     * 获取computedStyle
     */

  }, {
    key: "getComputedOuterStyle",
    value: function getComputedOuterStyle(labelPosition) {
      var style = this.props.style;

      if ((style === null || style === void 0 ? void 0 : style.display) === 'none') {
        return _objectSpread({}, style);
      } else {
        return _objectSpread(_objectSpread({}, style), {}, {
          display: labelPosition === 'top' ? 'block' : 'table'
        });
      }
    }
    /**
     * KeyList 操作
     */

  }, {
    key: "keyList",
    value: function keyList() {
      var _this7 = this;

      /**获取长度*/
      var length = function length() {
        return _this7._keyList.length;
      };
      /**获取指定key的索引*/


      var index = function index(key) {
        return _this7._keyList.findIndex(function (item) {
          return item.key === key;
        });
      };
      /**添加*/


      var add = function add(key) {
        _this7._keyList.push({
          key: key
        });
      };
      /**删除*/


      var remove = function remove(key) {
        _this7._keyList = _this7._keyList.filter(function (item) {
          return item.key !== key;
        });
      };

      return {
        length: length,
        index: index,
        add: add,
        remove: remove
      };
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this8 = this;

      var _this$props12 = this.props,
          style = _this$props12.style,
          label = _this$props12.label,
          required = _this$props12.required,
          children = _this$props12.children,
          prop = _this$props12.prop,
          validateMessage = _this$props12.validateMessage,
          autoComputeMaxLabel = _this$props12.autoComputeMaxLabel;
      var error = this.state.error;
      error = validateMessage ? validateMessage : error;
      var isRequired = required === false ? false : this.isRequired() || required;
      var classes = this.getClassNames(isRequired);
      var labelPosition = this.getLabelPosition();

      var _ref10 = this.context || {},
          labelSuffix = _ref10.labelSuffix,
          _labelWidth = _ref10.labelWidth;

      var labelWidth = this.props.labelWidth !== undefined ? this.props.labelWidth : _labelWidth;

      var _ref11 = this.context || {},
          onFieldChange = _ref11.onFieldChange,
          event = _ref11.event,
          model = _ref11.model,
          _model = _ref11._model,
          remove = _ref11.remove;

      var main = /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: this.getComputedOuterStyle(labelPosition)
      }, /*#__PURE__*/React.createElement(FormItemLabel, {
        style: style,
        className: classes,
        isRequired: isRequired,
        label: label,
        labelPosition: labelPosition,
        labelSuffix: labelSuffix,
        labelWidth: labelWidth,
        haveChildren: !!children,
        autoComputeMaxLabel: autoComputeMaxLabel,
        event: event
      }), /*#__PURE__*/React.createElement("div", {
        className: "rd-form-item__content",
        style: {
          display: labelPosition === 'top' ? 'block' : 'table-cell'
        }
      }, /*#__PURE__*/React.createElement(_FormContext.FormContext.Provider, {
        value: {}
      }, children), error && !!children && /*#__PURE__*/React.createElement("div", {
        className: "rd-form-item__error"
      }, error)));

      if (prop === undefined || prop === '') {
        return main;
      }

      return /*#__PURE__*/React.createElement(_FormContext.FormItemContext.Provider, {
        value: {
          keys: this.keyList(),
          prop: prop,
          model: model,
          _model: _model,
          remove: remove,
          onFieldChange: onFieldChange,
          status: this.renderSuffix(),
          onBlur: this.handleFieldBlur,
          onChange: this.handleFieldInput,
          resetState: function resetState() {
            _this8.setState({
              error: '',
              valid: false,
              validated: false,
              validating: false
            });
          }
        }
      }, main);
    }
  }], [{
    key: "addCustomRules",
    value: function addCustomRules(rules, value) {
      return rules.map(function (rule) {
        var arr = {
          ascii: _validator.ascii,
          byteLen: _validator.byteLen,
          date: _validator.date,
          email: _validator.email,
          hex: _validator.hex,
          ip: _validator.ip,
          mac: _validator.mac,
          mask: _validator.mask,
          numRange: _validator.numRange,
          serverName: _validator.serverName,
          ssid: _validator.ssid,
          ssidPwd: _validator.ssidPwd,
          url: _validator.url,
          domain: _validator.domain
        };

        for (var _key2 in arr) {
          var name = _key2;
          /**如果没有设置type值 那么type修改成和value一样的类型  validator的默认值为string会导致用number且没有写type的时候的一些怪异情况**/

          if (!rule.type) {
            var type = ['string', 'number', 'boolean', 'method', 'regexp', 'integer', 'float', 'array', 'object', 'enum', 'date', 'url', 'hex', 'email', 'any'];

            var _type = (0, _util.classType)(value).toLowerCase();

            rule.type = type.includes(_type) ? _type : 'any';
          }

          if (rule[name]) {
            var _name = name;
            rule.validator = arr[_name];

            if (rule[name] instanceof Object) {
              rule.params = rule[name];
            }

            break;
          }
        }

        var validator = rule.validator;

        if (validator) {
          rule.validator = function (rule) {
            var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
            var callback = arguments.length > 2 ? arguments[2] : undefined;
            var source = arguments.length > 3 ? arguments[3] : undefined;
            var options = arguments.length > 4 ? arguments[4] : undefined;

            try {
              validator(rule, value, callback, source, options);
            } catch (error) {
              callback(new Error(error));
            }
          };
        }

        return rule;
      });
    }
  }]);
  return FormItem;
}(React.Component), _class5.defaultProps = {
  autoComputeMaxLabel: true
}, _class5.contextType = _FormContext.FormContext, _class5), ((0, _applyDecoratedDescriptor2.default)(_class4.prototype, "handleFieldInput", [_dec], Object.getOwnPropertyDescriptor(_class4.prototype, "handleFieldInput"), _class4.prototype)), _class4)) || _class3);
exports.default = FormItem;