"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _RowContext = _interopRequireDefault(require("./RowContext"));

var _excluded = ["prefixCls", "span", "offset", "className", "style", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Col = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Col, _React$Component);

  var _super = _createSuper(Col);

  function Col() {
    var _this;

    (0, _classCallCheck2.default)(this, Col);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.validSpan = function (span) {
      if (Number(span) > 24) {
        (0, _warning.default)(false, 'Col', 'span 或 offset属性值不能大于24');
        return 24;
      } else {
        return span;
      }
    };

    _this.renderCol = function () {
      var _classNames;

      var _assertThisInitialize = (0, _assertThisInitialized2.default)(_this),
          props = _assertThisInitialize.props;

      var customPrefixCls = props.prefixCls,
          span = props.span,
          offset = props.offset,
          className = props.className,
          style = props.style,
          children = props.children,
          others = (0, _objectWithoutProperties2.default)(props, _excluded);
      var prefixCls = (0, _util.getPrefixCls)('col', customPrefixCls);
      var sizeClassObj = {}; //{span: 5}

      ['xs', 'sm', 'md', 'lg', 'xl'].forEach(function (size) {
        var _objectSpread2;

        var sizeProps = {};
        var propSize = props[size];

        if (typeof propSize === 'number' || typeof propSize === 'string') {
          sizeProps.span = propSize;
        } else if ((0, _typeof2.default)(propSize) === 'object') {
          sizeProps = propSize || {};
        }

        delete others[size];
        sizeClassObj = _objectSpread(_objectSpread({}, sizeClassObj), {}, (_objectSpread2 = {}, (0, _defineProperty2.default)(_objectSpread2, "".concat(prefixCls, "-").concat(size, "-").concat(_this.validSpan(sizeProps.span)), sizeProps.span !== undefined), (0, _defineProperty2.default)(_objectSpread2, "".concat(prefixCls, "-").concat(size, "-offset-").concat(_this.validSpan(sizeProps.span)), sizeProps.offset || sizeProps.offset === 0), _objectSpread2));
      });
      var classes = (0, _classnames.default)(prefixCls, (_classNames = {}, (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "-").concat(_this.validSpan(span)), span !== undefined), (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "-offset-").concat(_this.validSpan(offset)), offset), _classNames), className, sizeClassObj);
      return /*#__PURE__*/React.createElement(_RowContext.default.Consumer, null, function (_ref) {
        var gutter = _ref.gutter;

        var colStyle = _objectSpread({}, style);

        if (gutter) {
          colStyle = _objectSpread(_objectSpread(_objectSpread({}, gutter[0] > 0 ? {
            paddingLeft: gutter[0] / 2,
            paddingRight: gutter[0] / 2
          } : {}), gutter[1] > 0 ? {
            paddingTop: gutter[1] / 2,
            paddingBottom: gutter[1] / 2
          } : {}), colStyle);
        }

        return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({}, others, {
          className: classes,
          style: colStyle
        }), children);
      });
    };

    return _this;
  }

  (0, _createClass2.default)(Col, [{
    key: "render",
    value:
    /** */
    function render() {
      return /*#__PURE__*/React.createElement(React.Fragment, null, this.renderCol());
    }
  }]);
  return Col;
}(React.Component);

exports.default = Col;