"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _ref5 = require("../../libs/ref");

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _raf = _interopRequireDefault(require("raf"));

var _dec, _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CallbacksMap = [['insertBeforeCallbacks', 'insertBefore'], ['replaceChildCallbacks', 'replaceChild'], ['insertBeforeCallbacks', 'insertBefore'], ['removeChildCallbacks', 'removeChild']];
var Handler = (
/***
 * 该组件的功能相当于在children之前用一个div去包裹了 事件全部由div捕获处理了 但是最终div是没有显示在页面上的
 */
_dec = (0, _ref5.forwardRef)(), _dec(_class = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Handler, _React$PureComponent);

  var _super = _createSuper(Handler);

  /**是否挂载完成**/

  /**
   * 构造函数
   * @param props
   */
  function Handler(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Handler);
    _this = _super.call(this, props);
    _this.directlyRef = void 0;
    _this.el = /*#__PURE__*/React.createRef();
    _this.state = {};
    _this.key = void 0;
    _this.parentNode = void 0;
    _this.removedSibling = void 0;
    _this.childNodes = void 0;
    _this._isMounted = false;
    _this.directlyRef = (0, _util.combineRef)(props, true);
    _this.key = (0, _util.UUID)();
    return _this;
  }
  /**
   *给ref手动赋值
   * @param node
   */


  (0, _createClass2.default)(Handler, [{
    key: "assignmentRef",
    value: function assignmentRef(node) {
      if (this.directlyRef instanceof Function) {
        this.directlyRef(node);
      } else {
        this.directlyRef.current = node;
      }
    }
    /**
     * 组件挂载完成
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          disabled = _this$props.disabled,
          onBeforeReplace = _this$props.onBeforeReplace,
          onAfterReplace = _this$props.onAfterReplace,
          children = _this$props.children;
      var count = React.Children.count(children);

      if (count !== 1 && children) {
        return;
      }

      var _this$el$current = this.el.current,
          parentNode = _this$el$current.parentNode,
          childNodes = _this$el$current.childNodes;
      this.parentNode = parentNode;
      this.childNodes = Array.from(childNodes);

      if (!disabled) {
        this.removedSibling = this.el.current.nextSibling;
        var shouldFocus = false;
        var activeElement;

        var beforeReplace = function beforeReplace(el) {
          /*移动位置后之前获得的焦点会失去焦点这里先拿到焦点元素 方便后面重新获得焦点*/
          activeElement = document.activeElement;

          if (el.contains(activeElement)) {
            shouldFocus = true;
          }

          onBeforeReplace && onBeforeReplace(el);
        };

        var afterReplace = function afterReplace() {
          if (shouldFocus) {
            /**确保在移动children后的下一帧才去聚焦**/
            (0, _raf.default)(function () {
              _this2._isMounted = true;
              activeElement.focus();
              onAfterReplace && onAfterReplace();
            });
          } else {
            _this2._isMounted = true;
            onAfterReplace && onAfterReplace();
          }
        };

        this.el.current.UUID = this.key;
        /***
         * 因为下面this.el.current的children被插入到this.el.current的parentNode中去了
         * react库在fiber中保留的是this.el.current 操作的是this.el.current  而这个时候this.el.current 下面没有childNode
         * 所以需要将this.el.current 的方法覆写一遍
         * @param oldChild
         */

        this.el.current.removeChild = function (oldChild) {
          try {
            _this2.childNodes = _this2.childNodes.filter(function (node) {
              return node !== oldChild;
            });

            if (_this2.childNodes.length === 0) {
              /**childNodes 之前只有一个 现在移除后就没有了 那么removedSibling=oldChild.nextSibling**/
              _this2.removedSibling = oldChild.nextSibling;
            }

            var length = _this2.childNodes.length;
            /**删除操作交由父类去操作**/

            var res = parentNode.removeChild(oldChild);
            (0, _raf.default)(function () {
              /**一般执行了removeChild 后可能会执行appendChild 这里判断如果没有执行appendChild 后应该给ref赋值**/
              if (_this2.childNodes.length === length) {
                _this2.assignmentRef(_this2.childNodes[0]);
              }
            });
            return res;
          } catch (e) {
            (0, _warning.default)(false, 'Handler', e.message);
            return null;
          }
        };

        this.el.current.replaceChild = function (newChild, oldChild) {
          try {
            var res = parentNode.replaceChild(newChild, oldChild);
            _this2.childNodes = _this2.childNodes.map(function (node) {
              if (node === oldChild) {
                return newChild;
              }

              return node;
            });

            _this2.assignmentRef(_this2.childNodes[0]);

            return res;
          } catch (e) {
            (0, _warning.default)(false, 'Handler', e.message);
            return null;
          }
        };

        this.el.current.insertBefore = function (newChild, refChild) {
          var index = _this2.childNodes.findIndex(function (node) {
            return node === refChild;
          });

          _this2.childNodes.splice(index, 0, newChild);

          var res;

          try {
            res = parentNode.insertBefore(newChild, refChild);
          } catch (e) {
            (0, _warning.default)(false, 'Handler', e.message);
            res = null;
          }

          _this2.assignmentRef(_this2.childNodes[0]);

          return res;
        };

        this.el.current.appendChild = function (newChild) {
          try {
            var removedSibling = _this2.childNodes.length === 0 ? _this2.removedSibling : _this2.childNodes[_this2.childNodes.length - 1].nextSibling;
            var res = !removedSibling ? parentNode.appendChild(newChild) : parentNode.insertBefore(newChild, removedSibling);

            _this2.childNodes.push(newChild);

            _this2.assignmentRef(_this2.childNodes[0]);

            return res;
          } catch (e) {
            (0, _warning.default)(false, 'Handler', e.message);
            return null;
          }
        };

        Array.from(childNodes).forEach(function (node) {
          beforeReplace(node);
          parentNode.insertBefore(node, _this2.el.current);
        });
        parentNode.removeChild(this.el.current);
        CallbacksMap.forEach(function (_ref) {
          var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
              methodsCallbacks = _ref2[0],
              method = _ref2[1];

          if (!_this2.parentNode[methodsCallbacks]) {
            _this2.parentNode[methodsCallbacks] = [];

            _this2.parentNode[method] = function () {
              var res; //执行此父级元素上的对应方法的所有方法（两个handler同一个父级的情况，要都执行）

              for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
                params[_key] = arguments[_key];
              }

              for (var i = 0; i < this[methodsCallbacks].length; i++) {
                var callback = this[methodsCallbacks][i];

                try {
                  var _res = callback.call.apply(callback, [this, this].concat(params));

                  if (_res && _res.valid) {
                    res = _res.return;
                    break;
                  }
                } catch (e) {
                  (0, _warning.default)(false, 'Handler', e.message);
                }
              }

              if (res === undefined) {
                try {
                  var _HTMLElement$prototyp;

                  return (_HTMLElement$prototyp = HTMLElement.prototype[method]).call.apply(_HTMLElement$prototyp, [this].concat(params));
                } catch (e) {
                  (0, _warning.default)(false, 'Handler', e.message);
                }
              } else {
                return res;
              }
            };
          }
        }); //两个handler 同一个parent的情况，避免覆盖，需要都执行对应的方法

        this.parentNode.insertBeforeCallbacks.push(this.insertBefore);
        this.parentNode.removeChildCallbacks.push(this.removeChild);
        this.parentNode.removeChildCallbacks.push(this.replaceChild);
        this.assignmentRef(this.childNodes[0]);
        afterReplace();
      }
    }
    /**
     *在..之前插入
     * @param callee
     * @param newChild
     * @param refChild
     */

  }, {
    key: "insertBefore",
    value: function insertBefore(callee, newChild, refChild) {
      if (refChild.UUID === this.key) {
        return {
          valid: true,
          return: callee.insertBefore(newChild, this.childNodes[0])
        };
      }
    }
    /**
     *替换
     * @param callee
     * @param newChild
     * @param oldChild
     */

  }, {
    key: "replaceChild",
    value: function replaceChild(callee, newChild, oldChild) {
      if (newChild.UUID === this.key) {
        this.childNodes.forEach(function (childNode) {
          callee.replaceChild(newChild, childNode);
        });
        return {
          valid: true,
          return: oldChild
        };
      }
    }
    /**
     *移除
     * @param callee
     * @param oldChild
     */

  }, {
    key: "removeChild",
    value: function removeChild(callee, oldChild) {
      if (oldChild.UUID === this.key) {
        this.childNodes.forEach(function (childNode) {
          callee.removeChild(childNode);
        });
        return {
          valid: true,
          return: oldChild
        };
      }
    }
    /**
     * 组件销毁
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;

      var children = this.props.children;
      var count = React.Children.count(children);

      if (count !== 1 && children) {
        return;
      }

      (0, _raf.default)(function () {
        CallbacksMap.forEach(function (_ref3) {
          var _ref4 = (0, _slicedToArray2.default)(_ref3, 2),
              methodsCallbacks = _ref4[0],
              method = _ref4[1];

          _this3.parentNode[methodsCallbacks] = _this3.parentNode[methodsCallbacks].filter(function (callback) {
            return callback !== _this3[method];
          });
        });
      });
      this._isMounted = false;
    }
    /**
     *处理聚焦的情况
     * @param e
     */

  }, {
    key: "handleFocus",
    value: function handleFocus(e) {
      /**确保挂载成功后才去执行onFocus方法 能拿到ref实例**/
      if (this._isMounted) {
        var onFocus = this.props.onFocus;
        onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
      }
    }
    /**
     * 处理失去聚焦的情况
     * @param e
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      /**确保挂载成功后才去执行onBlur方法 才能拿到ref实例**/
      if (this._isMounted) {
        var onBlur = this.props.onBlur;
        onBlur === null || onBlur === void 0 ? void 0 : onBlur(e);
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          disabled = _this$props2.disabled;
      var count = React.Children.count(children);

      if (count !== 1 && children) {
        (0, _warning.default)(false, 'HandlerElement', '该组件只能传入一个children');
        return children;
      }

      var omitProps = (0, _omit.default)(_objectSpread(_objectSpread({}, this.props), {}, {
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      }), ['onBeforeReplace', 'onAfterReplace', 'disabled', 'children', 'forwardRef']);

      if (disabled) {
        omitProps = {};
      }

      return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        ref: this.el
      }, omitProps, {
        style: {
          display: 'inline-block',
          padding: 0,
          margin: 0,
          outline: 'none',
          border: 'none',
          width: '100%',
          height: '100%'
        }
      }), children);
    }
  }]);
  return Handler;
}(React.PureComponent)) || _class) || _class);
exports.default = Handler;