"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.PrefixesSuffixes = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _ClosePlane = _interopRequireDefault(require("net-design-icons/lib/icons/ClosePlane"));

var _FormContext = require("../form/FormContext");

var _util = require("../../libs/utils/util");

var _class, _class2, _class3, _class4;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 检查svg是否存在
 * @param ref
 */
function svgExist(ref) {
  if (ref) {
    var haveSvg = false;

    for (var i = 0; i < ref.childNodes.length; i++) {
      var item = ref.childNodes[i];

      if (item instanceof HTMLElement && item.className.includes('rd-svg-icon')) {
        haveSvg = true;
        break;
      }
    }

    if (haveSvg) {
      (0, _util.classList)(ref).add('is-svg');
    }
  }
}

var PrefixesSuffixes = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(PrefixesSuffixes, _React$PureComponent);

  var _super = _createSuper(PrefixesSuffixes);

  function PrefixesSuffixes() {
    var _this;

    (0, _classCallCheck2.default)(this, PrefixesSuffixes);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = void 0;
    return _this;
  }

  (0, _createClass2.default)(PrefixesSuffixes, [{
    key: "getFix",
    value:
    /**
     *得到prefix或者suffix
     */
    function getFix() {
      var _this$props = this.props,
          prefixIcon = _this$props.prefix,
          suffixIcon = _this$props.suffix,
          allowClear = _this$props.allowClear,
          status = _this$props.status,
          isClearVisible = _this$props.isClearVisible,
          renderLimitText = _this$props.renderLimitText;

      var generator = function generator(icon) {
        var fix;

        if (icon && icon.hasOwnProperty('props')) {
          fix = {
            children: icon
          };
        } else if ((0, _typeof2.default)(icon) === 'object') {
          fix = icon;
        } else {
          fix = {
            children: icon && /*#__PURE__*/React.createElement("span", {
              className: "fix_default"
            }, icon)
          };
        }

        return fix;
      };

      var suffixes = [],
          prefixes;

      if (suffixIcon) {
        if (Array.isArray(suffixIcon)) {
          suffixes = suffixIcon.map(function (item) {
            return generator(item);
          });
        } else {
          suffixes = [generator(suffixIcon)];
        }
      }

      if (prefixIcon) {
        if (Array.isArray(prefixIcon)) {
          prefixes = prefixIcon.map(function (item) {
            return generator(item);
          });
        } else {
          prefixes = [generator(prefixIcon)];
        }
      }

      if (renderLimitText !== undefined) {
        suffixes.unshift(generator({
          children: /*#__PURE__*/React.createElement("span", null, renderLimitText),
          className: 'icon-limit'
        }));
      }

      if (allowClear) {
        suffixes.push(generator({
          children: isClearVisible && /*#__PURE__*/React.createElement(_ClosePlane.default, null),
          className: 'icon-clear is-svg',
          style: {
            display: isClearVisible ? undefined : 'none'
          },
          onClick: this.handleClear
        }));
      }

      if (status) {
        suffixes.push(generator(status));
      }

      return {
        prefixes: prefixes,
        suffixes: suffixes
      };
    }
    /**
     * 处理清除
     * @param e
     */

  }, {
    key: "handleClear",
    value: function handleClear(e) {
      var onClear = this.props.onClear;
      onClear && onClear(e);
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          status = _this$props2.status,
          fitSize = _this$props2.fitSize,
          className = _this$props2.className,
          style = _this$props2.style,
          onClick = _this$props2.onClick,
          children = _this$props2.children,
          getRef = _this$props2.getRef;

      var _this$getFix = this.getFix(),
          suffixes = _this$getFix.suffixes,
          prefixes = _this$getFix.prefixes;

      return /*#__PURE__*/React.createElement("div", {
        ref: function (_ref) {
          function ref(_x) {
            return _ref.apply(this, arguments);
          }

          ref.toString = function () {
            return _ref.toString();
          };

          return ref;
        }(function (ref) {
          getRef && getRef(ref);
        }),
        style: _objectSpread({}, style),
        onClick: onClick,
        className: className
      }, prefixes && prefixes.map(function (prefix, index) {
        return prefix && /*#__PURE__*/React.createElement("span", (0, _extends2.default)({
          key: index
        }, prefix, {
          style: prefix.style,
          className: (0, _classnames.default)('rd-input__prefix', prefix.className),
          ref: svgExist
        }), prefix.children);
      }), typeof children === 'function' ? children((0, _classnames.default)({
        'is-status': !!status,
        'is-prefix': !!prefixes && Array.isArray(prefixes) && prefixes.length !== 0,
        'is-suffix': !!suffixes && Array.isArray(suffixes) && suffixes.length !== 0,
        'is-full': !fitSize
      })) : children, suffixes && suffixes.map(function (suffix, index) {
        return suffix && /*#__PURE__*/React.createElement("span", (0, _extends2.default)({
          key: index
        }, suffix, {
          style: suffix.style,
          className: (0, _classnames.default)('rd-input__suffix', suffix.className),
          ref: svgExist
        }), suffix.children);
      }));
    }
  }]);
  return PrefixesSuffixes;
}(React.PureComponent), _class2.contextType = _FormContext.SizeContext, _class2)) || _class;

exports.PrefixesSuffixes = PrefixesSuffixes;

var AppendPrepend = (0, _autoBind.default)(_class3 = (_class4 = /*#__PURE__*/function (_React$PureComponent2) {
  (0, _inherits2.default)(AppendPrepend, _React$PureComponent2);

  var _super2 = _createSuper(AppendPrepend);

  function AppendPrepend() {
    (0, _classCallCheck2.default)(this, AppendPrepend);
    return _super2.apply(this, arguments);
  }

  (0, _createClass2.default)(AppendPrepend, [{
    key: "render",
    value:
    /**
     * 渲染函数
     */
    function render() {
      var _this$context;

      var _this$props3 = this.props,
          prepend = _this$props3.prepend,
          append = _this$props3.append,
          fitSize = _this$props3.fitSize,
          className = _this$props3.className,
          style = _this$props3.style,
          Component = _this$props3.component;
      var size = this.props.size || ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.size);
      var _prepend = prepend;
      var _append = append;
      var validPrepend = /*#__PURE__*/React.isValidElement(prepend);
      var validAppend = /*#__PURE__*/React.isValidElement(append);
      var props = (0, _omit.default)(this.props, ['prepend', 'append', 'component', 'className', 'style']);
      var classes = (0, _classnames.default)(className, 'rd-input', size && "rd-input--".concat(size), {
        'is-full': !fitSize
      });

      if (prepend && !validPrepend) {
        _prepend = /*#__PURE__*/React.createElement("span", {
          className: "word"
        }, prepend);
      }

      if (append && !validAppend) {
        _append = /*#__PURE__*/React.createElement("span", {
          className: "word"
        }, append);
      }

      return /*#__PURE__*/React.createElement(_FormContext.SizeContext.Provider, {
        value: {
          size: size
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread({}, style)
      }, _prepend && /*#__PURE__*/React.createElement("div", {
        className: 'rd-input__prepend'
      }, _prepend), /*#__PURE__*/React.createElement(Component, (0, _extends2.default)({}, props, {
        className: (0, _classnames.default)(props.className, {
          'is-prepend': validPrepend,
          'is-append': validAppend
        })
      })), _append && /*#__PURE__*/React.createElement("div", {
        className: 'rd-input__append'
      }, _append)));
    }
  }]);
  return AppendPrepend;
}(React.PureComponent), _class4.contextType = _FormContext.SizeContext, _class4)) || _class3;

exports.default = AppendPrepend;