"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _types = require("../../libs/types");

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _span = _interopRequireDefault(require("../span"));

var _FormElement = require("../form/FormElement");

var _AppendPrepend = _interopRequireWildcard(require("./AppendPrepend"));

var _ref = require("../../libs/ref");

var _util = require("../../libs/utils/util");

var _FormContext = require("../form/FormContext");

var _focusWithin = _interopRequireDefault(require("../focus-within"));

var _excluded = ["disabled", "style", "className", "trim", "value", "title", "fitSize", "bordered", "prepend", "append", "regexp", "maxLengthTextVisible"];

var _dec, _dec2, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var InputResizeTypes = (0, _types.tuple)(
/**不能调整元素的尺寸**/
'none',
/**可调整元素的高度和宽度**/
'both',
/**可调整元素的宽度**/
'horizontal',
/**可调整元素的高度**/
'vertical');
var Input = (_dec = (0, _ref.forwardRef)(), _dec2 = (0, _FormElement.createFormElement)(), _dec(_class = _dec2(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Input, _React$Component);

  var _super = _createSuper(Input);

  /**
   * 构造函数
   * @param props
   */
  function Input(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Input);
    _this = _super.call(this, props);
    _this.inputRef = void 0;
    _this.state = void 0;
    var _props$value = props.value,
        value = _props$value === void 0 ? '' : _props$value,
        _props$defaultValue = props.defaultValue,
        defaultValue = _props$defaultValue === void 0 ? '' : _props$defaultValue;
    _this.inputRef = (0, _util.combineRef)(props);
    _this.state = {
      passwordType: false,
      placeholderVisible: true,
      style: props.style,
      isClearVisible: !!value || !!defaultValue
    };
    return _this;
  }

  (0, _createClass2.default)(Input, [{
    key: "handleClick",
    value:
    /**
     * 处理点击事件
     * @param e
     */
    function handleClick(e) {
      var onClick = this.props.onClick;
      e.persist();

      if (onClick) {
        onClick(e);
      }
    }
    /**
     * 键盘落下事件
     * @param e
     */

  }, {
    key: "handleKeyDown",
    value: function handleKeyDown(e) {
      var onKeyDown = this.props.onKeyDown;
      e.persist();

      if (onKeyDown) {
        onKeyDown(e);
      }
    }
    /**
     * 值改变事件
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(e) {
      var onChange = this.props.onChange;
      var isClearVisible = this.state.isClearVisible;
      e.persist();

      if (e.target.value !== undefined && e.target.value !== '' && !isClearVisible) {
        this.setState({
          isClearVisible: true
        });
      } else if (e.target.value === '' && isClearVisible) {
        this.setState({
          isClearVisible: false
        });
      }

      if (onChange) {
        onChange(e);
      }
    }
    /***
     * 处理正则判断输入
     */

  }, {
    key: "handleInput",
    value: function handleInput(e) {
      var _this$props = this.props,
          regexp = _this$props.regexp,
          onRegexp = _this$props.onRegexp;
      var target = e.target;
      var result = false;

      if (regexp instanceof RegExp) {
        result = regexp.test(target.value);
      } else if (regexp instanceof Function) {
        result = regexp(target.value);
      }

      if (!result) {
        e.preventDefault();
        e.stopPropagation(); //需要注意输入法，以及复制粘贴进来的内容，可能上一次的数据并不能准确获取到

        var preValue = target.value.slice(0, target.value.length - 1);
        target.value = preValue;
        onRegexp && onRegexp(result, preValue);
      } else {
        onRegexp && onRegexp(result, target.value);
      }
    }
    /**
     * 处理聚焦事件
     * @param e
     */

  }, {
    key: "handleFocus",
    value: function handleFocus(e) {
      var _this$props2 = this.props,
          onFocus = _this$props2.onFocus,
          readOnly = _this$props2.readOnly;

      if (e.target.value !== undefined && !readOnly) {
        this.setState({
          placeholderVisible: false
        });
      }

      if (onFocus) {
        onFocus(e);
      }
    }
    /**
     * 处理失去焦点事件
     * @param e
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      var onBlur = this.props.onBlur;

      if (e.target.value === '') {
        this.setState({
          placeholderVisible: true
        });
      }

      if (onBlur) {
        onBlur(e);
      }
    }
    /**
     *将输入框置空
     */

  }, {
    key: "handleClear",
    value: function handleClear(e) {
      var _this$props3 = this.props,
          onClear = _this$props3.onClear,
          onChange = _this$props3.onChange;
      this.inputRef.current.focus();
      this.inputRef.current.value = '';
      this.setState({
        isClearVisible: false
      });

      var fakeEvent = _objectSpread(_objectSpread({}, e), {}, {
        nativeEvent: this.inputRef.current,
        currentTarget: this.inputRef.current,
        target: this.inputRef.current
      });

      onChange && onChange(fakeEvent);
      onClear && onClear(e);
    }
    /**
     * @param renderProps
     * @param classes
     */

  }, {
    key: "renderRealInput",
    value: function renderRealInput(renderProps, classes) {
      var _this$props4 = this.props,
          fitSize = _this$props4.fitSize,
          placeholder = _this$props4.placeholder,
          value = _this$props4.value,
          disabled = _this$props4.disabled,
          defaultValue = _this$props4.defaultValue,
          readOnly = _this$props4.readOnly,
          ellipsis = _this$props4.ellipsis;

      var _input = /*#__PURE__*/React.createElement(React.Fragment, null, fitSize && /*#__PURE__*/React.createElement("div", {
        contentEditable: !disabled,
        suppressContentEditableWarning: true,
        className: (0, _classnames.default)('rd-input__inner is-fit', classes)
      }, function () {
        if (value !== undefined && value !== '') {
          return value;
        }

        if (defaultValue !== undefined && defaultValue !== '') {
          return defaultValue;
        }

        if (placeholder !== undefined && placeholder !== '') {
          return placeholder;
        }
      }()), readOnly && ellipsis ? /*#__PURE__*/React.createElement(_span.default, (0, _extends2.default)({
        title: renderProps.value
      }, renderProps, {
        className: (0, _classnames.default)('rd-input__inner rd-input__readonly', classes, fitSize && 'is-input-fit')
      }), renderProps.value) : /*#__PURE__*/React.createElement("input", (0, _extends2.default)({}, renderProps, {
        unselectable: readOnly ? 'on' : 'off' //ie readonly 一样会有聚焦的表现形式 所以加上这么一句话
        ,
        className: (0, _classnames.default)('rd-input__inner', classes, fitSize && 'is-input-fit')
      })));

      if (!fitSize) {
        return _input;
      }

      return /*#__PURE__*/React.createElement("div", {
        style: {
          position: 'relative',
          display: 'inline-block',
          height: '100%'
        }
      }, _input);
    }
    /**
     * 得到计算后的限制文本
     */

  }, {
    key: "getLimitText",
    value: function getLimitText() {
      var _this$props5 = this.props,
          maxLength = _this$props5.maxLength,
          value = _this$props5.value,
          _this$props5$defaultV = _this$props5.defaultValue,
          defaultValue = _this$props5$defaultV === void 0 ? '' : _this$props5$defaultV;
      var valueLength = 0;

      if (value !== undefined) {
        valueLength = value.length;
      } else {
        valueLength = defaultValue.length;
      }

      return "".concat(valueLength, "/").concat(maxLength);
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$context,
          _this2 = this;

      var isClearVisible = this.state.isClearVisible;
      var _this$props6 = this.props,
          disabled = _this$props6.disabled,
          style = _this$props6.style,
          className = _this$props6.className,
          trim = _this$props6.trim,
          value = _this$props6.value,
          title = _this$props6.title,
          fitSize = _this$props6.fitSize,
          bordered = _this$props6.bordered,
          prepend = _this$props6.prepend,
          append = _this$props6.append,
          regexp = _this$props6.regexp,
          maxLengthTextVisible = _this$props6.maxLengthTextVisible,
          rest = (0, _objectWithoutProperties2.default)(_this$props6, _excluded);
      var maxLength = this.props.maxLength;
      var size = this.props.size || ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.size);

      if (prepend !== undefined || append !== undefined) {
        return /*#__PURE__*/React.createElement(_AppendPrepend.default, (0, _extends2.default)({}, this.props, {
          component: Input
        }));
      }

      var classes = (0, _classnames.default)(className, 'rd-input', size && "rd-input--".concat(size), {
        'is-bordered': bordered,
        'is-disabled': disabled,
        'is-full': !fitSize
      });
      var otherProps = (0, _omit.default)(rest, ['onClear', 'forwardRef', 'allowClear', 'size', 'suffix', 'status', 'rows', 'prefix', 'password', 'autoSize', 'resize']);
      var _value = value;

      if (trim && typeof value === 'string') {
        _value = value.trim();
      }

      var renderProps = _objectSpread(_objectSpread({}, otherProps), {}, {
        ref: this.inputRef,
        value: _value,
        disabled: disabled,
        onChange: this.handleChange,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onKeyDown: this.handleKeyDown
      });

      if (regexp) {
        renderProps.onInput = this.handleInput;
      }

      var main = /*#__PURE__*/React.createElement(_FormContext.SizeContext.Provider, {
        value: {
          size: size
        }
      }, /*#__PURE__*/React.createElement(_focusWithin.default, {
        disabled: !bordered || this.props.readOnly || disabled
      }, /*#__PURE__*/React.createElement(_AppendPrepend.PrefixesSuffixes, (0, _extends2.default)({}, this.props, {
        className: classes,
        style: _objectSpread({}, style),
        onClick: this.handleClick,
        renderLimitText: maxLength !== undefined && maxLengthTextVisible ? this.getLimitText() : undefined,
        isClearVisible: value !== undefined && value !== '' || isClearVisible,
        onClear: this.handleClear
      }), function (classes) {
        return _this2.renderRealInput(renderProps, classes);
      })));

      if (title === undefined || title === '') {
        return main;
      } else {
        return /*#__PURE__*/React.createElement(_span.default, {
          needWrapper: false,
          title: title
        }, main);
      }
    }
  }]);
  return Input;
}(React.Component), _class2.contextType = _FormContext.SizeContext, _class2.defaultProps = {
  type: 'text',
  disabled: false,
  bordered: true,
  trim: false,
  autoComplete: 'off',
  size: 'medium',
  fitSize: false,
  maxLengthTextVisible: true,
  password: {
    showPassword: true,
    focusBlurChangePasswordType: false
  }
}, _class2)) || _class) || _class) || _class);
exports.default = Input;