"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormElement = require("../form/FormElement");

var _Input = _interopRequireDefault(require("../input/Input"));

var _ref3 = require("../../libs/ref");

var _AppendPrepend = require("../input/AppendPrepend");

var _FormContext = require("../form/FormContext");

var _focusWithin = _interopRequireDefault(require("../focus-within"));

var _class, _dec, _dec2, _class3, _class4;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Gap = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Gap, _React$PureComponent);

  var _super = _createSuper(Gap);

  function Gap() {
    var _this;

    (0, _classCallCheck2.default)(this, Gap);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    _this.el = /*#__PURE__*/React.createRef();
    _this.gapMark = /*#__PURE__*/React.createRef();
    _this.inputRefs = {};
    _this.keyCode = void 0;
    _this._isMounted = false;
    _this.activeIndex = 0;
    return _this;
  }

  (0, _createClass2.default)(Gap, [{
    key: "componentDidMount",
    value:
    /**
     *组件挂载
     */
    function componentDidMount() {
      this._isMounted = true;
    }
    /**
     * 组件卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
    }
    /**获取选区范围 */

  }, {
    key: "getLocation",
    value: function getLocation(ref) {
      return {
        start: ref.selectionStart,
        end: ref.selectionEnd
      };
    }
    /***
     * 处理键盘事件
     */

  }, {
    key: "handleChange",
    value: function handleChange(e, index) {
      var _this2 = this;

      var _this$props = this.props,
          gapWordLimit = _this$props.gapWordLimit,
          several = _this$props.several;
      var target = e.target;

      if (gapWordLimit !== undefined && target.value && target.value.length === gapWordLimit && index < several - 1) {
        //是为了防止部分输入法，中文下，onChange事件会在focus之后再执行一次，导致ip输入123得情况下，得到123.3得结果
        //需要使跳到下一个输入框得操作在onChange之后执行
        setTimeout(function () {
          _this2.inputRefs[index + 1].focus();
        }, 0);
      }

      if (target.value === '' && this.keyCode === 8 && index > 0) {
        setTimeout(function () {
          _this2.inputRefs[index - 1].focus();
        }, 0);
      }

      this.activeIndex = index;
    }
    /**
     *处理键盘按下
     */

  }, {
    key: "handleKeyDown",
    value: function handleKeyDown(e, index) {
      var _this$props2 = this.props,
          gapWordLimit = _this$props2.gapWordLimit,
          several = _this$props2.several,
          nextKeyCode = _this$props2.nextKeyCode;
      var _ref = e.target,
          value = _ref.value;
      this.keyCode = e.keyCode;
      var selectionRange = this.getLocation(this.inputRefs[index]); //获取当前按下键盘时，是否有选中如果选中了，那么就需要将按下键盘的内容替换选中内容

      var start = selectionRange.start,
          end = selectionRange.end;

      if (start !== end) {
        //说明有选中
        return;
      }

      if (value.length === gapWordLimit && index < several - 1 && e.keyCode !== 8) {
        this.inputRefs[index + 1].focus();
      }

      if (!value && index > 0 && e.keyCode === 8) {
        this.inputRefs[index - 1].focus();
      }
      /**向前**/


      if (e.keyCode === 37 && index > 0) {
        this.inputRefs[index - 1].focus();
        /**向后**/
      } else if (e.keyCode === 39 && index < several - 1) {
        this.inputRefs[index + 1].focus();
      }

      if (e.keyCode === nextKeyCode && index < several - 1 && value) {
        this.inputRefs[index + 1].focus();
      }
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props3 = this.props,
          several = _this$props3.several,
          gapMark = _this$props3.gapMark,
          gapWordLimit = _this$props3.gapWordLimit,
          placeholders = _this$props3.placeholders,
          value = _this$props3.value,
          textAlign = _this$props3.textAlign,
          regexp = _this$props3.regexp,
          _onFocus = _this$props3.onFocus,
          _onBlur = _this$props3.onBlur,
          getInstance = _this$props3.getInstance,
          defaultValue = _this$props3.defaultValue,
          _onChange = _this$props3.onChange;
      var inputWidth = this.state.inputWidth;
      var severalArray = new Array(several).fill('');
      var array = severalArray.map(function (item, index, array) {
        var _value = Array.isArray(value) ? value[index] : 'undefined';

        var _defaultValue = Array.isArray(defaultValue) ? defaultValue[index] : undefined;

        var _regexp;

        if (regexp instanceof Array) {
          _regexp = regexp[index];

          if (_regexp instanceof Function) {
            _regexp = function _regexp(value) {
              return regexp[index](value, _this3.inputRefs[index - 1], _this3.inputRefs[index + 1]);
            };
          }
        }

        var inner = /*#__PURE__*/React.createElement(_Input.default, {
          ref: function ref(_ref2) {
            _this3.inputRefs[index] = _ref2;

            if (index === array.length - 1) {
              getInstance(Object.values(_this3.inputRefs));
            }
          },
          key: index,
          bordered: false,
          regexp: _regexp,
          value: _value,
          defaultValue: _defaultValue,
          placeholder: placeholders[index],
          maxLength: gapWordLimit,
          maxLengthTextVisible: false,
          onKeyDown: function onKeyDown(e) {
            return _this3.handleKeyDown(e, index);
          },
          onChange: function onChange(e) {
            return _this3.handleChange(e, index);
          },
          onFocus: function onFocus(e) {
            return _onFocus && _onFocus(e, index);
          },
          onBlur: function onBlur(e) {
            return _onBlur && _onBlur(e, index);
          },
          style: {
            width: inputWidth,
            textAlign: textAlign
          }
        });

        if (index === array.length - 1) {
          return [inner];
        }

        var _gapMark = gapMark;

        if (Array.isArray(gapMark)) {
          _gapMark = gapMark[index];
        }

        return [inner, /*#__PURE__*/React.createElement("span", {
          key: "".concat(index, "span"),
          ref: _this3.gapMark,
          className: 'rd-interval__mark'
        }, _gapMark)];
      });
      return /*#__PURE__*/React.createElement("div", {
        className: "rd-interval",
        ref: this.el,
        onChange: function onChange(e) {
          var value = severalArray.map(function (item, index) {
            return _this3.inputRefs[index].value;
          });
          _onChange && _onChange(value, e, _this3.activeIndex);
        }
      }, array);
    }
  }]);
  return Gap;
}(React.PureComponent)) || _class;

var Interval = (_dec = (0, _ref3.forwardRef)(), _dec2 = (0, _FormElement.createFormElement)(), _dec(_class3 = _dec2(_class3 = (0, _autoBind.default)(_class3 = (_class4 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Interval, _React$Component);

  var _super2 = _createSuper(Interval);

  /**
   *
   * @param props
   */
  function Interval(props) {
    var _props$defaultValue;

    var _this4;

    (0, _classCallCheck2.default)(this, Interval);
    _this4 = _super2.call(this, props);
    _this4.el = /*#__PURE__*/React.createRef();
    _this4.state = void 0;
    _this4.inputRefs = void 0;
    _this4.state = {
      isClearVisible: props.value === undefined ? false : props.value.length !== 0 || ((_props$defaultValue = props.defaultValue) === null || _props$defaultValue === void 0 ? void 0 : _props$defaultValue.length) !== 0
    };
    return _this4;
  }
  /**
   * 点击清除的按键
   */


  (0, _createClass2.default)(Interval, [{
    key: "handleClear",
    value: function handleClear(e) {
      var _this$props4 = this.props,
          several = _this$props4.several,
          onChange = _this$props4.onChange;
      var value = new Array(several).fill('');
      this.setState({
        isClearVisible: false
      });
      this.inputRefs.forEach(function (ref) {
        ref.value = '';
      });
      this.inputRefs[0].focus();
      onChange && onChange(value, e, 0);
    }
    /**
     * 处理值改变事件
     * @param value
     * @param e
     * @param activeIndex
     */

  }, {
    key: "handleChange",
    value: function handleChange(value, e, activeIndex) {
      var onChange = this.props.onChange;
      this.setState({
        isClearVisible: value.filter(function (item) {
          return item !== '';
        }).length !== 0
      });
      onChange && onChange(value, e, activeIndex);
    }
    /**
     */

  }, {
    key: "render",
    value: function render() {
      var _this$context,
          _this5 = this;

      var _this$props5 = this.props,
          className = _this$props5.className,
          style = _this$props5.style,
          bordered = _this$props5.bordered,
          disabled = _this$props5.disabled,
          prefix = _this$props5.prefix,
          suffix = _this$props5.suffix,
          value = _this$props5.value,
          allowClear = _this$props5.allowClear,
          fitSize = _this$props5.fitSize,
          status = _this$props5.status,
          _getInstance = _this$props5.getInstance;
      var size = this.props.size || ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.size);
      var isClearVisible = this.state.isClearVisible;
      var classes = (0, _classnames.default)(className, 'rd-input', size && "rd-input--".concat(size), {
        'is-full': !fitSize,
        'is-bordered': bordered,
        'is-disabled': disabled
      });
      return /*#__PURE__*/React.createElement(_FormContext.SizeContext.Provider, {
        value: {
          size: size
        }
      }, /*#__PURE__*/React.createElement(_focusWithin.default, {
        disabled: !bordered
      }, /*#__PURE__*/React.createElement(_AppendPrepend.PrefixesSuffixes, {
        className: classes,
        style: _objectSpread({}, style),
        getRef: function getRef(ref) {
          return _this5.el.current = ref;
        },
        prefix: prefix,
        suffix: suffix,
        allowClear: allowClear,
        status: status,
        fitSize: fitSize,
        isClearVisible: isClearVisible,
        onClear: this.handleClear
      }, function () {
        return /*#__PURE__*/React.createElement(Gap, (0, _extends2.default)({}, _this5.props, {
          getInstance: function getInstance(refs) {
            _this5.inputRefs = refs;
            _getInstance && _getInstance(refs);
          },
          value: value,
          onChange: _this5.handleChange
        }));
      })));
    }
  }]);
  return Interval;
}(React.Component), _class4.defaultProps = {
  defaultValue: new Array(),
  several: 2,
  bordered: true,
  gapMark: '-',
  size: 'medium',
  placeholders: new Array()
}, _class4.contextType = _FormContext.SizeContext, _class4)) || _class3) || _class3) || _class3);
exports.default = Interval;