"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _LayoutContext = _interopRequireDefault(require("./LayoutContext"));

var _Sider = _interopRequireDefault(require("./Sider"));

var _util = require("../../libs/utils/util");

var _excluded = ["prefixCls", "style", "className"],
    _excluded2 = ["prefixCls", "className", "children", "hasSider", "flex"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 一个生成Layout，Header，Footer，Content的生成器
 * @param 后缀内容，便于生成前缀类名
 */
function generator(_ref) {
  var suffixCls = _ref.suffixCls;
  return function (BasicComponent) {
    var _class;

    return _class = /*#__PURE__*/function (_React$Component) {
      (0, _inherits2.default)(Adapter, _React$Component);

      var _super = _createSuper(Adapter);

      function Adapter() {
        var _this;

        (0, _classCallCheck2.default)(this, Adapter);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _super.call.apply(_super, [this].concat(args));

        _this.renderComponent = function (_ref2) {
          var hasSider = _ref2.hasSider,
              siderWidth = _ref2.siderWidth,
              flex = _ref2.flex;
          var _this$props = _this.props,
              customPrefixCls = _this$props.prefixCls,
              style = _this$props.style,
              className = _this$props.className,
              others = (0, _objectWithoutProperties2.default)(_this$props, _excluded); //others中获取也有hasSider，但此hasSider为真实的组件属性，而不是通过消费订阅而来

          var prefixCls = (0, _util.getPrefixCls)(suffixCls, customPrefixCls); //此处的hasSider和siderWidth为上级传递下来的，若有，则表示marginLeft或者是marginRight

          var layoutStyles = _objectSpread({}, style);

          var classString = (0, _classnames.default)(className);

          if (hasSider && !flex) {
            if (typeof siderWidth === 'number') {
              //若定义了siderWidth则表示使用自定义宽度
              layoutStyles = _objectSpread(_objectSpread({}, hasSider === 'left' ? {
                marginLeft: siderWidth
              } : {
                marginRight: siderWidth
              }), layoutStyles);
            } else {
              var _classNames;

              classString = (0, _classnames.default)((_classNames = {}, (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "--left"), hasSider === 'left'), (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "--right"), hasSider === 'right'), _classNames), className);
            }
          }

          return /*#__PURE__*/React.createElement(BasicComponent, (0, _extends2.default)({
            style: layoutStyles,
            flex: flex,
            prefixCls: prefixCls,
            className: classString
          }, others));
        };

        return _this;
      }

      (0, _createClass2.default)(Adapter, [{
        key: "render",
        value:
        /** */
        function render() {
          return /*#__PURE__*/React.createElement(_LayoutContext.default.Consumer, null, this.renderComponent);
        }
      }]);
      return Adapter;
    }(React.Component), _class.Header = void 0, _class.Footer = void 0, _class.Content = void 0, _class.Sider = void 0, _class;
  };
}

var BasicLayout = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2.default)(BasicLayout, _React$Component2);

  var _super2 = _createSuper(BasicLayout);

  /** */
  function BasicLayout(props) {
    var _this2;

    (0, _classCallCheck2.default)(this, BasicLayout);
    _this2 = _super2.call(this, props);

    _this2.changeSiderWidth = function (width, collapsed) {
      _this2.setState({
        collapsed: collapsed,
        //sider是否收起
        siderWidth: width
      });
    };

    _this2.renderComponent = function () {
      var _this2$props = _this2.props,
          prefixCls = _this2$props.prefixCls,
          className = _this2$props.className,
          children = _this2$props.children,
          hasSider = _this2$props.hasSider,
          flex = _this2$props.flex,
          others = (0, _objectWithoutProperties2.default)(_this2$props, _excluded2); //以上都为本身属性，没有消费订阅的属性内容

      var _this2$state = _this2.state,
          siderWidth = _this2$state.siderWidth,
          collapsed = _this2$state.collapsed;
      var classString = (0, _classnames.default)(prefixCls, {
        'has-sider': hasSider,
        'is-collapsed': collapsed,
        'is-flex': flex
      }, className);
      var providerValue = {
        hasSider: hasSider,
        siderWidth: siderWidth,
        flex: flex,
        changeSiderWidth: _this2.changeSiderWidth
      };
      return /*#__PURE__*/React.createElement(_LayoutContext.default.Provider, {
        value: providerValue
      }, /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        className: classString
      }, others), children));
    };

    _this2.state = {
      siderWidth: props.siderWidth,
      collapsed: false
    };
    return _this2;
  }

  (0, _createClass2.default)(BasicLayout, [{
    key: "render",
    value:
    /** */
    function render() {
      return /*#__PURE__*/React.createElement(React.Fragment, null, this.renderComponent());
    }
  }]);
  return BasicLayout;
}(React.Component);

BasicLayout.defaultProps = {
  flex: false
};
var Layout = generator({
  suffixCls: 'layout'
})(BasicLayout);
var Header = generator({
  suffixCls: 'layout-header'
})(BasicLayout);
var Footer = generator({
  suffixCls: 'layout-footer'
})(BasicLayout);
var Content = generator({
  suffixCls: 'layout-content'
})(BasicLayout);
Layout.Header = Header;
Layout.Footer = Footer;
Layout.Content = Content;
Layout.Sider = _Sider.default;
var _default = Layout;
exports.default = _default;