import * as React from 'react';
export interface SiderProps extends React.HTMLAttributes<HTMLDivElement> {
    prefixCls?: string;
    collapsible?: boolean;
    collapsed?: boolean;
    width?: number;
    collapsedWidth?: number;
}
export interface SiderState {
    collapsed?: boolean;
    siderWidth?: number;
}
export default class Sider extends React.Component<SiderProps, SiderState> {
    static contextType: React.Context<import("./LayoutContext").LayoutContextProps>;
    static defaultProps: {
        collapsible: boolean;
        collapsed: boolean;
    };
    /**
     * 改变当前展开收起状态
     */
    static getDerivedStateFromProps(nextProps: SiderProps): Partial<SiderState>;
    /**
     * 改变父级的MarginWidth
     */
    changeParentMarginWidth(): void;
    /**
     *
     * @param prevProps
     * @param prevState
     */
    componentDidUpdate(prevProps: SiderProps, prevState: SiderState): void;
    /**
     *
     * @param props
     */
    constructor(props: SiderProps);
    /**
     * 加载后，则需要通过自身宽度，收缩去通知父级，从而使得父级去通知其下其他的自己的margin的改变
     */
    componentDidMount(): void;
    /** */
    render(): React.ReactNode;
}
