"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _LayoutContext = _interopRequireDefault(require("./LayoutContext"));

var _excluded = ["prefixCls", "className", "collapsible", "collapsed", "width", "collapsedWidth", "children", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Sider = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Sider, _React$Component);

  var _super = _createSuper(Sider);

  /**
   * 
   * @param props 
   */
  function Sider(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Sider);
    _this = _super.call(this, props);
    var collapsed = false;

    if ('collapsed' in props) {
      // eslint-disable-next-line prefer-destructuring
      collapsed = props.collapsed;
    }

    _this.state = {
      collapsed: collapsed
    };
    return _this;
  }
  /**
   * 加载后，则需要通过自身宽度，收缩去通知父级，从而使得父级去通知其下其他的自己的margin的改变
   */


  (0, _createClass2.default)(Sider, [{
    key: "changeParentMarginWidth",
    value:
    /**
     * 改变父级的MarginWidth
     */
    function changeParentMarginWidth() {
      var _this$props = this.props,
          collapsible = _this$props.collapsible,
          collapsedWidth = _this$props.collapsedWidth,
          collapsed = _this$props.collapsed,
          width = _this$props.width;
      var siderWidth = this.context.siderWidth;
      var parentPropsSiderWidth = this.state.siderWidth;
      var currSiderWidth;

      if (collapsible) {
        var expanedWidth;

        if (typeof parentPropsSiderWidth === 'number' && typeof collapsedWidth === 'number') {
          expanedWidth = parentPropsSiderWidth;
        }

        currSiderWidth = collapsed ? collapsedWidth : width || expanedWidth;
      } else {
        currSiderWidth = width || siderWidth; //因为不可收缩，所以此处的siderWidth与parentPropsSiderWidth是相同的值
      }

      this.context.changeSiderWidth(currSiderWidth, collapsed);
    }
    /**
     * 
     * @param prevProps 
     * @param prevState 
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this$props2 = this.props,
          collapsible = _this$props2.collapsible,
          collapsed = _this$props2.collapsed;
      var _this$context = this.context,
          hasSider = _this$context.hasSider,
          parentSiderWidth = _this$context.siderWidth;
      var siderWidth = this.state.siderWidth;

      if (collapsible && prevState.collapsed !== collapsed && hasSider) {
        this.changeParentMarginWidth();
      } else if (!collapsible && siderWidth !== parentSiderWidth) {
        this.changeParentMarginWidth();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.setState({
        siderWidth: this.props.width || this.context.siderWidth //初始化时，获取到的上级的siderWidth，即为以后Sider展开的SiderWidth

      }, function () {
        //context在constructor中获取不到
        _this2.changeParentMarginWidth();
      });
    }
    /** */

  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props3 = this.props,
          customizePrefixCls = _this$props3.prefixCls,
          className = _this$props3.className,
          collapsible = _this$props3.collapsible,
          collapsed = _this$props3.collapsed,
          width = _this$props3.width,
          collapsedWidth = _this$props3.collapsedWidth,
          children = _this$props3.children,
          style = _this$props3.style,
          others = (0, _objectWithoutProperties2.default)(_this$props3, _excluded);
      var _this$context2 = this.context,
          hasSider = _this$context2.hasSider,
          flex = _this$context2.flex;
      var prefixCls = (0, _util.getPrefixCls)('layout-sider', customizePrefixCls);
      var siderCls = (0, _classnames.default)(className, prefixCls, (_classNames = {
        'is-flex': flex,
        'is-collapsed': !!this.state.collapsed
      }, (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "--left"), hasSider === 'left'), (0, _defineProperty2.default)(_classNames, "".concat(prefixCls, "--right"), hasSider === 'right'), _classNames));
      var divStyle;
      var siderWidth = this.state.siderWidth; //if ((typeof siderWidth === 'number' || typeof width === 'number') && typeof collapsedWidth === 'number') {

      var realWidth;

      if (typeof siderWidth === 'number' || typeof width === 'number' || typeof collapsedWidth === 'number') {
        var currSiderWidth = this.state.collapsed ? collapsedWidth : width || siderWidth;
        realWidth = currSiderWidth;
        divStyle = _objectSpread(_objectSpread({}, style), {}, {
          width: currSiderWidth
        });
      } else if (!collapsible) {
        //若无展开动作，则默认宽度，子级有，则用子级，子级覆盖父级
        realWidth = width || siderWidth;
        divStyle = _objectSpread(_objectSpread({}, style), {}, {
          width: realWidth
        });
      }

      if (typeof realWidth !== 'undefined' && flex) {
        divStyle = _objectSpread(_objectSpread({}, divStyle), {}, (0, _defineProperty2.default)({}, (0, _util.setPrefix)('flex'), "0 0 ".concat(divStyle.width, "px")));
      }

      return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        className: siderCls
      }, others, {
        style: divStyle
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**
     * 改变当前展开收起状态
     */
    function getDerivedStateFromProps(nextProps) {
      if ('collapsed' in nextProps) {
        return {
          collapsed: nextProps.collapsed
        };
      }

      return null;
    }
  }]);
  return Sider;
}(React.Component);

exports.default = Sider;
Sider.contextType = _LayoutContext.default;
Sider.defaultProps = {
  collapsible: false,
  collapsed: false
};