import * as React from 'react';
import { ItemLayoutType } from './ListContext';
import ListItem from './ListItem';
interface ListProps {
    /**是否有边框 */
    bordered?: boolean;
    /**是否有分割线 */
    split?: boolean;
    /**水平布局还是垂直布局，对ListItem */
    itemLayout?: ItemLayoutType;
    /**头部 */
    header?: React.ReactNode;
    /**脚部 */
    footer?: React.ReactNode;
    /**数据为空时的字符串 */
    emptyText?: string;
    /**数据为空是的自定义组件 */
    emptyComp?: React.ReactNode;
    /**源数据，只有使用dataSource的数据分页才会有效果 */
    dataSource?: Array<any>;
    /**分页的配置信息格式 */
    pagination?: any;
    children?: React.ReactNode;
    prefixCls?: string;
    style?: React.CSSProperties;
    className?: string;
    /**使用dataSource时的renderItem自定义Item方法 */
    renderItem?: (item: any, index: number) => React.ReactNode;
}
interface ListState {
    /**源数据 */
    dataSource?: Array<any>;
    pagination?: any;
    prevPropsPagination?: any;
}
export default class List extends React.Component<ListProps, ListState> {
    static defaultProps: ListProps;
    state: ListState;
    static Item: typeof ListItem;
    /**数据更新，或者是分页更新 */
    static getDerivedStateFromProps(nextProps: ListProps, prevState: ListState): ListState;
    /**处理当前页数改变 */
    handlePageCurrChange(currentPage: number): void;
    /**改变每页显示多少条数据 */
    handleSizeChange(size: number): void;
    /**生成头部，或者底部 */
    renderNode(node: React.ReactNode, className: string): React.ReactNode;
    /**根据pagination生成显示的列表源数据 */
    getListItemsData(): Array<React.ReactNode>;
    /**生成空数据显示的内容 */
    renderEmpty(listData: Array<React.ReactNode>): React.ReactNode;
    /**生成items */
    renderChildren(): React.ReactNode;
    /**生成JSX */
    render(): React.ReactNode;
}
export {};
