"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _pagination = _interopRequireDefault(require("../pagination"));

var _empty = _interopRequireDefault(require("../empty"));

var _ListContext = _interopRequireDefault(require("./ListContext"));

var _ListItem = _interopRequireDefault(require("./ListItem"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var List = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(List, _React$Component);

  var _super = _createSuper(List);

  function List() {
    var _this;

    (0, _classCallCheck2.default)(this, List);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      dataSource: [],
      pagination: {
        frontPage: true,
        currentPage: 1,
        pageSize: 10,
        layout: 'prev,pager,next'
      }
    };
    return _this;
  }

  (0, _createClass2.default)(List, [{
    key: "handlePageCurrChange",
    value:
    /**处理当前页数改变 */
    function handlePageCurrChange(currentPage) {
      var paginationProps = this.props.pagination;
      var pagination = this.state.pagination;

      if (pagination.frontPage) {
        //前端分页
        this.setState({
          pagination: _objectSpread(_objectSpread({}, pagination), {}, {
            currentPage: currentPage
          })
        });
      } //后端分页，数据源都不做处理，所有显示都交由用户自己处理


      paginationProps.onCurrentChange && paginationProps.onCurrentChange(currentPage);
    }
    /**改变每页显示多少条数据 */

  }, {
    key: "handleSizeChange",
    value: function handleSizeChange(size) {
      var paginationProps = this.props.pagination;
      var pagination = this.state.pagination;

      if (pagination.frontPage) {
        //前端分页
        this.setState({
          pagination: _objectSpread(_objectSpread({}, pagination), {}, {
            pageSize: size
          })
        });
      } //后端分页，数据源都不做处理，所有显示都交由用户自己处理


      paginationProps.onSizeChange && paginationProps.onSizeChange(size);
    }
    /**生成头部，或者底部 */

  }, {
    key: "renderNode",
    value: function renderNode(node, className) {
      if (node) {
        return /*#__PURE__*/React.createElement("div", {
          className: className
        }, node);
      }

      return null;
    }
    /**根据pagination生成显示的列表源数据 */

  }, {
    key: "getListItemsData",
    value: function getListItemsData() {
      var _this$state = this.state,
          dataSource = _this$state.dataSource,
          pagination = _this$state.pagination;
      var paginationProps = this.props.pagination; //前端分页才会获取数据

      if (paginationProps && dataSource && pagination.frontPage) {
        var currentPage = pagination.currentPage,
            pageSize = pagination.pageSize;
        var startIndex = (currentPage - 1) * pageSize;
        var endIndex = startIndex + pageSize;
        var data = dataSource.slice(startIndex, endIndex);
        return data;
      } else {
        return dataSource;
      }
    }
    /**生成空数据显示的内容 */

  }, {
    key: "renderEmpty",
    value: function renderEmpty(listData) {
      var _this$props = this.props,
          emptyText = _this$props.emptyText,
          emptyComp = _this$props.emptyComp,
          children = _this$props.children;

      if (listData || children) {
        return null;
      } else {
        if (emptyComp) {
          return emptyComp;
        } else {
          var emptyProps;

          if (emptyText) {
            emptyProps = {
              description: emptyText
            };
          }

          return /*#__PURE__*/React.createElement(_empty.default, emptyProps);
        }
      }
    }
    /**生成items */

  }, {
    key: "renderChildren",
    value: function renderChildren() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          renderItem = _this$props2.renderItem;
      var listItemsData = this.getListItemsData();
      return /*#__PURE__*/React.createElement(React.Fragment, null, listItemsData && listItemsData.map(function (item, index) {
        return renderItem ? renderItem(item, index) : /*#__PURE__*/React.createElement(_ListItem.default, {
          key: index
        }, item.toString());
      }), children, this.renderEmpty(listItemsData));
    }
    /**生成JSX */

  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          dataSource = _this$props3.dataSource,
          bordered = _this$props3.bordered,
          split = _this$props3.split,
          itemLayout = _this$props3.itemLayout,
          header = _this$props3.header,
          footer = _this$props3.footer,
          customizePrefixCls = _this$props3.prefixCls,
          style = _this$props3.style,
          className = _this$props3.className,
          propsPagination = _this$props3.pagination;
      var pagination = this.state.pagination;
      var prefixCls = (0, _util.getPrefixCls)('list', customizePrefixCls);
      var headerClassString = (0, _util.getPrefixCls)('list-header');
      var footerClassString = (0, _util.getPrefixCls)('list-footer');
      var footerNode = this.renderNode(footer, footerClassString);

      var paginationProp = _objectSpread(_objectSpread({}, pagination), propsPagination);

      if (paginationProp.frontPage) {
        paginationProp.total = dataSource ? dataSource.length : 0;
      }

      var paginationNode = propsPagination ? /*#__PURE__*/React.createElement("div", {
        className: (0, _util.getPrefixCls)('list-pagination')
      }, /*#__PURE__*/React.createElement(_pagination.default, (0, _extends2.default)({}, paginationProp, {
        onCurrentChange: this.handlePageCurrChange,
        onSizeChange: this.handleSizeChange
      }))) : null;
      var itemsClassString = (0, _classnames.default)((0, _util.getPrefixCls)('list-items'), {
        'has-something-after-last-item': footerNode || paginationNode
      });
      var classString = (0, _classnames.default)(className, prefixCls, {
        'has-bordered': bordered,
        'has-split': split
      });
      var contextVal = {
        itemLayout: itemLayout
      };
      return /*#__PURE__*/React.createElement(_ListContext.default.Provider, {
        value: contextVal
      }, /*#__PURE__*/React.createElement("div", {
        className: classString,
        style: style
      }, this.renderNode(header, headerClassString), /*#__PURE__*/React.createElement("div", {
        className: itemsClassString
      }, this.renderChildren()), footerNode, paginationNode));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**数据更新，或者是分页更新 */
    function getDerivedStateFromProps(nextProps, prevState) {
      var propsData = nextProps.dataSource,
          propsPagination = nextProps.pagination;
      var dataSource = prevState.dataSource,
          prevPropsPagination = prevState.prevPropsPagination,
          pagination = prevState.pagination;
      var listState = null;

      if (dataSource !== propsData) {
        listState = {
          dataSource: propsData
        };
      }

      if (prevPropsPagination !== propsPagination) {
        listState = _objectSpread(_objectSpread({}, listState), {}, {
          pagination: _objectSpread(_objectSpread({}, pagination), propsPagination),
          prevPropsPagination: propsPagination
        });
      }

      return listState;
    }
  }]);
  return List;
}(React.Component), _class2.defaultProps = {
  bordered: true,
  split: true,
  itemLayout: 'horizontal'
}, _class2.Item = void 0, _class2)) || _class;

exports.default = List;