import * as React from 'react';
import { ItemLayoutType } from './ListContext';
import ListItemMedia from './ListItemMedia';
interface ListItemProps {
    /**列表操作组，根据itemLayout的不同，位置在右侧或者底部 */
    actions?: React.ReactNode;
    /**额外内容，在右侧 */
    extra?: React.ReactNode;
    style?: React.CSSProperties;
    className?: string;
    prefixCls?: string;
    children?: React.ReactNode;
}
export default class ListItem extends React.PureComponent<ListItemProps> {
    static contextType: React.Context<import("./ListContext").ListContextProps>;
    static Media: typeof ListItemMedia;
    /**获取Item的布局方向 */
    getItemDirection(hasExtra: boolean, itemLayout: ItemLayoutType): string;
    /**生成操作列 */
    renderActions(actions: React.ReactNode): React.ReactNode;
    /**生成children */
    renderChildren(): React.ReactNode;
    /**返回JSX */
    render(): React.ReactNode;
}
export {};
