"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _ListContext = _interopRequireDefault(require("./ListContext"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ListItem = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(ListItem, _React$PureComponent);

  var _super = _createSuper(ListItem);

  function ListItem() {
    (0, _classCallCheck2.default)(this, ListItem);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(ListItem, [{
    key: "getItemDirection",
    value:
    /**获取Item的布局方向 */
    function getItemDirection(hasExtra, itemLayout) {
      //有额外内容，则都放到最右侧，所以都是水平
      if (hasExtra) {
        return 'is-horizontal';
      }

      return "is-".concat(itemLayout);
    }
    /**生成操作列 */

  }, {
    key: "renderActions",
    value: function renderActions(actions) {
      if (actions) {
        return /*#__PURE__*/React.createElement("div", {
          className: "actions-wrapper"
        }, actions);
      }

      return null;
    }
    /**生成children */

  }, {
    key: "renderChildren",
    value: function renderChildren() {
      var _this$props = this.props,
          extra = _this$props.extra,
          actions = _this$props.actions,
          children = _this$props.children,
          customizePrefixCls = _this$props.prefixCls;
      var itemLayout = this.context.itemLayout;
      var prefixCls = (0, _util.getPrefixCls)('list-item-content', customizePrefixCls); //当有extra的时候，都是水平布局，即actions需要和children在同一个div，才能便于item的方向布局

      var actionsReactNode = this.renderActions(actions);
      var classString = (0, _classnames.default)("".concat(prefixCls, "-wrapper"), "is-list-item-content-".concat(itemLayout));
      /**table布局，子元素的第一个div为100%，才能让后续div在最右侧 */

      var childNodes = typeof children === 'string' ? /*#__PURE__*/React.createElement("div", null, children) : children;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        className: classString
      }, /*#__PURE__*/React.createElement("div", {
        className: prefixCls
      }, childNodes, actionsReactNode)), extra && /*#__PURE__*/React.createElement("div", {
        className: "is-extra"
      }, extra));
    }
    /**返回JSX */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          extra = _this$props2.extra,
          style = _this$props2.style,
          className = _this$props2.className,
          customizePrefixCls = _this$props2.prefixCls;
      var itemLayout = this.context.itemLayout;
      var prefixCls = (0, _util.getPrefixCls)('list-item', customizePrefixCls);
      var listItemDirection = this.getItemDirection(!!extra, itemLayout);
      var classString = (0, _classnames.default)(className, prefixCls, listItemDirection //split && 'has-split',
      );
      return /*#__PURE__*/React.createElement("div", {
        className: classString,
        style: style
      }, this.renderChildren());
    }
  }]);
  return ListItem;
}(React.PureComponent), _class2.contextType = _ListContext.default, _class2.Media = void 0, _class2)) || _class;

exports.default = ListItem;