"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

/**
 *  String format template
 *  - Inspired:
 *    https://github.com/Matt-Esch/string-template/index.js
 */
var RE_NARGS = /(%|)\{([0-9a-zA-Z_ ]+)\}/g;
/**
 * format
 *
 * @param {String} string
 * @param {Array} ...args
 * @return {String}
 */

function _default(string) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  if (args.length === 1 && (0, _typeof2.default)(args[0]) === 'object') {
    args = args[0];
  }

  if (!args || !args.hasOwnProperty) {
    args = {};
  }

  var arr = [string];
  var newArr = [];
  (string.match(RE_NARGS) || []).forEach(function (item) {
    var arrSplit = arr[arr.length - 1].split(item);
    var itemArr = arrSplit[0];
    arrSplit.splice(0, 1);
    arr = [arrSplit.join(item)];

    if (itemArr) {
      newArr.push(itemArr);
    }

    var regItem = item.replace(/\{|\}/g, '');
    newArr.push(args[regItem]);
  });
  newArr.push(arr);
  return newArr;
}