import React from "react";
import { ObjectType } from "../../libs/types";
interface ConfigType extends ObjectType {
    current: string;
}
interface FormatterProps {
    path: string;
    options?: ObjectType;
}
interface ProviderProps {
    initConfig?: Config;
    lang?: string;
    onLangChange?: (lang: string) => void;
}
interface Config {
    [key: string]: ObjectType;
}
declare class Locale {
    defaultConfig: ConfigType;
    localeRender: (initProps?: ProviderProps) => (element: React.ReactElement, container: (Element | DocumentFragment), callback?: () => void) => void;
    /**
     * 初始化
     * @param config
     */
    init(config: Config): void;
    /**
     *
     * @param lang
     */
    use(lang: string): void;
    /**获取语言 */
    get(): string;
    /**
     *返回带有ast树的数组
     * @param path
     * @param options
     * @param lang
     */
    h(path: string, options?: {
        [key: string]: any;
    }, lang?: string): Array<React.ReactNode>;
    /**
     *
     * @constructor
     */
    Formatter: React.FC<FormatterProps>;
    /**
     *
     * @constructor
     */
    LocaleProvider: React.FC<ProviderProps>;
    /**
     *
     * @constructor
     */
    Provider: React.FC<ProviderProps>;
    /**
     *返回虚拟dom
     * @param path
     * @param options
     */
    t(path: string, options?: {
        [key: string]: any;
    }): string;
}
declare const locale: Locale;
/**
 * @deprecated 使用Provider 代替
 * @param initProps
 */
declare function localeRender(initProps?: ProviderProps): (element: React.ReactElement, container: Element | DocumentFragment, callback?: () => void) => void;
export { localeRender };
export default locale;
