"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.localeRender = localeRender;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _format = _interopRequireDefault(require("./format"));

var _zhCN = _interopRequireDefault(require("./lang/zh-CN"));

var _enUS = _interopRequireDefault(require("./lang/en-US"));

var _react = _interopRequireWildcard(require("react"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _util = require("../../libs/utils/util");

var _reactDom = require("react-dom");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var FormatterContext = /*#__PURE__*/_react.default.createContext(undefined);

var ProviderContext = /*#__PURE__*/_react.default.createContext(undefined);

var subscribes = {
  watches: {},

  /**
   * 订阅
   * @param name
   * @param id
   * @param callback
   */
  subscribe: function subscribe(name, id, callback) {
    if (!this.watches[name]) {
      this.watches[name] = [];
    }

    this.watches[name].push({
      id: id,
      callback: callback
    });
  },

  /**
   * 取消订阅
   * @param name
   * @param id
   */
  unSubscribe: function unSubscribe(name, id) {
    var index = this.watches[name].findIndex(function (item) {
      return item.id === id;
    });
    this.watches[name].splice(index, 1);
  },

  /**
   * 发布
   * @param name
   * @param lang
   */
  broadcast: function broadcast(name, lang) {
    if (!this.watches[name]) {
      this.watches[name] = [];
    }

    this.watches[name].forEach(function (item) {
      var callback = item.callback;
      /**就算callback有操作this.list 也不会影响继续运行下去中的**/

      setTimeout(function () {
        callback(lang);
      });
    });
  }
};

/**
 * 合并对象
 * @param dest
 * @param pre
 */
function merge() {
  var dest = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var pre = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  (0, _warning.default)((0, _typeof2.default)(dest) === 'object', 'Locale', "\u4F20\u5165\u7684\u8BED\u8A00\u914D\u7F6E\u4E0D\u662F\u4E00\u4E2A\u5BF9\u8C61");

  if ((0, _typeof2.default)(dest) !== 'object') {
    dest = {};
  }

  if ((0, _typeof2.default)(pre) !== 'object') {
    pre = {};
  }

  var newObj = _objectSpread({}, pre);

  Object.entries(dest).forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    if ((0, _typeof2.default)(value) !== 'object') {
      newObj[key] = value;
    } else {
      if (key in pre && (0, _typeof2.default)(pre[key]) === 'object') {
        newObj[key] = merge(value, pre[key]);
      } else {
        newObj[key] = value;
      }
    }
  });
  return newObj;
}

var Locale = /*#__PURE__*/function () {
  function Locale() {
    var _this = this;

    (0, _classCallCheck2.default)(this, Locale);
    this.defaultConfig = {
      'zh-CN': _zhCN.default,
      'en-US': _enUS.default,
      current: 'zh-CN'
    };
    this.localeRender = void 0;

    this.Formatter = function (_ref3) {
      var path = _ref3.path,
          options = _ref3.options,
          children = _ref3.children;
      return /*#__PURE__*/(0, _react.createElement)(ProviderContext.Consumer, null, function (value) {
        if (!value) {
          value = _this.defaultConfig.current;
        }

        var txt = _this.h(path, options, value).map(function (item) {
          if ((0, _typeof2.default)(item) === 'object' && !Array.isArray(item)) {
            return /*#__PURE__*/_react.default.cloneElement(item, {
              key: item.key
            });
          }

          return item;
        });

        var renderChildren = children ? /*#__PURE__*/(0, _react.createElement)(FormatterContext.Consumer, null, children) : txt;

        var _children = /*#__PURE__*/(0, _react.createElement)(_react.default.Fragment, null, renderChildren);

        return /*#__PURE__*/(0, _react.createElement)(FormatterContext.Provider, {
          value: txt
        }, _children);
      });
    };

    this.LocaleProvider = function (_ref4) {
      var initConfig = _ref4.initConfig,
          lang = _ref4.lang,
          children = _ref4.children,
          onLangChange = _ref4.onLangChange;
      initConfig && _this.init(initConfig);
      lang && (_this.defaultConfig.current = lang);
      var id = "".concat((0, _util.UUID)(), "_").concat(lang);
      subscribes.subscribe('language', id, function (lang) {
        onLangChange && onLangChange(lang);
      });
      return /*#__PURE__*/(0, _react.createElement)(ProviderContext.Provider, {
        value: _this.defaultConfig.current
      }, children);
    };

    this.Provider = function (_ref5) {
      var initConfig = _ref5.initConfig,
          lang = _ref5.lang,
          children = _ref5.children,
          onLangChange = _ref5.onLangChange;

      var _React$useState = _react.default.useState(true),
          _React$useState2 = (0, _slicedToArray2.default)(_React$useState, 2),
          reRender = _React$useState2[0],
          setReRender = _React$useState2[1];

      initConfig && _this.init(initConfig);
      lang && (_this.defaultConfig.current = lang);
      var id = "".concat((0, _util.UUID)(), "_").concat(lang);
      subscribes.subscribe('language', id, function (lang) {
        onLangChange && onLangChange(lang);
        setReRender(false);
        requestAnimationFrame(function () {
          setReRender(true);
        });
      });
      return /*#__PURE__*/(0, _react.createElement)(ProviderContext.Provider, {
        value: _this.defaultConfig.current
      }, reRender ? children : '');
    };
  }

  (0, _createClass2.default)(Locale, [{
    key: "init",
    value:
    /**
     * 初始化
     * @param config
     */
    function init(config) {
      if (!(this instanceof Locale)) {
        (0, _warning.default)(false, 'Locale', 'init方法不可以单独使用 必须调用Locale.init');
        return;
      }

      this.defaultConfig = _objectSpread(_objectSpread({
        current: 'zh-CN'
      }, config), {}, {
        'zh-CN': merge(config['zh-CN'], _zhCN.default),
        'en-US': merge(config['en-US'], _enUS.default)
      });
    }
    /**
     *
     * @param lang
     */

  }, {
    key: "use",
    value: function use(lang) {
      if (!(this instanceof Locale)) {
        (0, _warning.default)(false, 'Locale', 'use方法不可以单独使用 必须调用Locale.use');
        return;
      }

      this.defaultConfig.current = lang;
      subscribes.broadcast('language', lang);
    }
    /**获取语言 */

  }, {
    key: "get",
    value: function get() {
      return this.defaultConfig.current;
    }
    /**
     *返回带有ast树的数组
     * @param path
     * @param options
     * @param lang
     */

  }, {
    key: "h",
    value: function h(path, options, lang) {
      if (!(this instanceof Locale)) {
        (0, _warning.default)(false, 'Locale', 'h方法不可以单独使用 必须调用Locale.h');
        return;
      }

      var array = path.split('.');
      var current = this.defaultConfig[lang];

      if (!lang) {
        (0, _warning.default)(false, 'Locale', "\u627E\u4E0D\u5230".concat(path));
        return [];
      }

      for (var i = 0, j = array.length; i < j; i++) {
        var property = array[i];
        var _value = current[property];
        (0, _warning.default)(_value, 'Locale', "\u627E\u4E0D\u5230".concat(path));

        if (i === j - 1) {
          if (_value === undefined) {
            (0, _warning.default)(false, 'Locale', "\u627E\u4E0D\u5230".concat(path));
            return [''];
          }

          return (0, _format.default)(_value, options);
        }

        if (!_value) {
          (0, _warning.default)(_value, 'Locale', "\u627E\u4E0D\u5230".concat(path));
          return [];
        }

        current = _value;
      }

      return [];
    }
    /**
     *
     * @constructor
     */

  }, {
    key: "t",
    value:
    /**
     *返回虚拟dom
     * @param path
     * @param options
     */
    function t(path, options) {
      if (!(this instanceof Locale)) {
        (0, _warning.default)(false, 'Locale', 't方法不可以单独使用 必须调用Local.t');
        return;
      }

      var txt = this.h(path, options, this.defaultConfig.current).map(function (item) {
        if ((0, _typeof2.default)(item) === 'object' && !Array.isArray(item)) {
          return /*#__PURE__*/_react.default.cloneElement(item, {
            key: item.key
          });
        }

        return item;
      });
      return txt.join('');
    }
  }]);
  return Locale;
}();

var locale = new Locale();
/**
 * @deprecated 使用Provider 代替
 * @param initProps
 */

function localeRender() {
  var initProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var beforeLang;
  var beforeContainer;
  var beforeElement;
  var beforeCallback;
  var _onLangChange = initProps.onLangChange;

  initProps.onLangChange = function (lang) {
    _onLangChange && _onLangChange(lang);

    if (lang !== beforeLang) {
      innerRender()(beforeElement, beforeContainer, beforeCallback);
    }

    beforeLang = lang;
  };
  /**
   *内部渲染
   */


  function innerRender() {
    return function (element, container, callback) {
      if (beforeContainer) {
        (0, _reactDom.unmountComponentAtNode)(beforeContainer);
      }

      var _element = /*#__PURE__*/_react.default.createElement(locale.LocaleProvider, initProps, /*#__PURE__*/_react.default.cloneElement(element, element.props));

      (0, _reactDom.render)(_element, container, callback);
      beforeContainer = container;
      beforeElement = element;
      beforeCallback = callback;
    };
  }

  return innerRender();
}

locale.localeRender = localeRender;
var _default = locale;
exports.default = _default;