"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.getSelectedPathId = getSelectedPathId;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _types = require("../../libs/types");

var _util = require("../../libs/utils/util");

var _MenuContext = _interopRequireDefault(require("./MenuContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MenuMode = (0, _types.tuple)('vertical', 'inline');
var SubMenuShowLocation = (0, _types.tuple)('auto', 'top', 'bottom'); //Menu下面子级只能是MenuItem，SubMenu，MenuItemGroup
//SubMenu子级只能是MenuItem, MenuItemGroup

/** */
function getSelectedPathId(children, keys, ret) {
  var tempPath = [];

  try {
    /**MenuItemGroup 遍历子级 */
    var mapChildren = function mapChildren(c) {
      if (c.props && c.props.children) {
        React.Children.forEach(c.props.children, function (d) {
          getSelecteNodePath(d);
        });
      }
    };
    /** */


    var getSelecteNodePath = function getSelecteNodePath(c) {
      if (c) {
        var construct = c.type;

        if (construct) {
          if (construct.isMenuItemGroup) {
            mapChildren(c);
            return;
          }

          var _ref = c.props,
              _index = _ref.index;

          if (construct.isMenuItem || construct.isSubMenu) {
            tempPath.push(_index);

            if (construct.isMenuItem) {
              //MenuItem就是叶子节点，遍历将不会再继续
              if (keys.indexOf(_index) !== -1) {
                ret.find = true;
                throw 'got it';
              }
            }

            if (c.props && c.props.children) {
              React.Children.forEach(c.props.children, function (d) {
                getSelecteNodePath(d);
              });
              tempPath.pop();
            } else {
              tempPath.pop();
            }
          }
        }
      }
    };

    React.Children.forEach(children, function (c) {
      getSelecteNodePath(c);
    });
  } catch (e) {
    if (ret.find) {
      ret.openKeys = tempPath;
    }
  }
}

var Menu = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Menu, _React$Component);

  var _super = _createSuper(Menu);

  /**
   * 
   * @param props 
   */
  function Menu(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Menu);
    _this = _super.call(this, props);
    var selectedKeys = props.defaultSelectedKeys || [];
    var openKeys = props.defaultOpenKeys || [];

    if ('selectedKeys' in props) {
      selectedKeys = props.selectedKeys || [];
    }

    if ('openKeys' in props) {
      openKeys = props.openKeys || [];
    }

    _this.state = {
      openKeys: openKeys,
      selectedKeys: selectedKeys //prevProps: {},

    };
    return _this;
  }
  /**
   * 获取提供给下级调用的方法
   */


  (0, _createClass2.default)(Menu, [{
    key: "getMenuHandleHook",
    value: function getMenuHandleHook() {
      var _this2 = this;

      return {
        clickMenuItem: function clickMenuItem(e, item, index, indexPath) {
          //改变选中的selectedKeys，我们当前只有单选
          var _this2$props = _this2.props,
              mode = _this2$props.mode,
              onItemClick = _this2$props.onItemClick;

          _this2.setState({
            selectedKeys: [index]
          }); //如果是vertical，则选中后，只留下一级菜单


          if (mode !== 'inline') {
            //即openKeys，只有第一级，
            //Debug 15130， 选中后，要等待显示选中效果再更新
            setTimeout(function () {
              _this2.setState && _this2.setState({
                openKeys: []
              });
            }, 300);
          } // 自定义处理事件


          onItemClick && onItemClick({
            index: index,
            indexPath: indexPath,
            item: item,
            domEvent: e
          });
        },
        openSubMenu: function openSubMenu(index, indexPath) {
          //改变openKeys内容，要么是hide，要么是open
          //idPath为[], 前面父级选中的id
          var onOpenChange = _this2.props.onOpenChange;
          var _this2$state$openKeys = _this2.state.openKeys,
              openKeys = _this2$state$openKeys === void 0 ? [] : _this2$state$openKeys;
          var customOpenkeys = [].concat(openKeys); //需要删除，或者增加

          var existIndex = customOpenkeys.findIndex(function (item) {
            return item === index;
          });

          if (existIndex === -1) {
            //说明是展开
            customOpenkeys.push(index);
          } else {
            //说明是收起来
            customOpenkeys.splice(existIndex, 1);
          } //然后再去重，即为当前展开的内容


          var stateOpenKeys = (0, _toConsumableArray2.default)(customOpenkeys);

          if (_this2.props.openUnique || _this2.props.mode !== 'inline') {
            //TODO：若子级是展开的，那么此时父级也应该是展开的
            var parentOpenKeys = indexPath || [];
            stateOpenKeys = existIndex > -1 ? parentOpenKeys : [].concat((0, _toConsumableArray2.default)(parentOpenKeys), [index]);
          }

          _this2.setState({
            openKeys: (0, _toConsumableArray2.default)(stateOpenKeys)
          }); //自定义处理事件


          onOpenChange && onOpenChange(stateOpenKeys, index, indexPath);
        },
        getScrollContainer: this.props.getScrollContainer
      };
    }
    /**
     * 
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          customizePrefixCls = _this$props.prefixCls,
          className = _this$props.className,
          mode = _this$props.mode,
          style = _this$props.style,
          hasIndicator = _this$props.hasIndicator,
          ellipsis = _this$props.ellipsis,
          children = _this$props.children,
          verticalShowLocation = _this$props.verticalShowLocation,
          inlineIntent = _this$props.inlineIntent;
      var _this$state = this.state,
          selectedKeys = _this$state.selectedKeys,
          openKeys = _this$state.openKeys;
      var prefixCls = (0, _util.getPrefixCls)('menu', customizePrefixCls);
      var menuClassName = (0, _classnames.default)(className, "".concat(prefixCls), "".concat(prefixCls, "--").concat(mode));

      var menuStyle = _objectSpread({}, style);

      return /*#__PURE__*/React.createElement(_MenuContext.default.Provider, {
        value: {
          mode: mode,
          hasIndicator: hasIndicator,
          ellipsis: ellipsis,
          selectedKeys: selectedKeys,
          openKeys: openKeys,
          verticalShowLocation: verticalShowLocation,
          inlineIntent: inlineIntent,
          menuHandleHook: this.getMenuHandleHook()
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: menuClassName,
        style: menuStyle
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**
     * 根据上级传下的openKeys改变当前菜单的展开效果
     * @param nextProps 
     * @param prevState 
     */
    function getDerivedStateFromProps(nextProps, prevState) {
      var prevProps = prevState.prevProps || {};
      var prevDefaultSelectedKeys = prevProps.defaultSelectedKeys || [];
      var prevMode = prevProps.mode;
      var _nextProps$defaultSel = nextProps.defaultSelectedKeys,
          defaultSelectedKeys = _nextProps$defaultSel === void 0 ? [] : _nextProps$defaultSel,
          expandOpenKeysByDefaultSelectedKeys = nextProps.expandOpenKeysByDefaultSelectedKeys,
          mode = nextProps.mode,
          children = nextProps.children;
      var defaultOpenKeysBySelectedKeys = mode === 'inline' && expandOpenKeysByDefaultSelectedKeys && prevDefaultSelectedKeys !== defaultSelectedKeys;
      var newState = {
        prevProps: nextProps
      };

      if ('openKeys' in nextProps) {
        newState.openKeys = nextProps.openKeys;
      }

      if ('selectedKeys' in nextProps) {
        newState.selectedKeys = nextProps.selectedKeys;
      }

      if (defaultOpenKeysBySelectedKeys) {
        var ret = {
          find: false,
          openKeys: []
        };
        getSelectedPathId(children, nextProps.defaultSelectedKeys || [], ret);

        var _nextProps$openKeys = nextProps.openKeys,
            _openKeys = _nextProps$openKeys === void 0 ? [] : _nextProps$openKeys;

        if (ret.find) {
          _openKeys.push.apply(_openKeys, (0, _toConsumableArray2.default)(ret.openKeys));

          var lastOpenkeys = Array.from(new Set(_openKeys));
          newState.openKeys = lastOpenkeys;
        }
      } //当从inline 切换为vertical时，默认全部收起来


      if (prevMode === 'inline' && mode === 'vertical') {
        newState.openKeys = [];
      }

      return newState;
    }
  }]);
  return Menu;
}(React.Component);

Menu.SubMenu = void 0;
Menu.Item = void 0;
Menu.ItemGroup = void 0;
Menu.isMenu = true;
Menu.defaultProps = {
  mode: 'inline',
  hasIndicator: true,
  //subMenu才有，展开和收起
  ellipsis: false,
  //默认不省略
  verticalShowLocation: 'auto',
  inlineIntent: 24
};
var _default = Menu;
exports.default = _default;