import * as React from 'react';
export interface MenuItemProps {
    /**当前MenuItem的index属性，为唯一标志，必填 */
    index: string | number;
    /**当前MenuItem所在的纵向index路径，不包括本身，此属性不提供给用户，属于自动生成 */
    indexPath?: Array<string | number>;
    /**是否可选中 */
    disabled?: boolean;
    className?: string;
    /**图标（只能放在前面） */
    icon?: React.ReactElement;
    style?: React.CSSProperties;
    /**显示内容是否可省略 */
    ellipsis?: boolean;
    prefixCls?: string;
}
export default class MenuItem extends React.Component<MenuItemProps> {
    static isMenuItem: boolean;
    static contextType: React.Context<import("./MenuContext").MenuContextProps>;
    static defaultProps: Partial<MenuItemProps>;
    menuItemRef: HTMLElement;
    handleClick: React.MouseEventHandler<HTMLElement>;
    /**
     *
     */
    render(): React.ReactNode;
}
