"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _MenuContext = _interopRequireDefault(require("./MenuContext"));

var _excluded = ["disabled", "index", "prefixCls", "className", "icon", "style", "ellipsis", "children", "indexPath"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MenuItem = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(MenuItem, _React$Component);

  var _super = _createSuper(MenuItem);

  function MenuItem() {
    var _this;

    (0, _classCallCheck2.default)(this, MenuItem);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.menuItemRef = void 0;

    _this.handleClick = function (e) {
      //选中效果
      var _this$props = _this.props,
          index = _this$props.index,
          disabled = _this$props.disabled,
          indexPath = _this$props.indexPath;
      var menuHandleHook = _this.context.menuHandleHook;

      if (!disabled) {
        menuHandleHook.clickMenuItem(e, _this.menuItemRef, index, indexPath);
      } else {
        e.stopPropagation();
        e.nativeEvent.stopImmediatePropagation();
      }
    };

    return _this;
  }

  (0, _createClass2.default)(MenuItem, [{
    key: "render",
    value:
    /**
     * 
     */
    function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          index = _this$props2.index,
          customizePrefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          icon = _this$props2.icon,
          style = _this$props2.style,
          itemEllipsis = _this$props2.ellipsis,
          children = _this$props2.children,
          indexPath = _this$props2.indexPath,
          others = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);
      var _this$context = this.context,
          selectedKeys = _this$context.selectedKeys,
          menuEllipsis = _this$context.ellipsis,
          inlineIntent = _this$context.inlineIntent,
          mode = _this$context.mode;
      var ellipsis = itemEllipsis;

      if (typeof itemEllipsis === 'undefined') {
        ellipsis = menuEllipsis;
      }

      var prefixCls = (0, _util.getPrefixCls)('menu-item', customizePrefixCls);
      var isSelected = selectedKeys.find(function (item) {
        return item === index;
      });
      var menuItemClassNames = (0, _classnames.default)(className, "".concat(prefixCls), {
        'is-disabled': disabled,
        'is-selected': isSelected,
        'is-ellipsis': ellipsis,
        'has-icon': icon
      });

      var menuItemStyle = _objectSpread({}, style); //inlineIntent: 12, 12px, 12rem的情况


      var unitMatch = inlineIntent.toString().match(/([a-z%]+)$/ig);
      var unit = unitMatch ? unitMatch[0] : 'px';

      if (mode === 'inline') {
        var level = (indexPath || []).length + 1;
        menuItemStyle = _objectSpread({
          paddingLeft: "".concat(parseFloat(inlineIntent) * level).concat(unit)
        }, menuItemStyle);
      }

      return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        ref: function ref(div) {
          _this2.menuItemRef = div;
        },
        className: menuItemClassNames,
        style: menuItemStyle
      }, others, {
        onClick: this.handleClick
      }), icon && /*#__PURE__*/React.cloneElement(icon, {
        className: 'action-icon'
      }), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "--title-info")
      }, children));
    }
  }]);
  return MenuItem;
}(React.Component);

exports.default = MenuItem;
MenuItem.isMenuItem = true;
MenuItem.contextType = _MenuContext.default;
MenuItem.defaultProps = {
  disabled: false
};