"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _MenuContext = _interopRequireDefault(require("./MenuContext"));

var _tool = _interopRequireDefault(require("./tool"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MenuItemGroup = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(MenuItemGroup, _React$Component);

  var _super = _createSuper(MenuItemGroup);

  function MenuItemGroup() {
    (0, _classCallCheck2.default)(this, MenuItemGroup);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(MenuItemGroup, [{
    key: "render",
    value:
    /** */
    function render() {
      var _this = this;

      var _this$context = this.context,
          inlineIntent = _this$context.inlineIntent,
          parentEllipsis = _this$context.ellipsis,
          mode = _this$context.mode;
      var _this$props = this.props,
          groupTitle = _this$props.groupTitle,
          indexPath = _this$props.indexPath,
          className = _this$props.className,
          style = _this$props.style,
          children = _this$props.children,
          customizePrefixCls = _this$props.prefixCls,
          ellipsis = _this$props.ellipsis;
      var prefixCls = (0, _util.getPrefixCls)('menu-itemgroup', customizePrefixCls);
      var level = (indexPath || []).length + 1;

      var mergeStyle = _objectSpread({}, style);

      var unitMatch = inlineIntent.toString().match(/([a-z%]+)$/ig);
      var unit = unitMatch ? unitMatch[0] : 'px';

      if (mode === 'inline') {
        mergeStyle = _objectSpread({
          paddingLeft: unit === 'px' ? parseFloat(inlineIntent) * level - 8 : "".concat(parseFloat(inlineIntent) * level).concat(unit)
        }, style);
      }

      var classString = (0, _classnames.default)(prefixCls, className);
      var classItemGroup = (0, _classnames.default)("".concat(prefixCls, "__title"), [{
        'is-ellipsis': ellipsis || parentEllipsis
      }]);
      return /*#__PURE__*/React.createElement("div", {
        className: classString
      }, /*#__PURE__*/React.createElement("div", {
        className: classItemGroup,
        style: mergeStyle
      }, groupTitle), React.Children.map(children, function (c, i) {
        return (0, _tool.default)(c, _this.props);
      }));
    }
  }]);
  return MenuItemGroup;
}(React.Component);

exports.default = MenuItemGroup;
MenuItemGroup.contextType = _MenuContext.default;
MenuItemGroup.isMenuItemGroup = true;