"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.alert = alert;
exports.confirm = confirm;
exports.dialog = dialog;
exports.prompt = prompt;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _modal = _interopRequireDefault(require("../modal"));

var _button = _interopRequireDefault(require("../button"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _input = _interopRequireDefault(require("../input"));

var _locale = _interopRequireDefault(require("../locale"));

var _RemindLine = _interopRequireDefault(require("net-design-icons/lib/icons/RemindLine"));

var _InformationLine = _interopRequireDefault(require("net-design-icons/lib/icons/InformationLine"));

var _CompleteCircle = _interopRequireDefault(require("net-design-icons/lib/icons/CompleteCircle"));

var _CloseLine = _interopRequireDefault(require("net-design-icons/lib/icons/CloseLine"));

var _util = require("../../libs/utils/util");

var _excluded = ["title", "message", "iconType", "icon", "children", "type", "okText", "cancelText", "placeholder"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var Formatter = _locale.default.Formatter;

/**
 * 导出alert函数
 * @param message
 * @param title
 * @param props
 */
function alert() {
  var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var props = arguments.length > 2 ? arguments[2] : undefined;

  if ((0, _typeof2.default)(title) === 'object') {
    props = title;
  }

  var renderProps = _objectSpread({
    title: title,
    message: message,
    visible: true,
    type: 'alert',
    okText: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.message.know"
    }),
    closeOnPressEscape: false,
    closeOnClickMask: false
  }, props);

  return main(renderProps);
}
/**
 * 导出confirm函数
 * @param message
 * @param title
 * @param props
 */


function confirm() {
  var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var props = arguments.length > 2 ? arguments[2] : undefined;

  if ((0, _typeof2.default)(title) === 'object') {
    props = title;
  }

  var renderProps = _objectSpread({
    title: title,
    message: message,
    closeOnClickMask: false,
    type: 'confirm',
    okText: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.common.confirm"
    }),
    cancelText: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.common.cancel"
    })
  }, props);

  return main(renderProps);
}
/**
 * 导出prompt函数
 * @param message
 * @param title
 * @param props
 */


function prompt() {
  var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var props = arguments.length > 2 ? arguments[2] : undefined;

  if ((0, _typeof2.default)(title) === 'object') {
    props = title;
  }

  var renderProps = _objectSpread({
    title: title,
    message: message,
    type: 'prompt',
    closeOnClickMask: false,
    showInput: true,
    okText: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.common.confirm"
    }),
    cancelText: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.common.cancel"
    })
  }, props);

  return main(renderProps);
}
/**
 * 导出dialog函数
 * @param props
 */


function dialog(props) {
  var ref = /*#__PURE__*/React.createRef();
  props = _objectSpread({
    type: 'dialog',
    _ref: ref,
    closeOnClickMask: false
  }, props);
  main(props);
  return {
    destroy: function destroy() {
      ref.current.handleClose();
    }
  };
}

var Dialog = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Dialog, _React$Component);

  var _super = _createSuper(Dialog);

  function Dialog() {
    var _this;

    (0, _classCallCheck2.default)(this, Dialog);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      visible: true,
      value: ''
    };
    return _this;
  }

  (0, _createClass2.default)(Dialog, [{
    key: "componentDidMount",
    value:
    /**
     * 初次挂载
     */
    function componentDidMount() {
      var defaultValue = this.props.defaultValue;
      this.setState({
        value: defaultValue
      });
    }
    /**
     * 处理关闭
     */

  }, {
    key: "handleClose",
    value: function () {
      var _handleClose = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(e) {
        var _this$props, willUnmount, type, promise, onCancel, _ref, reject, visible, res;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props = this.props, willUnmount = _this$props.willUnmount, type = _this$props.type, promise = _this$props.promise, onCancel = _this$props.onCancel;
                _ref = promise || {}, reject = _ref.reject;
                visible = this.state.visible;
                /**有可能会连续点击该按钮**/

                if (visible) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("return");

              case 5:
                onCancel && onCancel(e);
                _context.next = 8;
                return this.beforeDestroy();

              case 8:
                res = _context.sent;

                if (res) {
                  this.setState({
                    visible: false
                  });

                  if (type === 'confirm') {
                    reject(false);
                  }

                  setTimeout(function () {
                    willUnmount();
                  }, 300);
                }

              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleClose(_x) {
        return _handleClose.apply(this, arguments);
      }

      return handleClose;
    }()
    /**
     * 销毁前
     */

  }, {
    key: "beforeDestroy",
    value: function () {
      var _beforeDestroy = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2() {
        var value, beforeDestroy, result;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                value = this.state.value;
                beforeDestroy = this.props.beforeDestroy;

                if (!(beforeDestroy === undefined)) {
                  _context2.next = 4;
                  break;
                }

                return _context2.abrupt("return", true);

              case 4:
                if (!(typeof beforeDestroy === 'boolean')) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt("return", beforeDestroy);

              case 8:
                if (!(beforeDestroy instanceof RegExp)) {
                  _context2.next = 12;
                  break;
                }

                return _context2.abrupt("return", beforeDestroy.test(value));

              case 12:
                if (!(typeof beforeDestroy === 'function')) {
                  _context2.next = 21;
                  break;
                }

                result = beforeDestroy(value);

                if (!(result instanceof Promise)) {
                  _context2.next = 20;
                  break;
                }

                _context2.next = 17;
                return result;

              case 17:
                return _context2.abrupt("return", _context2.sent);

              case 20:
                return _context2.abrupt("return", result);

              case 21:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function beforeDestroy() {
        return _beforeDestroy.apply(this, arguments);
      }

      return beforeDestroy;
    }()
    /**
     * 处理点击确定
     */

  }, {
    key: "handleOK",
    value: function () {
      var _handleOK = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3(e) {
        var _this$props2, promise, type, willUnmount, onOk, value, _ref2, resolve, res;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _this$props2 = this.props, promise = _this$props2.promise, type = _this$props2.type, willUnmount = _this$props2.willUnmount, onOk = _this$props2.onOk;
                value = this.state.value;
                _ref2 = promise || {}, resolve = _ref2.resolve;
                onOk && onOk(e);
                _context3.next = 6;
                return this.beforeDestroy();

              case 6:
                res = _context3.sent;

                if (res) {
                  this.setState({
                    visible: false
                  });
                  setTimeout(function () {
                    willUnmount();
                  }, 300);

                  if (type === 'confirm') {
                    resolve(true);
                  } else if (type === 'prompt') {
                    resolve(value);
                  }
                }

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function handleOK(_x2) {
        return _handleOK.apply(this, arguments);
      }

      return handleOK;
    }()
    /**
     * 值改变
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(e) {
      this.setState({
        value: e.target.value
      });
    }
    /**
     * 重新生成header、footer
     *
     */

  }, {
    key: "remakeSlot",
    value: function remakeSlot() {
      var _this2 = this;

      var value = this.state.value;
      var _this$props3 = this.props,
          promise = _this$props3.promise,
          type = _this$props3.type,
          willUnmount = _this$props3.willUnmount,
          header = _this$props3.header,
          footer = _this$props3.footer;

      var _ref3 = promise || {},
          resolve = _ref3.resolve,
          reject = _ref3.reject;

      var renderOk = function renderOk(ok) {
        return /*#__PURE__*/React.cloneElement(ok, _objectSpread(_objectSpread({}, ok.props), {}, {
          onClick: function onClick() {
            var onClick = ok.props.onClick;
            onClick && onClick.apply(void 0, arguments);

            if (type === 'prompt') {
              resolve(value);
            } else {
              resolve(true);
            }

            _this2.setState({
              visible: false
            });

            setTimeout(function () {
              willUnmount();
            }, 300);
          }
        }));
      };

      var renderCancel = function renderCancel(cancel) {
        return /*#__PURE__*/React.cloneElement(cancel, _objectSpread(_objectSpread({}, cancel.props), {}, {
          onClick: function onClick() {
            var onClick = cancel.props.onClick;
            onClick && onClick.apply(void 0, arguments);
            reject(false);

            _this2.setState({
              visible: false
            });

            setTimeout(function () {
              willUnmount();
            }, 300);
          }
        }));
      };

      var props = {
        footer: footer,
        header: header
      };

      if (typeof footer === 'function') {
        props.footer = footer(renderOk, renderCancel);
      }

      if (typeof header === 'function') {
        props.header = header(renderCancel);
      }

      return props;
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          title = _this$props4.title,
          message = _this$props4.message,
          iconType = _this$props4.iconType,
          icon = _this$props4.icon,
          children = _this$props4.children,
          type = _this$props4.type,
          okText = _this$props4.okText,
          cancelText = _this$props4.cancelText,
          placeholder = _this$props4.placeholder,
          rest = (0, _objectWithoutProperties2.default)(_this$props4, _excluded);
      var visible = this.state.visible;
      rest.visible = true;

      var _this$remakeSlot = this.remakeSlot(),
          header = _this$remakeSlot.header,
          footer = _this$remakeSlot.footer;

      var renderHeader = header;
      var icons = {
        success: /*#__PURE__*/React.createElement(_CompleteCircle.default, {
          className: "rd-message-content__icon",
          color: '#52C41A'
        }),
        info: /*#__PURE__*/React.createElement(_InformationLine.default, {
          className: "rd-message-content__icon",
          color: '#1890FF'
        }),
        warning: /*#__PURE__*/React.createElement(_RemindLine.default, {
          className: "rd-message-content__icon",
          color: '#FAAD14'
        }),
        error: /*#__PURE__*/React.createElement(_CloseLine.default, {
          className: "rd-message-content__icon",
          color: '#F5222D'
        })
      };
      var renderChildren = (0, _util.isExist)(children) ? children : /*#__PURE__*/React.createElement("div", {
        className: "rd-message-content__wrapper"
      }, icon ? icon : iconType && icons[iconType], /*#__PURE__*/React.createElement("div", {
        className: "rd-message__content"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-message__title"
      }, title), /*#__PURE__*/React.createElement("div", {
        className: "rd-message__message"
      }, message)));
      var renderFooter = (0, _util.isExist)(footer) ? footer : /*#__PURE__*/React.createElement("div", {
        className: "rd-message__button-group"
      }, cancelText && /*#__PURE__*/React.createElement(_button.default, {
        className: "rd-message-cancel",
        onClick: this.handleClose
      }, cancelText), okText && /*#__PURE__*/React.createElement(_button.default, {
        className: "rd-message-ok",
        type: "primary",
        onClick: this.handleOK
      }, okText));
      var node = {
        alert: {
          header: renderHeader,
          children: renderChildren,
          footer: (0, _util.isExist)(footer) ? footer : /*#__PURE__*/React.createElement("div", {
            className: "rd-message__button-group"
          }, okText && /*#__PURE__*/React.createElement(_button.default, {
            type: "primary",
            onClick: this.handleOK
          }, okText))
        },
        confirm: {
          header: renderHeader,
          children: renderChildren,
          footer: renderFooter
        },
        prompt: {
          header: (0, _util.isExist)(header) ? header : /*#__PURE__*/React.createElement("div", {
            className: "rd-message__prompt"
          }, /*#__PURE__*/React.createElement("div", {
            className: "rd-message__title"
          }, title), /*#__PURE__*/React.createElement("div", {
            className: "rd-message__message"
          }, /*#__PURE__*/React.createElement("div", {
            className: "rd-message__hint"
          }, message), /*#__PURE__*/React.createElement(_input.default, {
            placeholder: placeholder,
            value: this.state.value,
            onChange: this.handleChange
          }))),
          children: (0, _util.isExist)(children) ? children : renderHeader,
          footer: renderFooter
        },
        dialog: {
          children: children,
          header: header,
          footer: footer
        }
      };

      var props = _objectSpread({}, this.props);

      props.header = node[type].header;
      props.children = node[type].children;
      props.title = undefined;
      props.footer = node[type].footer;
      props.divider = type === 'dialog' ? this.props.divider : false;
      props.visible = visible;
      props.onOk = this.handleOK;
      props.onCancel = this.handleClose;
      return /*#__PURE__*/React.createElement(_modal.default, (0, _extends2.default)({
        className: type !== 'dialog' && 'rd-message'
      }, props));
    }
  }]);
  return Dialog;
}(React.Component), _class2.defaultProps = {
  iconType: 'info',
  placeholder: /*#__PURE__*/React.createElement(Formatter, {
    path: "rd.message.placeholder"
  })
}, _class2)) || _class;
/**
 * dialog 主函数
 * @param props
 */


function main(props) {
  var bodyStyle = '';
  return new Promise(function (resolve, reject) {
    var div = document.createElement('div');
    div.setAttribute('role', 'dialog');
    document.body.appendChild(div);

    if (props.lockScroll !== false) {
      bodyStyle = document.body.getAttribute('style');
      document.body.style.overflow = 'hidden';
    }

    var willUnmount = function willUnmount() {
      _reactDom.default.unmountComponentAtNode(div);

      if (!bodyStyle) {
        document.body.removeAttribute('style');
      } else {
        document.body.setAttribute('style', bodyStyle);
      }

      (0, _util.removeEvent)(window, 'popstate', willUnmount);
    };
    /**
     * bug15347 浏览器后退应该将组件销毁
     */


    (0, _util.addEvent)(window, 'popstate', willUnmount);
    props = Object.assign({}, props, {
      promise: {
        resolve: resolve,
        reject: reject
      },
      willUnmount: willUnmount
    });

    _reactDom.default.render( /*#__PURE__*/React.createElement(Dialog, (0, _extends2.default)({
      ref: props._ref
    }, props)), div);

    document.body.removeChild(div);
  });
}