"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _button = _interopRequireDefault(require("../button"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _Close = _interopRequireDefault(require("net-design-icons/lib/icons/Close"));

var _transition = _interopRequireDefault(require("../transition"));

var _locale = _interopRequireDefault(require("../locale"));

var _Portal = _interopRequireDefault(require("../portal/Portal"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Formatter = _locale.default.Formatter;
var ENTER = 13;
var ESC = 27;

var Modal = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Modal, _React$PureComponent);

  var _super = _createSuper(Modal);

  function Modal() {
    var _this;

    (0, _classCallCheck2.default)(this, Modal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      leave: true
    };
    _this.el = /*#__PURE__*/React.createRef();
    _this.isLongClick = void 0;
    return _this;
  }

  (0, _createClass2.default)(Modal, [{
    key: "componentDidMount",
    value:
    /**
     * 初次加載
     */
    function componentDidMount() {
      (0, _util.addEvent)(document, 'keydown', this.handleKeyDown);
    }
    /**
     * 将要卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _util.removeEvent)(document, 'keydown', this.handleKeyDown);
    }
    /**
     * 处理关闭
     * @param e
     */

  }, {
    key: "handleClose",
    value: function handleClose(e) {
      var onCancel = this.props.onCancel;
      onCancel && onCancel(e);
    }
    /**
     * 处理键盘落下
     * @param e
     */

  }, {
    key: "handleKeyDown",
    value: function handleKeyDown(e) {
      var _this$props = this.props,
          closeOnPressEscape = _this$props.closeOnPressEscape,
          visible = _this$props.visible; //如果当前modal未显示，则不处理
      // if (e.keyCode === ENTER) {
      //     e.preventDefault();
      // } // 添加是因为Message点击回车会一直弹出消息提醒；
      // 取消是因为当前操作会阻止表单回车默认事件，并且取消此操作，也不会引起message点击回车一直弹出消息的问题

      if (!visible) {
        return;
      }

      if (closeOnPressEscape && e.keyCode === ESC) {
        this.handleClose(e);
      }
    }
    /**
     * 处理mask点击
     * @param e
     */

  }, {
    key: "handleMaskClose",
    value: function handleMaskClose(e) {
      if (!this.isLongClick) {
        var _this$props2 = this.props,
            closeOnClickMask = _this$props2.closeOnClickMask,
            onCancel = _this$props2.onCancel;
        closeOnClickMask && onCancel && onCancel(e);
      }

      this.isLongClick = false;
    }
    /***
     *主要解决在modal中鼠标按下后移出modal框在松开鼠标的bug
     */

  }, {
    key: "handleMouseDown",
    value: function handleMouseDown() {
      var _this2 = this;

      var time = Date.now();

      var mouseUpHandler = function mouseUpHandler(e) {
        var time2 = Date.now();

        if (time2 - time > 150 && !_this2.el.current.contains(e.target)) {
          _this2.isLongClick = true;
          e.preventDefault();
          e.stopPropagation();
        } else {
          _this2.isLongClick = false;
        }

        document.removeEventListener('mouseup', mouseUpHandler);
      };

      document.addEventListener('mouseup', mouseUpHandler);
    }
    /**
     * 确定按钮的点击
     * @param e
     */

  }, {
    key: "handleOK",
    value: function handleOK(e) {
      var onOk = this.props.onOk;
      onOk && onOk(e);
    }
    /**
     * 处理点击内部事件
     */

  }, {
    key: "handleScroll",
    value:
    /**
     * 处理鼠标滚动
     */
    function handleScroll(e) {
      var lockScroll = this.props.lockScroll;

      if (lockScroll) {
        e.stopPropagation();
      }
    }
    /**渲染modal*/

  }, {
    key: "renderModal",
    value: function renderModal() {
      var _this$props3 = this.props,
          showClose = _this$props3.showClose,
          children = _this$props3.children,
          header = _this$props3.header,
          footer = _this$props3.footer,
          style = _this$props3.style,
          width = _this$props3.width,
          divider = _this$props3.divider,
          title = _this$props3.title,
          mask = _this$props3.mask,
          position = _this$props3.position;
      var border = {
        borderTop: divider && '1px solid #ccc'
      };

      var _style = _objectSpread(_objectSpread({}, style), {}, {
        marginLeft: position.left,
        marginTop: position.top,
        marginRight: position.right
      });

      return /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-dialog', {
          'is-without-mask': !mask
        }),
        style: _objectSpread({
          width: width
        }, _style),
        ref: this.el,
        onMouseDown: this.handleMouseDown,
        onClick: Modal.handleClickInner
      }, ((0, _util.isExist)(header) || (0, _util.isExist)(title)) && /*#__PURE__*/React.createElement("div", {
        className: "rd-dialog__header",
        style: {
          borderBottom: divider && '1px solid #ccc'
        }
      }, header, !(0, _util.isExist)(header) && /*#__PURE__*/React.createElement("div", {
        className: "rd-dialog__header-inner"
      }, !header && /*#__PURE__*/React.createElement("span", {
        className: "rd-dialog_title"
      }, title), !header && showClose && /*#__PURE__*/React.createElement(_Close.default, {
        className: "rd-dialog__header-close",
        onClick: this.handleClose
      }))), (0, _util.isExist)(children) && /*#__PURE__*/React.createElement("div", {
        className: "rd-dialog__content"
      }, children), (0, _util.isExist)(footer) && /*#__PURE__*/React.createElement("div", {
        className: "rd-dialog__footer",
        style: border
      }, footer), !(0, _util.isExist)(footer) && /*#__PURE__*/React.createElement("div", {
        className: "rd-dialog__footer",
        style: border
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-dialog__action"
      }, /*#__PURE__*/React.createElement(_button.default, {
        onClick: this.handleClose
      }, /*#__PURE__*/React.createElement(Formatter, {
        path: "rd.common.cancel"
      })), /*#__PURE__*/React.createElement(_button.default, {
        type: "primary",
        onClick: this.handleOK
      }, /*#__PURE__*/React.createElement(Formatter, {
        path: "rd.common.confirm"
      })))));
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          visible = _this$props4.visible,
          mask = _this$props4.mask,
          className = _this$props4.className,
          getContainer = _this$props4.getContainer,
          transitionName = _this$props4.transitionName,
          ieWithoutTransition = _this$props4.ieWithoutTransition;
      var transitionChildren = visible && /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)(className, 'rd-dialog__rivet'),
        onScroll: this.handleScroll
      }, mask ? /*#__PURE__*/React.createElement("div", {
        className: "rd-dialog__mask",
        onClick: this.handleMaskClose
      }, this.renderModal()) : this.renderModal());
      var transition = _util.isIE && ieWithoutTransition ? transitionChildren : /*#__PURE__*/React.createElement(_transition.default, {
        name: transitionName,
        appear: true
      }, transitionChildren);
      return /*#__PURE__*/React.createElement(_Portal.default, {
        getContainer: getContainer
      }, transition);
    }
  }], [{
    key: "handleClickInner",
    value: function handleClickInner(e) {
      e.stopPropagation();
    }
  }]);
  return Modal;
}(React.PureComponent), _class2.defaultProps = {
  visible: false,
  showClose: true,
  closeOnClickMask: true,
  closeOnPressEscape: true,
  lockScroll: true,
  ieWithoutTransition: true,
  divider: true,
  width: '40%',
  mask: true,
  position: {},
  transitionName: 'fade-in-linear'
}, _class2)) || _class;

exports.default = Modal;