"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _util = require("../../libs/utils/util");

var _reactDom = require("react-dom");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _event = _interopRequireDefault(require("../../libs/event"));

var _handler = _interopRequireDefault(require("../handler"));

var _ref2 = require("../../libs/ref");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var EVENT_ATTR = ['currentTarget', 'eventPhase', 'bubbles', 'cancelable', 'defaultPrevented', 'isTrusted', 'preventDefault', 'timeStamp', 'type', 'nativeEvent', 'target', 'altKey', 'button', 'buttons', 'clientX', 'clientY', 'ctrlKey', 'getModifierState', 'metaKey', 'movementX', 'movementY', 'pageX', 'pageY', 'relatedTarget', 'screenX', 'screenY', 'shiftKey', 'detail', 'view'];
var target = new _event.default();
/**
 * document 事件处理函数
 */

function documentClickHandler(e) {
  target.dispatchEvent('click', e);
}

if (!window.__observerDocument__) {
  /**确保只监听一次**/

  /**由于react的合成事件也是监听的document 这里想要让documentClickHandler 必须先于react的合成事件之前就必须先于构造函数之前执行**/

  /**使用捕获的话一般来说不会被 用户写的e.stopPropagation(); 所打断干扰 造成点击页面后没有效果 **/
  (0, _util.addEvent)(document, 'click', documentClickHandler, true);
  /**确保只监听一次**/

  window.__observerDocument__ = true;
}

var OutSideContext = /*#__PURE__*/React.createContext(undefined);
OutSideContext.displayName = 'OutSideContext';
/**
 * 用于判断点击的地点是否在children中
 */

var OutSide = (_dec = (0, _ref2.forwardRef)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(OutSide, _React$Component);

  var _super = _createSuper(OutSide);

  /**是否点击了children**/

  /**只执行一次的onOutSideClick**/

  /**
   *
   * @param props
   */
  function OutSide(props) {
    var _this;

    (0, _classCallCheck2.default)(this, OutSide);
    _this = _super.call(this, props);
    _this.state = {};
    _this.el = void 0;
    _this.triggerInner = void 0;
    _this.onceClick = void 0;
    _this.isPropagationStopped = false;
    _this.el = (0, _util.combineRef)(props);
    return _this;
  }
  /***
   * 组件加载后
   */


  (0, _createClass2.default)(OutSide, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          onOutSideClick = _this$props.onOutSideClick,
          onClick = _this$props.onClick;

      if (onOutSideClick || onClick) {
        this.generateOnce();
        target.addEventListener('click', this.handleCallback);
      }
    }
    /**
     * 生成一次执行函数
     */

  }, {
    key: "generateOnce",
    value: function generateOnce() {
      var _this$props2 = this.props,
          onOutSideClick = _this$props2.onOutSideClick,
          once = _this$props2.once;
      /**是否只能点击一次**/

      if (once) {
        this.onceClick = (0, _util.once)(onOutSideClick);
      }
    }
    /**
     * 组件将要卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      target.removeEventListener('click', this.handleCallback);
    }
    /**
     * 处理鼠标进入
     * @param e
     */

  }, {
    key: "handleMouseEnter",
    value: function handleMouseEnter(e) {
      /**事件确保这里只需要在目标元素执行**/
      if ((0, _reactDom.findDOMNode)(this.el.current).contains(e.target)) {
        this.triggerInner = true;
        var onMouseEnter = this.props.onMouseEnter;
        onMouseEnter && onMouseEnter(e);
      }
    }
    /**
     * 处理鼠标进入
     * @param e
     */

  }, {
    key: "handleMouseLeave",
    value: function handleMouseLeave(e) {
      /**事件确保这里只需要在目标元素执行**/
      if ((0, _reactDom.findDOMNode)(this.el.current).contains(e.target)) {
        var onMouseLeave = this.props.onMouseLeave;
        onMouseLeave && onMouseLeave(e);
      }
    }
    /**
     * 生成event
     * @param e
     */

  }, {
    key: "generateEvent",
    value: function generateEvent(e) {
      var _ref = this.context || {},
          _stopPropagation = _ref.stopPropagation;

      var _isPropagationStopped = false;
      var event = {
        stopPropagation: function stopPropagation() {
          if (e.stopPropagation) {
            e.stopPropagation();
          }

          _stopPropagation && _stopPropagation();
          _isPropagationStopped = true;
        },
        isPropagationStopped: function isPropagationStopped() {
          return _isPropagationStopped;
        }
      };
      EVENT_ATTR.forEach(function (attr) {
        Object.defineProperty(event, attr, {
          get: function get() {
            /**对这个target属性做特殊处理**/
            if (attr === 'target') {
              return e.target || e.srcElement;
            }

            return e[attr];
          }
        });
      });
      return event;
    }
    /**
     * 处理组价的事件
     */

  }, {
    key: "handleCallback",
    value: function handleCallback(e) {
      var _this$props3 = this.props,
          triggerTiming = _this$props3.triggerTiming,
          onOutSideClick = _this$props3.onOutSideClick;
      var current = (0, _reactDom.findDOMNode)(this.el.current);
      /**ie中不存在e.target 只有e.srcElement**/

      if (!current.contains(e.target || e.srcElement)) {
        if (triggerTiming === 'outside' || triggerTiming === 'inner' && this.triggerInner) {
          var callback;
          /**是否只执行一次**/

          if (this.props.once) {
            /**取出this.onceClick等函数**/
            callback = this.onceClick;
            /**执行this.onceClick等函数**/

            callback && callback(e);
            /**表示当前是没有点击children**/

            this.triggerInner = false;
          } else {
            /**如果不是执行一次那么就使用传下来的callback**/
            !this.isPropagationStopped && onOutSideClick && onOutSideClick(this.generateEvent(e));
          }
        }
      }
    }
    /**
     *处理内部点击
     * @param e
     */

  }, {
    key: "handleInnerClick",
    value: function handleInnerClick(e) {
      this.triggerInner = true;
      this.generateOnce();
      var onClick = this.props.onClick;
      onClick && onClick(e);
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var children = this.props.children;
      var _this$props4 = this.props,
          onFocus = _this$props4.onFocus,
          onBlur = _this$props4.onBlur;

      if ((0, _typeof2.default)(children) !== 'object') {
        children = /*#__PURE__*/React.createElement("span", null, children);
        (0, _warning.default)(false, 'OutSide', '传入的children不是JSX.Element类型的值');
      }

      var childProps = _objectSpread({}, children.props);

      return /*#__PURE__*/React.createElement(OutSideContext.Provider, {
        value: {
          stopPropagation: function stopPropagation() {
            _this2.isPropagationStopped = true;
          }
        }
      }, /*#__PURE__*/React.createElement(_handler.default, {
        ref: this.el,
        onClick: this.handleInnerClick,
        onFocus: onFocus,
        onBlur: onBlur,
        onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave
      }, /*#__PURE__*/React.cloneElement(children, childProps)));
    }
  }]);
  return OutSide;
}(React.Component), _class2.contextType = OutSideContext, _class2.defaultProps = {
  triggerTiming: 'inner',
  once: true
}, _class2)) || _class) || _class);
exports.default = OutSide;