import * as React from 'react';
interface PagerState {
    internalCurrentPage?: number;
    internalPageSize?: number;
    quickPrevIcon?: React.ReactElement;
    quickNextIcon?: React.ReactElement;
    showPrevMore?: boolean;
    showNextMore?: boolean;
    currentPage?: number;
    pageCount?: number;
    pagers?: Array<number>;
}
interface PagerProps {
    middlePageNum?: number;
    currentPage: number;
    pageCount: number;
    onChange?: (pageSie: number) => void;
}
export default class Pager extends React.Component<PagerProps, PagerState> {
    /**
     * 构造函数
     * @param props
     */
    constructor(props: PagerProps);
    /**
     * 点击li执行的回调
     * @param e
     */
    handlePagerClick(e: React.MouseEvent<HTMLElement>): void;
    /**
      *
      * @param nextProps
      * @param prevState
      */
    static getDerivedStateFromProps(nextProps: PagerProps, prevState: PagerState): PagerState;
    /**
     * 获取页码数组[1,2,3,4,5...]
     */
    static getPages(nextProps: PagerProps, prevState: PagerState): PagerState;
    /**
     * render
     */
    render(): React.ReactNode;
}
export {};
