"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Pager = _interopRequireDefault(require("./Pager"));

var _select = _interopRequireDefault(require("../select"));

var _Input = _interopRequireDefault(require("../input/Input"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Left = _interopRequireDefault(require("net-design-icons/lib/icons/Left"));

var _Right = _interopRequireDefault(require("net-design-icons/lib/icons/Right"));

var _locale = _interopRequireDefault(require("../locale"));

var _button = _interopRequireDefault(require("../button"));

var _class, _class3, _class4;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Formatter = _locale.default.Formatter;

/**
 * 上一页
 * @param props
 */
var Pre = function Pre(props) {
  var background = props.background,
      small = props.small;
  var disabled = props.internalCurrentPage <= 1 ? 'disabled' : '';
  return /*#__PURE__*/React.createElement(_button.default, {
    size: small ? 'small' : 'medium',
    className: "page-btn btn-prev ".concat(disabled),
    text: !background,
    disabled: !!disabled,
    onClick: props.prev
  }, props.preCustom || /*#__PURE__*/React.createElement(_Left.default, {
    className: "rd-pagination__icon"
  }));
};
/**
 * 下一页
 * @param props
 */


var Next = function Next(props) {
  var background = props.background,
      small = props.small;
  var disabled = props.internalCurrentPage === props.internalPageCount || props.internalPageCount === 0 ? 'disabled' : '';
  return /*#__PURE__*/React.createElement(_button.default, {
    size: small ? 'small' : 'medium',
    className: "page-btn btn-next ".concat(disabled),
    text: !background,
    disabled: !!disabled,
    onClick: props.next
  }, props.nextCustom || /*#__PURE__*/React.createElement(_Right.default, {
    className: "rd-pagination__icon"
  }));
};
/**
 * xxx条/页   组件
 */


var Sizes = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Sizes, _React$Component);

  var _super = _createSuper(Sizes);

  function Sizes() {
    var _this;

    (0, _classCallCheck2.default)(this, Sizes);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(Sizes, [{
    key: "render",
    value: // }

    /**
     * render
     */
    function render() {
      var _this$props = this.props,
          onSizeChange = _this$props.onSizeChange,
          selectProps = _this$props.selectProps,
          internalPageSize = _this$props.internalPageSize,
          pageSizes = _this$props.pageSizes,
          small = _this$props.small;
      return /*#__PURE__*/React.createElement("span", {
        className: "rd-pagination__sizes"
      }, /*#__PURE__*/React.createElement(_select.default, (0, _extends2.default)({
        fitSize: true,
        size: small ? 'small' : 'medium'
      }, selectProps, {
        value: internalPageSize,
        onChange: onSizeChange
      }), pageSizes.map(function (item, idx) {
        var number = typeof item === 'number' ? item : item.num;
        return /*#__PURE__*/React.createElement(_select.default.Option, {
          key: idx,
          value: number,
          label: _locale.default.t('rd.pagination.pagesize', {
            num: number
          })
        });
      })));
    }
  }]);
  return Sizes;
}(React.Component);
/**
 * 总条数组件
 * @param props
 */


var Total = function Total(props) {
  return typeof props.total === 'number' ? /*#__PURE__*/React.createElement("span", {
    className: "rd-pagination__total"
  }, _locale.default.t('rd.pagination.total', {
    total: props.total
  })) : /*#__PURE__*/React.createElement("span", null);
};
/**
 * 前往xx页  页码跳转
 */


var Jumper = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2.default)(Jumper, _React$Component2);

  var _super2 = _createSuper(Jumper);

  /**
   *
   * @param props
   */
  function Jumper(props) {
    var _this2;

    (0, _classCallCheck2.default)(this, Jumper);
    _this2 = _super2.call(this, props);
    _this2.state = {};
    _this2.state = {
      currentPage: props.internalCurrentPage
    };
    return _this2;
  }
  /**
   * 更新
   */


  (0, _createClass2.default)(Jumper, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var internalCurrentPage = this.props.internalCurrentPage;

      if (prevProps.internalCurrentPage !== internalCurrentPage) {
        this.setState({
          currentPage: internalCurrentPage
        });
      }
    }
    /**
     *跳页 
     */

  }, {
    key: "handleJumper",
    value: function handleJumper(tag) {
      if (tag === 'blur') {
        return;
      }

      var currentPage = this.state.currentPage;

      if (currentPage) {
        var _this$props2 = this.props,
            frontPage = _this$props2.frontPage,
            clearJumper = _this$props2.clearJumper,
            onCurrentChange = _this$props2.onCurrentChange;

        if (!frontPage) {
          onCurrentChange(currentPage);
          this.setState({
            currentPage: clearJumper ? '' : currentPage
          });
          return;
        }

        var _this$props3 = this.props,
            jumper = _this$props3.jumper,
            internalPageCount = _this$props3.internalPageCount;
        var validPage = Pagination.validateCurrent(currentPage, internalPageCount);
        this.setState({
          currentPage: clearJumper ? '' : validPage
        });
        jumper && jumper(validPage);
      }
    }
    /**
     * 失去焦点校验合法性
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e, tag) {
      var _this3 = this;

      var value = e.target.value;
      tag = tag || 'blur';
      var currentPage = this.state.currentPage;

      if (!/^[1-9]\d*$/.test(value)) {
        currentPage = this.props.internalCurrentPage;
      }

      this.setState({
        currentPage: currentPage
      }, function () {
        if (tag === 'blur') {
          _this3.handleJumper();
        }
      });
    }
    /**
     *
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(e) {
      var value = e.target.value;
      this.setState({
        currentPage: value
      });
    }
    /**
     *
     */

  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props4 = this.props,
          internalPageCount = _this$props4.internalPageCount,
          jumpMini = _this$props4.jumpMini,
          small = _this$props4.small,
          jumpRender = _this$props4.jumpRender;
      var currentPage = this.state.currentPage;
      var defaultInput = /*#__PURE__*/React.createElement(_Input.default, {
        key: "input",
        style: {
          width: '48px'
        }
      });

      var renderInput = function renderInput(input, tag) {
        input = input || defaultInput;
        tag = tag || 'blur';
        return /*#__PURE__*/React.cloneElement(input, _objectSpread({
          size: small ? 'small' : 'medium',
          value: currentPage,
          onBlur: function onBlur(e) {
            return _this4.handleBlur(e, tag);
          },
          onKeyUp: function onKeyUp(event) {
            if (tag === 'blur' && event.keyCode === 13) {
              _this4.handleJumper('blur');

              event.target.blur();
            }
          },
          onChange: _this4.handleChange
        }, input.props));
      };

      if (jumpMini) {
        return /*#__PURE__*/React.createElement("span", {
          className: "rd-pagination__jump jump-mini"
        }, defaultInput, /*#__PURE__*/React.createElement("span", null, " / "), /*#__PURE__*/React.createElement("span", null, internalPageCount));
      } else {
        return /*#__PURE__*/React.createElement("span", {
          className: "rd-pagination__jump"
        }, jumpRender(renderInput, _objectSpread(_objectSpread(_objectSpread({}, this.props), this.state), {}, {
          onJump: this.handleJumper
        })));
      }
    }
  }]);
  return Jumper;
}(React.Component)) || _class;

var Pagination = (0, _autoBind.default)(_class3 = (_class4 = /*#__PURE__*/function (_React$Component3) {
  (0, _inherits2.default)(Pagination, _React$Component3);

  var _super3 = _createSuper(Pagination);

  /**
       * 构造
       */
  function Pagination(props) {
    var _this5;

    (0, _classCallCheck2.default)(this, Pagination);
    _this5 = _super3.call(this, props);
    _this5.state = {};
    var total = props.total;
    _this5.state = {
      total: total,
      internalCurrentPage: 1
    };
    return _this5;
  }
  /**
       *
       */


  (0, _createClass2.default)(Pagination, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props5 = this.props,
          pageSize = _this$props5.pageSize,
          layout = _this$props5.layout;
      var pageSizes = this.state.pageSizes;
      var internalPageSize = 0; // 设置每页显示条数

      if (layout.split(',').indexOf('sizes') > -1 && Array.isArray(pageSizes)) {
        internalPageSize = pageSizes.indexOf(pageSize) > -1 ? pageSize : pageSizes[0];
      } else {
        internalPageSize = pageSize;
      }

      this.setState({
        internalPageSize: internalPageSize
      });
    }
    /**
         * 更新当前页面条数,总条数,总页数
         * @param prevProps
         * @param prevState
         */

  }, {
    key: "pre",
    value:
    /**
         * 上一页切换
         */
    function pre() {
      var internalCurrentPage = this.state.internalCurrentPage;
      var newVal = internalCurrentPage - 1;
      this.onCurrentChange(internalCurrentPage, newVal);
    }
    /**
         * 下一页切换
         */

  }, {
    key: "next",
    value: function next() {
      var internalCurrentPage = this.state.internalCurrentPage;
      var newVal = internalCurrentPage + 1;
      this.onCurrentChange(internalCurrentPage, newVal);
    }
    /**
         * 执行改变改变之后的回调
         * @param oldPage
         * @param newPage
         */

  }, {
    key: "onCurrentChange",
    value: function onCurrentChange(oldPage, newPage) {
      if (newPage !== oldPage) {
        var onCurrentChange = this.props.onCurrentChange;
        var validPage = Pagination.getValidCurrentPage(newPage, this.props, this.state);
        onCurrentChange && onCurrentChange(validPage);
        this.setState({
          internalCurrentPage: newPage
        });
      }
    }
    /**
         * 获取合法的页码
         * @param value
         */

  }, {
    key: "jumperToPage",
    value:
    /**
         * 跳到某页
         * @param page
         */
    function jumperToPage(page) {
      var internalCurrentPage = this.state.internalCurrentPage;
      this.onCurrentChange(internalCurrentPage, page);
    }
    /**
         * 页码改变
         * @param val
         */

  }, {
    key: "handleCurrentChange",
    value: function handleCurrentChange(val) {
      var internalCurrentPage = this.state.internalCurrentPage;
      this.onCurrentChange(internalCurrentPage, val);
    }
    /**
         * 选项改变 函数 [10,20,30,50,100...]
         * @param val
         */

  }, {
    key: "handleSizeChange",
    value: function handleSizeChange(val) {
      var internalPageSize = this.state.internalPageSize;

      if (val !== internalPageSize) {
        val = parseInt(val.toString(), 10);
        var _this$props6 = this.props,
            frontPage = _this$props6.frontPage,
            onSizeChange = _this$props6.onSizeChange;

        if (frontPage) {
          this.setState({
            internalPageSize: val
          });
        }

        onSizeChange && onSizeChange(val);
      }
    }
    /**
         *
         */

  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          internalCurrentPage = _this$state.internalCurrentPage,
          internalPageSize = _this$state.internalPageSize,
          total = _this$state.total;
      var _this$props7 = this.props,
          style = _this$props7.style,
          jumpMini = _this$props7.jumpMini,
          small = _this$props7.small,
          pageSizes = _this$props7.pageSizes,
          background = _this$props7.background,
          middlePageNum = _this$props7.middlePageNum,
          className = _this$props7.className,
          preCustom = _this$props7.preCustom,
          nextCustom = _this$props7.nextCustom,
          selectProps = _this$props7.selectProps,
          jumpRender = _this$props7.jumpRender;
      var children = [];
      var layout = this.props.layout || '';

      if (!layout) {
        return null;
      }

      var components = layout.split(',').map(function (item) {
        return item.trim();
      });
      var internalPageCount = Pagination.internalPageCount(this.props, this.state) || 1;
      var template = {
        prev: /*#__PURE__*/React.createElement(Pre, {
          key: "pre",
          preCustom: preCustom,
          internalCurrentPage: internalCurrentPage,
          prev: this.pre,
          background: background,
          small: small
        }),
        jumper: /*#__PURE__*/React.createElement(Jumper, (0, _extends2.default)({}, this.props, {
          key: "jumper",
          small: small,
          jumpMini: jumpMini,
          jumper: this.jumperToPage,
          jumpRender: jumpRender,
          internalPageCount: internalPageCount,
          internalCurrentPage: internalCurrentPage
        })),
        pager: /*#__PURE__*/React.createElement(_Pager.default, {
          key: "pager",
          middlePageNum: middlePageNum,
          currentPage: internalCurrentPage,
          pageCount: internalPageCount,
          onChange: this.handleCurrentChange
        }),
        next: /*#__PURE__*/React.createElement(Next, {
          key: "next",
          nextCustom: nextCustom,
          internalCurrentPage: internalCurrentPage,
          internalPageCount: internalPageCount,
          next: this.next,
          background: background,
          small: small
        }),
        sizes: /*#__PURE__*/React.createElement(Sizes, {
          key: "sizes",
          internalPageSize: internalPageSize,
          small: small,
          pageSizes: pageSizes,
          selectProps: selectProps,
          onSizeChange: this.handleSizeChange
        }),
        total: /*#__PURE__*/React.createElement(Total, {
          key: "total",
          total: total
        })
      };
      children = components.map(function (compo) {
        return template[compo];
      });
      return /*#__PURE__*/React.createElement("div", {
        style: _objectSpread({}, style),
        className: (0, _classnames.default)(className, {
          'rd-pagination': true,
          'rd-pagination__rightwrapper': false,
          'rd-pagination--small': small,
          'is-background': background
        })
      }, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var currentPage = nextProps.currentPage,
          pageSize = nextProps.pageSize,
          total = nextProps.total,
          layout = nextProps.layout;
      var internalPageSize = prevState.internalPageSize;
      /**页码选项 */

      var newPageSizes = nextProps.pageSizes.map(function (item) {
        if (typeof item === 'number') {
          return item;
        } else {
          return item.num;
        }
      });
      /**总页码 */

      var hasSizesLayout = layout.split(',').map(function (item) {
        return item.trim();
      }).indexOf('sizes') > -1;
      var newPageSize = pageSize;

      if (prevState._prevProps && prevState._prevProps.pageSize === nextProps.pageSize) {
        newPageSize = internalPageSize;
      }

      if (hasSizesLayout && Array.isArray(newPageSizes)) {
        internalPageSize = newPageSizes.indexOf(pageSize) > -1 ? newPageSize : newPageSizes[0];
      }
      /**当前页码 */


      var newCurrentPage = currentPage;

      if (prevState._prevProps && prevState._prevProps.currentPage === nextProps.currentPage) {
        newCurrentPage = prevState.internalCurrentPage;
      }

      return {
        _prevProps: nextProps,
        pageSizes: newPageSizes,
        internalPageSize: internalPageSize,
        internalPageCount: Pagination.internalPageCount(nextProps, prevState),
        total: total,
        internalCurrentPage: newCurrentPage ? Pagination.getValidCurrentPage(newCurrentPage, nextProps, prevState) : 1
      };
    }
  }, {
    key: "getValidCurrentPage",
    value: function getValidCurrentPage(value, props, state) {
      value = parseInt(value.toString(), 10); // 获取总页数

      var internalPageCount = Pagination.internalPageCount(props, state);
      return Pagination.validateCurrent(value, internalPageCount);
    }
    /**验证页码合法性 */

  }, {
    key: "validateCurrent",
    value: function validateCurrent(value, internalPageCount) {
      var resetValue; // 如果没有总页数，重置为1

      if (!internalPageCount) {
        if (isNaN(value) || value < 1) {
          resetValue = 1;
        }
      } else {
        if (value < 1) {
          resetValue = 1;
        } else if (value > internalPageCount) {
          resetValue = internalPageCount;
        }
      }

      if (resetValue === undefined && isNaN(value)) {
        resetValue = 1;
      } else if (resetValue === 0) {
        resetValue = 1;
      }

      return resetValue === undefined ? value : resetValue;
    }
    /**
         * 计算总页数
         */

  }, {
    key: "internalPageCount",
    value: function internalPageCount(props, state) {
      var count;

      if (state) {
        var total = state.total,
            internalPageSize = state.internalPageSize;

        if (typeof total === 'number') {
          count = Math.ceil(total / internalPageSize);
        }
      } else {
        var _total = props.total,
            pageSize = props.pageSize;
        count = Math.ceil(_total / pageSize);
      }

      return count;
    }
  }]);
  return Pagination;
}(React.Component), _class4.defaultProps = {
  jumpRender: function jumpRender(renderInput) {
    return /*#__PURE__*/React.createElement(Formatter, {
      path: 'rd.pagination.goto',
      options: {
        input: renderInput()
      }
    });
  },
  small: false,
  pageSize: 10,
  currentPage: 1,
  frontPage: true,
  //默认前端分页
  clearJumper: true,
  layout: 'prev, pager, next, jumper',
  //默认排序
  // pageSizes: [10, 20, 30, 40, 50, 100],
  pageSizes: [{
    num: 10,
    path: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.pagination.pagesize",
      options: {
        num: 10
      }
    })
  }, {
    num: 20,
    path: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.pagination.pagesize",
      options: {
        num: 20
      }
    })
  }],
  middlePageNum: 5 //默认跨度为5

}, _class4)) || _class3;

exports.default = Pagination;