import * as React from 'react';
import Popover from '../popover';
import { PlacementType, PopoverProps } from '../popover/Popover';
import { ButtonType } from '../button/Button';
import { GetContainer } from "../portal/Portal";
interface ConfirmCancel {
    necessary?: boolean;
    text?: React.ReactNode;
    type?: ButtonType;
}
export interface PopConfirmProps extends PopoverProps {
    children?: React.ReactElement;
    className?: string;
    style?: React.CSSProperties;
    visibleArrow?: boolean;
    offset?: [number, number];
    placement?: PlacementType;
    disabled?: boolean;
    overlay?: string;
    title?: string;
    hideIcon?: boolean;
    IconColor?: string;
    confirm?: ConfirmCancel;
    cancel?: ConfirmCancel;
    onConfirm?: () => void;
    onCancel?: () => void;
    allowedAutoPlacements: Array<PlacementType>;
    getContainer?: GetContainer;
}
export default class PopConfirm extends React.Component<PopConfirmProps> {
    static defaultProps: {
        hideIcon: boolean;
        title: JSX.Element;
        confirm: {
            necessary: boolean;
            text: JSX.Element;
            type: string;
        };
        cancel: {
            necessary: boolean;
            text: JSX.Element;
            type: string;
        };
    };
    state: {};
    protected popover: Popover;
    /**
     * 点击确定
     */
    handleConfirm(): void;
    /**
     * 点击取消
     */
    handleCancel(): void;
    /**
     * 给confirm和cancel设置默认值
     */
    getDefaultConfirmAndCancel(): {
        confirm: ConfirmCancel;
        cancel: ConfirmCancel;
    };
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
