"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _popover = _interopRequireDefault(require("../popover"));

var _Button = _interopRequireDefault(require("../button/Button"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _locale = _interopRequireDefault(require("../locale"));

var _ReminderPlane = _interopRequireDefault(require("net-design-icons/lib/icons/ReminderPlane"));

var _excluded = ["children", "overlay", "className", "hideIcon", "IconColor", "title", "allowedAutoPlacements"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Formatter = _locale.default.Formatter;

var PopConfirm = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(PopConfirm, _React$Component);

  var _super = _createSuper(PopConfirm);

  function PopConfirm() {
    var _this;

    (0, _classCallCheck2.default)(this, PopConfirm);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    _this.popover = void 0;
    return _this;
  }

  (0, _createClass2.default)(PopConfirm, [{
    key: "handleConfirm",
    value:
    /**
     * 点击确定
     */
    function handleConfirm() {
      var onConfirm = this.props.onConfirm;
      this.popover.emitClose();
      onConfirm && onConfirm();
    }
    /**
     * 点击取消
     */

  }, {
    key: "handleCancel",
    value: function handleCancel() {
      var onCancel = this.props.onCancel;
      this.popover.emitClose();
      onCancel && onCancel();
    }
    /**
     * 给confirm和cancel设置默认值
     */

  }, {
    key: "getDefaultConfirmAndCancel",
    value: function getDefaultConfirmAndCancel() {
      var _this$props = this.props,
          confirm = _this$props.confirm,
          cancel = _this$props.cancel;

      if (confirm.text === undefined) {
        confirm.text = PopConfirm.defaultProps.confirm.text;
      }

      if (confirm.type === undefined) {
        confirm.type = 'primary';
      }

      if (cancel.text === undefined) {
        cancel.text = PopConfirm.defaultProps.cancel.text;
      }

      return {
        confirm: confirm,
        cancel: cancel
      };
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          children = _this$props2.children,
          overlay = _this$props2.overlay,
          className = _this$props2.className,
          hideIcon = _this$props2.hideIcon,
          IconColor = _this$props2.IconColor,
          title = _this$props2.title,
          allowedAutoPlacements = _this$props2.allowedAutoPlacements,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);
      var classes = (0, _classnames.default)('rd-popconfirm', className);
      var otherProps = (0, _omit.default)(rest, ['confirm', 'cancel']);

      var _this$getDefaultConfi = this.getDefaultConfirmAndCancel(),
          confirm = _this$getDefaultConfi.confirm,
          cancel = _this$getDefaultConfi.cancel;

      var renderOverlay = overlay ? overlay : /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
        className: "rd-popconfirm__main"
      }, !hideIcon && /*#__PURE__*/React.createElement(_ReminderPlane.default, {
        className: "rd-popconfirm__icon",
        color: IconColor
      }), /*#__PURE__*/React.createElement("p", {
        className: "rd-popconfirm__title"
      }, title)), /*#__PURE__*/React.createElement("div", {
        className: "rd-popconfirm__action"
      }, cancel.necessary && /*#__PURE__*/React.createElement(_Button.default, {
        size: "small",
        onClick: this.handleCancel,
        type: cancel.type
      }, cancel.text), confirm.necessary && /*#__PURE__*/React.createElement(_Button.default, {
        className: "margin-left-24",
        size: "small",
        onClick: this.handleConfirm,
        type: confirm.type
      }, confirm.text)));
      return /*#__PURE__*/React.createElement(_popover.default, (0, _extends2.default)({
        ref: function ref(_ref) {
          return _this2.popover = _ref;
        },
        modifiers: allowedAutoPlacements && [{
          name: 'flip',
          options: {
            allowedAutoPlacements: allowedAutoPlacements
          }
        }],
        overlay: renderOverlay,
        className: classes,
        trigger: "click",
        enterAble: true,
        needWrapper: true
      }, otherProps), /*#__PURE__*/React.cloneElement(children, {}));
    }
  }]);
  return PopConfirm;
}(React.Component), _class2.defaultProps = {
  hideIcon: true,
  //是否隐藏icon
  title: /*#__PURE__*/React.createElement(Formatter, {
    path: "rd.common.confirmTitle"
  }),
  confirm: {
    necessary: true,
    text: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.common.confirm"
    }),
    type: 'primary'
  },
  cancel: {
    necessary: true,
    text: /*#__PURE__*/React.createElement(Formatter, {
      path: "rd.common.cancel"
    }),
    type: 'default'
  }
}, _class2)) || _class;

exports.default = PopConfirm;