"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _reactPopper = require("react-popper");

var _reactDom = require("react-dom");

var _resizeObserverPolyfill = _interopRequireDefault(require("resize-observer-polyfill"));

var _util = require("../../libs/utils/util");

var _types = require("../../libs/types");

var _classnames = _interopRequireDefault(require("classnames"));

var _outside = _interopRequireDefault(require("../outside"));

var _Portal = _interopRequireDefault(require("../portal/Portal"));

var _raf = _interopRequireDefault(require("raf"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TriggerTypes = (0, _types.tuple)('hover', 'click', 'focus');
var PlacementTypes = (0, _types.tuple)('top', 'top-start', 'top-end', 'bottom', 'bottom-start', 'bottom-end', 'left', 'left-start', 'left-end', 'right', 'right-start', 'right-end');

var Popover = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Popover, _React$PureComponent);

  var _super = _createSuper(Popover);

  function Popover() {
    var _this;

    (0, _classCallCheck2.default)(this, Popover);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.el = void 0;
    _this.parentMountNode = void 0;
    _this.popper = void 0;
    _this.state = {
      parent: document.body,
      visible: false,
      popperWidth: undefined
    };
    _this._isMounted = false;
    _this.popperForceUpdate = void 0;
    _this.resizeObserver = void 0;
    _this.parentResizeObserver = void 0;
    _this._isFocused = void 0;
    return _this;
  }

  (0, _createClass2.default)(Popover, [{
    key: "componentDidMount",
    value:
    /**
     * 本组件第一次挂载
     */
    function componentDidMount() {
      this._isMounted = true;
      var disabled = this.props.disabled;

      if (disabled) {
        return;
      }

      this.setPopperWidth();
      this.obServerDom();
      this.setState({
        parent: this.getScrollParent(this.el.parentNode)
      });
    }
    /**
     *处理最终渲染挂载的dom节点
     */

  }, {
    key: "handleFinallyRender",
    value: function handleFinallyRender(parentNode) {
      var _this2 = this;

      this.parentMountNode = parentNode;
      this.parentResizeObserver = new _resizeObserverPolyfill.default(function () {
        _this2.popperForceUpdate && _this2.popperForceUpdate();
      });
      this.parentResizeObserver.observe(parentNode);
    }
    /***
     * 观察dom变化
     * 参考用途 主要功能是TreeSelect 的tag高度变高后 能自动更新popover的位置
     */

  }, {
    key: "obServerDom",
    value: function obServerDom() {
      var _this3 = this;

      this.resizeObserver = new _resizeObserverPolyfill.default(function () {
        _this3.setPopperWidth();

        _this3.popperForceUpdate && _this3.popperForceUpdate();
      });
      this.resizeObserver.observe(this.el);
    }
    /***
     * 设置popper宽度
     */

  }, {
    key: "setPopperWidth",
    value: function setPopperWidth() {
      var popperWidthSameWithChildren = this.props.popperWidthSameWithChildren;

      if (popperWidthSameWithChildren) {
        this.safeSetState({
          popperWidth: this.el.getBoundingClientRect().width
        });
      }
    }
    /**
     * 安全的设置state
     * @param state
     */

  }, {
    key: "safeSetState",
    value: function safeSetState(state) {
      this._isMounted && this.setState(state);
    }
    /**
     * 组件卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
      this.resizeObserver.unobserve(this.el);
      this.parentMountNode && this.resizeObserver.unobserve(this.parentMountNode);
    }
    /**
     * 获取滚动的父类
     */

  }, {
    key: "getScrollParent",
    value: function getScrollParent(node) {
      if (!node) {
        return document.body;
      }

      var parent = node;
      var specScrollParent = this.props.specScrollParent;

      if (specScrollParent) {
        return specScrollParent;
      }

      if (parent === document.body) {
        return parent;
      }

      var style = getComputedStyle(parent);

      if (style.overflowX === 'auto' || style.overflowX === 'scroll') {
        return parent;
      }

      if (style.overflowY === 'auto' || style.overflowY === 'scroll') {
        return parent;
      }

      parent = this.getScrollParent(parent.parentNode);
      return parent;
    }
    /**
     * 更新父级
     * @param nextProps
     * @param prevState
     */

  }, {
    key: "handleFocus",
    value:
    /***
     * 处理focus
     */
    function handleFocus(e) {
      this._isFocused = true;
      var _this$props = this.props,
          trigger = _this$props.trigger,
          focusActiveElements = _this$props.focusActiveElements;

      if (focusActiveElements.includes(e.target.nodeName.toLowerCase())) {
        if (trigger === 'focus') {
          this.handleClick(true);
        }
      }
    }
    /***
     * 处理blur
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      var _this$props2 = this.props,
          trigger = _this$props2.trigger,
          focusActiveElements = _this$props2.focusActiveElements;

      if (this._isFocused) {
        this._isFocused = false;

        if (focusActiveElements.includes(e.target.nodeName.toLowerCase())) {
          if (trigger === 'focus') {
            this.handleClick(false);
          }
        }
      }
    }
    /**
     * 处理触发对象事件
     */

  }, {
    key: "handleMouseEnter",
    value: function handleMouseEnter() {
      var _this4 = this;

      var _this$props3 = this.props,
          onVisibleChange = _this$props3.onVisibleChange,
          hoverLeaveDuration = _this$props3.hoverLeaveDuration,
          trigger = _this$props3.trigger;

      if (trigger === 'hover') {
        /**如果当前不可见那么在延迟时间内改变状态为可见**/
        setTimeout(function () {
          _this4.safeSetState({
            visible: true
          });

          onVisibleChange && onVisibleChange(true);
        }, hoverLeaveDuration);
      }
    }
    /**
     * 处理鼠标离开事件
     */

  }, {
    key: "handlePopperMouseLeave",
    value: function handlePopperMouseLeave(e) {
      var _this5 = this;

      if (this.popper !== (e.target || e.srcElement)) {
        return;
      }

      var _this$props4 = this.props,
          hoverLeaveDuration = _this$props4.hoverLeaveDuration,
          onVisibleChange = _this$props4.onVisibleChange;
      setTimeout(function () {
        _this5.safeSetState({
          visible: false
        });

        onVisibleChange && onVisibleChange(false);
      }, hoverLeaveDuration);
    }
    /**
     * 处理鼠标离开事件
     */

  }, {
    key: "handleMouseLeave",
    value: function handleMouseLeave() {
      var _this6 = this;

      var _this$props5 = this.props,
          trigger = _this$props5.trigger,
          hoverLeaveHidden = _this$props5.hoverLeaveHidden,
          hoverLeaveDuration = _this$props5.hoverLeaveDuration,
          onVisibleChange = _this$props5.onVisibleChange,
          enterAble = _this$props5.enterAble;

      if (trigger === 'hover' && hoverLeaveHidden) {
        var _target;

        var fn = function fn(event) {
          _target = event.target || event.srcElement;
        };

        setTimeout(function () {
          if (_this6.popper) {
            //当前是否点击popper里面
            if (_this6.popper.contains(_target) && enterAble) {
              (0, _util.removeEvent)(document, 'mousemove', fn);
            } else {
              _this6.safeSetState({
                visible: false
              });

              onVisibleChange && onVisibleChange(false);
            }
          } else {
            _this6.safeSetState({
              visible: false
            });
          }
        }, hoverLeaveDuration);
        (0, _util.addEvent)(document, 'mousemove', fn);
      }
    }
    /**
     * 供外部调用
     */

  }, {
    key: "emitClose",
    value: function emitClose() {
      var onVisibleChange = this.props.onVisibleChange;
      this.safeSetState({
        visible: false
      });
      onVisibleChange && onVisibleChange(false);
    }
    /**
     * 得到箭头的边框色
     * @param placement
     */

  }, {
    key: "getBorder",
    value: function getBorder(placement) {
      var borderColor = this.props.borderColor;
      var config = {
        top: {
          borderTopColor: borderColor
        },
        bottom: {
          borderBottomColor: borderColor
        },
        right: {
          borderRightColor: borderColor
        },
        left: {
          borderLeftColor: borderColor
        }
      };
      return config[placement];
    }
    /**
     * 处理鼠标在目标外点击
     * @param e
     */

  }, {
    key: "handleOutsideClick",
    value: function handleOutsideClick(e) {
      var _this$props6 = this.props,
          enterAble = _this$props6.enterAble,
          onVisibleChange = _this$props6.onVisibleChange,
          clickPopperOutSideHidden = _this$props6.clickPopperOutSideHidden;

      if (!clickPopperOutSideHidden) {
        return;
      } //当前是否点击popper里面


      var boo = true;

      if (enterAble) {
        if (!this.popper) {
          boo = true;
        } else {
          boo = !this.popper.contains(e.target);
        }
      }

      if (boo) {
        this.safeSetState({
          visible: false
        });
        onVisibleChange && onVisibleChange(false);
      }
    }
    /**
     * 处理鼠标点击
     */

  }, {
    key: "handleClick",
    value: function handleClick(focus) {
      var clickTriggerRevert = this.props.clickTriggerRevert;
      var visible = this.state.visible;
      var onVisibleChange = this.props.onVisibleChange;
      var bool;
      /**focus blur 等情況*/

      if (focus !== undefined) {
        bool = focus;
      } else {
        bool = clickTriggerRevert ? !visible : true;
      }

      this.safeSetState({
        visible: bool
      });
      onVisibleChange && onVisibleChange(bool);
    }
    /**
     * 弹出框点击
     */

  }, {
    key: "handlePopoverClick",
    value: function handlePopoverClick() {
      var _this$props7 = this.props,
          onVisibleChange = _this$props7.onVisibleChange,
          clickPopperHidden = _this$props7.clickPopperHidden;
      clickPopperHidden && onVisibleChange && onVisibleChange(false);
    }
    /**
     * 合并modifiers
     */

  }, {
    key: "combineModifiers",
    value: function combineModifiers() {
      var _this$props8 = this.props,
          offset = _this$props8.offset,
          flipEnabled = _this$props8.flipEnabled,
          eventListenerScroll = _this$props8.eventListenerScroll,
          modifiers = _this$props8.modifiers;
      var computeStylesModifier = {
        name: 'computeStyles',
        options: {
          gpuAcceleration: false
        }
      };
      var eventListenersModifier = {
        name: 'eventListeners',
        options: {
          scroll: eventListenerScroll
        }
      };
      var offsetModifier = {
        name: 'offset',
        options: {
          offset: offset
        }
      };
      var flipModifier = {
        name: 'flip',
        enabled: flipEnabled,
        options: {
          boundary: this.state.parent
        }
      };
      var _modifiers = [computeStylesModifier, eventListenersModifier, offsetModifier, flipModifier];

      if (modifiers) {
        _modifiers = modifiers;

        if (!modifiers.find(function (item) {
          return item.name === 'computeStyles';
        })) {
          _modifiers.push(computeStylesModifier);
        }

        if (!modifiers.find(function (item) {
          return item.name === 'eventListeners';
        })) {
          _modifiers.push(eventListenersModifier);
        }

        if (!modifiers.find(function (item) {
          return item.name === 'offset';
        })) {
          _modifiers.push(offsetModifier);
        }

        if (!modifiers.find(function (item) {
          return item.name === 'flip';
        })) {
          _modifiers.push(flipModifier);
        }
      }

      return _modifiers;
    }
    /**
     * 给ie10打补丁
     * 在ie10下Popper会闪动一下 初始位置计算不正确
     */

  }, {
    key: "polyfillIE10",
    value: function polyfillIE10(ref) {
      if (ref) {
        if (!ref.firstRender && window.setImmediate) {
          var opacity = ref.style.opacity;
          ref.style.opacity = '0';
          (0, _raf.default)(function () {
            ref.style.opacity = opacity;
          });
        }

        ref.firstRender = true;
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this7 = this;

      var _this$props9 = this.props,
          baseStyle = _this$props9.style,
          borderColor = _this$props9.borderColor,
          disabled = _this$props9.disabled,
          overlay = _this$props9.overlay,
          placement = _this$props9.placement,
          visibleArrow = _this$props9.visibleArrow,
          needWrapper = _this$props9.needWrapper,
          className = _this$props9.className,
          hoverLeaveHidden = _this$props9.hoverLeaveHidden,
          trigger = _this$props9.trigger,
          popperWidthSameWithChildren = _this$props9.popperWidthSameWithChildren,
          arrowPosition = _this$props9.arrowPosition,
          strategy = _this$props9.strategy,
          getContainer = _this$props9.getContainer,
          firstRender = _this$props9.firstRender,
          clickTriggerRevert = _this$props9.clickTriggerRevert;
      var children = this.props.children;
      var _this$state = this.state,
          visible = _this$state.visible,
          popperWidth = _this$state.popperWidth;

      if (disabled) {
        return children;
      }

      var classes = (0, _classnames.default)(className, 'rd-popper');
      var renderOverlay = needWrapper ? /*#__PURE__*/React.createElement("div", {
        className: "rd-popover"
      }, overlay) : overlay;
      var widthOrMinWidth = popperWidthSameWithChildren === true ? 'width' : 'minWidth';
      return /*#__PURE__*/React.createElement(_reactPopper.Manager, null, /*#__PURE__*/React.createElement(_reactPopper.Reference, null, function (_ref) {
        var ref = _ref.ref;

        if ((0, _typeof2.default)(children) !== 'object') {
          children = /*#__PURE__*/React.createElement("span", null, children);
        }

        var refFunction = ref;
        return React.Children.map(React.Children.only(children), function (child) {
          var childProps = _objectSpread({}, child.props);

          return (
            /*#__PURE__*/
            //outside 最好内部child是一个
            React.createElement(_outside.default, {
              onOutSideClick: _this7.handleOutsideClick,
              once: false,
              onClick: function onClick(e) {
                child.props.onClick && child.props.onClick(e); //如果是hover的情况下，内容有点击事件，那么建议是点击的时候可以取消显示的弹窗

                if (trigger === 'click') {
                  _this7.handleClick();
                } else if (trigger === 'hover' && clickTriggerRevert) {
                  // 点击后，需要隐藏提示
                  _this7.handleClick();
                }
              },
              onFocus: _this7.handleFocus,
              onBlur: _this7.handleBlur,
              onMouseEnter: _this7.handleMouseEnter,
              onMouseLeave: _this7.handleMouseLeave,
              ref: function ref(_ref2) {
                _this7.el = (0, _reactDom.findDOMNode)(_ref2);
                refFunction(_this7.el);
              }
            }, /*#__PURE__*/React.cloneElement(child, childProps))
          );
        });
      }), /*#__PURE__*/React.createElement(_reactPopper.Popper, {
        placement: placement,
        modifiers: this.combineModifiers(),
        strategy: strategy
      }, function (_ref3) {
        var _arrowProps$style;

        var ref = _ref3.ref,
            style = _ref3.style,
            placement = _ref3.placement,
            arrowProps = _ref3.arrowProps,
            forceUpdate = _ref3.forceUpdate;
        var refFunction = ref;
        _this7.popperForceUpdate = forceUpdate;

        if (!visible) {
          return '';
        }

        return /*#__PURE__*/React.createElement(_Portal.default, {
          firstRender: firstRender,
          getContainer: getContainer,
          onFinallyRender: _this7.handleFinallyRender
        }, /*#__PURE__*/React.createElement("div", {
          ref: function ref(_ref4) {
            _this7.popper = _ref4;

            _this7.polyfillIE10(_ref4);

            if (hoverLeaveHidden && trigger === 'hover') {
              (0, _util.addEvent)(_this7.popper, 'mouseleave', _this7.handlePopperMouseLeave);
            }

            refFunction(_ref4);
          },
          onClick: _this7.handlePopoverClick,
          className: classes,
          style: borderColor ? _objectSpread(_objectSpread(_objectSpread((0, _defineProperty2.default)({}, widthOrMinWidth, popperWidth), baseStyle), {
            border: borderColor ? "1px solid ".concat(borderColor) : undefined
          }), style) : _objectSpread(_objectSpread((0, _defineProperty2.default)({}, widthOrMinWidth, popperWidth), baseStyle), style),
          "data-placement": placement
        }, renderOverlay, visibleArrow && /*#__PURE__*/React.createElement("div", {
          className: "popover__arrow",
          ref: arrowProps.ref,
          "data-placement": placement,
          style: arrowPosition === undefined ? _objectSpread(_objectSpread({}, _this7.getBorder(placement)), arrowProps.style) : _objectSpread(_objectSpread({}, _this7.getBorder(placement)), _objectSpread({
            position: arrowProps === null || arrowProps === void 0 ? void 0 : (_arrowProps$style = arrowProps.style) === null || _arrowProps$style === void 0 ? void 0 : _arrowProps$style.position
          }, arrowPosition))
        })));
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var visible = nextProps.visible;

      if (prevState._prevProps === nextProps) {
        return _objectSpread(_objectSpread({}, prevState), {}, {
          _prevProps: nextProps
        });
      } else {
        var _visible = visible === undefined ? prevState.visible : visible;

        return {
          _prevProps: nextProps,
          visible: _visible
        };
      }
    }
  }]);
  return Popover;
}(React.PureComponent), _class2.defaultProps = {
  trigger: 'click',
  popperWidthSameWithChildren: 'minWidth',
  flipEnabled: true,
  enterAble: false,
  hoverLeaveHidden: true,
  hoverLeaveDuration: 200,
  hoverEnterDuration: 200,
  visibleArrow: true,
  needWrapper: true,
  disabled: false,
  offset: [0, 10],
  strategy: 'absolute',
  placement: 'bottom',
  clickPopperHidden: false,
  clickPopperOutSideHidden: true,
  getContainer: document.body,
  eventListenerScroll: false,
  focusActiveElements: ['textarea', 'input', 'form', 'select']
}, _class2)) || _class;

exports.default = Popover;