import * as React from 'react';
export declare type GetContainer = string | HTMLElement | ((node?: Node | null) => HTMLElement | Node);
export interface PortalProps {
    getContainer?: GetContainer;
    children: React.ReactNode;
    /**第一帧渲染什么内容**/
    firstRender?: React.ReactNode;
    /**最终渲染的node**/
    onFinallyRender?: (node: Node) => void;
}
declare class Portal extends React.PureComponent<PortalProps> {
    private container;
    private rafId;
    static defaultProps: {
        /**注意次处不能修改为'' 因为''外面有拿不到parenNode**/
        firstRender: string;
    };
    /**
     * 组件挂载后
     */
    componentDidMount(): void;
    /**
     * 组件卸载
     */
    componentWillUnmount(): void;
    /**
     * 渲染子节点
     * **/
    renderChildren(): React.ReactNode;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export default Portal;
