"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _raf = _interopRequireDefault(require("raf"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var getParent = function getParent(getContainer, node) {
  if (getContainer) {
    if (typeof getContainer === 'string') {
      return document.querySelectorAll(getContainer)[0];
    }

    if (typeof getContainer === 'function') {
      return getContainer(node);
    }

    if ((0, _typeof2.default)(getContainer) === 'object' && getContainer instanceof window.HTMLElement) {
      return getContainer;
    }
  }

  return document.body;
};

var Portal = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Portal, _React$PureComponent);

  var _super = _createSuper(Portal);

  function Portal() {
    var _this;

    (0, _classCallCheck2.default)(this, Portal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.container = void 0;
    _this.rafId = void 0;
    return _this;
  }

  (0, _createClass2.default)(Portal, [{
    key: "componentDidMount",
    value:
    /**
     * 组件挂载后
     */
    function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          getContainer = _this$props.getContainer,
          onFinallyRender = _this$props.onFinallyRender;

      var firstRender = _reactDom.default.findDOMNode(this);

      this.rafId = (0, _raf.default)(function () {
        _this2.container = getParent(getContainer, firstRender);
        onFinallyRender && onFinallyRender(_this2.container);

        _this2.forceUpdate();
      });
    }
    /**
     * 组件卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _raf.default.cancel(this.rafId);
    }
    /**
     * 渲染子节点
     * **/

  }, {
    key: "renderChildren",
    value: function renderChildren() {
      var children = this.props.children;
      return typeof children === "function" ? children(this.container) : children;
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var firstRender = this.props.firstRender;
      return this.container ? /*#__PURE__*/_reactDom.default.createPortal(this.renderChildren(), this.container) : firstRender;
    }
  }]);
  return Portal;
}(React.PureComponent);

Portal.defaultProps = {
  /**注意次处不能修改为'' 因为''外面有拿不到parenNode**/
  firstRender: ' '
};
var _default = Portal;
exports.default = _default;