"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _types = require("../../libs/types");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Types = (0, _types.tuple)('line', 'circle');

var Progress = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Progress, _React$Component);

  var _super = _createSuper(Progress);

  function Progress() {
    var _this;

    (0, _classCallCheck2.default)(this, Progress);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(Progress, [{
    key: "relativeStrokeWidth",
    value:
    /** 获取相对宽度，在100的画布下的进度条宽度 */
    function relativeStrokeWidth() {
      // 实际进度条宽度/实际画布宽度 = 进度条宽度/画布宽度100
      // 由于Line的strokeWidth可以由css定义，因此，不在默认props中设置默认值
      var _this$props = this.props,
          _this$props$strokeWid = _this$props.strokeWidth,
          strokeWidth = _this$props$strokeWid === void 0 ? 8 : _this$props$strokeWid,
          _this$props$width = _this$props.width,
          width = _this$props$width === void 0 ? 120 : _this$props$width;
      return (strokeWidth / width * 100).toFixed(1);
    }
    /** 
     * 绘制的是圆形路径
     * 半径是以线条到中心的距离，而线宽（strokeWidth），线条是在线宽的中间位置，所以要/2 */

  }, {
    key: "trackPath",
    value: function trackPath() {
      var relativeStorkeWidth = parseFloat(this.relativeStrokeWidth());
      var radius = parseInt((50 - relativeStorkeWidth / 2).toString(), 10);
      return "M 50 50 m 0 -".concat(radius, " a ").concat(radius, " ").concat(radius, " 0 1 1 0 ").concat(radius * 2, " a ").concat(radius, " ").concat(radius, " 0 1 1 0 -").concat(radius * 2);
    }
    /**计算周长 */

  }, {
    key: "perimeter",
    value: function perimeter() {
      var radius = 50 - parseFloat(this.relativeStrokeWidth()) / 2;
      return 2 * Math.PI * radius;
    }
    /**进度条样式 */

  }, {
    key: "circlePathStyle",
    value: function circlePathStyle() {
      var perimeter = this.perimeter();
      var percent = this.state.percent;
      var color = this.props.color;
      return {
        strokeDasharray: "".concat(perimeter, "px, ").concat(perimeter, "px"),
        strokeDashoffset: "".concat((1 - percent / 100) * perimeter, "px"),
        //偏移占比总周长
        stroke: color
      };
    }
    /**根据内容返回显示的百分比内容或者自定义内容 */

  }, {
    key: "showTextInfo",
    value: function showTextInfo(prefixCls, text) {
      var textType = (0, _typeof2.default)(text);

      if (textType === 'string') {
        return /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "__text"),
          title: text
        }, text);
      } else {
        return /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "__text")
        }, text);
      }
    }
    /**生成线型进度条 */

  }, {
    key: "generateLine",
    value: function generateLine() {
      var _this$props2 = this.props,
          customizePrefixCls = _this$props2.prefixCls,
          textInside = _this$props2.textInside,
          strokeWidth = _this$props2.strokeWidth,
          message = _this$props2.message,
          className = _this$props2.className,
          type = _this$props2.type,
          style = _this$props2.style;
      var _this$state = this.state,
          percent = _this$state.percent,
          color = _this$state.color,
          bgColor = _this$state.bgColor,
          showText = _this$state.showText;
      var prefixCls = (0, _util.getPrefixCls)('progress', customizePrefixCls);
      var progressClassName = (0, _classnames.default)(className, "".concat(prefixCls), "is-".concat(type), {
        'is-show-info': showText,
        'is-text-inside': textInside
      }); //进度条背景颜色

      var progressBgStyle;

      if (bgColor) {
        progressBgStyle = _objectSpread(_objectSpread({}, progressBgStyle), {}, {
          backgroundColor: bgColor
        });
      }

      if (strokeWidth) {
        progressBgStyle = _objectSpread(_objectSpread({}, progressBgStyle), {}, {
          height: strokeWidth
        });
      } //进度条样式


      var progressStyle = {
        width: "".concat(percent, "%")
      };

      if (color) {
        progressStyle = _objectSpread(_objectSpread({}, progressStyle), {}, {
          backgroundColor: color
        });
      }

      var text = message ? message(percent) : "".concat(percent, "%");
      return /*#__PURE__*/React.createElement("div", {
        className: progressClassName,
        style: style
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__outer")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__inner"),
        style: progressBgStyle
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__bg"),
        style: progressStyle
      }, textInside && showText && /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "__innerText")
      }, text)))), !textInside && showText && this.showTextInfo(prefixCls, text));
    }
    /**生成环形进度条 */

  }, {
    key: "generateCircle",
    value: function generateCircle() {
      var _this$props3 = this.props,
          customizePrefixCls = _this$props3.prefixCls,
          message = _this$props3.message,
          className = _this$props3.className,
          type = _this$props3.type,
          style = _this$props3.style;
      var _this$state2 = this.state,
          percent = _this$state2.percent,
          bgColor = _this$state2.bgColor,
          showText = _this$state2.showText;
      var prefixCls = (0, _util.getPrefixCls)('progress', customizePrefixCls);
      var progressClassName = (0, _classnames.default)(className, "".concat(prefixCls), "is-".concat(type), [{
        'is-show-info': showText,
        'is-zero-percent': percent === 0
        /* 兼容IE9 的情况下，仍然有一个小圆点的问题 */

      }]);
      var tailStyle;

      if (bgColor) {
        tailStyle = {
          stroke: bgColor
        };
      }

      var text = message ? message(percent) : "".concat(percent, "%");
      var realStrokeWidth = this.relativeStrokeWidth();
      var circlePath = this.trackPath();
      return /*#__PURE__*/React.createElement("div", {
        className: progressClassName,
        style: style
      }, /*#__PURE__*/React.createElement("svg", {
        className: "".concat(prefixCls, "-circle"),
        viewBox: "0 0 100 100"
      }, /*#__PURE__*/React.createElement("path", {
        className: "".concat(prefixCls, "-circle__tail"),
        d: circlePath,
        fill: "none",
        style: tailStyle,
        strokeWidth: realStrokeWidth
      }), /*#__PURE__*/React.createElement("path", {
        className: "".concat(prefixCls, "-circle__path"),
        d: circlePath,
        fill: "none",
        strokeWidth: realStrokeWidth,
        style: this.circlePathStyle()
      })), showText && this.showTextInfo(prefixCls, text));
    }
    /** */

  }, {
    key: "render",
    value: function render() {
      var type = this.props.type;
      return /*#__PURE__*/React.createElement(React.Fragment, null, type === 'line' ? this.generateLine() : this.generateCircle());
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**
     * 根据上级传下的百分比，颜色，是否显示内容，改变state
     * @param nextProps 
     * @param prevState 
     */
    function getDerivedStateFromProps(nextProps) {
      var percent = nextProps.percent,
          color = nextProps.color,
          bgColor = nextProps.bgColor,
          showText = nextProps.showText;
      var newState = {
        percent: percent,
        color: color,
        bgColor: bgColor,
        showText: showText
      };
      return newState;
    }
  }]);
  return Progress;
}(React.Component), _class2.defaultProps = {
  type: 'line',
  percent: 0,
  textInside: false,
  showText: true
}, _class2)) || _class;

exports.default = Progress;