import * as React from 'react';
import RadioGroup from './RadioGroup';
import RadioButton from './radioButton';
import { RadioProps, CheckboxValueType, RadioState } from './interface';
export default class Radio extends React.Component<RadioProps, RadioState> {
    static Group: typeof RadioGroup;
    static Button: typeof RadioButton;
    static contextType: React.Context<any>;
    static defaultProps: {
        size: string;
    };
    /**
     * 父级的引用
     */
    parent(): RadioGroup;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: RadioProps);
    /**
     * 初始化
     */
    componentDidMount(): void;
    /**
   * 更新
   * @param nextProps
   * @param prevState
   */
    componentDidUpdate(prevProps: RadioProps): void;
    /**
     * 改变
     * @param value
     * @param e
     */
    handleChange(value: CheckboxValueType, e: React.ChangeEvent<HTMLInputElement>): void;
    /**
     * 点击
     * @param e
     */
    handleClick(e: React.MouseEvent<HTMLInputElement, MouseEvent>): void;
    /**
     * 渲染
     */
    render(): React.ReactNode;
}
