"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _RadioContext = _interopRequireDefault(require("./RadioContext"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _excluded = ["disabled", "size", "style", "value", "label", "children", "name", "className"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Radio = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Radio, _React$Component);

  var _super = _createSuper(Radio);

  /**
   * 构造函数
   * @param props
   */
  function Radio(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Radio);
    _this = _super.call(this, props);
    _this.state = {};
    return _this;
  }
  /**
   * 初始化
   */


  (0, _createClass2.default)(Radio, [{
    key: "parent",
    value: // 默认大小为medium

    /**
     * 父级的引用
     */
    function parent() {
      return this.context && this.context.component;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          checked = _this$props.checked,
          value = _this$props.value,
          label = _this$props.label,
          model = _this$props.model;

      if (model !== undefined) {
        this.setState({
          checked: model === (value !== undefined ? value : label)
        });
      } else {
        this.setState({
          checked: checked
        });
      }
    }
    /**
    * 更新
    * @param nextProps
    * @param prevState
    */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props2 = this.props,
          checked = _this$props2.checked,
          value = _this$props2.value,
          label = _this$props2.label,
          model = _this$props2.model;

      if (prevProps.checked !== checked) {
        this.setState({
          checked: checked
        });
      } else if (this.props.model !== prevProps.model) {
        this.setState({
          checked: model === (value !== undefined ? value : label)
        });
      }
    }
    /**
     * 改变
     * @param value
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(value, e) {
      var checked = e.target.checked;

      if (checked) {
        var onChange = this.props.onChange;
        onChange && onChange(value, e);
      }

      this.setState({
        checked: checked
      });
    }
    /**
     * 点击
     * @param e
     */

  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var _this$props3 = this.props,
          onClick = _this$props3.onClick,
          value = _this$props3.value;
      onClick && onClick(value, e);
    }
    /**
     * 渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var checked = this.state.checked;
      var _this$props4 = this.props,
          disabled = _this$props4.disabled,
          size = _this$props4.size,
          style = _this$props4.style,
          value = _this$props4.value,
          label = _this$props4.label,
          children = _this$props4.children,
          name = _this$props4.name,
          className = _this$props4.className,
          rest = (0, _objectWithoutProperties2.default)(_this$props4, _excluded); // 没有value是,可将label值作为value

      var newValue = value;

      if (value === undefined) {
        newValue = label;
      }

      var otherProps = (0, _omit.default)(rest, ['fill', 'textColor']);
      var labelText = children || label;
      return /*#__PURE__*/React.createElement("label", {
        style: style,
        className: (0, _classnames.default)(className, 'rd-radio', size && "rd-radio--".concat(size), {
          'is-checked': checked
        }),
        onClick: function onClick(e) {
          e.stopPropagation();
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: (0, _classnames.default)({
          'rd-radio__input': true,
          'is-disabled': disabled,
          'is-checked': checked
        })
      }, /*#__PURE__*/React.createElement("span", {
        className: "rd-radio__inner"
      }), /*#__PURE__*/React.createElement("input", (0, _extends2.default)({}, otherProps, {
        type: "radio",
        className: "rd-radio__original" // 解决React 中受控组件和非受控组件的问题
        ,
        checked: checked === undefined ? false : checked,
        disabled: disabled,
        name: name,
        value: newValue,
        onChange: function onChange(e) {
          return _this2.handleChange(newValue, e);
        },
        onClick: this.handleClick
      }))), labelText && /*#__PURE__*/React.createElement("span", {
        className: "rd-radio__label"
      }, children || label));
    }
  }]);
  return Radio;
}(React.Component), _class2.Group = void 0, _class2.Button = void 0, _class2.contextType = _RadioContext.default, _class2.defaultProps = {
  size: 'medium'
}, _class2)) || _class;

exports.default = Radio;