"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Radio2 = _interopRequireDefault(require("./Radio"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _excluded = ["disabled", "style", "value", "label", "children", "className"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var RadioButton = // 继承Radio组件上的方法和属性
(0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_Radio) {
  (0, _inherits2.default)(RadioButton, _Radio);

  var _super = _createSuper(RadioButton);

  function RadioButton() {
    (0, _classCallCheck2.default)(this, RadioButton);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(RadioButton, [{
    key: "componentDidMount",
    value:
    /**
     * 初始化
     */
    function componentDidMount() {
      var _this$props = this.props,
          checked = _this$props.checked,
          value = _this$props.value,
          label = _this$props.label,
          model = _this$props.model;

      if (model !== undefined) {
        this.setState({
          checked: model === (value !== undefined ? value : label)
        });
      } else {
        this.setState({
          checked: checked
        });
      }
    }
    /**
     * 更新
     * @param nextProps
     * @param prevState
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props2 = this.props,
          checked = _this$props2.checked,
          value = _this$props2.value,
          label = _this$props2.label,
          model = _this$props2.model;

      if (prevProps.checked !== checked) {
        this.setState({
          checked: checked
        });
      } else if (this.props.model !== prevProps.model) {
        this.setState({
          checked: model === (value !== undefined ? value : label)
        });
      }
    }
    /**
     * 获取父级尺寸
     */

  }, {
    key: "size",
    value: function size() {
      var parent = this.parent();
      var newSize = this.props.size;

      if (parent) {
        newSize = parent.props.size;
      }

      return newSize;
    }
    /**
     * 获取填充颜色
     */

  }, {
    key: "activeStyle",
    value: function activeStyle() {
      var parent = this.parent();
      var _this$props3 = this.props,
          fill = _this$props3.fill,
          textColor = _this$props3.textColor,
          style = _this$props3.style;
      return _objectSpread({
        backgroundColor: parent ? parent.props.fill : fill,
        borderColor: parent ? parent.props.fill : fill,
        color: parent ? parent.props.textColor : textColor
      }, style);
    }
    /**button渲染 */

  }, {
    key: "buttonRender",
    value: function buttonRender() {
      var _this = this;

      var checked = this.state.checked;
      var _this$props4 = this.props,
          disabled = _this$props4.disabled,
          style = _this$props4.style,
          value = _this$props4.value,
          label = _this$props4.label,
          children = _this$props4.children,
          className = _this$props4.className,
          rest = (0, _objectWithoutProperties2.default)(_this$props4, _excluded);
      var newValue = value;

      if (value === undefined) {
        newValue = label;
      }

      var size = this.size();
      var otherProps = (0, _omit.default)(rest, ['fill', 'textColor', 'size']);
      var labelText = children || label;
      return /*#__PURE__*/React.createElement("label", {
        style: checked ? this.activeStyle() : _objectSpread({}, style),
        className: (0, _classnames.default)(className, 'rd-radio-button', size && "rd-radio-button--".concat(size), {
          'is-checked': checked,
          'is-disabled': disabled
        })
      }, /*#__PURE__*/React.createElement("input", (0, _extends2.default)({}, otherProps, {
        type: "radio",
        className: "rd-radio-button__orig-radio" // 解决React 中受控组件和非受控组件的问题
        ,
        checked: checked === undefined ? false : checked,
        value: newValue,
        disabled: disabled,
        onChange: function onChange(e) {
          return _this.handleChange(newValue, e);
        },
        onClick: this.handleClick
      })), labelText && /*#__PURE__*/React.createElement("span", {
        className: "rd-radio-button__inner"
      }, children || label));
    }
    /**
     *渲染
     */

  }, {
    key: "render",
    value: function render() {
      /**注意：radio和checkbox的button单独使用时需要添加一个标签将button包裹一下样式才会正常显示 */
      return this.buttonRender();
    }
  }]);
  return RadioButton;
}(_Radio2.default), _class2.defaultProps = {
  size: 'medium'
}, _class2)) || _class;

exports.default = RadioButton;