import * as React from 'react';
import { Size } from '../../libs/types';
export declare type CheckboxValueType = string | number;
export interface AbstractCheckboxProps extends Omit<React.InputHTMLAttributes<HTMLInputElement>, 'size' | 'onChange' | 'onClick' | 'value'> {
    className?: string;
    checked?: boolean;
    style?: React.CSSProperties;
    disabled?: boolean;
    label?: React.ReactNode;
    name?: string;
    children?: React.ReactNode;
    size?: Size;
    fill?: string;
    textColor?: string;
    onFocus?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onBlur?: (e: React.ChangeEvent<HTMLInputElement>) => void;
}
export interface CheckProps extends AbstractCheckboxProps {
    indeterminate?: boolean;
    onChange?: (value: Array<CheckboxValueType> | CheckboxValueType, e?: React.ChangeEvent<HTMLInputElement>) => void;
}
export interface RadioProps extends AbstractCheckboxProps {
    value?: CheckboxValueType;
    model?: CheckboxValueType;
    onChange?: (value: CheckboxValueType | boolean, e?: React.ChangeEvent<HTMLInputElement>) => void;
    onClick?: (value: CheckboxValueType | boolean, e?: React.MouseEvent<HTMLInputElement, MouseEvent>) => void;
}
export interface CheckboxProps extends CheckProps {
    onLabelClick?: React.MouseEventHandler<HTMLLabelElement>;
    value?: CheckboxValueType;
    options?: Array<CheckboxValueType>;
}
export interface CheckboxState {
    checked?: boolean;
    focus?: boolean;
    _prevProps?: CheckboxProps;
}
export interface RadioState {
    checked?: boolean;
    _prevProps?: RadioProps;
}
