"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _raf2 = _interopRequireWildcard(require("raf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _utils = require("./utils");

var _styles = require("./styles");

var _classnames = _interopRequireDefault(require("classnames"));

var _domresize = _interopRequireDefault(require("../../libs/domresize"));

var _excluded = ["onScroll", "onScrollFrame", "onScrollStart", "onScrollStop", "onUpdate", "renderView", "renderTrackHorizontal", "renderTrackVertical", "renderThumbHorizontal", "renderThumbVertical", "tagName", "hideTracksWhenNotNeeded", "autoHide", "autoHideTimeout", "autoHideDuration", "thumbSize", "thumbMinSize", "universal", "autoHeight", "autoHeightMin", "autoHeightMax", "style", "children", "className", "hoverShowTrack", "hideScrollY"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**创建默认Div */
function renderDefaultDiv(props) {
  return /*#__PURE__*/React.createElement("div", props);
}

var ScrollBar = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(ScrollBar, _React$PureComponent);

  var _super = _createSuper(ScrollBar);

  function ScrollBar() {
    var _this;

    (0, _classCallCheck2.default)(this, ScrollBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.container = void 0;
    _this.view = void 0;
    _this.viewChildren = void 0;
    _this.trackHorizontal = void 0;
    _this.trackVertical = void 0;
    _this.thumbHorizontal = void 0;
    _this.thumbVertical = void 0;
    _this.hideTracksTimeout = void 0;
    _this.detectScrollingInterval = void 0;
    _this.dragging = false;
    _this.scrolling = false;
    _this.trackMouseOver = false;
    _this.viewScrollLeft = void 0;
    _this.viewScrollTop = void 0;
    _this.prevPageY = void 0;
    _this.prevPageX = void 0;
    _this.lastViewScrollLeft = void 0;
    _this.lastViewScrollTop = void 0;
    _this.requestFrameId = void 0;
    _this.state = {
      didMountUniversal: false
    };
    return _this;
  }

  (0, _createClass2.default)(ScrollBar, [{
    key: "componentDidMount",
    value:
    /**
     * 加载完成后
     */
    function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        _this2.update();
      }, 0);
      (0, _domresize.default)(this.viewChildren, function () {
        _this2.update();
      });
      this.addListeners();
      this.componentDidMountUniversal();
    }
    /**
     *
     */

  }, {
    key: "componentDidMountUniversal",
    value: function componentDidMountUniversal() {
      // eslint-disable-line react/sort-comp
      var universal = this.props.universal;

      if (!universal) {
        return;
      }

      this.setState({
        didMountUniversal: true
      });
    }
    /**更新 */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var _this3 = this;

      // 避免上级更新后，UI未渲染完，就执行了update，导致高度获取到的是更新之前的高度
      // 比如表格里面有编辑内容，提示错误时，就会概率出现高度不更新
      setTimeout(function () {
        _this3.update();
      }, 0);
    }
    /**卸载 */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeListeners();
      (0, _raf2.cancel)(this.requestFrameId);
      clearTimeout(this.hideTracksTimeout);
      clearInterval(this.detectScrollingInterval);
    }
    /**获取滚动条左侧 */

  }, {
    key: "getScrollLeft",
    value: function getScrollLeft() {
      if (!this.view) {
        return 0;
      }

      return this.view.scrollLeft;
    }
    /**顶部滚动 */

  }, {
    key: "getScrollTop",
    value: function getScrollTop() {
      if (!this.view) {
        return 0;
      }

      return this.view.scrollTop;
    }
    /**滚动宽度 */

  }, {
    key: "getScrollWidth",
    value: function getScrollWidth() {
      if (!this.view) {
        return 0;
      }

      return this.view.scrollWidth;
    }
    /**滚动高度 */

  }, {
    key: "getScrollHeight",
    value: function getScrollHeight() {
      if (!this.view) {
        return 0;
      }

      return this.view.scrollHeight;
    }
    /**视图宽度 */

  }, {
    key: "getClientWidth",
    value: function getClientWidth() {
      if (!this.view) {
        return 0;
      }

      return this.view.clientWidth;
    }
    /**视图高度 */

  }, {
    key: "getClientHeight",
    value: function getClientHeight() {
      if (!this.view) {
        return 0;
      }

      return this.view.clientHeight;
    }
    /**获取所有参数信息 */

  }, {
    key: "getValues",
    value: function getValues() {
      var _ref = this.view || {},
          _ref$scrollLeft = _ref.scrollLeft,
          scrollLeft = _ref$scrollLeft === void 0 ? 0 : _ref$scrollLeft,
          _ref$scrollTop = _ref.scrollTop,
          scrollTop = _ref$scrollTop === void 0 ? 0 : _ref$scrollTop,
          _ref$scrollWidth = _ref.scrollWidth,
          scrollWidth = _ref$scrollWidth === void 0 ? 0 : _ref$scrollWidth,
          _ref$scrollHeight = _ref.scrollHeight,
          scrollHeight = _ref$scrollHeight === void 0 ? 0 : _ref$scrollHeight,
          _ref$clientWidth = _ref.clientWidth,
          clientWidth = _ref$clientWidth === void 0 ? 0 : _ref$clientWidth,
          _ref$clientHeight = _ref.clientHeight,
          clientHeight = _ref$clientHeight === void 0 ? 0 : _ref$clientHeight;

      return {
        left: scrollLeft / (scrollWidth - clientWidth) || 0,
        top: scrollTop / (scrollHeight - clientHeight) || 0,
        scrollLeft: scrollLeft,
        scrollTop: scrollTop,
        scrollWidth: scrollWidth,
        scrollHeight: scrollHeight,
        clientWidth: clientWidth,
        clientHeight: clientHeight
      };
    }
    /**获取水平滑动块宽度 */

  }, {
    key: "getThumbHorizontalWidth",
    value: function getThumbHorizontalWidth() {
      var _this$props = this.props,
          thumbSize = _this$props.thumbSize,
          thumbMinSize = _this$props.thumbMinSize;
      var _this$view = this.view,
          scrollWidth = _this$view.scrollWidth,
          clientWidth = _this$view.clientWidth;

      if (clientWidth === 0) {
        var _getSize = (0, _utils.getSize)(this.view),
            scrollW = _getSize.scrollWidth,
            _width = _getSize.width;

        scrollWidth = scrollW;
        clientWidth = _width;
      }

      var trackWidth = (0, _utils.getInnerWidth)(this.trackHorizontal);
      var width = Math.ceil(clientWidth / scrollWidth * trackWidth);

      if (trackWidth === width) {
        return 0;
      }

      if (thumbSize) {
        return thumbSize;
      } // scrollWidth, clientWidth可能为0


      if (isNaN(width)) {
        return 0;
      }

      return Math.max(width, thumbMinSize);
    }
    /**获取垂直滑块高度 */

  }, {
    key: "getThumbVerticalHeight",
    value: function getThumbVerticalHeight() {
      var _this$props2 = this.props,
          thumbSize = _this$props2.thumbSize,
          thumbMinSize = _this$props2.thumbMinSize;
      var _this$view2 = this.view,
          scrollHeight = _this$view2.scrollHeight,
          clientHeight = _this$view2.clientHeight;

      if (clientHeight === 0) {
        var _getSize2 = (0, _utils.getSize)(this.view),
            scrollW = _getSize2.scrollHeight,
            _height = _getSize2.height;

        scrollHeight = scrollW;
        clientHeight = _height;
      }

      var trackHeight = (0, _utils.getInnerHeight)(this.trackVertical);
      var height = Math.ceil(clientHeight / scrollHeight * trackHeight);

      if (trackHeight === height) {
        return 0;
      }

      if (thumbSize) {
        return thumbSize;
      }

      return Math.max(height, thumbMinSize);
    }
    /**获取滚动条左侧位移 */

  }, {
    key: "getScrollLeftForOffset",
    value: function getScrollLeftForOffset(offset) {
      var _this$view3 = this.view,
          scrollWidth = _this$view3.scrollWidth,
          clientWidth = _this$view3.clientWidth;
      var trackWidth = (0, _utils.getInnerWidth)(this.trackHorizontal);
      var thumbWidth = this.getThumbHorizontalWidth();
      return offset / (trackWidth - thumbWidth) * (scrollWidth - clientWidth);
    }
    /**获取滚动条顶部位移 */

  }, {
    key: "getScrollTopForOffset",
    value: function getScrollTopForOffset(offset) {
      var _this$view4 = this.view,
          scrollHeight = _this$view4.scrollHeight,
          clientHeight = _this$view4.clientHeight;
      var trackHeight = (0, _utils.getInnerHeight)(this.trackVertical);
      var thumbHeight = this.getThumbVerticalHeight();
      return offset / (trackHeight - thumbHeight) * (scrollHeight - clientHeight);
    }
    /**往左侧滑动 */

  }, {
    key: "scrollLeft",
    value: function scrollLeft() {
      var left = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (!this.view) {
        return;
      }

      this.view.scrollLeft = left;
    }
    /**往顶部滑动 */

  }, {
    key: "scrollTop",
    value: function scrollTop() {
      var top = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (!this.view) {
        return;
      }

      this.view.scrollTop = top;
    }
    /**滑到左测 */

  }, {
    key: "scrollToLeft",
    value: function scrollToLeft() {
      if (!this.view) {
        return;
      }

      this.view.scrollLeft = 0;
    }
    /**滑到顶部 */

  }, {
    key: "scrollToTop",
    value: function scrollToTop() {
      if (!this.view) {
        return;
      }

      this.view.scrollTop = 0;
    }
    /**滑到右侧 */

  }, {
    key: "scrollToRight",
    value: function scrollToRight() {
      if (!this.view) {
        return;
      }

      this.view.scrollLeft = this.view.scrollWidth;
    }
    /**滑到底侧 */

  }, {
    key: "scrollToBottom",
    value: function scrollToBottom() {
      if (!this.view) {
        return;
      }

      this.view.scrollTop = this.view.scrollHeight;
    }
    /**事件注册 */

  }, {
    key: "addListeners",
    value: function addListeners() {
      /* istanbul ignore if */
      if (typeof document === 'undefined' || !this.view) {
        return;
      }

      var view = this.view,
          trackHorizontal = this.trackHorizontal,
          trackVertical = this.trackVertical,
          thumbHorizontal = this.thumbHorizontal,
          thumbVertical = this.thumbVertical;
      view.addEventListener('scroll', this.handleScroll);

      if (!(0, _utils.getScrollbarWidth)()) {
        return;
      }

      trackHorizontal.addEventListener('mouseenter', this.handleTrackMouseEnter);
      trackHorizontal.addEventListener('mouseleave', this.handleTrackMouseLeave);
      trackHorizontal.addEventListener('mousedown', this.handleHorizontalTrackMouseDown);
      trackVertical.addEventListener('mouseenter', this.handleTrackMouseEnter);
      trackVertical.addEventListener('mouseleave', this.handleTrackMouseLeave);
      trackVertical.addEventListener('mousedown', this.handleVerticalTrackMouseDown);
      thumbHorizontal.addEventListener('mousedown', this.handleHorizontalThumbMouseDown);
      thumbVertical.addEventListener('mousedown', this.handleVerticalThumbMouseDown); // window.addEventListener('resize', this.handleWindowResize);
    }
    /**移除监听事件 */

  }, {
    key: "removeListeners",
    value: function removeListeners() {
      /* istanbul ignore if */
      if (typeof document === 'undefined' || !this.view) {
        return;
      }

      var view = this.view,
          trackHorizontal = this.trackHorizontal,
          trackVertical = this.trackVertical,
          thumbHorizontal = this.thumbHorizontal,
          thumbVertical = this.thumbVertical;
      view.removeEventListener('scroll', this.handleScroll);

      if (!(0, _utils.getScrollbarWidth)()) {
        return;
      }

      trackHorizontal.removeEventListener('mouseenter', this.handleTrackMouseEnter);
      trackHorizontal.removeEventListener('mouseleave', this.handleTrackMouseLeave);
      trackHorizontal.removeEventListener('mousedown', this.handleHorizontalTrackMouseDown);
      trackVertical.removeEventListener('mouseenter', this.handleTrackMouseEnter);
      trackVertical.removeEventListener('mouseleave', this.handleTrackMouseLeave);
      trackVertical.removeEventListener('mousedown', this.handleVerticalTrackMouseDown);
      thumbHorizontal.removeEventListener('mousedown', this.handleHorizontalThumbMouseDown);
      thumbVertical.removeEventListener('mousedown', this.handleVerticalThumbMouseDown); // window.removeEventListener('resize', this.handleWindowResize);
      // Possibly setup by `handleDragStart`

      this.teardownDragging();
    }
    /**滑动处理回调 */

  }, {
    key: "handleScroll",
    value: function handleScroll(event) {
      var _this4 = this;

      var _this$props3 = this.props,
          onScroll = _this$props3.onScroll,
          onScrollFrame = _this$props3.onScrollFrame;
      onScroll && onScroll(event);
      this.update(function (values) {
        var scrollLeft = values.scrollLeft,
            scrollTop = values.scrollTop;
        _this4.viewScrollLeft = scrollLeft;
        _this4.viewScrollTop = scrollTop;
        onScrollFrame && onScrollFrame(values);
      });
      this.detectScrolling();
    }
    /**滑动开始 */

  }, {
    key: "handleScrollStart",
    value: function handleScrollStart() {
      var onScrollStart = this.props.onScrollStart;
      onScrollStart && onScrollStart();
      this.handleScrollStartAutoHide();
    }
    /**滑动开始自动隐藏 */

  }, {
    key: "handleScrollStartAutoHide",
    value: function handleScrollStartAutoHide() {
      var autoHide = this.props.autoHide;

      if (!autoHide) {
        return;
      }

      this.showTracks();
    }
    /**停止滑动 */

  }, {
    key: "handleScrollStop",
    value: function handleScrollStop() {
      var onScrollStop = this.props.onScrollStop;
      onScrollStop && onScrollStop();
      this.handleScrollStopAutoHide();
    }
    /**停止滑动自动隐藏 */

  }, {
    key: "handleScrollStopAutoHide",
    value: function handleScrollStopAutoHide() {
      var autoHide = this.props.autoHide;

      if (!autoHide) {
        return;
      }

      this.hideTracks();
    }
    /**窗口resize处理 */
    // handleWindowResize(): void {
    //     this.update();
    // }

    /**处理水平滑块鼠标按下 */

  }, {
    key: "handleHorizontalTrackMouseDown",
    value: function handleHorizontalTrackMouseDown(event) {
      event.preventDefault();
      var target = event.target,
          clientX = event.clientX;

      var _target$getBoundingCl = target.getBoundingClientRect(),
          targetLeft = _target$getBoundingCl.left;

      var thumbWidth = this.getThumbHorizontalWidth();
      var offset = Math.abs(targetLeft - clientX) - thumbWidth / 2;
      this.view.scrollLeft = this.getScrollLeftForOffset(offset);
    }
    /**处理垂直滑块鼠标按下 */

  }, {
    key: "handleVerticalTrackMouseDown",
    value: function handleVerticalTrackMouseDown(event) {
      event.preventDefault();
      var target = event.target,
          clientY = event.clientY;

      var _target$getBoundingCl2 = target.getBoundingClientRect(),
          targetTop = _target$getBoundingCl2.top;

      var thumbHeight = this.getThumbVerticalHeight();
      var offset = Math.abs(targetTop - clientY) - thumbHeight / 2;
      this.view.scrollTop = this.getScrollTopForOffset(offset);
    }
    /**处理水平轨道鼠标按下 */

  }, {
    key: "handleHorizontalThumbMouseDown",
    value: function handleHorizontalThumbMouseDown(event) {
      event.preventDefault();
      this.handleDragStart(event);
      var target = event.target,
          clientX = event.clientX;
      var offsetWidth = target.offsetWidth;

      var _target$getBoundingCl3 = target.getBoundingClientRect(),
          left = _target$getBoundingCl3.left;

      this.prevPageX = offsetWidth - (clientX - left);
    }
    /**处理垂直轨道鼠标按下 */

  }, {
    key: "handleVerticalThumbMouseDown",
    value: function handleVerticalThumbMouseDown(event) {
      event.preventDefault();
      this.handleDragStart(event);
      var target = event.target,
          clientY = event.clientY;
      var offsetHeight = target.offsetHeight;

      var _target$getBoundingCl4 = target.getBoundingClientRect(),
          top = _target$getBoundingCl4.top;

      this.prevPageY = offsetHeight - (clientY - top);
    }
    /**拖动 */

  }, {
    key: "setupDragging",
    value: function setupDragging() {
      (0, _utils.setCss)(document.body, _styles.disableSelectStyle);
      document.addEventListener('mousemove', this.handleDrag);
      document.addEventListener('mouseup', this.handleDragEnd);
      document.onselectstart = _utils.returnFalse;
    }
    /**拖动事件注册 */

  }, {
    key: "teardownDragging",
    value: function teardownDragging() {
      (0, _utils.setCss)(document.body, _styles.disableSelectStyleReset);
      document.removeEventListener('mousemove', this.handleDrag);
      document.removeEventListener('mouseup', this.handleDragEnd);
      document.onselectstart = undefined;
    }
    /**开始拖动 */

  }, {
    key: "handleDragStart",
    value: function handleDragStart(event) {
      this.dragging = true;
      event.stopImmediatePropagation();
      this.setupDragging();
    }
    /**拖动 */

  }, {
    key: "handleDrag",
    value: function handleDrag(event) {
      if (this.prevPageX) {
        var clientX = event.clientX;

        var _this$trackHorizontal = this.trackHorizontal.getBoundingClientRect(),
            trackLeft = _this$trackHorizontal.left;

        var thumbWidth = this.getThumbHorizontalWidth();
        var clickPosition = thumbWidth - this.prevPageX;
        var offset = -trackLeft + clientX - clickPosition;
        this.view.scrollLeft = this.getScrollLeftForOffset(offset);
      }

      if (this.prevPageY) {
        var clientY = event.clientY;

        var _this$trackVertical$g = this.trackVertical.getBoundingClientRect(),
            trackTop = _this$trackVertical$g.top;

        var thumbHeight = this.getThumbVerticalHeight();

        var _clickPosition = thumbHeight - this.prevPageY;

        var _offset = -trackTop + clientY - _clickPosition;

        this.view.scrollTop = this.getScrollTopForOffset(_offset);
      }

      return false;
    }
    /**拖动结束 */

  }, {
    key: "handleDragEnd",
    value: function handleDragEnd() {
      this.dragging = false;
      this.prevPageX = this.prevPageY = 0;
      this.teardownDragging();
      this.handleDragEndAutoHide();
    }
    /** */

  }, {
    key: "handleDragEndAutoHide",
    value: function handleDragEndAutoHide() {
      var autoHide = this.props.autoHide;

      if (!autoHide) {
        return;
      }

      this.hideTracks();
    }
    /** */

  }, {
    key: "handleTrackMouseEnter",
    value: function handleTrackMouseEnter() {
      this.trackMouseOver = true;
      this.handleTrackMouseEnterAutoHide();
    }
    /** */

  }, {
    key: "handleTrackMouseEnterAutoHide",
    value: function handleTrackMouseEnterAutoHide() {
      var autoHide = this.props.autoHide;

      if (!autoHide) {
        return;
      }

      this.showTracks();
    }
    /** */

  }, {
    key: "handleTrackMouseLeave",
    value: function handleTrackMouseLeave() {
      this.trackMouseOver = false;
      this.handleTrackMouseLeaveAutoHide();
    }
    /** */

  }, {
    key: "handleTrackMouseLeaveAutoHide",
    value: function handleTrackMouseLeaveAutoHide() {
      var autoHide = this.props.autoHide;

      if (!autoHide) {
        return;
      }

      this.hideTracks();
    }
    /** */

  }, {
    key: "showTracks",
    value: function showTracks() {
      clearTimeout(this.hideTracksTimeout);
      (0, _utils.setCss)(this.trackHorizontal, {
        opacity: 1
      });
      (0, _utils.setCss)(this.trackVertical, {
        opacity: 1
      });
    }
    /** */

  }, {
    key: "hideTracks",
    value: function hideTracks() {
      var _this5 = this;

      if (this.dragging || this.scrolling || this.trackMouseOver) {
        return;
      }

      var autoHideTimeout = this.props.autoHideTimeout;
      clearTimeout(this.hideTracksTimeout);
      this.hideTracksTimeout = setTimeout(function () {
        (0, _utils.setCss)(_this5.trackHorizontal, {
          opacity: 0
        });
        (0, _utils.setCss)(_this5.trackVertical, {
          opacity: 0
        });
      }, autoHideTimeout);
    }
    /** */

  }, {
    key: "detectScrolling",
    value: function detectScrolling() {
      var _this6 = this;

      if (this.scrolling) {
        return;
      }

      this.scrolling = true;
      this.handleScrollStart();
      this.detectScrollingInterval = setInterval(function () {
        if (_this6.lastViewScrollLeft === _this6.viewScrollLeft && _this6.lastViewScrollTop === _this6.viewScrollTop) {
          clearInterval(_this6.detectScrollingInterval);
          _this6.scrolling = false;

          _this6.handleScrollStop();
        }

        _this6.lastViewScrollLeft = _this6.viewScrollLeft;
        _this6.lastViewScrollTop = _this6.viewScrollTop;
      }, 100);
    }
    /** */

  }, {
    key: "raf",
    value: function raf(callback) {
      var _this7 = this;

      if (this.requestFrameId) {
        _raf2.default.cancel(this.requestFrameId);
      }

      this.requestFrameId = (0, _raf2.default)(function () {
        _this7.requestFrameId = undefined;
        callback();
      });
    }
    /** */

  }, {
    key: "update",
    value: function update(callback) {
      var _this8 = this;

      this.raf(function () {
        return _this8._update(callback);
      });
    }
    /** */

  }, {
    key: "_update",
    value: function _update(callback) {
      var _this$props4 = this.props,
          onUpdate = _this$props4.onUpdate,
          hideTracksWhenNotNeeded = _this$props4.hideTracksWhenNotNeeded,
          hideScrollY = _this$props4.hideScrollY;
      var values = this.getValues();

      if ((0, _utils.getScrollbarWidth)()) {
        var scrollLeft = values.scrollLeft,
            clientWidth = values.clientWidth,
            scrollWidth = values.scrollWidth;
        var trackHorizontalWidth = (0, _utils.getInnerWidth)(this.trackHorizontal);
        var thumbHorizontalWidth = this.getThumbHorizontalWidth();
        var thumbHorizontalX = scrollLeft / (scrollWidth - clientWidth) * (trackHorizontalWidth - thumbHorizontalWidth);
        var thumbHorizontalStyle = {
          width: "".concat(thumbHorizontalWidth, "px")
        };

        if (!isNaN(thumbHorizontalX)) {
          thumbHorizontalStyle.transform = "translateX(".concat(thumbHorizontalX, "px)");
        }

        var scrollTop = values.scrollTop,
            clientHeight = values.clientHeight,
            scrollHeight = values.scrollHeight;

        if (hideScrollY) {
          var height = (0, _utils.getViewHeight)(this.viewChildren);
          var containerHeightStyle = {
            height: "".concat(height, "px") //`${this.viewChildren.offsetHeight}px`

          };
          (0, _utils.setCss)(this.container, containerHeightStyle);
        } else {
          var trackVerticalHeight = (0, _utils.getInnerHeight)(this.trackVertical);
          var thumbVerticalHeight = this.getThumbVerticalHeight();
          var thumbVerticalY = scrollTop / (scrollHeight - clientHeight) * (trackVerticalHeight - thumbVerticalHeight);
          var thumbVerticalStyle = {
            height: "".concat(thumbVerticalHeight, "px")
          };

          if (!isNaN(thumbVerticalY)) {
            thumbVerticalStyle.transform = "translateY(".concat(thumbVerticalY, "px)");
          }

          (0, _utils.setCss)(this.thumbVertical, thumbVerticalStyle);
        }

        if (hideTracksWhenNotNeeded) {
          var trackHorizontalStyle = {
            visibility: scrollWidth > clientWidth ? 'visible' : 'hidden'
          };
          (0, _utils.setCss)(this.trackHorizontal, trackHorizontalStyle);

          if (!hideScrollY) {
            var trackVerticalStyle = {
              visibility: scrollHeight > clientHeight ? 'visible' : 'hidden'
            };
            (0, _utils.setCss)(this.trackVertical, trackVerticalStyle);
          }
        }

        (0, _utils.setCss)(this.thumbHorizontal, thumbHorizontalStyle);
      }

      onUpdate && onUpdate(values);

      if (typeof callback !== 'function') {
        return;
      }

      callback(values);
    }
    /**JSX */

  }, {
    key: "render",
    value: function render() {
      var _this9 = this;

      var scrollbarWidth = (0, _utils.getScrollbarWidth)();
      var _this$props5 = this.props,
          onScroll = _this$props5.onScroll,
          onScrollFrame = _this$props5.onScrollFrame,
          onScrollStart = _this$props5.onScrollStart,
          onScrollStop = _this$props5.onScrollStop,
          onUpdate = _this$props5.onUpdate,
          renderView = _this$props5.renderView,
          renderTrackHorizontal = _this$props5.renderTrackHorizontal,
          renderTrackVertical = _this$props5.renderTrackVertical,
          renderThumbHorizontal = _this$props5.renderThumbHorizontal,
          renderThumbVertical = _this$props5.renderThumbVertical,
          tagName = _this$props5.tagName,
          hideTracksWhenNotNeeded = _this$props5.hideTracksWhenNotNeeded,
          autoHide = _this$props5.autoHide,
          autoHideTimeout = _this$props5.autoHideTimeout,
          autoHideDuration = _this$props5.autoHideDuration,
          thumbSize = _this$props5.thumbSize,
          thumbMinSize = _this$props5.thumbMinSize,
          universal = _this$props5.universal,
          autoHeight = _this$props5.autoHeight,
          autoHeightMin = _this$props5.autoHeightMin,
          autoHeightMax = _this$props5.autoHeightMax,
          style = _this$props5.style,
          children = _this$props5.children,
          className = _this$props5.className,
          hoverShowTrack = _this$props5.hoverShowTrack,
          hideScrollY = _this$props5.hideScrollY,
          props = (0, _objectWithoutProperties2.default)(_this$props5, _excluded);
      /* eslint-enable no-unused-vars */

      var didMountUniversal = this.state.didMountUniversal;
      var containerClassNames = (0, _classnames.default)('rd-custom-scroll', className, {
        'is-auto-height': autoHeight
      }, {
        'is-hover-show': hoverShowTrack
      });

      var containerStyle = _objectSpread(_objectSpread({}, autoHeight && {
        minHeight: autoHeightMin,
        maxHeight: autoHeightMax
      }), style);

      var viewClassName = (0, _classnames.default)('rd-custom-scroll__view', {
        'is-auto-height': autoHeight
      });

      var viewStyle = _objectSpread(_objectSpread(_objectSpread({
        // Hide scrollbars by setting a negative margin
        marginRight: scrollbarWidth ? -scrollbarWidth : 0,
        marginBottom: scrollbarWidth ? -scrollbarWidth : 0,
        height: scrollbarWidth ? "calc(100% + ".concat(scrollbarWidth, "px)") : '100%'
      }, autoHeight && {
        //...viewStyleAutoHeight,
        // Add scrollbarWidth to autoHeight in order to compensate negative margins
        minHeight: (0, _utils.isString)(autoHeightMin) ? "calc(".concat(autoHeightMin, " + ").concat(scrollbarWidth, "px)") : Number(autoHeightMin) + Number(scrollbarWidth),
        maxHeight: (0, _utils.isString)(autoHeightMax) ? "calc(".concat(autoHeightMax, " + ").concat(scrollbarWidth, "px)") : Number(autoHeightMax) + Number(scrollbarWidth)
      }), autoHeight && universal && !didMountUniversal && {
        minHeight: autoHeightMin,
        maxHeight: autoHeightMax
      }), universal && !didMountUniversal && _styles.viewStyleUniversalInitial);

      var trackHorizontalClassName = (0, _classnames.default)('rd-custom-scroll__track', 'is-horizontal' // 不能直接通过css来处理，不然获取不到thumb的宽度，高度
      // {
      //     'is-hide': autoHide
      // }
      );
      var trackVerticalClassName = (0, _classnames.default)('rd-custom-scroll__track', 'is-vertical' // {
      //     'is-hide': autoHide
      // }
      );
      var trackAutoHideStyle = {
        transition: "opacity ".concat(autoHideDuration, "ms"),
        opacity: 0
      };

      var trackHorizontalStyle = _objectSpread(_objectSpread({}, autoHide && autoHideDuration && trackAutoHideStyle), (!scrollbarWidth || universal && !didMountUniversal) && {
        display: 'none'
      });

      var trackVerticalStyle = _objectSpread(_objectSpread({}, autoHide && autoHideDuration && trackAutoHideStyle), (!scrollbarWidth || universal && !didMountUniversal) && {
        display: 'none'
      });

      return /*#__PURE__*/React.createElement(tagName, _objectSpread(_objectSpread({}, props), {}, {
        className: containerClassNames,
        style: containerStyle,
        ref: function ref(_ref2) {
          _this9.container = _ref2;
        }
      }), [/*#__PURE__*/React.cloneElement(renderView({
        className: viewClassName,
        style: viewStyle
      }), {
        key: 'view',
        ref: function ref(_ref3) {
          _this9.view = _ref3;
        }
      }, /*#__PURE__*/React.createElement("div", {
        ref: function ref(_ref4) {
          _this9.viewChildren = _ref4;
        },
        style: {
          position: 'relative'
        }
      }, children)), /*#__PURE__*/React.cloneElement(renderTrackHorizontal({
        className: trackHorizontalClassName,
        style: trackHorizontalStyle
      }), {
        key: 'trackHorizontal',
        ref: function ref(_ref5) {
          _this9.trackHorizontal = _ref5;
        }
      }, /*#__PURE__*/React.cloneElement(renderThumbHorizontal({
        className: 'rd-custom-scroll__thumb is-horizontal'
      }), {
        ref: function ref(_ref6) {
          _this9.thumbHorizontal = _ref6;
        }
      })), /*#__PURE__*/React.cloneElement(renderTrackVertical({
        className: trackVerticalClassName,
        style: trackVerticalStyle
      }), {
        key: 'trackVertical',
        ref: function ref(_ref7) {
          _this9.trackVertical = _ref7;
        }
      }, /*#__PURE__*/React.cloneElement(renderThumbVertical({
        className: 'rd-custom-scroll__thumb is-vertical'
      }), {
        ref: function ref(_ref8) {
          _this9.thumbVertical = _ref8;
        }
      }))]);
    }
  }]);
  return ScrollBar;
}(React.PureComponent), _class2.defaultProps = {
  renderView: renderDefaultDiv,
  renderTrackHorizontal: renderDefaultDiv,
  renderTrackVertical: renderDefaultDiv,
  renderThumbHorizontal: renderDefaultDiv,
  renderThumbVertical: renderDefaultDiv,
  tagName: 'div',
  thumbMinSize: 30,
  hideTracksWhenNotNeeded: false,
  autoHide: false,
  autoHideTimeout: 1000,
  autoHideDuration: 200,
  autoHeight: false,
  autoHeightMin: 0,
  autoHeightMax: 200,
  universal: false,
  hoverShowTrack: false,
  hideScrollY: false
}, _class2)) || _class;

exports.default = ScrollBar;