import * as React from 'react';
import { InputBaseProps, InputPropsWidthRef } from "../input/Input";
import { ForwardRef } from "../../libs/types";
export interface CusSearch extends React.DOMAttributes<HTMLSpanElement> {
    style?: React.CSSProperties;
    className?: string;
    icon?: React.ReactNode;
}
export interface SearchProps extends InputBaseProps {
    position?: 'prefix' | 'suffix';
    icon?: React.ReactNode | CusSearch;
    enterButton?: React.ReactNode | CusSearch;
    onSearch?: (value: string) => void;
}
export interface SearchPropsWidthRef extends SearchProps, ForwardRef {
}
export default class Search extends React.Component<SearchPropsWidthRef> {
    state: {};
    static defaultProps: {
        position: string;
        icon: JSX.Element;
    };
    private readonly searchRef;
    /**
     * 构造函数
     * @param props
     */
    constructor(props: InputPropsWidthRef);
    /**
     * 处理搜索
     */
    handleKeyDown(e: React.KeyboardEvent<HTMLInputElement | HTMLTextAreaElement>): void;
    /**
     * 处理搜索
     */
    handleSearch(): void;
    /**
     *渲染函数
     */
    render(): React.ReactNode;
}
