"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _Input = _interopRequireDefault(require("../input/Input"));

var _Search = _interopRequireDefault(require("net-design-icons/lib/icons/Search"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _FormElement = require("../form/FormElement");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _ref = require("../../libs/ref");

var _util = require("../../libs/utils/util");

var _excluded = ["position", "icon"];

var _dec, _dec2, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Search = (_dec = (0, _ref.forwardRef)(), _dec2 = (0, _FormElement.createFormElement)(), _dec(_class = _dec2(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Search, _React$Component);

  var _super = _createSuper(Search);

  /**
   * 构造函数
   * @param props
   */
  function Search(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Search);
    _this = _super.call(this, props);
    _this.state = {};
    _this.searchRef = void 0;
    _this.searchRef = (0, _util.combineRef)(props);
    return _this;
  }
  /**
   * 处理搜索
   */


  (0, _createClass2.default)(Search, [{
    key: "handleKeyDown",
    value: function handleKeyDown(e) {
      if (e.keyCode === 13) {
        this.handleSearch();
      }
    }
    /**
     * 处理搜索
     */

  }, {
    key: "handleSearch",
    value: function handleSearch() {
      var _this$props = this.props,
          onSearch = _this$props.onSearch,
          disabled = _this$props.disabled,
          readOnly = _this$props.readOnly;

      if (!disabled && !readOnly) {
        onSearch && onSearch(this.searchRef.current.value);
      }
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          position = _this$props2.position,
          icon = _this$props2.icon,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);

      var _icon;

      if (icon.hasOwnProperty('props')) {
        _icon = {
          children: icon,
          className: 'icon-search',
          onClick: this.handleSearch.bind(this)
        };
      } else {
        _icon = icon;
      }

      var _props = _objectSpread(_objectSpread({}, (0, _omit.default)(rest, ['type', 'onSearch', 'forwardRef'])), {}, (0, _defineProperty2.default)({
        onKeyDown: this.handleKeyDown.bind(this)
      }, position, _icon));

      return /*#__PURE__*/React.createElement(_Input.default, (0, _extends2.default)({
        type: 'text',
        ref: this.searchRef
      }, _props));
    }
  }]);
  return Search;
}(React.Component), _class2.defaultProps = {
  position: 'suffix',
  icon: /*#__PURE__*/React.createElement(_Search.default, null)
}, _class2)) || _class) || _class) || _class);
exports.default = Search;