import * as React from 'react';
import { TagValue } from './Select';
import { Omit } from "../../libs/types";
export interface OptionProps extends Omit<React.DOMAttributes<HTMLLIElement>, 'onClick'> {
    /**类名称**/
    className?: string;
    /**样式**/
    style?: React.CSSProperties;
    /**子类**/
    children?: React.ReactNode;
    /**option上显示的标签**/
    label?: string | number;
    /**option上显示的标签对应的值**/
    value?: string | number | undefined | null | boolean;
    /**是否禁用**/
    disabled?: boolean;
    /**是否是自定义**/
    userDefined?: boolean;
}
export default class Option extends React.PureComponent<OptionProps> {
    static contextType: React.Context<any>;
    static defaultProps: {
        disabled: boolean;
        userDefined: boolean;
    };
    /**
     * 得到child的值
     */
    getChildValue(): TagValue;
    /**
     * 得到children
     */
    getChildren(): React.ReactNode;
    /**
     * 是否是选中状态
     */
    isSelected(): boolean;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
