"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Select = require("./Select");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _Complete = _interopRequireDefault(require("net-design-icons/lib/icons/Complete"));

var _DropdownItem = _interopRequireDefault(require("../dropdown/DropdownItem"));

var _excluded = ["className", "disabled", "children", "style"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Option = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Option, _React$PureComponent);

  var _super = _createSuper(Option);

  function Option() {
    (0, _classCallCheck2.default)(this, Option);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(Option, [{
    key: "getChildValue",
    value:
    /**
     * 得到child的值
     */
    function getChildValue() {
      var _this$props = this.props,
          children = _this$props.children,
          label = _this$props.label,
          value = _this$props.value,
          userDefined = _this$props.userDefined;

      var _value, _label;

      if (value !== undefined) {
        _value = value;
      } else if (label !== undefined) {
        _value = label;
      } else {
        _value = children;
      }

      if (label !== undefined) {
        _label = label;
      } else if (children !== undefined) {
        _label = children;
      } else {
        _label = value;
      }

      return {
        userDefined: userDefined,
        value: _value,
        label: _label
      };
    }
    /**
     * 得到children
     */

  }, {
    key: "getChildren",
    value: function getChildren() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          label = _this$props2.label,
          value = _this$props2.value;

      if (children === undefined && label === undefined && value !== undefined) {
        return value;
      } else if (label === undefined && children !== undefined) {
        return children;
      } else {
        return label;
      }
    }
    /**
     * 是否是选中状态
     */

  }, {
    key: "isSelected",
    value: function isSelected() {
      var userDefined = this.props.userDefined;
      var _this$context = this.context,
          multiple = _this$context.multiple,
          options = _this$context.options;
      var value = this.context.value;
      var childValue = this.getChildValue();

      if (multiple) {
        if (!Array.isArray(value)) {
          value = [];
        }

        var _value = value;
        return !!_value.find(function (item) {
          return item.value === childValue.value;
        }); //return !!_value.find((item: TagValue) => item.value === childValue.value && item.label === childValue.label);
      } else {
        if (userDefined) {
          var have = options.filter(function (item) {
            return !item.userDefined;
          }).find(function (item) {
            return item.value === value;
          });
          return !have;
        } else {
          return childValue.value === value;
        }
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var multiple = this.context.multiple;
      var _this$props3 = this.props,
          className = _this$props3.className,
          disabled = _this$props3.disabled,
          children = _this$props3.children,
          style = _this$props3.style,
          rest = (0, _objectWithoutProperties2.default)(_this$props3, _excluded);
      var classes = (0, _classnames.default)('rd-select-dropdown__item', className, {
        'is-selected': this.isSelected(),
        'is-disabled': disabled
      });
      var renderChildren = this.getChildren();
      var renderLiProps = (0, _omit.default)(rest, ['value', 'label', 'userDefined']);
      return /*#__PURE__*/React.createElement(_DropdownItem.default, (0, _extends2.default)({}, renderLiProps, {
        style: style,
        className: classes,
        data: this.getChildValue()
      }), /*#__PURE__*/React.createElement("span", null, renderChildren), children !== undefined && multiple && /*#__PURE__*/React.createElement(_Complete.default, {
        className: "rd-select-dropdown__item_right",
        width: 16
      }));
    }
  }]);
  return Option;
}(React.PureComponent), _class2.contextType = _Select.SelectContext, _class2.defaultProps = {
  disabled: false,
  userDefined: false
}, _class2)) || _class;

exports.default = Option;