"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SelectContext = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _input = _interopRequireDefault(require("../input"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _warning2 = _interopRequireDefault(require("../../libs/warning"));

var _Down = _interopRequireDefault(require("net-design-icons/lib/icons/Down"));

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _FormElement = require("../form/FormElement");

var _TagGroup = _interopRequireDefault(require("../tag/TagGroup"));

var _AppendPrepend = _interopRequireDefault(require("../input/AppendPrepend"));

var _FormContext = require("../form/FormContext");

var _Span = _interopRequireDefault(require("../span/Span"));

var _Scroll = _interopRequireDefault(require("../scroll-bar/Scroll"));

var _DropdownMenu = _interopRequireDefault(require("../dropdown/DropdownMenu"));

var _util = require("../table/util");

var _excluded = ["style", "className", "disabled", "multiple", "fitSize", "prepend", "append", "title", "bordered", "searchable", "onCustomSearch"];

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**判断是否是ie环境**/
var isIE = navigator.userAgent.toLowerCase().indexOf('trident') > -1;
var SelectContext = /*#__PURE__*/React.createContext(undefined);
exports.SelectContext = SelectContext;
var Select = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Select, _React$Component);

  var _super = _createSuper(Select);

  /**
   * 构造函数
   * @param props
   */
  function Select(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Select);
    _this = _super.call(this, props);
    _this.state = {
      value: '',
      visible: false,
      hoverIndex: 0,
      optionMinWidth: 200,
      writable: false,
      selectedLabel: '',
      focus: false,
      searchValue: '',
      index: 0,
      allListData: [/*#__PURE__*/React.createElement(React.Fragment, null)],
      showListData: [/*#__PURE__*/React.createElement(React.Fragment, null)],
      isListAdd: false,
      scrollTop: 0
    };
    _this.select = void 0;
    _this.tag = void 0;
    _this.options = [];
    _this.dropdown = /*#__PURE__*/React.createRef();
    _this.dropdownMenu = /*#__PURE__*/React.createRef();
    _this.tagGroup = /*#__PURE__*/React.createRef();
    _this.values = void 0;
    _this.inputRef = /*#__PURE__*/React.createRef();
    _this.userDefined = void 0;
    var multiple = props.multiple,
        value = props.value,
        defaultValue = props.defaultValue;

    if (value === undefined) {
      if (multiple) {
        _this.values = Array.isArray(value) ? value : [];
      } else {
        _this.values = defaultValue;
      }
    }

    return _this;
  }
  /**
   * 处理警告
   */


  (0, _createClass2.default)(Select, [{
    key: "warning",
    value: function warning() {
      var _this$props = this.props,
          value = _this$props.value,
          onChange = _this$props.onChange,
          multiple = _this$props.multiple,
          defaultValue = _this$props.defaultValue;
      (0, _warning2.default)(!(value !== undefined && onChange === undefined), 'Select', 'Failed prop type: You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`.');
      (0, _warning2.default)(!(value !== undefined && defaultValue !== undefined), 'Select', "contains both value and defaultValue props. Select must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props."); //console.log('------------', value !== undefined || !(multiple && Array.isArray(value)));

      (0, _warning2.default)(value !== undefined || !(multiple && Array.isArray(value)), 'Select', 'when multiple mode value must be array');
    }
    /**
     * 加载后
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props2 = this.props,
          prepend = _this$props2.prepend,
          append = _this$props2.append;
      /**排除掉AppendPrepend 的情况**/

      if (prepend === undefined && append === undefined) {
        this.warning();
      }
      /**这个时候得到this.options 应该重新渲染一次**/


      this.forceUpdate();
    }
    /**
     *统一处理change
     */

  }, {
    key: "handleUnifiedChange",
    value: function handleUnifiedChange(e) {
      var _this$props3 = this.props,
          value = _this$props3.value,
          onChange = _this$props3.onChange,
          searchable = _this$props3.searchable,
          multiple = _this$props3.multiple;

      if (value === undefined) {
        this.values = e;

        if (onChange) {
          onChange(e);
        } else {
          this.forceUpdate();
        }
      } else {
        onChange && onChange(e);
      }

      if (searchable && multiple) {
        this.tagGroup.current.handleSearchInput('clear');
      }
    }
    /**
     * 处理option点击
     * @param e
     * @param childProps
     */

  }, {
    key: "handleOptionClick",
    value: function handleOptionClick(e, childProps) {
      e.preventDefault();
      e.stopPropagation();
      var _this$props4 = this.props,
          disabled = _this$props4.disabled,
          multiple = _this$props4.multiple,
          propValue = _this$props4.value,
          onOptionClick = _this$props4.onOptionClick;
      onOptionClick && onOptionClick(e, childProps);

      if (disabled) {
        return;
      }

      var childValue = childProps.data;
      var userDefined = childValue.userDefined;
      this.userDefined = userDefined;

      if (userDefined) {
        this.inputRef.current.focus();
        this.setState({
          writable: true
        });
        return;
      } else {
        this.setState({
          writable: false
        });
      }

      var isAdd = true;
      var index = -1;
      var value;

      if (multiple) {
        var selectedTags = propValue || []; //查找重复的对象的索引

        index = selectedTags.findIndex(function (tag) {
          return tag.value === childValue.value;
        }); //index = selectedTags.findIndex(tag => tag.value === childValue.value && tag.label === childValue.label);

        if (index !== -1) {
          isAdd = false;
        } //判断是新增还是删除


        isAdd ? selectedTags.push(childValue) : selectedTags.splice(index, 1);
        value = selectedTags;
      } else {
        value = childValue.value;
        this.dropdown.current.emitClose();
      }

      this.handleUnifiedChange(value);
    }
    /**
     * 处理input中的select点击
     * @param e
     */

  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var _this$props5 = this.props,
          disabled = _this$props5.disabled,
          readOnly = _this$props5.readOnly,
          onClick = _this$props5.onClick,
          multiple = _this$props5.multiple,
          searchable = _this$props5.searchable;

      if (disabled || readOnly) {
        return;
      }

      var optionMinWidth = this.select.getBoundingClientRect().width;

      if (isIE && e.target.contains(this.inputRef.current)) {
        this.inputRef.current.focus();
      }

      if (multiple && searchable) {
        this.tagGroup.current.handleSearchInput('focus');
      }

      this.setState({
        optionMinWidth: optionMinWidth
      });
      onClick && onClick(e);
    }
    /**
     * 处理tag关闭
     * @param tag
     * @param e
     */

  }, {
    key: "handleTagClose",
    value: function handleTagClose(tag, e) {
      this.handleUnifiedChange(tag);
      e.stopPropagation();
      e.preventDefault();
    }
    /***
     * 处理打开或者关闭
     */

  }, {
    key: "handleOpenClose",
    value: function handleOpenClose(visible) {
      this.setState({
        visible: visible
      });
      var _this$props6 = this.props,
          multiple = _this$props6.multiple,
          searchable = _this$props6.searchable;

      if (searchable && multiple && !visible) {
        this.tagGroup.current.handleSearchInput('clear');
      }
    }
    /**
     *
     * @param e
     */

  }, {
    key: "handleClear",
    value: function handleClear(e) {
      var onChange = this.props.onChange;
      onChange && onChange([]);
      e.stopPropagation();
      e.preventDefault();
    }
    /**
     * 处理失去焦点事件
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      var _this2 = this;

      var _this$props7 = this.props,
          multiple = _this$props7.multiple,
          onBlur = _this$props7.onBlur;
      e.persist();
      var dropdownMenu = (0, _reactDom.findDOMNode)(this.dropdownMenu.current);

      var fn = function fn(ev) {
        document.removeEventListener('click', fn);

        if (!(dropdownMenu && dropdownMenu.contains(ev.target || ev.srcElement))) {
          onBlur && onBlur(e);
        } else {
          _this2.inputRef.current._customFocus = true;
          _this2.inputRef.current && _this2.inputRef.current.focus();
        }
      };
      /**在鼠标点击弹出框的时候不应该认为失去焦点**/


      document.addEventListener('click', fn);

      if (multiple) {
        return;
      }

      this.setState({
        focus: false
      });
    }
    /**
     * 处理获得焦点
     */

  }, {
    key: "handleFocus",
    value: function handleFocus(e) {
      var _this3 = this;

      var _this$props8 = this.props,
          multiple = _this$props8.multiple,
          onFocus = _this$props8.onFocus;
      var target = e.target;

      if (target._customFocus) {
        delete target._customFocus;
      } else {
        onFocus && onFocus(e);
      }

      if (multiple) {
        return;
      }

      this.setState({
        focus: true
      }, function () {
        if (_this3.userDefined) {
          _this3.inputRef.current.select();
        }
      });
    }
    /**
     * 处理input onChange
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(e) {
      var readOnly = this.props.readOnly;

      if (!readOnly) {
        this.handleUnifiedChange(e.target.value);
      }
    }
    /**focus图标的处理 */

  }, {
    key: "handleArrowTriggerFocus",
    value: function handleArrowTriggerFocus(e) {
      var visible = this.state.visible;

      if (visible) {
        //说明是focus，现在要变为blur
        this.inputRef.current.blur();
      } else {
        this.inputRef.current.focus();
      }
    }
    /**搜索事件处理 */

  }, {
    key: "handleSearchChange",
    value: function handleSearchChange(value) {
      this.setState({
        searchValue: value
      });
    }
    /**
     * 渲染options
     */

  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this$state = this.state,
          optionMinWidth = _this$state.optionMinWidth,
          searchValue = _this$state.searchValue,
          showListData = _this$state.showListData;
      var _this$props9 = this.props,
          children = _this$props9.children,
          maxHeight = _this$props9.maxHeight,
          maxWidth = _this$props9.maxWidth,
          size = _this$props9.size,
          useCustomScrollBar = _this$props9.useCustomScrollBar,
          searchable = _this$props9.searchable,
          multiple = _this$props9.multiple,
          onCustomSearch = _this$props9.onCustomSearch,
          listHeight = _this$props9.listHeight,
          itemHeight = _this$props9.itemHeight,
          customOption = _this$props9.customOption,
          customOptionTemp = _this$props9.customOptionTemp,
          onCustomOptionSearch = _this$props9.onCustomOptionSearch;
      var style = {
        minWidth: optionMinWidth
      };

      if (typeof maxHeight !== 'undefined') {
        style.maxHeight = maxHeight;
      }

      if (typeof maxWidth !== 'undefined') {
        style.maxWidth = maxWidth;
      } // 原来的搜索 返回 React.ReactNode


      var childrenArr = [];

      if (multiple && searchable && searchValue && !customOption) {
        if (onCustomSearch) {
          childrenArr = onCustomSearch(searchValue, children);
        } else {
          childrenArr = React.Children.map(children, function (child) {
            var childMsg = (0, _util.getTdValue)(child) || '';

            if (childMsg.toLowerCase().includes(searchValue.toLowerCase())) {
              return child;
            }
          });
        }
      } else {
        childrenArr = children;
      } // 现在的搜索


      var customOptionArr = [];

      if (multiple && searchable && searchValue && customOption) {
        if (onCustomOptionSearch) {
          customOptionArr = onCustomOptionSearch(searchValue, customOption);
        } else {
          var searchValLower = searchValue.toLowerCase();
          customOptionArr = customOption.filter(function (item) {
            return item.label.toLowerCase().includes(searchValLower) || item.letter.toLowerCase().includes(searchValLower);
          });
        }
      } else {
        customOptionArr = customOption;
      }

      return useCustomScrollBar ? /*#__PURE__*/React.createElement(_DropdownMenu.default, {
        useCustomScrollBar: useCustomScrollBar,
        ref: this.dropdownMenu,
        className: (0, _classnames.default)('rd-select-dropdown', 'rd-select-scroll', size && "rd-select-dropdown--".concat(size)),
        style: _objectSpread({}, style),
        listHeight: listHeight,
        itemHeight: itemHeight,
        customOption: customOptionArr,
        customOptionTemp: customOptionTemp
      }, childrenArr) : /*#__PURE__*/React.createElement(_Scroll.default, null, /*#__PURE__*/React.createElement(_DropdownMenu.default, {
        ref: this.dropdownMenu,
        className: (0, _classnames.default)('rd-select-dropdown', 'rd-select-scroll', size && "rd-select-dropdown--".concat(size)),
        style: _objectSpread({}, style),
        listHeight: listHeight,
        itemHeight: itemHeight,
        customOption: customOptionArr,
        customOptionTemp: customOptionTemp
      }, childrenArr));
    }
    /**
     * 通过value得到label
     * @param value
     */

  }, {
    key: "getLabelByValue",
    value: function getLabelByValue(value) {
      if (value === undefined) {
        return '';
      }

      var _this$state2 = this.state,
          writable = _this$state2.writable,
          focus = _this$state2.focus;

      if (writable && focus) {
        return value + '';
      }

      var options = this.options;
      var formatter = this.props.formatter;
      var userDefined = options.find(function (item) {
        return item.userDefined;
      });
      /**用全等去查找**/

      var option = options.find(function (item) {
        return item.value === value;
      });
      /**说明是自定义**/

      if (!option) {
        if (userDefined) {
          return formatter(value);
        }

        return value + '';
      }

      return option.label + '';
    }
    /**
     * 获得Value
     */

  }, {
    key: "getTagValue",
    value: function getTagValue() {
      var multiple = this.props.multiple;
      var value = this.props.value;

      if (value === undefined) {
        return this.values;
      } else {
        if (multiple) {
          if (!Array.isArray(value)) {
            value = []; // warning(
            //     false,
            //     'Select',
            //     'when multiple mode value must be array'
            // );
          }
        }

        return value;
      }
    }
    /**
     * 渲染input
     */

  }, {
    key: "renderInput",
    value: function renderInput() {
      var _this4 = this;

      var _this$state3 = this.state,
          visible = _this$state3.visible,
          writable = _this$state3.writable;
      var _this$props10 = this.props,
          disabled = _this$props10.disabled,
          multiple = _this$props10.multiple,
          name = _this$props10.name,
          size = _this$props10.size,
          status = _this$props10.status,
          fitSize = _this$props10.fitSize,
          readOnly = _this$props10.readOnly,
          prefix = _this$props10.prefix,
          suffix = _this$props10.suffix,
          placeholder = _this$props10.placeholder,
          popoverClassName = _this$props10.popoverClassName,
          getContainer = _this$props10.getContainer,
          placement = _this$props10.placement,
          strategy = _this$props10.strategy,
          allowClear = _this$props10.allowClear,
          offset = _this$props10.offset,
          firstRender = _this$props10.firstRender,
          arrowTriggerFocus = _this$props10.arrowTriggerFocus,
          searchable = _this$props10.searchable,
          formatter = _this$props10.formatter,
          key = _this$props10.key,
          ellipsis = _this$props10.ellipsis;

      var _readOnly = readOnly !== undefined ? readOnly : !writable;

      var renderSuffix = [];
      var arrowDownLineProps = {};

      if (arrowTriggerFocus) {
        arrowDownLineProps = {
          onClick: this.handleArrowTriggerFocus
        };
      }

      var suffixIcon = /*#__PURE__*/React.createElement(_Down.default, (0, _extends2.default)({}, arrowDownLineProps, {
        className: (0, _classnames.default)('arrow-down', {
          'arrow-up': visible
        })
      }));

      if (suffix) {
        if (Array.isArray(suffix)) {
          renderSuffix = [].concat((0, _toConsumableArray2.default)(suffix), [{
            className: 'rd-select-arrow',
            children: suffixIcon
          }]);
        } else {
          renderSuffix = [suffix, {
            className: 'rd-select-arrow',
            children: suffixIcon
          }];
        }
      } else {
        renderSuffix = [{
          className: 'rd-select-arrow',
          children: suffixIcon
        }];
      }

      var input = !multiple ? /*#__PURE__*/React.createElement(_input.default, {
        ref: this.inputRef,
        bordered: false,
        placeholder: placeholder,
        readOnly: _readOnly,
        disabled: disabled,
        value: this.getLabelByValue(this.getTagValue()),
        size: size,
        allowClear: allowClear,
        fitSize: fitSize,
        unselectable: "on" //ie readonly 一样会有聚焦的表现形式 所以加上这么一句话
        ,
        suffix: renderSuffix,
        prefix: prefix,
        status: status,
        onClear: this.handleClear,
        onChange: this.handleChange,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        name: name,
        ellipsis: ellipsis
      }) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_TagGroup.default, {
        visible: visible,
        ref: this.tagGroup,
        searchable: searchable,
        readOnly: _readOnly,
        bordered: false,
        disabled: disabled,
        placeholder: placeholder,
        closable: _readOnly,
        size: size,
        name: name,
        suffix: renderSuffix,
        prefix: prefix,
        allowClear: allowClear,
        value: formatter ? formatter(this.getTagValue()) : this.getTagValue(),
        onChange: this.handleTagClose,
        onSearchOptions: this.handleSearchChange
      }));
      return /*#__PURE__*/React.createElement(_dropdown.default, {
        ref: this.dropdown,
        size: size,
        key: key,
        offset: offset,
        clickTriggerRevert: true,
        hideOnClick: !multiple,
        className: popoverClassName,
        onItemClick: this.handleOptionClick,
        overlay: this.renderOptions(),
        getContainer: getContainer,
        placement: placement,
        firstRender: firstRender,
        getOptions: function getOptions(options) {
          _this4.options = options.map(function (item) {
            return item.data;
          });
        },
        strategy: strategy,
        onOpen: function onOpen() {
          return _this4.handleOpenClose(true);
        },
        onClose: function onClose() {
          return _this4.handleOpenClose(false);
        },
        disabled: disabled || readOnly
      }, input);
    }
    /**
     * 主动关闭弹出框供外部调用
     */

  }, {
    key: "emitClose",
    value: function emitClose() {
      this.setState({
        visible: false
      });
      this.dropdown.current.emitClose();
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$context,
          _this5 = this;

      var visible = this.state.visible;
      var _this$props11 = this.props,
          style = _this$props11.style,
          className = _this$props11.className,
          disabled = _this$props11.disabled,
          multiple = _this$props11.multiple,
          fitSize = _this$props11.fitSize,
          prepend = _this$props11.prepend,
          append = _this$props11.append,
          title = _this$props11.title,
          bordered = _this$props11.bordered,
          searchable = _this$props11.searchable,
          onCustomSearch = _this$props11.onCustomSearch,
          rest = (0, _objectWithoutProperties2.default)(_this$props11, _excluded);

      if (prepend !== undefined || append !== undefined) {
        return /*#__PURE__*/React.createElement(_AppendPrepend.default, (0, _extends2.default)({}, this.props, {
          component: Select
        }));
      }

      var size = this.props.size || ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.size);
      var classes = (0, _classnames.default)('rd-select', size && "rd-select--".concat(size), className, {
        'is-bordered': bordered,
        'is-full': !fitSize,
        'is-multiple': multiple,
        'is-disabled': disabled,
        'is-active': visible
      });
      /**使传入onMouseUp等事件时也能有响应**/

      var renderDivProps = (0, _omit.default)(rest, ['size', 'allowClear', 'prefix', 'suffix', 'name', 'popoverClassName', 'status', 'value', 'placeholder', 'onClick', 'onChange', 'getContainer', 'offset', 'formatter', 'firstRender', 'defaultValue', 'onOptionClick', 'onBlur', 'onFocus', 'maxHeight', 'arrowTriggerFocus', 'useCustomScrollBar', 'maxWidth', 'listHeight', 'customOption', 'itemHeight', 'customOptionTemp', 'onCustomOptionSearch']);
      var main = /*#__PURE__*/React.createElement(_FormContext.SizeContext.Provider, {
        value: {
          size: size
        }
      }, /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        ref: function ref(_ref) {
          return _this5.select = _ref;
        },
        className: classes,
        style: _objectSpread({}, style)
      }, renderDivProps, {
        onClick: this.handleClick
      }), /*#__PURE__*/React.createElement(SelectContext.Provider, {
        value: {
          multiple: multiple,
          value: this.getTagValue(),
          options: this.options
        }
      }, this.renderInput())));

      if (title === undefined || title === '') {
        return main;
      } else {
        return /*#__PURE__*/React.createElement(_Span.default, {
          needWrapper: false,
          title: title
        }, main);
      }
    }
  }]);
  return Select;
}(React.Component), _class2.defaultProps = {
  multiple: false,
  bordered: true,
  disabled: false,
  useCustomScrollBar: false,
  //maxHeight: 500,
  size: 'medium',
  fitSize: false,
  getContainer: document.body,
  offset: [-1, 0],
  arrowTriggerFocus: false,
  searchable: false,
  formatter: function formatter(value) {
    return value;
  }
}, _class2.Option = void 0, _class2.contextType = _FormContext.SizeContext, _class2)) || _class) || _class);
exports.default = Select;