"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _tooltip = _interopRequireDefault(require("../tooltip"));

var _input = _interopRequireDefault(require("../input"));

var _button = _interopRequireDefault(require("../button"));

var _Minus = _interopRequireDefault(require("net-design-icons/lib/icons/Minus"));

var _Add = _interopRequireDefault(require("net-design-icons/lib/icons/Add"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormElement = require("../form/FormElement");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Slider = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Slider, _React$PureComponent);

  var _super = _createSuper(Slider);

  function Slider() {
    var _this;

    (0, _classCallCheck2.default)(this, Slider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      //propsValue: 0,
      //value: 0,
      //inputValue: '0',
      dragging: false,
      disabled: false
    };
    _this.trackPosition = {
      pageX: 0,
      startPosition: 0
    };
    _this.sliderRailRef = /*#__PURE__*/React.createRef();
    _this.handleMouseMove = (0, _util.throttle)(function (event) {
      //要防抖，节流
      event.preventDefault();
      var dragging = _this.state.dragging;

      if (!dragging) {
        return;
      }

      _this.setPositionValue(event);
    }, 50);
    _this.handleTouchMove = (0, _util.throttle)(function (event) {
      //要防抖，节流
      event.preventDefault();
      var dragging = _this.state.dragging;

      if (!dragging) {
        return;
      }

      _this.setPositionValue(event);
    }, 50);
    return _this;
  }

  (0, _createClass2.default)(Slider, [{
    key: "componentDidMount",
    value:
    /**初始化后要更新滑块位置 */
    function componentDidMount() {
      this.setTrackPosition();
    }
  }, {
    key: "isTouchEvent",
    value:
    /**判断是否为touch事件 */
    function isTouchEvent(e) {
      return e.touches && e.touches.length > 0;
    }
    /**滑块事件 */

  }, {
    key: "handleMouseDown",
    value: function handleMouseDown(event) {
      event.preventDefault();
      var disabled = this.state.disabled;

      if (disabled) {
        return;
      }

      this.setHandlePosition(event, 'mouse');
      this.addDocumentEvent('mouse');
    }
    /**设置滑块的位置 */

  }, {
    key: "setPositionValue",
    value: function setPositionValue(event) {
      var disabled = this.props.disabled;

      if (disabled) {
        return;
      }

      var _this$trackPosition = this.trackPosition,
          pageX = _this$trackPosition.pageX,
          startPosition = _this$trackPosition.startPosition;
      var currentX = this.isTouchEvent(event) ? event.touches[0].pageX : event.clientX;
      var diff = (currentX - pageX) / this.getSliderWidth() * 100;
      var currPosition = startPosition + diff;

      if (currPosition < 0) {
        currPosition = 0;
      } else if (currPosition > 100) {
        currPosition = 100;
      }

      this.trackPosition.startPosition = currPosition;
      this.trackPosition.pageX = currentX;
      return this.setSliderPosition(currPosition);
    }
    /**处理移动事件 */

  }, {
    key: "handleMouseUp",
    value:
    /**鼠标松开事件处理 */
    function handleMouseUp() {
      var _this2 = this;

      //是为了在节流的最后一个处理完成后再取消事件
      var dragging = this.state.dragging;
      var onEnd = this.props.onEnd;

      if (dragging) {
        setTimeout(function () {
          var value = _this2.setSliderPosition(_this2.trackPosition.startPosition);

          _this2.setState({
            dragging: false
          });

          _this2.removeDocumentEvent('mouse');

          onEnd && onEnd(value);
        }, 100);
      }
    }
    /**移动端事件处理 */

  }, {
    key: "handleTouchStart",
    value: function handleTouchStart(event) {
      if (this.isTouchEvent(event)) {
        event.preventDefault();
        var disabled = this.state.disabled;

        if (disabled) {
          return;
        }

        this.setHandlePosition(event, 'touch');
        this.addDocumentEvent('touch');
      }
    }
  }, {
    key: "handleTouchEnd",
    value:
    /**移动结束 */
    function handleTouchEnd() {
      var _this3 = this;

      //是为了在节流的最后一个处理完成后再取消事件
      var dragging = this.state.dragging;
      var onEnd = this.props.onEnd;

      if (dragging) {
        setTimeout(function () {
          var value = _this3.setSliderPosition(_this3.trackPosition.startPosition);

          _this3.setState({
            dragging: false
          });

          _this3.removeDocumentEvent('touch');

          onEnd && onEnd(value);
        }, 100);
      }
    }
    /**设置鼠标按下滑块位置 */

  }, {
    key: "setHandlePosition",
    value: function setHandlePosition(event, type) {
      this.trackPosition = {
        pageX: type === 'mouse' ? event.clientX : event.touches[0].pageX,
        startPosition: this.currSliderPosition()
      };
      this.setState({
        dragging: true
      });
    }
    /**设置滑块的位置，初始化，以及点击按钮时 */

  }, {
    key: "setTrackPosition",
    value: function setTrackPosition(pageX) {
      var currentPercent = this.currSliderPosition();

      if (typeof pageX === 'undefined') {
        //根据slider的最左侧位置 + 滑块位置
        var sliderStartX = this.sliderRailRef.current.getBoundingClientRect().left;
        var sliderWidth = this.getSliderWidth();
        this.trackPosition = {
          pageX: sliderStartX + sliderWidth * currentPercent / 100,
          startPosition: currentPercent
        };
      } else {
        this.trackPosition = {
          pageX: pageX,
          startPosition: currentPercent
        };
      }
    }
    /**当前滑块在slider上的百分比值 */

  }, {
    key: "currSliderPosition",
    value: function currSliderPosition() {
      var _this$props = this.props,
          min = _this$props.min,
          max = _this$props.max;
      var value = this.state.value;
      var percent = (value - Number(min)) / (Number(max) - Number(min)) * 100;

      if (percent > 100) {
        return 100;
      } else if (percent < 0) {
        return 0;
      }

      return percent;
    }
    /**根据Position百分比值设置slider的值value */

  }, {
    key: "setSliderPosition",
    value: function setSliderPosition(position) {
      var _this$props2 = this.props,
          min = _this$props2.min,
          max = _this$props2.max,
          step = _this$props2.step,
          onChange = _this$props2.onChange; //每一步长占的宽度（以100表示slider宽度，因为position用的百分比）； px/step

      var lengthPerStep = 100 / ((Number(max) - Number(min)) / Number(step)); // 此位置有多少步，四舍五入

      var steps = Math.round(position / lengthPerStep);
      var value = steps * Number(step) + Number(min);
      this.setState({
        value: value,
        inputValue: value
      });

      if (onChange) {
        onChange(value);
      }

      return value;
    }
    /**slider的实际宽度，px */

  }, {
    key: "getSliderWidth",
    value: function getSliderWidth() {
      if (this.sliderRailRef) {
        return this.sliderRailRef.current.offsetWidth;
      }

      return 100;
    }
    /**添加事件 */

  }, {
    key: "addDocumentEvent",
    value: function addDocumentEvent(type) {
      if (type === 'mouse') {
        window.addEventListener('mousemove', this.handleMouseMove);
        window.addEventListener('mouseup', this.handleMouseUp);
      } else {
        window.addEventListener('touchmove', this.handleTouchMove);
        window.addEventListener('touchend', this.handleTouchEnd);
      }
    }
    /**移除事件 */

  }, {
    key: "removeDocumentEvent",
    value: function removeDocumentEvent(type) {
      if (type === 'mouse') {
        window.removeEventListener('mousemove', this.handleMouseMove);
        window.removeEventListener('mouseup', this.handleMouseUp);
      } else {
        window.removeEventListener('touchmove', this.handleTouchMove);
        window.removeEventListener('touchend', this.handleTouchEnd);
      }
    }
    /**点击slider事件 */

  }, {
    key: "handleClickSlider",
    value: function handleClickSlider(event) {
      var onEnd = this.props.onEnd;
      var value = this.setPositionValue(event);
      onEnd && onEnd(value);
    }
    /**处理输入框失去焦点操作 */

  }, {
    key: "handleInputBlur",
    value: function handleInputBlur(event) {
      //失去焦点才开始
      var value = Number(event.target.value);

      if (this.validValue(value)) {
        this.setState({
          value: value
        });
      } else {
        var _value = this.state.value;
        this.setState({
          inputValue: _value
        });
      }
    }
    /**输入框内容改变处理 */

  }, {
    key: "handleInputChange",
    value: function handleInputChange(event) {
      var value = Number(event.target.value);

      if (this.validValue(value)) {
        this.setState({
          inputValue: value
        });
      }
    }
    /**处理减操作 */

  }, {
    key: "handleMinus",
    value: function handleMinus() {
      var _this$props$onEnd, _this$props4;

      var _this$props3 = this.props,
          min = _this$props3.min,
          step = _this$props3.step;
      var value = this.state.value;
      var opVal = value - Number(step);

      if (opVal < min) {
        this.setState({
          value: Number(min),
          inputValue: min
        });
      } else {
        this.setState({
          value: opVal,
          inputValue: opVal
        });
      }

      (_this$props$onEnd = (_this$props4 = this.props).onEnd) === null || _this$props$onEnd === void 0 ? void 0 : _this$props$onEnd.call(_this$props4, value);
    }
    /**处理加操作 */

  }, {
    key: "handlePlus",
    value: function handlePlus() {
      var _this$props$onEnd2, _this$props6;

      var _this$props5 = this.props,
          max = _this$props5.max,
          step = _this$props5.step;
      var value = this.state.value;
      var opVal = value + Number(step);

      if (opVal > max) {
        this.setState({
          value: Number(max),
          inputValue: max
        });
      } else {
        this.setState({
          value: opVal,
          inputValue: opVal
        });
      }

      (_this$props$onEnd2 = (_this$props6 = this.props).onEnd) === null || _this$props$onEnd2 === void 0 ? void 0 : _this$props$onEnd2.call(_this$props6, value);
    }
    /**判断value值是否有效 */

  }, {
    key: "validValue",
    value: function validValue(value) {
      var _this$props7 = this.props,
          min = _this$props7.min,
          max = _this$props7.max,
          step = _this$props7.step;
      var val = Number(value);

      if (val >= Number(min) && val <= Number(max) && val % Number(step) === 0) {
        return true;
      } else {
        return false;
      }
    }
    /**判断是否有额外信息 */

  }, {
    key: "hasExtraInfo",
    value: function hasExtraInfo() {
      var _this$props8 = this.props,
          rangeInfoPre = _this$props8.rangeInfoPre,
          rangeInfoSuffix = _this$props8.rangeInfoSuffix,
          hasInput = _this$props8.hasInput,
          hasInputIcon = _this$props8.hasInputIcon,
          extraInfo = _this$props8.extraInfo;
      return !!extraInfo || !!rangeInfoPre || !!rangeInfoSuffix || hasInput || hasInputIcon;
    }
    /**生成Input输入框 */

  }, {
    key: "generateInput",
    value: function generateInput(prefixCls) {
      var _this$props9 = this.props,
          hasInput = _this$props9.hasInput,
          hasInputIcon = _this$props9.hasInputIcon,
          min = _this$props9.min,
          max = _this$props9.max;
      var _this$state = this.state,
          disabled = _this$state.disabled,
          value = _this$state.value,
          inputValue = _this$state.inputValue;
      var minusClassString = (0, _classnames.default)("".concat(prefixCls, "-input-icon-minus"));
      var minDisabled = disabled || value === Number(min);
      var plusClassString = (0, _classnames.default)("".concat(prefixCls, "-input-icon-plus"));
      var maxDisabled = disabled || value === Number(max);

      if (hasInputIcon) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-input-icon")
        }, /*#__PURE__*/React.createElement(_input.default, {
          prepend: /*#__PURE__*/React.createElement(_button.default, {
            prefixIcon: /*#__PURE__*/React.createElement(_Minus.default, null),
            disabled: minDisabled,
            className: minusClassString,
            onClick: this.handleMinus
          }),
          append: /*#__PURE__*/React.createElement(_button.default, {
            prefixIcon: /*#__PURE__*/React.createElement(_Add.default, null),
            disabled: maxDisabled,
            className: plusClassString,
            onClick: this.handlePlus
          }),
          className: "".concat(prefixCls, "-input"),
          value: inputValue,
          onChange: this.handleInputChange,
          onBlur: this.handleInputBlur,
          disabled: disabled
        }));
      } else if (hasInput) {
        return /*#__PURE__*/React.createElement(_input.default, {
          className: "".concat(prefixCls, "-input"),
          value: inputValue,
          onChange: this.handleInputChange,
          onBlur: this.handleInputBlur,
          disabled: disabled
        });
      } else {
        return null;
      }
    }
    /**生成JSX */

  }, {
    key: "render",
    value: function render() {
      var _this$props10 = this.props,
          tooltipVisible = _this$props10.tooltipVisible,
          className = _this$props10.className,
          style = _this$props10.style,
          customizePrefixCls = _this$props10.prefixCls,
          rangeInfoPre = _this$props10.rangeInfoPre,
          rangeInfoSuffix = _this$props10.rangeInfoSuffix,
          extraInfo = _this$props10.extraInfo;
      var _this$state2 = this.state,
          value = _this$state2.value,
          disabled = _this$state2.disabled,
          dragging = _this$state2.dragging; //(max - min )/step 必须为正数，否则给予提示信息

      var prefixCls = (0, _util.getPrefixCls)('slider', customizePrefixCls);
      var classString = (0, _classnames.default)(prefixCls, disabled && "is-disabled", dragging && "is-dragging", this.hasExtraInfo() && 'has-extra-info', className);
      var trackStyle = {
        width: "".concat(this.currSliderPosition(), "%")
      };
      var handleStyle = {
        left: "".concat(this.currSliderPosition(), "%")
      };
      return /*#__PURE__*/React.createElement("div", {
        className: classString,
        style: style
      }, rangeInfoPre && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-info")
      }, rangeInfoPre), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-line")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-rail"),
        ref: this.sliderRailRef,
        onClick: this.handleClickSlider
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-track"),
        style: trackStyle,
        onClick: this.handleClickSlider
      }), tooltipVisible ? /*#__PURE__*/React.createElement(_tooltip.default, {
        title: value,
        theme: "dark",
        placement: "top"
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-handle"),
        style: handleStyle,
        onMouseDown: this.handleMouseDown,
        onTouchStart: this.handleTouchStart
      })) : /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-handle"),
        style: handleStyle,
        onTouchStart: this.handleTouchStart,
        onMouseDown: this.handleMouseDown
      })), extraInfo && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-info")
      }, extraInfo(value)), rangeInfoSuffix && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-info")
      }, rangeInfoSuffix), this.generateInput(prefixCls));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**监听value，disabled状态 */
    function getDerivedStateFromProps(nextProps, prevState) {
      var value = nextProps.value,
          disabled = nextProps.disabled,
          min = nextProps.min,
          max = nextProps.max;
      var propsValue = prevState.propsValue,
          stateDisabled = prevState.disabled;

      if (Number(value) !== propsValue || disabled !== stateDisabled) {
        var newState = {};
        var val = Number(value);
        var minVal = Number(min);
        var maxVal = Number(max);

        if (val < minVal) {
          val = minVal;
        } else if (val > maxVal) {
          val = maxVal;
        }

        newState.propsValue = val;
        newState.value = val;
        newState.inputValue = val;
        newState.disabled = disabled;
        return newState;
      }

      return null;
    }
  }]);
  return Slider;
}(React.PureComponent), _class2.defaultProps = {
  //value: 0,
  min: 0,
  max: 100,
  step: 1,
  disabled: false,
  tooltipVisible: true
}, _class2)) || _class) || _class);
exports.default = Slider;