import * as React from 'react';
import { GetContainer } from "../portal/Portal";
interface SpanProps extends Omit<React.HTMLAttributes<HTMLSpanElement>, 'title'> {
    /**允许使用/n换行**/
    title?: React.ReactNode;
    maxWidth?: number;
    style?: React.CSSProperties;
    className?: string;
    /** 容器 默认为body**/
    getContainer?: GetContainer;
    needWrapper?: boolean;
}
interface SpanState {
    visible?: boolean;
    clientX?: number;
    clientY?: number;
}
export default class Span extends React.Component<SpanProps, SpanState> {
    state: SpanState;
    private event;
    private el;
    private timer;
    static defaultProps: {
        needWrapper: boolean;
        getContainer: HTMLElement;
    };
    private _isMounted;
    /**
     *安全的設置state
     * @param state
     */
    safeSetState(state: SpanState): void;
    /**
     * 挂载后
     **/
    componentDidMount(): void;
    /**
     *处理滚动
     */
    wheelHandler(): void;
    /**
     * 鼠标移入目标
     */
    handleMouseOver(e: React.MouseEvent<HTMLSpanElement>): void;
    /**
     *处理鼠标移动
     * @param e
     */
    handleMouseMove(e: MouseEvent): void;
    /**
     *处理鼠标离开目标
     */
    handleMouseOut(e: React.MouseEvent<HTMLSpanElement>): void;
    /**
     * 挂载完成
     */
    componentWillUnmount(): void;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
