"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _handler = _interopRequireDefault(require("../handler"));

var _Portal = _interopRequireDefault(require("../portal/Portal"));

var _excluded = ["children", "title", "style", "className", "needWrapper", "getContainer"];

var _class, _class2, _class3, _class4;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var SpanPopover = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(SpanPopover, _React$Component);

  var _super = _createSuper(SpanPopover);

  function SpanPopover() {
    var _this;

    (0, _classCallCheck2.default)(this, SpanPopover);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.ref = void 0;
    _this.state = {
      width: 0,
      height: 0
    };
    return _this;
  }

  (0, _createClass2.default)(SpanPopover, [{
    key: "componentDidMount",
    value:
    /**
     * 初次加载
     */
    function componentDidMount() {
      if (process.env.NODE_ENV !== 'test') {
        (0, _warning.default)((0, _util.isDisplayNone)(this.ref), 'Span', "Span\u6216\u8005Span\u7684\u7236\u7C7B\u4E0D\u53EF\u89C1 \u5BFC\u81F4\u539F\u56E0\u53EF\u80FD\u662F\u4F60\u5728Span\u6216\u8005Span\u7684\u7236\u7C7B\u4E0A\u8BBE\u7F6E\u4E86display:none");
      }

      var width = this.getWidth();
      /**该代码必须先于this.getPosition()执行**/

      this.ref.style.width = width;
      var pos = this.getPosition();
      this.ref.style.left = pos.left + 'px';
      this.ref.style.top = pos.top + 'px';
    }
    /**
     *根据clientX,clientY设置位置
     */

  }, {
    key: "getPosition",
    value: function getPosition() {
      var _this$props = this.props,
          clientX = _this$props.clientX,
          clientY = _this$props.clientY;
      var clientRect = this.ref.getBoundingClientRect();
      var widowWidth = top.innerWidth;
      var widowHeight = top.innerHeight;
      var res = {
        left: clientX,
        top: clientY
      };
      /**在前面**/

      if (clientX > widowWidth - clientX) {
        res.left = clientX - clientRect.width - 10;
        /**'在后面'**/
      } else {
        res.left = clientX + 10;
      }
      /**在上面**/


      if (widowHeight - clientY < clientRect.height + 15) {
        res.top = clientY - clientRect.height - 10;
      } else {
        res.top = clientY + 10;
      }

      return res;
    }
    /**
     * 得到最大宽度
     */

  }, {
    key: "getWidth",
    value: function getWidth() {
      var clientRect = this.ref.getBoundingClientRect();
      var clientX = this.props.clientX;
      var widowWidth = top.innerWidth;
      var computedWidth;

      if (clientX >= widowWidth - clientX) {
        computedWidth = clientX - 20;
      } else {
        computedWidth = widowWidth - clientX - 30;
      }

      var style = getComputedStyle(this.ref);

      var getComputedWidth = function getComputedWidth() {
        //ie内核
        if (navigator.userAgent.indexOf('Trident') > -1) {
          return computedWidth - parseFloat(style.paddingLeft) - parseFloat(style.paddingRight) - parseFloat(style.borderLeftWidth) - parseFloat(style.borderRightWidth);
        } else {
          return computedWidth;
        }
      };

      return clientRect.width < computedWidth ? style.width : getComputedWidth() + 'px';
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          title = _this$props2.title,
          maxWidth = _this$props2.maxWidth;
      return /*#__PURE__*/React.createElement("div", {
        className: "rd-span",
        ref: function ref(_ref) {
          return _this2.ref = _ref;
        },
        style: {
          boxSizing: 'content-box',
          position: 'fixed',
          maxWidth: maxWidth
        }
      }, title);
    }
  }]);
  return SpanPopover;
}(React.Component), _class2.defaultProps = {
  maxWidth: 700
}, _class2)) || _class;

var Span = (0, _autoBind.default)(_class3 = (_class4 = /*#__PURE__*/function (_React$Component2) {
  (0, _inherits2.default)(Span, _React$Component2);

  var _super2 = _createSuper(Span);

  function Span() {
    var _this3;

    (0, _classCallCheck2.default)(this, Span);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    _this3.state = {
      visible: false,
      clientX: 0,
      clientY: 0
    };
    _this3.event = void 0;
    _this3.el = void 0;
    _this3.timer = void 0;
    _this3._isMounted = false;
    return _this3;
  }

  (0, _createClass2.default)(Span, [{
    key: "safeSetState",
    value:
    /**
     *安全的設置state
     * @param state
     */
    function safeSetState(state) {
      this._isMounted && this.setState(state);
    }
    /**
     * 挂载后
     **/

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;
    }
    /**
     *处理滚动
     */

  }, {
    key: "wheelHandler",
    value: function wheelHandler() {
      if (this._isMounted) {
        this.safeSetState({
          visible: false
        });
      }

      (0, _util.removeEvent)(document, 'wheel', this.wheelHandler);
    }
    /**
     * 鼠标移入目标
     */

  }, {
    key: "handleMouseOver",
    value: function handleMouseOver(e) {
      var _this4 = this;

      /**为了获取鼠标在500毫秒后的位置**/
      (0, _util.addEvent)(document, 'mousemove', this.handleMouseMove);
      /**500毫秒后设置位置**/

      this.timer = setTimeout(function () {
        if (_this4._isMounted && _this4.el && _this4.event && _this4.el.contains(_this4.event.target)) {
          _this4.safeSetState({
            visible: true,
            clientX: _this4.event.clientX,
            clientY: _this4.event.clientY
          });
          /**为什么不用scroll 是因为如果dom上有dom设置了overflow=scroll等就不会讲事件冒泡到document上了**/


          (0, _util.addEvent)(document, 'wheel', _this4.wheelHandler);
        }

        (0, _util.removeEvent)(document, 'mousemove', _this4.handleMouseMove);
      }, 500);
      var onMouseOver = this.props.onMouseOver;
      onMouseOver && onMouseOver(e);
    }
    /**
     *处理鼠标移动
     * @param e
     */

  }, {
    key: "handleMouseMove",
    value: function handleMouseMove(e) {
      this.event = {
        target: e.target || e.srcElement,
        clientX: e.clientX,
        clientY: e.clientY
      };
    }
    /**
     *处理鼠标离开目标
     */

  }, {
    key: "handleMouseOut",
    value: function handleMouseOut(e) {
      (0, _util.removeEvent)(document, 'mousemove', this.handleMouseMove);
      (0, _util.removeEvent)(document, 'wheel', this.wheelHandler);
      this.timer && clearTimeout(this.timer);

      if (this._isMounted) {
        this.safeSetState({
          visible: false,
          clientX: 0,
          clientY: 0
        });
      }

      var onMouseOut = this.props.onMouseOut;
      onMouseOut && onMouseOut(e);
    }
    /**
     * 挂载完成
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _util.removeEvent)(document, 'mousemove', this.handleMouseMove);
      (0, _util.removeEvent)(document, 'wheel', this.wheelHandler);
      this.timer && clearTimeout(this.timer);
      this._isMounted = false;
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props3 = this.props,
          children = _this$props3.children,
          title = _this$props3.title,
          style = _this$props3.style,
          className = _this$props3.className,
          needWrapper = _this$props3.needWrapper,
          getContainer = _this$props3.getContainer,
          rest = (0, _objectWithoutProperties2.default)(_this$props3, _excluded);
      var _this$state = this.state,
          clientX = _this$state.clientX,
          clientY = _this$state.clientY,
          visible = _this$state.visible;

      var props = _objectSpread(_objectSpread({
        ref: function ref(_ref2) {
          _this5.el = _ref2;
        },
        className: className,
        style: style
      }, rest), {}, {
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseOut
      });

      var renderChildren;

      if (needWrapper) {
        renderChildren = /*#__PURE__*/React.createElement("span", props, children);
      } else {
        renderChildren = /*#__PURE__*/React.createElement(_handler.default, props, /*#__PURE__*/React.isValidElement(children) ? children : /*#__PURE__*/React.createElement("span", null, children));
      }

      return /*#__PURE__*/React.createElement(React.Fragment, null, renderChildren, title !== undefined && title !== null && title !== '' && visible && /*#__PURE__*/React.createElement(_Portal.default, {
        getContainer: getContainer
      }, /*#__PURE__*/React.createElement(SpanPopover, {
        title: title,
        clientY: clientY,
        clientX: clientX
      })));
    }
  }]);
  return Span;
}(React.Component), _class4.defaultProps = {
  needWrapper: true,
  getContainer: document.body
}, _class4)) || _class3;

exports.default = Span;