/// <reference types="node" />
import * as React from 'react';
import { Size } from '../../libs/types';
export interface RotateProps {
    /**是否旋转 */
    loading?: boolean;
    /**图标大小 , 'large', 'medium', 'small'*/
    size?: Size;
    /**旋转时间 */
    duration?: number;
    /**每次动画旋转角度间隔时间，单位毫秒 */
    interval?: number;
    /**每次旋转角度，默认为10 */
    rotateDeg?: number;
    /**开始旋转角度，默认为0 */
    startIndex?: number;
    /**旋转结束角度，默认为一圈，360 */
    /**在rotateDeg为正数时，startIndex必须必endIndex小，为负数时，startIndex必须必endIndex大，否则不生效（startIndex会一直递增） */
    endIndex?: number;
    style?: React.CSSProperties;
    children?: any;
    className?: string;
    prefixCls?: string;
    forbbidenIE9?: boolean;
}
export interface RotateState {
    loading?: boolean;
    startIndex?: number;
}
export default class RotateIcon extends React.Component<RotateProps, RotateState> {
    static defaultProps: {
        startIndex: number;
        endIndex: number;
        rotateDeg: number;
        interval: number;
        duration: number;
        forbbidenIE9: boolean;
    };
    timer: NodeJS.Timeout;
    state: RotateState;
    /**返回当前loading状态 */
    static getDerivedStateFromProps(nextProps: RotateProps, prevState: RotateState): Partial<RotateState>;
    /**若loading变化，则还需要根据loading确认是否重新开始转圈 */
    componentDidUpdate(prevProps: RotateProps): void;
    /**加载成功后开始动画 */
    componentDidMount(): void;
    /** */
    componentWillUnmount(): void;
    /**开始旋转 */
    onStart(): void;
    /**旋转过程 */
    beginRotate(): void;
    /**结束旋转 */
    onEnd(): void;
    /** */
    render(): React.ReactNode;
}
