"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**是否支持animation css属性 */
function supportAnimation() {
  return 'animation' in document.documentElement.style || 'msAnimation' in document.documentElement.style || 'WebkitAnimation' in document.documentElement.style || 'MozAnimation' in document.documentElement.style;
}

var SupportAnimation = supportAnimation();

var RotateIcon = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(RotateIcon, _React$Component);

  var _super = _createSuper(RotateIcon);

  function RotateIcon() {
    var _this;

    (0, _classCallCheck2.default)(this, RotateIcon);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.timer = void 0;
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(RotateIcon, [{
    key: "componentDidUpdate",
    value:
    /**若loading变化，则还需要根据loading确认是否重新开始转圈 */
    function componentDidUpdate(prevProps) {
      var loading = this.state.loading;
      var prevLoading = prevProps.loading;

      if (loading && loading !== prevLoading) {
        this.beginRotate();
      }
    }
    /**加载成功后开始动画 */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.onStart();
    }
    /** */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.onEnd();
    }
    /**开始旋转 */

  }, {
    key: "onStart",
    value: function onStart() {
      var _this2 = this;

      var _this$props = this.props,
          startIndex = _this$props.startIndex,
          endIndex = _this$props.endIndex,
          rotateDeg = _this$props.rotateDeg,
          _this$props$loading = _this$props.loading,
          loading = _this$props$loading === void 0 ? true : _this$props$loading;
      (0, _warning.default)(!(rotateDeg > 0 && startIndex > endIndex), 'RotateIcon', '角度递增时，起始角度不能大于结束角度');
      (0, _warning.default)(!(rotateDeg < 0 && startIndex < endIndex), 'RotateIcon', '角度递减时，起始角度不能小于结束角度');
      this.setState({
        loading: loading,
        startIndex: startIndex
      }, function () {
        _this2.beginRotate();
      });
    }
    /**旋转过程 */

  }, {
    key: "beginRotate",
    value: function beginRotate() {
      var _this3 = this;

      var forbbidenIE9 = this.props.forbbidenIE9;

      if (SupportAnimation && !forbbidenIE9) {
        return;
      }

      if (this.timer !== null) {
        clearInterval(this.timer);
      }

      var currentDuritionTime = 0;
      this.timer = setInterval(function () {
        if (_this3.state && _this3.props) {
          var _this3$state = _this3.state,
              startIndex = _this3$state.startIndex,
              loading = _this3$state.loading;
          var _this3$props = _this3.props,
              propsStartIndex = _this3$props.startIndex,
              endIndex = _this3$props.endIndex,
              rotateDeg = _this3$props.rotateDeg,
              duration = _this3$props.duration,
              interval = _this3$props.interval;
          var rotate = loading;

          if (duration !== -1) {
            currentDuritionTime += interval;
            rotate = loading && currentDuritionTime < duration;
          }

          if (rotate) {
            var currIndex = startIndex;

            if (startIndex === endIndex) {
              currIndex = propsStartIndex;
            }

            currIndex += rotateDeg;

            _this3.setState({
              startIndex: currIndex
            });
          } else {
            _this3.onEnd();
          }
        } else {
          (0, _warning.default)(false, 'RotateIcon', 'state or props 消失');
        }
      }, this.props.interval);
    }
    /**结束旋转 */

  }, {
    key: "onEnd",
    value: function onEnd() {
      var forbbidenIE9 = this.props.forbbidenIE9;

      if (SupportAnimation && !forbbidenIE9) {
        return;
      }

      if (this.timer !== null) {
        clearInterval(this.timer);
      }

      this.setState({
        loading: false
      });
    }
    /** */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          propsStyle = _this$props2.style,
          className = _this$props2.className,
          children = _this$props2.children,
          size = _this$props2.size,
          customizePrefixCls = _this$props2.prefixCls,
          loading = _this$props2.loading,
          forbbidenIE9 = _this$props2.forbbidenIE9;
      var prefixCls = (0, _util.getPrefixCls)('js-rotate', customizePrefixCls);

      if (SupportAnimation && !forbbidenIE9) {
        var cssRotateName = (0, _util.getPrefixCls)('css-rotate', customizePrefixCls);
        var classNameString = (0, _classnames.default)(className, size && "".concat(prefixCls, "--").concat(size), cssRotateName, loading && 'is-animation');
        return /*#__PURE__*/React.createElement("span", {
          style: propsStyle,
          className: classNameString
        }, children);
      } else {
        var _this$state$startInde = this.state.startIndex,
            startIndex = _this$state$startInde === void 0 ? 0 : _this$state$startInde;

        var _classNameString = (0, _classnames.default)(className, "".concat(prefixCls), size && "".concat(prefixCls, "--").concat(size));

        var style = _objectSpread((0, _defineProperty2.default)({}, (0, _util.setPrefix)('transform'), "rotate(".concat(startIndex, "deg)")), propsStyle);

        return /*#__PURE__*/React.createElement("span", {
          style: style,
          className: _classNameString
        }, children);
      }
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**返回当前loading状态 */
    function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.loading !== prevState.loading) {
        return {
          loading: nextProps.loading
        };
      } else {
        return null;
      }
    }
  }]);
  return RotateIcon;
}(React.Component), _class2.defaultProps = {
  startIndex: 0,
  endIndex: 360,
  rotateDeg: 10,
  interval: 50,
  duration: -1,
  //表示不限制,
  forbbidenIE9: false
}, _class2)) || _class;

exports.default = RotateIcon;