import * as React from 'react';
import { Size } from '../../libs/types';
export interface SpinProps {
    /**是否加载中 */
    loading?: boolean;
    /**是否全屏显示 */
    fullScreen?: boolean;
    /**图标大小 , 'large', 'medium', 'small'*/
    size?: Size;
    /**自定义加载文案 */
    text?: React.ReactNode;
    /**图标父级span的样式 */
    iconStyle?: React.CSSProperties;
    /**Spin的类名 */
    className?: string;
    /**Spin的样式 */
    style?: React.CSSProperties;
    children?: any;
    prefixCls?: string;
    /**自定义加载图标 */
    icon?: (loading: boolean) => React.ReactNode;
}
export interface SpinState {
    loading?: boolean;
}
export default class Spin extends React.Component<SpinProps, SpinState> {
    static defaultProps: {
        size: string;
    };
    state: SpinState;
    /**返回当前状态 */
    static getDerivedStateFromProps(nextProps: SpinProps, prevState: SpinState): Partial<SpinState>;
    /**得到旋转图标 */
    getIcon(prefixCls: string): React.ReactNode;
    /** */
    render(): React.ReactNode;
}
