import * as React from 'react';
import { Status, StepsContextProps } from './StepsContext';
export interface StepItemProps {
    /**当前step的索引值，不对外进行翻译 */
    stepNumber: number;
    /**是否禁止点击，默认不禁止 */
    disabled: boolean;
    /**当前step的状态，可以覆盖上级的current或者status */
    status?: typeof Status[number];
    className?: string;
    title?: React.ReactNode;
    subTitle?: React.ReactNode;
    icon?: React.ReactNode;
    style?: React.CSSProperties;
    prefixCls?: string;
}
export interface StepItemState {
    disabled: boolean;
}
export default class Step extends React.PureComponent<StepItemProps & StepsContextProps, StepItemState> {
    static defaultProps: Partial<StepItemProps>;
    state: StepItemState;
    /**获取返回的disabled */
    static getDerivedStateFromProps(nextProps: StepItemProps, prevState: StepItemState): StepItemState;
    /**获取当前步骤的状态 */
    getStatusClassString(current: number, parentStatus: typeof Status[number]): typeof Status[number];
    /**获取当前步骤的图标 */
    getIcon(icon: React.ReactNode, status: typeof Status[number]): React.ReactNode;
    /**生成DOM */
    renderStep(context: StepsContextProps): React.ReactNode;
    /**
     *
     */
    render(): React.ReactNode;
}
