"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Close = _interopRequireDefault(require("net-design-icons/lib/icons/Close"));

var _CheckBold = _interopRequireDefault(require("net-design-icons/lib/icons/CheckBold"));

var _util = require("../../libs/utils/util");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _StepsContext = _interopRequireDefault(require("./StepsContext"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var StatusEnum;

(function (StatusEnum) {
  StatusEnum["FINISH"] = "finish";
  StatusEnum["WAIT"] = "wait";
  StatusEnum["PROCESS"] = "process";
  StatusEnum["ERROR"] = "error";
  StatusEnum["DISABLE"] = "disable";
})(StatusEnum || (StatusEnum = {}));

var Step = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Step, _React$PureComponent);

  var _super = _createSuper(Step);

  function Step() {
    var _this;

    (0, _classCallCheck2.default)(this, Step);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      disabled: false
    };
    return _this;
  }

  (0, _createClass2.default)(Step, [{
    key: "getStatusClassString",
    value:
    /**获取当前步骤的状态 */
    function getStatusClassString(current, parentStatus) {
      var _this$props = this.props,
          stepNumber = _this$props.stepNumber,
          status = _this$props.status; //current < parentStatus < status

      if (status) {
        return status;
      } //父级的status，只对当前步骤有效


      if (stepNumber === current) {
        if (parentStatus) {
          return parentStatus;
        }

        return StatusEnum.PROCESS;
      } else if (stepNumber < current) {
        return StatusEnum.FINISH;
      } else {
        return StatusEnum.WAIT;
      }
    }
    /**获取当前步骤的图标 */

  }, {
    key: "getIcon",
    value: function getIcon(icon, status) {
      var stepNumber = this.props.stepNumber; //若status为error，则，需要覆盖他本身的icon

      if (status === StatusEnum.ERROR) {
        return /*#__PURE__*/React.createElement(_Close.default, null);
      }

      if (icon) {
        return icon;
      }

      if (status === StatusEnum.FINISH) {
        return /*#__PURE__*/React.createElement(_CheckBold.default, null);
      } //其他的内部为数字


      return /*#__PURE__*/React.createElement("span", {
        className: "is-text"
      }, stepNumber + 1);
    }
    /**生成DOM */

  }, {
    key: "renderStep",
    value: function renderStep(context) {
      var _this$props2 = this.props,
          stepNumber = _this$props2.stepNumber,
          className = _this$props2.className,
          style = _this$props2.style,
          title = _this$props2.title,
          subTitle = _this$props2.subTitle,
          icon = _this$props2.icon,
          customizePrefixCls = _this$props2.prefixCls;
      var disabled = this.state.disabled;
      var current = context.current,
          parentStatus = context.status,
          space = context.space,
          count = context.count,
          onChange = context.onChange;
      var prefixCls = (0, _util.getPrefixCls)('step-item', customizePrefixCls);

      var stepStyle = _objectSpread({
        width: space || "".concat(1 / count * 100, "%")
      }, style);

      var stepStatus = this.getStatusClassString(current, parentStatus);
      var clickHandle = {};
      var clickable = onChange && !disabled;

      if (clickable) {
        clickHandle = {
          onClick: function onClick(e) {
            onChange(stepNumber, e);
          }
        };
      }

      var classString = (0, _classnames.default)("".concat(prefixCls), "is-".concat(stepStatus), //finish, wait, process, error, disable
      //`is-${labelPosition}`,
      {
        'is-custom': stepStatus !== StatusEnum.ERROR && icon,
        //自定义图标， 但是is-error会覆盖is-custom的图标
        'is-clickable': clickable
      }, className);
      var iconNode = this.getIcon(icon, stepStatus);
      return /*#__PURE__*/React.createElement("div", {
        className: classString,
        style: stepStyle
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__container")
      }, /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        className: "".concat(prefixCls, "__icon")
      }, clickHandle), iconNode), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__content")
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__title")
      }, title), subTitle && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__desc")
      }, subTitle))));
    }
    /**
     *
     */

  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(_StepsContext.default.Consumer, null, this.renderStep);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**获取返回的disabled */
    function getDerivedStateFromProps(nextProps, prevState) {
      var disabled = nextProps.disabled;
      var stateDisabled = prevState.disabled;

      if (disabled !== stateDisabled) {
        return {
          disabled: disabled
        };
      }

      return null;
    }
  }]);
  return Step;
}(React.PureComponent), _class2.defaultProps = {
  disabled: false
}, _class2)) || _class;

exports.default = Step;