import * as React from 'react';
import { Status, Direction, Position } from './StepsContext';
import StepItem from './Step';
export interface StepsProps {
    /**当前步骤条所在位置，从0开始计数，默认为0 */
    current: number;
    /**方向，暂时只支持horizontal */
    direction: typeof Direction[number];
    /**文在在图标的位置，默认为：bottom */
    labelPosition: typeof Position[number];
    /**单个步骤的宽度，若不填写，则均分 */
    space?: number;
    /**当前步骤的状态，若设置了此状态，则可以覆盖current的索引计算出来的状态 */
    status?: typeof Status[number];
    className?: string;
    /**样式 */
    style?: React.CSSProperties;
    prefixCls?: string;
    /**点击步骤的回调，若无此方法，则无法点击， 只有在使用current属性的时候，才会有效 */
    onChange?: (current: number) => void;
}
export interface StepsState {
    current: number;
    status?: typeof Status[number];
}
export default class Steps extends React.PureComponent<StepsProps, StepsState> {
    static defaultProps: StepsProps;
    state: StepsState;
    static Step: typeof StepItem;
    /**获取上级返回的status和current */
    static getDerivedStateFromProps(nextProps: StepsProps, prevState: StepsState): StepsState;
    /**处理点击事件 */
    handleStepChange(stepNumber: number, e: MouseEvent): void;
    /** */
    render(): React.ReactNode;
}
