import * as React from 'react';
import { Size } from "../../libs/types";
interface SwitchProps {
    inner?: boolean;
    size?: Size;
    value?: number | string;
    disabled?: boolean;
    width?: number;
    onText?: React.ReactNode;
    offText?: React.ReactNode;
    onColor?: string;
    offColor?: string;
    onValue?: number | string;
    offValue?: number | string;
    name?: string;
    onChange?: (value: boolean | number | string, event?: React.FocusEvent<HTMLInputElement>) => void;
    style?: React.CSSProperties;
    className?: string;
    circle?: boolean;
    checkbox?: boolean;
    label?: React.ReactNode;
}
interface SwitchState {
    value?: number | string;
    coreWidth?: number;
    _prevProps?: SwitchProps;
}
export default class Switch extends React.Component<SwitchProps, SwitchState> {
    input: HTMLInputElement;
    core: HTMLSpanElement;
    static defaultProps: {
        size: string;
        disabled: boolean;
        width: number;
        onValue: boolean;
        offValue: boolean;
        circle: boolean;
        inner: boolean;
    };
    /**
     * 构造函数
     * @param props
     */
    constructor(props: SwitchProps);
    /**
     * 监听value属性
     */
    static getDerivedStateFromProps(nextProps: SwitchProps, prevState: SwitchState): SwitchState;
    /**
     *onchange事件
     */
    handleChange(e: React.FocusEvent<HTMLInputElement>): void;
    /**
         * 打开时文字渲染
         */
    onTextRender(): React.ReactNode;
    /**
         * 关闭时文字渲染
         */
    offTextRender(): React.ReactNode;
    /**
     * 渲染开关样式
     */
    renderCheckbox(): React.ReactNode;
    /**
    *渲染dom
    */
    render(): React.ReactNode;
}
export {};
