"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormElement = require("../form/FormElement");

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _Complete = _interopRequireDefault(require("net-design-icons/lib/icons/Complete"));

var _excluded = ["name", "disabled", "onText", "offText", "onValue", "style", "size", "circle", "onColor", "offColor", "className", "checkbox", "label"];

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Switch = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Switch, _React$Component);

  var _super = _createSuper(Switch);

  /**
   * 构造函数
   * @param props
   */
  function Switch(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Switch);
    _this = _super.call(this, props);
    _this.input = void 0;
    _this.core = void 0;
    _this.state = {
      value: props.value,
      coreWidth: props.width
    };
    return _this;
  }
  /**
   * 监听value属性
   */


  (0, _createClass2.default)(Switch, [{
    key: "handleChange",
    value:
    /**
     *onchange事件
     */
    function handleChange(e) {
      var _this$props = this.props,
          onValue = _this$props.onValue,
          offValue = _this$props.offValue,
          onChange = _this$props.onChange;
      var event = e; //true value为onValue值 false为offValue值

      var newValue = e.target.checked ? onValue : offValue;
      onChange && onChange(newValue, event);
      this.setState({
        value: newValue
      });
    }
    /**
         * 打开时文字渲染
         */

  }, {
    key: "onTextRender",
    value: function onTextRender() {
      var _this$props2 = this.props,
          onText = _this$props2.onText,
          offText = _this$props2.offText,
          onValue = _this$props2.onValue,
          offValue = _this$props2.offValue,
          inner = _this$props2.inner;
      var value = this.state.value;
      return /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)("rd-switch__label", "rd-switch__label--left", {
          "is-active": !inner && value === onValue,
          'rd-switch__inner--right': inner
        })
      }, inner ? value === offValue && offText : onText);
    }
    /**
         * 关闭时文字渲染
         */

  }, {
    key: "offTextRender",
    value: function offTextRender() {
      var _this$props3 = this.props,
          onText = _this$props3.onText,
          offText = _this$props3.offText,
          onValue = _this$props3.onValue,
          offValue = _this$props3.offValue,
          inner = _this$props3.inner;
      var value = this.state.value;
      return /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)("rd-switch__label", "rd-switch__label--right", {
          "is-active": !inner && value === offValue,
          'rd-switch__inner--left': inner
        })
      }, inner ? value === onValue && onText : offText);
    }
    /**
     * 渲染开关样式
     */

  }, {
    key: "renderCheckbox",
    value: function renderCheckbox() {
      var _this$props4 = this.props,
          checkbox = _this$props4.checkbox,
          disabled = _this$props4.disabled,
          circle = _this$props4.circle,
          onValue = _this$props4.onValue,
          offColor = _this$props4.offColor,
          onColor = _this$props4.onColor;
      var _this$state = this.state,
          value = _this$state.value,
          coreWidth = _this$state.coreWidth;
      var isChecked = value === onValue;
      var newColor = isChecked ? onColor : offColor;
      var coreStyle = coreWidth && {
        width: coreWidth + 'px'
      };

      if (checkbox) {
        return /*#__PURE__*/React.createElement("span", {
          className: (0, _classnames.default)({
            'rd-checkbox__input': true,
            'is-disabled': disabled,
            'is-checked': isChecked
          })
        }, /*#__PURE__*/React.createElement("span", {
          className: (0, _classnames.default)('rd-checkbox__inner', {
            'is-disabled': disabled
          })
        }, isChecked && /*#__PURE__*/React.createElement(_Complete.default, {
          className: (0, _classnames.default)('rd-checkbox__icon')
        })));
      } else {
        return /*#__PURE__*/React.createElement("span", {
          className: (0, _classnames.default)('rd-switch__core', {
            'is-circle': circle
          }),
          style: _objectSpread({
            borderColor: newColor,
            backgroundColor: newColor
          }, coreStyle)
        });
      }
    }
    /**
    *渲染dom
    */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          name = _this$props5.name,
          disabled = _this$props5.disabled,
          onText = _this$props5.onText,
          offText = _this$props5.offText,
          onValue = _this$props5.onValue,
          style = _this$props5.style,
          size = _this$props5.size,
          circle = _this$props5.circle,
          onColor = _this$props5.onColor,
          offColor = _this$props5.offColor,
          className = _this$props5.className,
          checkbox = _this$props5.checkbox,
          label = _this$props5.label,
          rest = (0, _objectWithoutProperties2.default)(_this$props5, _excluded);
      var otherProps = (0, _omit.default)(rest, ['offValue', 'inner']);
      var value = this.state.value;
      var isChecked = value === onValue;
      return /*#__PURE__*/React.createElement("label", {
        style: style,
        className: (0, _classnames.default)(className, 'rd-switch', "rd-switch--".concat(size), {
          'is-disabled': disabled,
          'is-checked': isChecked,
          'is-checkbox': checkbox
        })
      }, disabled && /*#__PURE__*/React.createElement("div", {
        className: "rd-switch__mask"
      }), /*#__PURE__*/React.createElement("input", (0, _extends2.default)({}, otherProps, {
        className: (0, _classnames.default)('rd-switch__input'),
        type: "checkbox",
        checked: isChecked,
        name: name,
        value: value,
        ref: function ref(_ref) {
          return _this2.input = _ref;
        },
        disabled: disabled,
        onChange: this.handleChange
      })), offText && this.onTextRender(), this.renderCheckbox(), onText && this.offTextRender(), label && /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)("rd-switch__label", "rd-switch__label--right")
      }, label));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newValue = nextProps.value;

      if (prevState._prevProps && prevState._prevProps.value === nextProps.value) {
        newValue = prevState.value;
      }

      return {
        _prevProps: nextProps,
        value: newValue
      };
    }
  }]);
  return Switch;
}(React.Component), _class2.defaultProps = {
  size: 'medium',
  disabled: false,
  width: 0,
  onValue: true,
  offValue: false,
  circle: false,
  inner: false
}, _class2)) || _class) || _class);
exports.default = Switch;