"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TableHeader = _interopRequireDefault(require("./TableHeader"));

var _TableBody = _interopRequireDefault(require("./TableBody"));

var _TableContext = _interopRequireDefault(require("./TableContext"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _util = require("./util");

var _pagination2 = _interopRequireDefault(require("../pagination"));

var _empty = _interopRequireDefault(require("../empty"));

var _util2 = require("../../libs/utils/util");

var _spin = _interopRequireDefault(require("../spin"));

var _locale = _interopRequireDefault(require("../locale"));

var _dynamicList = _interopRequireDefault(require("../dynamic-list"));

var _scrollBar = _interopRequireDefault(require("../scroll-bar"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Table = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Table, _React$Component);

  var _super = _createSuper(Table);

  /**
   * 构造函数
   * @param props
   */
  function Table(props) {
    var _props$pagination;

    var _this;

    (0, _classCallCheck2.default)(this, Table);
    _this = _super.call(this, props);
    _this.el = void 0;
    _this.headerWrapper = void 0;
    _this.bodyWrapper = void 0;
    _this.resizeProxy = void 0;
    _this.bodyScrollWrapper = void 0;
    _this.trHeight = void 0;
    _this.isSupSkicky = (0, _util.isSupports)('position: sticky');
    _this.resize = false;
    _this.state = {
      selectedRowKeys: [],
      // 原始数据
      dataSource: [],
      data: [],
      columns: [],
      showData: [],
      fixedColumns: [],
      rightFixedColumns: [],
      columnRows: [],
      selectRowKey: props.selectRowKey,
      pagination: _objectSpread({
        small: false,
        pageSize: 10,
        currentPage: ((_props$pagination = props.pagination) === null || _props$pagination === void 0 ? void 0 : _props$pagination.currentPage) || 1,
        layout: 'prev, pager, next, jumper, total',
        pageSizes: [10, 20, 30, 40, 50, 100],
        frontPage: true
      }, props.pagination)
    };

    var columns = _this.updateColumns();

    var data = _this.updateData({
      columns: columns.columns
    });

    _this.state = _objectSpread(_objectSpread(_objectSpread({}, _this.state), columns), data);
    return _this;
  }
  /**
   * 筛选所有可选中的数据
   * @returns 
   */


  (0, _createClass2.default)(Table, [{
    key: "getSelectableData",
    value: function getSelectableData(data, _columns) {
      var _this$state = this.state,
          dataSource = _this$state.dataSource,
          columns = _this$state.columns;
      data = data || dataSource;
      _columns = _columns || columns;
      return data.filter(function (row, index) {
        return _columns[0].selectable ? _columns[0].selectable(row.data, row.key, index) : true;
      });
    }
    /**
     * 获取单页选中还是全选的数据
     */

  }, {
    key: "getSelectData",
    value: function getSelectData(dataSource, data, showData) {
      var singleSelectAll = this.props.singleSelectAll;
      var _this$state2 = this.state,
          _data = _this$state2.data,
          _showData = _this$state2.showData;

      var __data = data || _data;

      var __showData = showData || _showData;

      if (singleSelectAll) {
        return __showData || __data;
      } else {
        return __data;
      }
    }
    /**
     * 表头全选按钮判断是否选中
     */

  }, {
    key: "isAllSelected",
    get: function get() {
      /**父级选中的keys */

      /**data为显示的数据  */
      var currentRowKey = this.props.currentRowKey;
      var data = this.getSelectData();
      /**选中的数据 */

      var selectableData = this.getSelectableData(data);

      var _dataSource = this.getSelectableData();
      /**没有可选数据，不进行操作 */


      if (!selectableData.length) {
        return {
          selectAll: false,
          selectedData: [],
          selectedDataSource: []
        };
      }
      /**如果传了currentRowKey，则父级维护，使用currentRowKey判断全选 */


      if (Array.isArray(currentRowKey)) {
        var _selectedData = selectableData.filter(function (row) {
          return currentRowKey.includes(row.key);
        });

        var _selectedDataSource = (0, _util.map)(_dataSource.filter(function (row) {
          return currentRowKey.includes(row.key);
        }), function (row) {
          return row.key;
        });

        return {
          selectAll: _selectedData.length === selectableData.length,
          selectedData: _selectedData,
          selectedDataSource: _selectedDataSource
        };
      }
      /**如果没有传currentRowKey，则自己维护，使用selectedRowKeys判断全选 */


      var selectedRowKeys = this.state.selectedRowKeys;
      var selectedData = selectableData.filter(function (row) {
        return selectedRowKeys.includes(row.key);
      });
      var selectedDataSource = (0, _util.map)(_dataSource.filter(function (row) {
        return selectedRowKeys.includes(row.key);
      }), function (row) {
        return row.key;
      });
      return {
        selectAll: selectedData.length === selectableData.length,
        selectedData: selectedData,
        selectedDataSource: selectedDataSource
      };
    }
    /**
     * 浏览器缩放监听宽度高度
     */

  }, {
    key: "onResize",
    value: function onResize() {
      /**获取宽度 */
      this.caculateWidth();
    }
    /** * 初始化 */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      /**实时监测表格大小*/
      (0, _util2.addEvent)(window, 'resize', (0, _util2.debounce)(this.onResize, 100));
      this.caculateWidth();
    }
    /**
     * 排序时，更新固定列样式
     * */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      var _this$props = this.props,
          data = _this$props.data,
          search = _this$props.search,
          pagination = _this$props.pagination,
          selectRowKey = _this$props.selectRowKey,
          currentRowKey = _this$props.currentRowKey,
          columns = _this$props.columns,
          onSearch = _this$props.onSearch; // 是否更新数据

      var isFresh = false; // 更新的内容

      var content = {};
      /**数据，搜索，分页 */

      if (prevProps.data !== data || prevProps.search !== search || prevProps.pagination !== pagination) {
        var _data2 = this.updateData();

        if (prevProps.search !== search) {
          onSearch && onSearch(_data2.showDataAll);
        }

        isFresh = true;
        content = _objectSpread(_objectSpread({}, content), _data2);
      }
      /**单选选中改变根更新 */


      if (prevProps.selectRowKey !== selectRowKey) {
        isFresh = true;
        content = _objectSpread(_objectSpread({}, content), {}, {
          selectRowKey: selectRowKey
        });
      }
      /**多选选中改变根更新 */


      if (prevProps.currentRowKey !== currentRowKey) {
        isFresh = true;
        content = _objectSpread(_objectSpread({}, content), {}, {
          selectedRowKeys: currentRowKey
        });
      }
      /**表头更新 */


      if (prevProps.columns !== columns) {
        isFresh = true;

        var _columns2 = this.updateColumns();

        content = _objectSpread(_objectSpread({}, content), _columns2);
      }
      /**执行更新 */


      if (isFresh) {
        this.setState(_objectSpread({}, content), function () {
          _this2.fixedWidth();
        });
      }
    }
    /**
     * 销毁resize
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _util2.removeEvent)(window, 'resize', this.onResize);
    }
    /**
     * 获取原始data数据+key值的封装数据
     * @returns [
     *   {
     *      key:xx,
     *      data:{xxx}
     *   }
     * ]
     */

  }, {
    key: "getDataSource",
    value: function getDataSource() {
      var _this$props$data = this.props.data,
          data = _this$props$data === void 0 ? [] : _this$props$data;
      /**深度复制 */

      var filteredData = (0, _util2.deepClone)(data);
      /**dataSource为添加key的data数据， dataSource组装数据为[{key:xxx,data:{}},....]的格式，data里面的内容为真正数据内容 */

      return (0, _util.getKeyData)(filteredData, this.props);
    }
    /**
     * 获取选中的key值
     * @returns [key1,key2,...]
     */

  }, {
    key: "updateSelectedRowKeys",
    value: function updateSelectedRowKeys(data, params) {
      var columns = params && params.columns;
      /**筛选所有可以选中的数据 */

      var allSelectableRows = this.getSelectableData(data, columns) || [];
      /**如果为全选，则置空，反之全选 */

      /**没有可选数据，不进行操作 */

      var _selectRowKeys = [];
      var _selectRowKey = null;
      var _this$props2 = this.props,
          currentRowKey = _this$props2.currentRowKey,
          selectRowKey = _this$props2.selectRowKey;
      /**如果传了currentRowKey，则父级维护，使用currentRowKey判断全选 */

      if (Array.isArray(currentRowKey)) {
        //多选
        _selectRowKeys = currentRowKey;
      } else if (selectRowKey) {
        //单选
        _selectRowKey = selectRowKey;
      } else {
        var _columns3 = this.props.columns;
        var _selectRowKey2 = this.state.selectRowKey;

        if (_columns3[0].type === 'radio') {
          _selectRowKey = (0, _util.map)(allSelectableRows.filter(function (row) {
            return _selectRowKey2 === row.key;
          })).length !== 0 ? _selectRowKey2 : null;
        }

        if (_columns3[0].type === 'checkbox') {
          _selectRowKeys = this.isAllSelected.selectedDataSource;
        }
      }

      return {
        selectedRowKeys: _selectRowKeys,
        selectRowKey: _selectRowKey
      };
    }
    /**
     * colums数据处理
     * @param columns 获取表格高度
     */

  }, {
    key: "updateColumns",
    value: function updateColumns() {
      var columns = this.props.columns;

      var _columns = (0, _util.normalizeColumns)(columns);
      /**获取左边固定列 true|left*/


      var fixedColumns = _columns.filter(function (column) {
        return column.fixed === 'left';
      });
      /**右边固定列  right*/


      var rightFixedColumns = _columns.filter(function (column) {
        return column.fixed === 'right';
      });
      /**如果第一列为radio或checkbox，并且有左边固定列，就把当前的radio或checkbox添加到左边固定列里面去 */


      if (_columns[0] && (_columns[0].type === 'checkbox' || _columns[0].type === 'radio' || _columns[0].type === 'index')) {
        if (fixedColumns.length && !_columns[0].fixed) {
          _columns[0].fixed = 'left';
          fixedColumns.unshift(_columns[0]);
        }
      }
      /**重新获取到一个新的列数组，构成是左边固定列+中间不固定的列+右边固定列 */


      _columns = [].concat(fixedColumns, _columns.filter(function (column) {
        return !column.fixed;
      }), rightFixedColumns);
      /**getLeafColumns作用是将最终要显示出来的列提出来 */

      var newColumns = (0, _util.getLeafColumns)(_columns);
      /**convertToRows 组装数据为二维数组的格式 */

      var newColumnRows = (0, _util.convertToRows)(_columns);
      return {
        fixedColumns: fixedColumns,
        rightFixedColumns: rightFixedColumns,
        columnRows: newColumnRows,
        columns: newColumns
      };
    }
    /**
     * data数据更新处理,data,搜索，排序，分页
     * key哪个变化就传哪个，data，search，sort，page关键字
     * @param props
     */

  }, {
    key: "updateData",
    value: function updateData(params) {
      var _this$props3 = this.props,
          search = _this$props3.search,
          pagination = _this$props3.pagination;
      var sortColumn = this.state.sortColumn;

      var _sortColumn = (0, _util2.deepClone)(sortColumn);

      var _pagination = (0, _util2.deepClone)(this.state.pagination);

      if (params && params.sortColumn) {
        _sortColumn = params.sortColumn;
      }

      if (params && params.pagination) {
        _pagination = _objectSpread(_objectSpread({}, _pagination), params.pagination);
      } //后台分页更新


      if (pagination && !_pagination.frontPage) {
        _pagination = _objectSpread(_objectSpread({}, _pagination), pagination);
      }

      var isSingleSort = function isSingleSort() {
        return _sortColumn && _sortColumn.sortOrder.single;
      };

      var isMultiSort = function isMultiSort() {
        return _sortColumn && !_sortColumn.sortOrder.single;
      };
      /**
       * 1、原始数据改变======》原始数据改变=>对应搜索数据改变=>排序数据改变=>分页显示数据改变
       * 2、搜索数据改变======》原始数据不变=>对应搜索数据改变=>排序数据改变=>分页显示数据改变
       * 3、排序数据改变======》原始数据不变=>对应搜索数据不变=>排序数据改变=>分页显示数据改变
       * 4、分页数据改变======》原始数据不变=>对应搜索数据不变=>排序数据不变=>分页显示数据改变
       */

      /**
       *   第一次渲染带入搜索=>排序=>分页来计算显示
       */
      // 1、获取原始数据添加 key 之后的数据 dataSource


      var dataSource = this.getDataSource();
      /**默认显示数据为全部数据  */

      var showData = (0, _util2.deepClone)(dataSource);
      /**
       * 如果为后台分页，则不需要前端对搜索，排序以及分页来计算
       * 一下为前端分页时，需要计算的数据
       * ============================================================================>
       */

      /**
       *  2、搜索带入计算
       * 有分页 且为 前端排序才会进行排序，搜索，处理页码操作
      */

      var showDataAll = [];

      if (_pagination.frontPage) {
        /**
         * 3、搜索
         * 有关键词才进行搜索，得到的结果赋值为showData作为显示结果
        */
        if (search) {
          showData = (0, _util.searchFunc)(showData, this.props);
          /**搜索之后的所有数据，防止checkbox全选时选中页面上没有渲染的数据 */
        }
        /**
         * 4、排序
         * 对页面上所有的需要显示的数据进行排序
         * 分单页排序和多页排序
         * a、当多页排序时，会先排序再进行分页
         * b、单页排序时，会先分页再排序
         */


        if (isMultiSort()) {
          showData = (0, _util.sortOrderFunc)(showData, _sortColumn);
        }

        showDataAll = showData;
        /**
         * 5、分页处理
         * 对每页数据显示进行处理
         */

        if (pagination) {
          var pageConfig = (0, _util.dealPagination)(this.props, showData, _pagination);
          showData = pageConfig.data;
          _pagination = pageConfig.pagination;
          /**
           * 6、对单页的数据进行排序
           */

          if (isSingleSort()) {
            showData = (0, _util.sortOrderFunc)(showData, _sortColumn);
          }
        }
      }

      var data = showData;
      showData = this.firstRenderBodyData(showData);

      var _data = this.getSelectData(dataSource, data, showData);

      var selected = this.updateSelectedRowKeys(_data, params); //后台分页

      return _objectSpread({
        pagination: _pagination,
        dataSource: dataSource,
        data: data,
        showData: showData,
        showDataAll: showDataAll
      }, selected);
    }
    /**
     * 首次渲染页面，如果有动态加载数据，返回空，避免过多渲染占用时间
     */

  }, {
    key: "firstRenderBodyData",
    value: function firstRenderBodyData(showData) {
      var _this$props4 = this.props,
          listView = _this$props4.listView,
          loading = _this$props4.loading,
          tableHeight = _this$props4.tableHeight;

      if (!this.bodyScrollWrapper && listView && tableHeight && !loading) {
        showData = [];
      } else if (this.calcDymanicData()) {
        showData = this.bodyScrollWrapper.getDynamicData(showData);
      }

      return showData;
    }
    /**
     * 判断是否需要动态计算显示数据
     */

  }, {
    key: "calcDymanicData",
    value: function calcDymanicData() {
      var _this$props5 = this.props,
          listView = _this$props5.listView,
          loading = _this$props5.loading,
          tableHeight = _this$props5.tableHeight;
      return this.bodyScrollWrapper && listView && tableHeight && !loading;
    }
    /**
     * 计算table宽度
     */

  }, {
    key: "caculateWidth",
    value: function caculateWidth(column) {
      var _this3 = this;

      /**获取当前state的左边固定列，右边固定列和总列数据 */
      var _this$state3 = this.state,
          columns = _this$state3.columns,
          data = _this$state3.data;
      var isFresh = false;
      var state = {};

      if (column) {
        var _columns = (0, _util.map)(columns, function (item) {
          return item.prop === column.prop ? column : item;
        });

        isFresh = true;
        state = _objectSpread(_objectSpread({}, state), {}, {
          column: _columns
        });
      }

      if (this.calcDymanicData()) {
        var showData = this.bodyScrollWrapper.getDynamicData(data);
        isFresh = true;
        state = _objectSpread(_objectSpread({}, state), {}, {
          showData: showData
        });
      }

      if (isFresh) {
        this.setState(_objectSpread({}, state), function () {
          /**计算浮动列 */
          _this3.fixedWidth();
        });
      }
    }
    /**拖动后更新高度 */

  }, {
    key: "scheduleLayout",
    value: function scheduleLayout(column) {
      this.caculateWidth(column);
    }
    /**
     * row改变时执行
     * @param row
     */

  }, {
    key: "handleRowChange",
    value: function handleRowChange(rowKey) {
      this.setState({
        selectRowKey: rowKey
      });
    }
    /**
     * 判断是否全部选中
     */

  }, {
    key: "toggleAllSelection",
    value: function toggleAllSelection(keys, event, row) {
      var _this$props6 = this.props,
          onSelectAll = _this$props6.onSelectAll,
          onSelectChange = _this$props6.onSelectChange;
      var newCurrentRowKey = [];

      if (keys) {
        newCurrentRowKey = keys;
      } else {
        /**筛选所有可以选中的数据 */
        var data = this.getSelectData();
        var allSelectableRows = this.getSelectableData(data);
        /**如果为全选，则置空，反之全选 */

        var selectAll = this.isAllSelected.selectAll;
        var selectedRowKeys = this.state.selectedRowKeys;

        if (selectAll) {
          newCurrentRowKey = selectedRowKeys;
          allSelectableRows.forEach(function (row) {
            newCurrentRowKey.forEach(function (key, index) {
              if (row.key === key) {
                newCurrentRowKey.splice(index, 1);
              }
            });
          });
        } else {
          newCurrentRowKey = selectedRowKeys;
          allSelectableRows.forEach(function (row) {
            if (!newCurrentRowKey.includes(row.key)) {
              newCurrentRowKey.push(row.key);
            }
          });
        }
      }

      this.setState({
        selectedRowKeys: newCurrentRowKey
      });

      if (keys) {
        onSelectChange && onSelectChange(newCurrentRowKey, row, event);
      } else {
        if (onSelectAll) {
          onSelectAll(newCurrentRowKey, event);
        } else if (onSelectChange) {
          onSelectChange(newCurrentRowKey, row, event);
        }
      }
    }
    /**
     * 页码改变执行的回调
     */

  }, {
    key: "pageChange",
    value: function pageChange(key, value) {
      var pagination = this.state.pagination;

      var _pagination = _objectSpread({}, pagination);

      _pagination[key] = value;

      var _data = this.updateData({
        pagination: _pagination
      });

      this.setState(_objectSpread({}, _data));
    }
    /**
     * 页码选项改变
     * @param val
     */

  }, {
    key: "handleSizeChange",
    value: function handleSizeChange(pageSize) {
      this.pageChange('pageSize', pageSize);
      var onSizeChange = this.props.onSizeChange;
      onSizeChange && onSizeChange(pageSize);
    }
    /**
     * 页码改变
     * @param page
     */

  }, {
    key: "handleCurrentChange",
    value: function handleCurrentChange(currentPage) {
      this.pageChange('currentPage', currentPage);
      var onCurrentChange = this.props.onCurrentChange;
      onCurrentChange && onCurrentChange(currentPage);
    }
    /**
     * 点击头部排序
     */

  }, {
    key: "onHeaderSortClick",
    value: function onHeaderSortClick(column, givenOrder, event) {
      var _this$props7 = this.props,
          hasSortNull = _this$props7.hasSortNull,
          onSortClick = _this$props7.onSortClick;
      var sortColumn = this.state.sortColumn;
      var sortOrder = column.sortOrder;
      var _sortArr = ['ascending', 'descending'];

      if (hasSortNull) {
        _sortArr.push(null);
      }

      var getOrder = function getOrder(order) {
        /**点击的是否与上次点击的是同一列 */
        if (sortColumn && column.prop === sortColumn.prop) {
          /**如果当前没有排序，就变成升序，否则就变成降序，是降序就变成不排序 */
          if (!order) {
            order = _sortArr[0];
          } else {
            var index = _sortArr.indexOf(order);

            index = index === _sortArr.length - 1 ? 0 : index + 1;
            order = _sortArr[index];
          }
        } else {
          /**如果不是和和上次点击的是同一列，则变成升序 */
          order = _sortArr[0];
        }

        return order;
      };
      /**如果传的排序配置信息为true，则需要转换成对象的格式赋值，不然在给true赋值会报错 */


      if (typeof sortOrder === 'boolean') {
        sortOrder = {};
      }

      if (givenOrder) {
        /**获取排序方式 升序还是降序 */
        sortOrder.order = givenOrder;
      } else {
        sortOrder.order = getOrder(sortOrder.order);
      }

      column.sortOrder = sortOrder;

      var _data = this.updateData({
        sortColumn: column
      });

      this.setState(_objectSpread({
        sortColumn: column
      }, _data), function () {
        onSortClick && onSortClick(column.sortOrder.order, column, event);
      });
    }
    /**
     * body滚动
     */

  }, {
    key: "handleBodyScroll",
    value: function handleBodyScroll(e, data) {
      var target = e.target;
      var headerWrapper = this.headerWrapper;
      var scrollLeft = target.scrollLeft;
      this.fixedWidth();

      if (this.calcDymanicData() && data) {
        this.setState({
          showData: data
        });
      }

      if (headerWrapper) {
        headerWrapper.style.left = "".concat(-scrollLeft, "px");
      }
    }
    /**
     * 浮动位置
     */

  }, {
    key: "fixedWidth",
    value: function fixedWidth() {
      var _this4 = this;

      if (this.bodyWrapper) {
        var _this$bodyWrapper$get = this.bodyWrapper.getBoundingClientRect(),
            left = _this$bodyWrapper$get.left,
            right = _this$bodyWrapper$get.right;

        var elRight = Math.min(this.el.getBoundingClientRect().right, right);
        var elLeft = Math.max(this.el.getBoundingClientRect().left, left);
        var tdStyle = {
          tdFixedLeft: elLeft - left,
          tdFixedRight: right - elRight
        };
        var _this$state4 = this.state,
            fixedColumns = _this$state4.fixedColumns,
            rightFixedColumns = _this$state4.rightFixedColumns;
        /**没有数据时隐藏阴影条 */

        var setHiddenLine = function setHiddenLine() {
          if (_this4.bodyScrollWrapper) {
            var tableHeight = _this4.props.tableHeight;

            var scrollHeight = _this4.bodyScrollWrapper.getHeight();

            var height = Math.min(tableHeight ? Math.min(tableHeight, scrollHeight) : scrollHeight, _this4.bodyWrapper.clientHeight) + (_this4.headerWrapper ? _this4.headerWrapper.clientHeight : 0); // this.resizeProxy.style.height = `${height}px`;

            if (fixedColumns.length !== 0 && Math.round(tdStyle.tdFixedLeft) > 0) {
              !(0, _util2.classList)(_this4.el).contains('is-left-fixed') && (0, _util2.classList)(_this4.el).add('is-left-fixed');
            } else {
              (0, _util2.classList)(_this4.el).remove('is-left-fixed');
            }

            if (rightFixedColumns.length !== 0 && Math.round(tdStyle.tdFixedRight) > 0) {
              !(0, _util2.classList)(_this4.el).contains('is-right-fixed') && (0, _util2.classList)(_this4.el).add('is-right-fixed');
            } else {
              (0, _util2.classList)(_this4.el).remove('is-right-fixed');
            }
          }
        };
        /**如果不支持sticky属性，则不显示隐藏阴影线 */


        this.isSupSkicky && setHiddenLine();
      }
    }
    /**
     * 获取真实宽度
     * @param column 
     * @returns 
     */

  }, {
    key: "getTrWidth",
    value: function getTrWidth(width, bodyWidth) {
      // /**计算出表格最小宽度 reduce计算返回某数组某值的总和 根据每列的宽度或最小宽度来算*/
      bodyWidth = bodyWidth || this.el && this.el.clientWidth;

      if ("".concat(width).includes('%')) {
        return parseInt("".concat(width)) * bodyWidth / 100;
      } else {
        return parseInt("".concat(width));
      }
    }
    /**
     * 是否有纵向滚动条
     *当有tableHeight，也就是固定头，只滚动body时，是否存在纵向滚动条
    */

  }, {
    key: "hasScrollY",
    value: function hasScrollY() {
      var _this5 = this;

      var columns = this.state.columns;
      var bodyWidth = this.el && this.el.clientWidth;
      var bodyMinWidth = columns.reduce(function (pre, col) {
        return pre + (_this5.getTrWidth(col.width) || _this5.getTrWidth(col.minWidth) || 0);
      }, 0);
      return bodyWidth < bodyMinWidth;
    }
    /**
     * 
     */

  }, {
    key: "getTdWidth",
    value: function getTdWidth(column) {
      var hasScrollY = this.hasScrollY();
      return hasScrollY ? column.width || column.minWidth : column.width;
    }
    /**
     * 表头
     */

  }, {
    key: "headerTableRender",
    value: function headerTableRender() {
      var _this6 = this;

      var showHeader = this.props.showHeader;
      var columns = this.state.columns;

      if (showHeader) {
        return /*#__PURE__*/React.createElement("div", {
          style: {
            overflow: 'hidden'
          }
        }, /*#__PURE__*/React.createElement("table", {
          ref: function ref(_ref) {
            return _this6.headerWrapper = _ref;
          },
          className: (0, _classnames.default)('rd-table__header'),
          cellPadding: 0,
          cellSpacing: 0
        }, /*#__PURE__*/React.createElement("colgroup", null, (0, _util.map)(columns, function (column, index) {
          // const width = this.getTrWidth(this.getTdWidth(column));
          return /*#__PURE__*/React.createElement("col", {
            width: column.width,
            key: index,
            style: {
              width: column.width
            }
          });
        })), /*#__PURE__*/React.createElement(_TableHeader.default, this.props)));
      }
    }
    /**
     * 表body
     */

  }, {
    key: "bodyTableRender",
    value: function bodyTableRender() {
      var _this7 = this;

      var _this$props8 = this.props,
          showHeader = _this$props8.showHeader,
          emptyTableInner = _this$props8.emptyTableInner,
          mini = _this$props8.mini,
          trHeight = _this$props8.trHeight,
          tableHeight = _this$props8.tableHeight,
          emptyComp = _this$props8.emptyComp,
          emptyText = _this$props8.emptyText,
          loading = _this$props8.loading,
          loadComp = _this$props8.loadComp,
          listView = _this$props8.listView,
          bodyStyle = _this$props8.bodyStyle,
          useCustomScrollBar = _this$props8.useCustomScrollBar;
      var _this$state5 = this.state,
          selectRowKey = _this$state5.selectRowKey,
          columns = _this$state5.columns,
          showData = _this$state5.showData,
          data = _this$state5.data;
      var isOneTableEmpty = !emptyTableInner && !showData.length;

      var _trHeight = trHeight || mini ? 32 : 48;

      var bodyCententRender = function bodyCententRender() {
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("table", {
          cellPadding: 0,
          cellSpacing: 0,
          ref: function ref(_ref2) {
            _this7.bodyWrapper = _ref2;
          },
          className: (0, _classnames.default)({
            'is-body-border': !showHeader
          })
        }, /*#__PURE__*/React.createElement("colgroup", null, (0, _util.map)(columns, function (column, index) {
          if (column.resizable) {
            _this7.resize = true;
          } // const width = this.getTrWidth(this.getTdWidth(column));


          return /*#__PURE__*/React.createElement("col", {
            width: column.width,
            key: index,
            style: {
              width: column.width
            }
          });
        })), !(tableHeight && listView) && showHeader && /*#__PURE__*/React.createElement(_TableHeader.default, (0, _extends2.default)({
          headClassName: (0, _classnames.default)('rd-table__header')
        }, _this7.props)), /*#__PURE__*/React.createElement(_TableBody.default, (0, _extends2.default)({}, _this7.props, {
          selectRowKey: selectRowKey
        })), !showData.length && emptyTableInner && /*#__PURE__*/React.createElement("tbody", null, /*#__PURE__*/React.createElement("tr", null, /*#__PURE__*/React.createElement("td", {
          colSpan: columns.length,
          className: (0, _classnames.default)('rd-table__empty', {
            'is-empty-inner': emptyTableInner
          })
        }, emptyComp || /*#__PURE__*/React.createElement(_empty.default, {
          description: emptyText
        }))))), isOneTableEmpty && (emptyComp || /*#__PURE__*/React.createElement(_empty.default, {
          description: emptyText
        })));
      };

      var load = function load() {
        if (loading) {
          if (loadComp) {
            return /*#__PURE__*/React.createElement(React.Fragment, null, !tableHeight && _this7.headerTableRender(), loadComp);
          } else {
            return /*#__PURE__*/React.createElement(_spin.default, {
              className: 'is-loading',
              loading: loading,
              text: _locale.default.t('rd.table.loading')
            });
          }
        } else {
          return bodyCententRender();
        }
      };

      if (this.calcDymanicData() && !loading) {
        return /*#__PURE__*/React.createElement(_dynamicList.default, {
          height: tableHeight,
          itemHeight: _trHeight,
          data: data,
          num: typeof listView !== 'boolean' ? listView.num : undefined,
          className: (0, _classnames.default)('rd-table__body'),
          onScroll: this.handleBodyScroll,
          ref: function ref(_ref3) {
            return _this7.bodyScrollWrapper = _ref3;
          },
          listView: listView,
          style: _objectSpread({
            height: tableHeight
          }, bodyStyle)
        }, load());
      } else if (useCustomScrollBar) {
        return /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames.default)('rd-table__body')
        }, /*#__PURE__*/React.createElement(_scrollBar.default, {
          hoverShowTrack: true,
          autoHide: true,
          autoHeight: !!tableHeight,
          hideScrollY: !tableHeight,
          autoHeightMax: tableHeight
        }, load()));
      } else {
        return /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames.default)('rd-table__body')
        }, load());
      }
    }
    /**
     * footer
     */

  }, {
    key: "footerTableRender",
    value: function footerTableRender() {
      var loading = this.props.loading;
      var _this$state6 = this.state,
          pagination = _this$state6.pagination,
          showData = _this$state6.showData;
      var hasLen = showData.length;

      if (this.props.pagination && hasLen && !loading) {
        return /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames.default)('rd-table__footer', "is-".concat(pagination.align || 'right'))
        }, /*#__PURE__*/React.createElement(_pagination2.default, (0, _extends2.default)({}, pagination, {
          onSizeChange: this.handleSizeChange,
          onCurrentChange: this.handleCurrentChange
        })));
      }
    }
    /**
     * 渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this8 = this;

      var _this$props9 = this.props,
          mini = _this$props9.mini,
          tableHeight = _this$props9.tableHeight,
          _this$props9$style = _this$props9.style,
          style = _this$props9$style === void 0 ? {} : _this$props9$style,
          className = _this$props9.className,
          stripe = _this$props9.stripe,
          border = _this$props9.border,
          listView = _this$props9.listView;
      /**如果没有header和footer，rd-tabled 样式即为content的样式 */

      return /*#__PURE__*/React.createElement(_TableContext.default.Provider, {
        value: {
          component: this
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)(className, 'rd-table', {
          /**斑马纹样式 */
          'rd-table__striped': stripe,
          'rd-table__border': border,
          'is-mini': mini
        }),
        ref: function ref(_ref5) {
          return _this8.el = _ref5;
        },
        style: _objectSpread({}, style)
      }, tableHeight && listView ? /*#__PURE__*/React.createElement(React.Fragment, null, this.headerTableRender(), this.bodyTableRender()) : /*#__PURE__*/React.createElement(React.Fragment, null, this.bodyTableRender()), this.footerTableRender(), this.resize && /*#__PURE__*/React.createElement("span", {
        className: "rd-table__column-resize-proxy",
        ref: function ref(_ref4) {
          return _this8.resizeProxy = _ref4;
        },
        style: {
          visibility: 'hidden'
        }
      })));
    }
  }]);
  return Table;
}(React.Component), _class2.defaultProps = {
  showHeader: true,
  editCoordinate: {
    key: new Array(),
    prop: new Array()
  },

  /**默认滚动高度动态加载数据 */
  listView: false,
  search: {},
  hasSortNull: true,
  useCustomScrollBar: true
}, _class2)) || _class;

exports.default = Table;