import * as React from 'react';
import Table from './Table';
import { Column, TableBodyProps, DataTypes, StrOrNum, searchType } from "./Types";
export default class TableBody extends React.Component<TableBodyProps> {
    static contextType: React.Context<any>;
    /**
     * 使用父级的引用
     */
    parent(): Table;
    /**
     *
     * @param props
     */
    constructor(props: TableBodyProps);
    /**
     * 点击当前行
     * @param row
     */
    handleClick(row: DataTypes, column: Column, disabled: boolean, event: React.MouseEvent): void;
    /**
     * 移入单元格
     * @param row
     */
    handleCellMouseEnter(row: DataTypes, column: Column, disabled: boolean, event: React.MouseEvent): void;
    /**
     * 移出单元格
     * @param row
     */
    handleCellMouseLeave(row: DataTypes, column: Column, disabled: boolean, event: React.MouseEvent): void;
    /**
     * 列渲染
     * @param row
     * @param column
     * @param index
     */
    renderCell(row: searchType, rowIndex: number, index: number, disabled: boolean): React.ReactNode;
    /**是否显示编辑行 */
    editDomRender(row: DataTypes, column: Column): boolean;
    /**
     * 是否checkbox勾选
     */
    isRowSelected(key?: StrOrNum): boolean;
    /**
     * checkbox单个选中
     * @param row
     * @param isSelected
     */
    toggleRowSelection(row: DataTypes, isSelected: boolean, event: any): void;
    /**
     * 渲染内容
     */
    renderContent(): React.ReactNode;
    /**
     * render
     */
    render(): React.ReactNode;
}
