"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _checkbox = _interopRequireDefault(require("../checkbox"));

var _TableContext = _interopRequireDefault(require("./TableContext"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _radio = _interopRequireDefault(require("../radio"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _span = _interopRequireDefault(require("../span"));

var _util = require("./util");

var _excluded = ["selectRowKey", "rowStyle", "rowKey", "selectableRow"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TableBody = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TableBody, _React$Component);

  var _super = _createSuper(TableBody);

  /**
   *
   * @param props
   */
  function TableBody(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TableBody);
    _this = _super.call(this, props);
    _this.state = {};
    return _this;
  }
  /**
   * 点击当前行
   * @param row
   */


  (0, _createClass2.default)(TableBody, [{
    key: "parent",
    value:
    /**
     * 使用父级的引用
     */
    function parent() {
      return this.context && this.context.component;
    }
  }, {
    key: "handleClick",
    value: function handleClick(row, column, disabled, event) {
      /**执行父级的回调，不管可不可以点击，外面传了就返回 */
      var _this$parent$props = this.parent().props,
          onRowClick = _this$parent$props.onRowClick,
          onSelectChange = _this$parent$props.onSelectChange,
          onCellClick = _this$parent$props.onCellClick;

      if (!disabled) {
        if (onCellClick) {
          onCellClick(row.data, row.data[column.prop], column, event);
        } else if (onRowClick) {
          onRowClick(row.data, row.key, event);
        }

        if (this.parent().state.columns[0].type === 'radio') {
          /**如果当前列允许点击并且类型为radio时，改变当前选中的列的key值 */
          this.parent().handleRowChange(row.key);
          var selectRowKey = this.props.selectRowKey;

          if (row.key !== selectRowKey) {
            onSelectChange && onSelectChange(row.key, row.data, event);
          }
        }
      }
    }
    /**
     * 移入单元格
     * @param row
     */

  }, {
    key: "handleCellMouseEnter",
    value: function handleCellMouseEnter(row, column, disabled, event) {
      /**执行父级的回调，不管可不可以点击，外面传了就返回 */
      if (!disabled) {
        var onMouseEnter = this.parent().props.onMouseEnter;
        onMouseEnter && onMouseEnter(row.data, row.data[column.prop], column, event);
      }
    }
    /**
     * 移出单元格
     * @param row
     */

  }, {
    key: "handleCellMouseLeave",
    value: function handleCellMouseLeave(row, column, disabled, event) {
      /**执行父级的回调，不管可不可以点击，外面传了就返回 */
      if (!disabled) {
        var onMouseLeave = this.parent().props.onMouseLeave;
        onMouseLeave && onMouseLeave(row.data, row.data[column.prop], column, event);
      }
    }
    /**
     * 列渲染
     * @param row
     * @param column
     * @param index
     */

  }, {
    key: "renderCell",
    value: function renderCell(row, rowIndex, index, disabled) {
      var _this2 = this;

      var parent = this.parent();
      var _parent$state = parent.state,
          columns = _parent$state.columns,
          pagination = _parent$state.pagination;
      /**类型为index时，动态添加序号 */

      var currentPage = 0;
      /**计算索引显示内容 */

      if (pagination) {
        currentPage = (pagination.currentPage - 1) * pagination.pageSize;
      }

      if (columns[index].type === 'index') {
        return currentPage + rowIndex + 1;
      }
      /**类型为radio时。添加radio组件 */


      if (columns[index].type === 'radio') {
        var selectRowKey = this.props.selectRowKey;
        /**判断是否选中，当前的可以和选中的key做对比 */

        var isSelected = row.key === selectRowKey;
        return /*#__PURE__*/React.createElement(_radio.default, {
          checked: isSelected,
          value: row.key
          /**是否可以点击 */
          ,
          disabled: disabled
        });
      }

      if (columns[index].type === 'checkbox') {
        var _isSelected = this.isRowSelected(row.key);

        return /*#__PURE__*/React.createElement(_checkbox.default, {
          checked: _isSelected
          /**是否可以点击 */
          ,
          disabled: disabled,
          onChange: function onChange(value, e) {
            !disabled && _this2.toggleRowSelection(row, !_isSelected, e);
          }
        });
      }

      var column = columns[index];
      var result = this.editDomRender(row, column);
      var renderDom = null;

      if (result && column.editDom && column.editable) {
        renderDom = column.editDom(row.data, column, row.key);
      } else {
        renderDom = column.render ? column.render(row.data, column, row.key) : row.data[column.prop];
      } //高亮显示搜索关键字


      if (typeof renderDom === 'string' && parent.props.keyWordClassName && row.keySearch && row.keySearch[column.prop]) {
        return /*#__PURE__*/React.createElement("span", {
          dangerouslySetInnerHTML: {
            __html: row.keySearch[column.prop]
          }
        });
      } else {
        return renderDom || parent.props.cellPlaceholder;
      }
      /**有prop属性就为数据，找到列数据渲染，没有prop就直接执行render函数，在column初始化时，每个column都有一个render函数且一般为操作项 */

    }
    /**是否显示编辑行 */

  }, {
    key: "editDomRender",
    value: function editDomRender(row, column) {
      var editCoordinate = this.parent().props.editCoordinate;
      /**有编辑显示位置且为true且有编辑时的dom时显示编辑的dom */

      var result = false;

      if (editCoordinate.props && editCoordinate.keys) {
        result = editCoordinate.keys.includes(row.key) && editCoordinate.props.includes(column.prop);
      } else {
        result = editCoordinate.keys && editCoordinate.keys.includes(row.key) || editCoordinate.props && editCoordinate.props.includes(column.prop);
      }

      return result;
    }
    /**
     * 是否checkbox勾选
     */

  }, {
    key: "isRowSelected",
    value: function isRowSelected(key) {
      var currentRowKey = this.props.currentRowKey;
      var selectedRowKeys = this.parent().state.selectedRowKeys;
      /**如果父级传了currentRowKey，则永辉自己维护 */

      if (Array.isArray(currentRowKey)) {
        return currentRowKey.includes(key);
      }
      /**否则使用selectedRowKeys */


      return selectedRowKeys instanceof Array && selectedRowKeys.includes(key);
    }
    /**
     * checkbox单个选中
     * @param row
     * @param isSelected
     */

  }, {
    key: "toggleRowSelection",
    value: function toggleRowSelection(row, isSelected, event) {
      var parent = this.parent();
      var currentRowKey = this.props.currentRowKey;
      /**当前key的索引位置 */

      var rowIndex = parent.state.selectedRowKeys.indexOf(row.key);
      /**新选择的默认为之前的 */

      var newCurrentRowKey = parent.state.selectedRowKeys;
      /**如果传了 currentRowKey，则使用currentRowKey*/

      if (Array.isArray(currentRowKey)) {
        rowIndex = currentRowKey.indexOf(row.key);
      }
      /**如果存在，则删除，不存在添加 */


      if (isSelected !== undefined) {
        if (isSelected && rowIndex === -1) {
          newCurrentRowKey.push(row.key);
        } else if (!isSelected && rowIndex !== -1) {
          newCurrentRowKey.splice(rowIndex, 1);
        }
      } else {
        rowIndex === -1 ? newCurrentRowKey.push(row.key) : newCurrentRowKey.splice(rowIndex, 1);
      }

      this.setState({
        selectedRowKeys: newCurrentRowKey
      });
      this.parent().toggleAllSelection(newCurrentRowKey, event, row.data);
    }
    /**
     * 渲染内容
     */

  }, {
    key: "renderContent",
    value: function renderContent() {
      var _this3 = this;

      var _this$props = this.props,
          selectRowKey = _this$props.selectRowKey,
          rowStyle = _this$props.rowStyle,
          rowKey = _this$props.rowKey,
          selectableRow = _this$props.selectableRow,
          props = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var parent = this.parent();
      var showData = parent.state.showData;

      if (!showData || showData.length === 0) {
        return null;
      }

      var _parent$state2 = parent.state,
          fixedColumns = _parent$state2.fixedColumns,
          rightFixedColumns = _parent$state2.rightFixedColumns,
          columns = _parent$state2.columns;
      var leftFixedLen = fixedColumns.length;
      var rightFixedLen = rightFixedColumns.length;

      var isFixed = function isFixed(column, pos) {
        return column.fixed === pos && parent.isSupSkicky;
      };

      var content = (0, _util.map)(showData, function (row, index) {
        var rowIndex = row.index;

        if (rowIndex === undefined) {
          rowIndex = index;
        }

        var selectable = parent.state.columns[0].selectable;
        var disabled = selectable && !selectable(row.data, row.key, rowIndex);
        var style = {};

        if (rowStyle) {
          style = rowStyle(row.data, rowIndex);
        }

        if (row.key.toString().indexOf('Placeholder') > -1) {
          return /*#__PURE__*/React.createElement("tr", {
            style: {
              height: row.data.height
            },
            key: row.key
          });
        }

        var left = 0;
        var right = 0;
        var rowDisabled = disabled && selectableRow;
        return /*#__PURE__*/React.createElement("tr", {
          key: row.key
          /**每行样式 */
          ,
          style: _objectSpread({}, style),
          className: (0, _classnames.default)(typeof props.rowClassName === 'string' ? props.rowClassName : typeof props.rowClassName === 'function' && props.rowClassName(row.data, rowIndex), 'rd-table__row', {
            /**斑马纹样式 */
            'rd-table__row--striped': parent.props.stripe && rowIndex % 2 === 1,
            'current-row': row.key === selectRowKey,
            'is-disabled': rowDisabled
            /**每行数据添加classname */

          })
        }, (0, _util.map)(columns, function (column, cellIndex) {
          var columnsLen = columns.length;

          if (column.editable && !row.key && !rowKey) {
            (0, _warning.default)(false, 'Table', 'table组件中使用可编辑的列时，data中必须传入key值，否则会导致编辑不成功');
          }

          var trStyle = {};

          if (isFixed(column, 'left')) {
            (0, _warning.default)(false, 'Table', '若需要使用左固定列，需要将固定列的宽度固定为number类型，否则不会出现固定列');
            trStyle.left = left;
            left += parent.getTrWidth(parent.getTdWidth(column));
          }

          if (isFixed(column, 'right')) {
            (0, _warning.default)(false, 'Table', '若需要使用右固定列，需要将固定列的宽度固定为number类型，否则不会出现固定列');
            trStyle.right = right;
            right += parent.getTrWidth(parent.getTdWidth(column));
          }

          var renderCell = _this3.renderCell(row, rowIndex, cellIndex, disabled);

          return /*#__PURE__*/React.createElement("td", {
            key: cellIndex,
            style: _objectSpread(_objectSpread(_objectSpread({}, style), trStyle), {}, {
              height: props.trHeight,
              minWidth: column.minWidth
            }),
            className: (0, _classnames.default)(column.className, column.align, column.fixed && "sticky-".concat(column.fixed), {
              'is-last-left-fix': leftFixedLen === cellIndex + 1,
              'is-first-right-fix': rightFixedLen === columnsLen - cellIndex
            }),
            onClick: function onClick(e) {
              _this3.handleClick(row, column, rowDisabled, e);
            },
            onMouseEnter: function onMouseEnter(e) {
              _this3.handleCellMouseEnter(row, column, rowDisabled, e);
            },
            onMouseLeave: function onMouseLeave(e) {
              _this3.handleCellMouseLeave(row, column, rowDisabled, e);
            }
          }, /*#__PURE__*/React.createElement("span", {
            className: (0, _classnames.default)('cell', {
              'is-ellipsis': column.ellipsis
            })
          }, column.ellipsis && column.title && !column.type ? /*#__PURE__*/React.createElement(_span.default, {
            title: renderCell
          }, renderCell) : renderCell));
        }));
      });
      return content;
    }
    /**
     * render
     */

  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement("tbody", null, this.renderContent());
    }
  }]);
  return TableBody;
}(React.Component), _class2.contextType = _TableContext.default, _class2)) || _class;

exports.default = TableBody;