import * as React from 'react';
import { TableHeaderProps, Column, SortOrderType } from './Types';
import Table from './Table';
export default class TableHeader extends React.Component<TableHeaderProps> {
    /**是否拖动  */
    dragging: boolean;
    draggingColumn: Column;
    static contextType: React.Context<any>;
    /**
     *
     */
    parent(): Table;
    /**
     *构造函数
     */
    constructor(props: TableHeaderProps);
    /**
     * 如果有默认排序，手动触发点击事件
     */
    componentDidMount(): void;
    /**
     * 列拖动按下时
     * @param column
     * @param event
     */
    handleMouseMove(column: Column, event: React.MouseEvent): void;
    /**设置鼠标样式 */
    mouseStyle(column: Column, event: React.MouseEvent): void;
    /**
     * 列拖动鼠标抬起时
     * @param column
     * @param event
     */
    handleMouseDown(column: Column, event: React.MouseEvent): void;
    /**
     * 列拖动鼠标移出时
     */
    handleMouseOut(): void;
    /**
     *th点击
     */
    handleHeaderClick(column: Column, event: React.MouseEvent): void;
    /**
     *排序按钮点击
     */
    handleSortClick(column?: Column, givenOrder?: SortOrderType, e?: React.MouseEvent<HTMLElement>): void;
    /**
     * 渲染头部
     */
    renderHeader(column: Column): React.ReactNode | null;
    /**
     * cell渲染
     * @param column
     */
    renderThCell(column: Column, order: SortOrderType | ''): React.ReactNode;
    /**
     *表头 渲染
     */
    render(): React.ReactNode;
}
