"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _checkbox = _interopRequireDefault(require("../checkbox"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _TableContext = _interopRequireDefault(require("./TableContext"));

var _util = require("../../libs/utils/util");

var _span = _interopRequireDefault(require("../span"));

var _util2 = require("./util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TableHeader = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TableHeader, _React$Component);

  var _super = _createSuper(TableHeader);

  /**
   *构造函数
   */
  function TableHeader(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TableHeader);
    _this = _super.call(this, props);
    _this.dragging = void 0;
    _this.draggingColumn = void 0;
    _this.state = {};
    return _this;
  }
  /**
   * 如果有默认排序，手动触发点击事件
   */


  (0, _createClass2.default)(TableHeader, [{
    key: "parent",
    value:
    /**是否拖动  */

    /**
     *
     */
    function parent() {
      return this.context && this.context.component;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var parent = this.parent();
      (0, _util2.map)(parent.state.columns, function (column) {
        var initOrder = column.sortOrder && column.sortOrder.order;

        if (!parent.state.sortColumn && initOrder) {
          _this2.handleSortClick(column, initOrder);
        }
      });
    }
    /**
     * 列拖动按下时
     * @param column
     * @param event
     */

  }, {
    key: "handleMouseMove",
    value: function handleMouseMove(column, event) {
      event.preventDefault();
      /**如果表头有子列不生效 */

      if (!column.resizable || column.subColumns && column.subColumns.length) {
        return;
      }
      /**有边框时才会生效 */


      var border = this.props.border;

      if (!this.dragging && border) {
        this.mouseStyle(column, event);
      }
    }
    /**设置鼠标样式 */

  }, {
    key: "mouseStyle",
    value: function mouseStyle(column, event) {
      var target = event.target;
      /**只有为th表头才会拉伸 */

      while (target && target.tagName && target.tagName.toUpperCase() !== 'TH') {
        target = target.parentNode;
      }

      var rect = target.getBoundingClientRect();
      var bodyStyle = document.body.style;
      /**鼠标移动当前选中的th右边位置的时候才会改变鼠标形状 */

      if (rect.width > 12 && rect.right - event.pageX < 8) {
        target.childNodes[0].style.cursor = 'col-resize';
        bodyStyle.cursor = 'col-resize';
        this.draggingColumn = column;
      } else {
        target.childNodes[0].style.cursor = column.sortOrder ? 'pointer' : '';
        bodyStyle.cursor = '';
        this.draggingColumn = null;
      }
    }
    /**
     * 列拖动鼠标抬起时
     * @param column
     * @param event
     */

  }, {
    key: "handleMouseDown",
    value: function handleMouseDown(column, event) {
      var _this3 = this;

      var parent = this.parent();
      var newColumn = column;
      /**当鼠标形状为可拉伸时有效 */

      if (this.draggingColumn) {
        this.dragging = true;
        var tableEl = parent.el,
            resizeProxy = parent.resizeProxy;
        var tableLeft = tableEl.getBoundingClientRect().left;
        var columnEl = event.target;
        /**如果鼠标选中的不为th，则一直向上冒，直到找到th元素 */

        while (columnEl && columnEl.tagName && columnEl.tagName.toUpperCase() !== 'TH') {
          columnEl = columnEl.parentNode;
        }

        var columnRect = columnEl.getBoundingClientRect();
        /**列最小宽度为30*/

        var minLeft = columnRect.left - tableLeft + 30;
        (0, _util.classList)(columnEl).add('noclick');
        var startMouseLeft = event.clientX;
        /**列的右边离表格左边的位置 */

        var startLeft = columnRect.right - tableLeft;
        /**列的左边离表格左边的位置 */

        var startColumnLeft = columnRect.left - tableLeft;
        /**隐藏移动线的位置，跟着鼠标走 */

        resizeProxy.style.visibility = 'visible';
        resizeProxy.style.left = startLeft + 'px';
        /**在document上添加拖拽事件 */

        var dragStart = function dragStart() {
          return false;
        };

        (0, _util.addEvent)(document, 'selectstart', dragStart);
        (0, _util.addEvent)(document, 'dragstart', dragStart);
        /**鼠标移动时不断改变隐藏线的位置 */

        var handleMouseMove = function handleMouseMove(event) {
          var deltaLeft = event.clientX - startMouseLeft;
          var proxyLeft = startLeft + deltaLeft;
          resizeProxy.style.left = Math.max(minLeft, proxyLeft) + 'px';
        };
        /**鼠标弹起时，隐藏线隐藏，移除拖拽事件和鼠标事件 */


        var handleMouseUp = function handleMouseUp(event) {
          if (_this3.dragging) {
            var finalLeft = parseInt(resizeProxy.style.left, 10);

            var minWidth = _this3.parent().getTrWidth(column.minWidth);

            var columnWidth = Math.max(finalLeft - startColumnLeft, minWidth);
            var oldWidth = newColumn.width;
            newColumn.width = columnWidth;
            newColumn.width = newColumn.width;
            _this3.dragging = false;
            _this3.draggingColumn = null;
            document.body.style.cursor = '';
            resizeProxy.style.visibility = 'hidden';
            (0, _util.removeEvent)(document, 'mousemove', handleMouseMove);
            (0, _util.removeEvent)(document, 'mouseup', handleMouseUp);

            var _dragStart = function _dragStart() {
              return null;
            };

            (0, _util.addEvent)(document, 'selectstart', _dragStart);
            (0, _util.addEvent)(document, 'dragstart', _dragStart);
            setTimeout(function () {
              (0, _util.classList)(columnEl).remove('noclick');
            });
            /**调用table更新宽度高度 */

            parent.scheduleLayout(newColumn);
            /**执行拖拽后的接口回调 */

            var onHeaderDragEnd = newColumn.onHeaderDragEnd;
            onHeaderDragEnd && onHeaderDragEnd(columnWidth, oldWidth, newColumn, event);
          }
        };

        (0, _util.addEvent)(document, 'mousemove', handleMouseMove);
        (0, _util.addEvent)(document, 'mouseup', handleMouseUp);
      }
    }
    /**
     * 列拖动鼠标移出时
     */

  }, {
    key: "handleMouseOut",
    value: function handleMouseOut() {
      document.body.style.cursor = "";
    }
    /**
     *th点击
     */

  }, {
    key: "handleHeaderClick",
    value: function handleHeaderClick(column, event) {
      if (this.dragging) {
        return;
      }

      var onThClick = this.props.onThClick;
      onThClick && onThClick(column, event);
      column.sortOrder && this.handleSortClick(column);
    }
    /**
     *排序按钮点击
     */

  }, {
    key: "handleSortClick",
    value: function handleSortClick(column, givenOrder, e) {
      /**e阻止冒泡，有e才执行 */
      e && e.stopPropagation();
      this.parent().onHeaderSortClick(column, givenOrder, e);
    }
    /**
     * 渲染头部
     */

  }, {
    key: "renderHeader",
    value: function renderHeader(column) {
      var type = column.type;
      /**索引或序号 */

      if (type === 'index') {
        return column.label || '#';
      }
      /**单选 */


      if (type === 'radio') {
        return column.label || '';
      }
      /**多选 */


      if (type === 'checkbox') {
        var parent = this.parent();
        var _parent$isAllSelected = parent.isAllSelected,
            selectAll = _parent$isAllSelected.selectAll,
            selectedData = _parent$isAllSelected.selectedData;
        var indeterminate = false;

        if (selectAll !== undefined && !selectAll && selectedData.length !== 0) {
          indeterminate = true;
        }

        var allowelect = parent.getSelectableData().length;
        return /*#__PURE__*/React.createElement(_checkbox.default, {
          disabled: !allowelect || !parent.state.showData.length,
          indeterminate: indeterminate,
          checked: selectAll,
          onChange: this.parent().toggleAllSelection
        });
      }
      /**头部renderHeader函数，只针对header表头 */


      return column.renderHeader ? column.renderHeader(column) : column.label;
    }
    /**
     * cell渲染
     * @param column
     */

  }, {
    key: "renderThCell",
    value: function renderThCell(column, order) {
      var _this4 = this;

      var renderCell = this.renderHeader(column);
      var _this$props = this.props,
          sortIcon = _this$props.sortIcon,
          sortSingleColumn = _this$props.sortSingleColumn,
          sortSingleIcon = _this$props.sortSingleIcon;
      var parent = this.parent();
      var currentColumn = parent.state.sortColumn && parent.state.sortColumn.prop === column.prop;
      var showAscending = sortSingleColumn && !sortSingleIcon && currentColumn || //单列显示升降符号
      sortSingleColumn && sortSingleIcon && order === 'ascending' || // 单列显示单个符号
      !sortSingleColumn && !sortSingleColumn; //不单列，显示升级符号

      var showDescending = sortSingleColumn && !sortSingleIcon && currentColumn || //单列显示升降符号
      sortSingleColumn && sortSingleIcon && order === 'descending' || // 单列显示单个符号
      !sortSingleColumn && !sortSingleColumn; //不单列，显示升级符号

      return /*#__PURE__*/React.createElement("span", {
        className: (0, _classnames.default)('cell', {
          'is-header-ellipsis': column.headEllipsis
        })
      }, column.headEllipsis && column.title && !column.type ? /*#__PURE__*/React.createElement(_span.default, {
        title: renderCell
      }, renderCell) : renderCell, column.sortOrder && /*#__PURE__*/React.createElement("div", {
        className: "caret-wrapper",
        onClick: function onClick(e) {
          return _this4.handleSortClick(column, null, e);
        }
      }, sortIcon ? /*#__PURE__*/React.createElement(React.Fragment, null, showAscending && sortIcon.ascending, showDescending && sortIcon.descending) : /*#__PURE__*/React.createElement(React.Fragment, null, showAscending && /*#__PURE__*/React.createElement("i", {
        className: "sort-caret ascending",
        onClick: function onClick(e) {
          return _this4.handleSortClick(column, 'ascending', e);
        }
      }), showDescending && /*#__PURE__*/React.createElement("i", {
        className: "sort-caret descending",
        onClick: function onClick(e) {
          return _this4.handleSortClick(column, 'descending', e);
        }
      }))));
    }
    /**
     *表头 渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var parent = this.parent();
      var _parent$state = parent.state,
          columnRows = _parent$state.columnRows,
          fixedColumns = _parent$state.fixedColumns,
          rightFixedColumns = _parent$state.rightFixedColumns;
      var _this$props2 = this.props,
          headClassName = _this$props2.headClassName,
          tableHeight = _this$props2.tableHeight;
      var leftFixedLen = fixedColumns.length;
      var rightFixedLen = rightFixedColumns.length;

      var isFixed = function isFixed(column, pos) {
        return column.fixed === pos && parent.isSupSkicky;
      };
      /**获取左右 */


      return /*#__PURE__*/React.createElement("thead", {
        className: headClassName
      }, columnRows.length && (0, _util2.map)(columnRows, function (columns, index) {
        var left = 0;
        var right = 0;
        return /*#__PURE__*/React.createElement("tr", {
          key: index
        }, (0, _util2.map)(columns, function (column, cellIndex) {
          // const width = parent.getTrWidth(parent.getTdWidth(column));
          var columnsLen = columns.length;
          var style = {};

          if (isFixed(column, 'left')) {
            (0, _warning.default)(false, 'Table', '若需要使用左固定列，需要将固定列的宽度固定为number类型，否则不会出现固定列');
            style.left = left;
            left += column.width;
          }

          if (isFixed(column, 'right')) {
            (0, _warning.default)(false, 'Table', '若需要使用右固定列，需要将固定列的宽度固定为number类型，否则不会出现固定列');
            style.right = right;
            right += column.width;
          } // style.width = isNaN(width) ? '' : width;


          style.width = column.width || '';
          var order = parent.state.sortColumn && parent.state.sortColumn.prop === column.prop && parent.state.sortColumn.sortOrder.order;
          return /*#__PURE__*/React.createElement("th", {
            key: cellIndex,
            colSpan: column.colSpan,
            rowSpan: column.rowSpan,
            style: _objectSpread(_objectSpread({}, style), {}, {
              minWidth: column.minWidth
            }),
            className: (0, _classnames.default)(column.className, order, column.headerAlign, column.labelClassName, column.fixed && "sticky-".concat(column.fixed), tableHeight && 'sticky-top', {
              /**是否为列表头，如果为多列表头，表头带边框 */
              'is-leaf': columnRows.length !== 1,

              /**是否排序样式 */
              'is-sortable': column.sortOrder,
              'is-last-left-fix': leftFixedLen === cellIndex + 1,
              'is-first-right-fix': rightFixedLen === columnsLen - cellIndex
            })
            /**伸缩列 */
            ,
            onMouseMove: function onMouseMove(e) {
              return _this5.handleMouseMove(column, e);
            },
            onMouseDown: function onMouseDown(e) {
              return _this5.handleMouseDown(column, e);
            },
            onMouseOut: _this5.handleMouseOut,
            onClick: function onClick(e) {
              return _this5.handleHeaderClick(column, e);
            }
          }, _this5.renderThCell(column, order));
        }));
      }));
    }
  }]);
  return TableHeader;
}(React.Component), _class2.contextType = _TableContext.default, _class2)) || _class;

exports.default = TableHeader;