"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Left = _interopRequireDefault(require("net-design-icons/lib/icons/Left"));

var _Right = _interopRequireDefault(require("net-design-icons/lib/icons/Right"));

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _types = require("../../libs/types");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Types = (0, _types.tuple)('default', 'card', 'border-card');
var PositionTypes = (0, _types.tuple)('left', 'top', 'right', 'bottom');

var Tabs = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Tabs, _React$Component);

  var _super = _createSuper(Tabs);

  // 默认props属性

  /**
   *
   * @param props 构造函数
   */
  function Tabs(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Tabs);
    _this = _super.call(this, props);
    _this.navScroll = void 0;
    _this.nav = void 0;
    _this.activeTab = void 0;
    var children = props.children,
        activeName = props.activeName;
    (0, _warning.default)(children, 'tabs', 'tab的内容不能为空，如果要用空，建议Tabs组件也不使用');
    _this.state = {
      children: children,
      currentName: activeName,
      navStyle: (0, _defineProperty2.default)({}, (0, _util.setPrefix)('transform'), ''),
      isAddStatus: false
    };
    return _this;
  }
  /**如果render为第一个，手动置为false */


  (0, _createClass2.default)(Tabs, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState(_objectSpread(_objectSpread({}, this.updateAcrollable()), this.calcBarStyle()));
      /**滚动时始终将active显示在页面上 */

      (0, _util.addEvent)(window, 'resize', (0, _util.debounce)(this.scrollToActiveTab, 200));
    }
    /**
     * 更新child和activename
     */

  }, {
    key: "componentDidUpdate",
    value:
    /**更新 */
    function componentDidUpdate(prevProps, prevState) {
      if (this.state.currentName !== prevState.currentName || prevProps.tabPosition !== this.props.tabPosition) {
        this.scrollToActiveTab();
        this.setState(_objectSpread(_objectSpread({}, this.updateAcrollable()), this.calcBarStyle()));
      }
    }
    /** */

  }, {
    key: "scrollToActiveTab",
    value: function scrollToActiveTab() {
      /**没有滚动条，不执行下面的操作 */
      var scrollable = this.state.scrollable;

      if (!scrollable) {
        return;
      }

      var nav = this.nav,
          navScroll = this.navScroll,
          activeTab = this.activeTab;
      /**tab选中显示区域 */

      var activeTabBounding = activeTab.getBoundingClientRect();
      /**tabs滚动区域===显示区域 */

      var navScrollBounding = navScroll.getBoundingClientRect();
      /**tabs所有tabs区域 */

      var navBounding = nav.getBoundingClientRect();
      /**当前滚动的偏移量 */

      var currentOffset = this.getCurrentScrollOffset();
      var newOffset = currentOffset;
      /**选中tab在显示区域左边，则往右边挪 */

      if (activeTabBounding.left < navScrollBounding.left) {
        /**偏移量 == 选中隐藏区域的宽度 */
        newOffset = currentOffset - (navScrollBounding.left - activeTabBounding.left);
        /**如果选中在显示区域右边 */
      } else if (activeTabBounding.right > navScrollBounding.right) {
        /**偏移量 == 选中区域右边隐藏的宽度 */
        newOffset = currentOffset + activeTabBounding.right - navScrollBounding.right;
        /**没有沾满 的情况 */
      } else if (navBounding.right < navScrollBounding.right) {
        /**偏移量 == 显示区域宽度 - 滚动条宽度 */
        newOffset = nav.offsetWidth - navScrollBounding.width;
      }

      newOffset = Math.max(newOffset, 0);
      this.setOffset(newOffset);
    }
    /**
     * tab切换
     * @param tab tabs实例
     * @param e
     */

  }, {
    key: "handleTabClick",
    value: function handleTabClick(tab, e) {
      var _this2 = this;

      if (tab.props.disabled) {
        return;
      } // 点击tab或切换当前选择的currentName值


      this.setState({
        currentName: tab.props.name
      }, function () {
        var onTabClick = _this2.props.onTabClick;
        onTabClick && onTabClick(tab, e);
      });
    }
    /**
     * 滑动条样式
     */

  }, {
    key: "calcBarStyle",
    value: function calcBarStyle() {
      var _this$props = this.props,
          type = _this$props.type,
          tabPosition = _this$props.tabPosition,
          tabNavInterval = _this$props.tabNavInterval,
          showTabNavBarByLabel = _this$props.showTabNavBarByLabel;
      var _this$state = this.state,
          currentName = _this$state.currentName,
          children = _this$state.children; //没有tab，retrun

      if (type !== 'default' || !children.length) {
        return {};
      }

      var style = {};
      var offset = 0;
      var tabClient = 0;
      var newChildren = children instanceof Array ? children : [children];
      var nav = this.nav; // 判断tab布局是处于水平的还是垂直的,如果水平,就获取tabs的宽度,否则获取高度

      var horizontal = tabPosition === 'top' || tabPosition === 'bottom';
      newChildren.every(function (item, index) {
        if (nav) {
          var $el = nav.childNodes[index]; // 定位到当前active tab的下面

          var _$el$getBoundingClien = $el.getBoundingClientRect(),
              width = _$el$getBoundingClien.width,
              height = _$el$getBoundingClien.height;

          if (item.props.name !== currentName) {
            offset += horizontal ? width + tabNavInterval : height;
            return true;
          } else {
            var labelWidth = 0;

            if (showTabNavBarByLabel) {
              // 获取el内部内容的宽度，只会获取到rd-tabs__label的宽度
              var _$el$querySelector$ge = $el.querySelector('.rd-tabs__label').getBoundingClientRect(),
                  childWidth = _$el$querySelector$ge.width;

              labelWidth = childWidth;
              offset = offset + (width - labelWidth) / 2;
            } else {
              labelWidth = width;
            }

            tabClient = horizontal ? labelWidth : height;
            return false;
          }
        }
      }); // 动态设置滚动的位置/

      if (horizontal) {
        style.width = "".concat(tabClient, "px");
        style.left = offset;
        style['transitionProperty'] = 'width , left';
        style['transitionDuration'] = '.3s cubic-bezier(.645, .045, .355, 1)';
      } else {
        style.height = "".concat(tabClient, "px");
        style.top = offset;
        style['transitionProperty'] = 'height , top';
        style['transitionDuration'] = '.3s cubic-bezier(.645, .045, .355, 1)';
      }

      return {
        barStyle: style
      };
    }
    /**
     * tab动态添加
     */

  }, {
    key: "handleTabAdd",
    value: function handleTabAdd() {
      var _this3 = this;

      // 添加方法完全由上级维护
      var onTabAdd = this.props.onTabAdd;
      var isAddStatus = this.state.isAddStatus;
      onTabAdd && onTabAdd();
      this.setState({
        isAddStatus: !isAddStatus
      }, function () {
        var children = _this3.state.children;

        _this3.setState({
          currentName: children[children.length - 1].props.name
        });
      });
    }
    /**
     * tab删除
     */

  }, {
    key: "handleTabRemove",
    value: function handleTabRemove(tab, index, e) {
      var _this4 = this;

      var _this$state2 = this.state,
          children = _this$state2.children,
          currentName = _this$state2.currentName;
      var onTabRemove = this.props.onTabRemove;
      e.stopPropagation(); // 当前name和选中的name相同 把当前tab扣掉,组后上一个tab和下一个tab在一起

      if (children[index].props.name === currentName) {
        var nextChild = children[index + 1];
        var prevChild = children[index - 1];
        /**设置currentName  如果上一个下一个tab都没有说明没有tab标签,当前选中name设置为-1,如果有下一个tab,当前tab name就设置为下一个name的值,然后没有下一个name就找上一个 */

        var _currentName = '-1';

        if (nextChild) {
          _currentName = nextChild.props.name;
        } else if (prevChild) {
          _currentName = prevChild.props.name;
        }

        this.setState({
          currentName: _currentName
        });
      } // 在所有children中将当前选中tab移除


      children.splice(index, 1);
      this.setState({
        children: children
      }, function () {
        onTabRemove && onTabRemove(tab, index);

        _this4.scrollToActiveTab();

        _this4.setState(_objectSpread(_objectSpread({}, _this4.updateAcrollable()), _this4.calcBarStyle()));
      });
    }
    /**更新控制滚动图标的显示隐藏 */

  }, {
    key: "updateAcrollable",
    value: function updateAcrollable() {
      var nav = this.nav,
          navScroll = this.navScroll;
      var navWidth = nav && nav.offsetWidth;
      var containerWidth = navScroll && navScroll.offsetWidth;
      var _this$state3 = this.state,
          scrollablePrev = _this$state3.scrollablePrev,
          scrollableNext = _this$state3.scrollableNext;
      /**有滚动条 */

      var scrollable = false;

      if (containerWidth < navWidth) {
        var currentOffset = this.getCurrentScrollOffset();
        scrollable = true;
        scrollablePrev = !!currentOffset;
        scrollableNext = currentOffset + containerWidth < navWidth;
      } else {
        scrollable = false;
      }

      return {
        scrollable: scrollable,
        scrollablePrev: scrollablePrev,
        scrollableNext: scrollableNext
      };
    }
    /**
    * 滚动往前
    */

  }, {
    key: "scrollPrev",
    value: function scrollPrev() {
      var navScroll = this.navScroll;
      var scrollablePrev = this.state.scrollablePrev;
      /**显示宽度 */

      var containerWidth = navScroll.offsetWidth;
      /**滚动transform宽度 */

      var currentOffset = this.getCurrentScrollOffset();

      if (!currentOffset || !scrollablePrev) {
        return;
      }

      var newOffset = currentOffset > containerWidth ? currentOffset - containerWidth : 0;
      this.setOffset(newOffset);
    }
    /**滚动往后 */

  }, {
    key: "scrollNext",
    value: function scrollNext() {
      var navScroll = this.navScroll,
          nav = this.nav;
      var scrollableNext = this.state.scrollableNext;
      var navWidth = nav.offsetWidth;
      var containerWidth = navScroll.offsetWidth;
      var currentOffset = this.getCurrentScrollOffset();
      /**nav总宽度和滚动宽度<=显示宽度，说明没有滚动条 */

      if (navWidth - currentOffset <= containerWidth || !scrollableNext) {
        return;
      }
      /**nav总宽度-滚动宽度(剩下的宽度)> 显示的总宽度*2 ，就滚动一个显示宽度，否则直接滚到最后*/


      var newOffset = navWidth - currentOffset > containerWidth * 2 ? currentOffset + containerWidth : navWidth - containerWidth;
      this.setOffset(newOffset);
    }
    /**获取滚动位置 */

  }, {
    key: "getCurrentScrollOffset",
    value: function getCurrentScrollOffset() {
      var navStyle = this.state.navStyle;
      return navStyle[(0, _util.setPrefix)('transform')]
      /**获取transform的宽度 */
      ? Number(navStyle[(0, _util.setPrefix)('transform')].match(/translateX\(-(\d+(\.\d+)*)px\)/)[1]) : 0;
    }
    /**设置滚动位置 */

  }, {
    key: "setOffset",
    value: function setOffset(value) {
      var _this5 = this;

      this.setState({
        navStyle: (0, _defineProperty2.default)({}, (0, _util.setPrefix)('transform'), "translateX(-".concat(value, "px)"))
      }, function () {
        _this5.setState(_objectSpread({}, _this5.updateAcrollable()));
      });
    }
    /**
    * 渲染
    */

  }, {
    key: "render",
    value: function render() {
      var _this6 = this;

      var _this$state4 = this.state,
          currentName = _this$state4.currentName,
          navStyle = _this$state4.navStyle,
          barStyle = _this$state4.barStyle,
          scrollable = _this$state4.scrollable,
          scrollablePrev = _this$state4.scrollablePrev,
          scrollableNext = _this$state4.scrollableNext;
      var _this$props2 = this.props,
          children = _this$props2.children,
          style = _this$props2.style,
          tabPosition = _this$props2.tabPosition,
          type = _this$props2.type,
          addable = _this$props2.addable,
          className = _this$props2.className,
          tabNavClassName = _this$props2.tabNavClassName,
          tabNavStretch = _this$props2.tabNavStretch,
          tabNavInterval = _this$props2.tabNavInterval;
      var tabsCls = (0, _classnames.default)('rd-tabs', "rd-tabs--".concat(type), "rd-tabs--".concat(tabPosition)); // 是否有添加按钮

      var addButton = addable && /*#__PURE__*/React.createElement("span", {
        className: "rd-tabs__new-tab",
        onClick: function onClick() {
          return _this6.handleTabAdd();
        }
      }, "+"); // 是否有滚动

      var scrollBtn = scrollable && [/*#__PURE__*/React.createElement("span", {
        key: "rd-tabs__nav-prev",
        className: scrollablePrev ? 'rd-tabs__nav-prev' : 'rd-tabs__nav-prev is-disabled',
        onClick: function onClick() {
          return _this6.scrollPrev();
        }
      }, /*#__PURE__*/React.createElement(_Left.default, null)), /*#__PURE__*/React.createElement("span", {
        key: "rd-tabs__nav-next",
        className: scrollableNext ? 'rd-tabs__nav-next' : 'rd-tabs__nav-next is-disabled',
        onClick: function onClick() {
          return _this6.scrollNext();
        }
      }, /*#__PURE__*/React.createElement(_Right.default, null))];
      /**children内容 */

      var contentRender = /*#__PURE__*/React.createElement("div", {
        className: "rd-tabs__content"
      }, React.Children.map(children, function (element) {
        var name = element.props.name;

        var style = _objectSpread({}, element.props.style);

        if (name !== currentName) {
          style.display = 'none';
        } else {
          style.display = undefined;
        }

        return /*#__PURE__*/React.cloneElement(element, Object.assign({}, element.props, {
          style: _objectSpread({}, style)
        }));
      }));
      var tabsNavCls = (0, _classnames.default)("rd-tabs__nav", "is-".concat(tabPosition), tabNavClassName, {
        "is-stretch": tabNavStretch
      }); // top的情况下，

      var tabsItemStyle = {};

      if (tabPosition === 'top' && tabNavInterval) {
        tabsItemStyle.marginLeft = tabNavInterval;
      }

      return /*#__PURE__*/React.createElement("div", {
        style: style,
        className: (0, _classnames.default)(className, tabsCls)
      }, tabPosition === 'bottom' && contentRender, /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-tabs__header', "is-".concat(tabPosition))
      }, addButton, /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-tabs__nav-wrap', "is-".concat(tabPosition), {
          "is-scrollable": scrollable
        })
      }, scrollBtn, /*#__PURE__*/React.createElement("div", {
        className: "rd-tabs__nav-scroll",
        ref: function ref(_ref3) {
          _this6.navScroll = _ref3;
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: tabsNavCls,
        ref: function ref(_ref2) {
          _this6.nav = _ref2;
        },
        style: navStyle
      }, React.Children.map(children, function (tab, index) {
        var _tab$props = tab.props,
            name = _tab$props.name,
            label = _tab$props.label,
            disabled = _tab$props.disabled;
        var tabCls = (0, _classnames.default)("is-".concat(tabPosition), {
          'rd-tabs__item': true,
          'is-active': name === currentName,
          'is-disabled': disabled,
          'is-closable': tab.props.closable
        });
        var currTabsItemStyle = {};

        if (index > 0) {
          currTabsItemStyle = _objectSpread({}, tabsItemStyle);
        }

        return /*#__PURE__*/React.createElement("div", {
          key: "rd-tabs__item-".concat(index),
          className: tabCls,
          style: _objectSpread({}, currTabsItemStyle),
          onClick: function onClick(e) {
            return _this6.handleTabClick(tab, e);
          },
          ref: function ref(_ref) {
            if (name === currentName) {
              _this6.activeTab = _ref;
            }
          }
        }, tab.props.prefix && /*#__PURE__*/React.createElement("span", {
          className: "rd-tabs__prefix"
        }, tab.props.prefix), /*#__PURE__*/React.createElement("span", {
          className: "rd-tabs__label"
        }, label), tab.props.closable && /*#__PURE__*/React.createElement("span", {
          className: (0, _classnames.default)('rd-tabs__close'),
          onClick: function onClick(e) {
            return _this6.handleTabRemove(tab, index, e);
          }
        }, "x"));
      }), type === 'default' && /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)("rd-tabs__active-bar", "is-".concat(tabPosition)),
        style: barStyle
      }))))), tabPosition !== 'bottom' && contentRender);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newChildren = nextProps.children || [];
      var newActiveName = nextProps.activeName || nextProps.children[0].props.name;

      if (prevState._prevProps) {
        if (prevState._prevProps.children === nextProps.children) {
          newChildren = prevState.children;
        }

        if (prevState._prevProps.activeName === nextProps.activeName) {
          newActiveName = prevState.currentName;
        }
      }

      return _objectSpread(_objectSpread({}, nextProps), {}, {
        _prevProps: nextProps,
        children: newChildren,
        currentName: newActiveName
      });
    }
  }]);
  return Tabs;
}(React.Component), _class2.Pane = void 0, _class2.defaultProps = {
  type: 'default',
  addable: false,
  tabPosition: 'top',
  tabNavStretch: false,
  tabNavInterval: 0,
  showTabNavBarByLabel: false
}, _class2)) || _class;

exports.default = Tabs;