import * as React from 'react';
import { Size } from '../../libs/types';
import TagGroup from "./TagGroup";
declare const TagTypeTypes: ["success", "info", "danger", "warning"];
export declare type TagType = typeof TagTypeTypes[number];
declare const TagThemeTypes: ["dark", "light", "plain"];
export declare type TagTheme = typeof TagThemeTypes[number];
interface TagProps {
    className?: string;
    type?: TagType;
    style?: React.CSSProperties;
    theme?: TagTheme;
    size?: Size;
    closable?: boolean;
    onClose?: (e: React.MouseEvent<HTMLOrSVGElement>) => void;
}
export default class Tag extends React.Component<TagProps> {
    static defaultProps: {
        closable: boolean;
        size: string;
    };
    static Group: typeof TagGroup;
    static TagGroup: typeof TagGroup;
    /**
     * 关闭
     * @param e
     */
    handleClose(e: React.MouseEvent<HTMLOrSVGElement>): void;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
