import * as React from 'react';
import { Size } from '../../libs/types';
import { Slot } from "../input/Input";
declare const TagTypeTypes: ["success", "info", "danger", "warning"];
export declare type TagType = typeof TagTypeTypes[number];
declare const TagThemeTypes: ["dark", "light", "plain"];
export declare type TagTheme = typeof TagThemeTypes[number];
export declare type ItemValue = string | number | {
    label: string | number;
};
interface TagGroupState {
    searchValue?: string;
}
interface TagGroupProps {
    /**select下拉框的visible */
    visible?: boolean;
    searchable?: boolean;
    className?: string;
    name?: string;
    placeholder?: string;
    bordered?: boolean;
    type?: TagType;
    style?: React.CSSProperties;
    theme?: TagTheme;
    size?: Size;
    value?: Array<ItemValue>;
    allowClear?: boolean;
    /**前缀自定义--位于边框内部**/
    prefix?: React.ReactNode | Slot | Array<Slot>;
    /**后缀自定义--位于边框内部**/
    suffix?: React.ReactNode | Slot | Array<Slot>;
    /**前缀自定义--位于边框外部**/
    prepend?: React.ReactNode;
    /**后缀自定义--位于边框外部**/
    append?: React.ReactNode;
    /**表单校验显示状态图标**/
    status?: Slot;
    /**是否可读**/
    readOnly?: boolean;
    /**是否禁用**/
    disabled?: boolean;
    /**是否呈现收缩状态**/
    collapsible?: boolean;
    onChange?: (value: Array<ItemValue>, e: React.MouseEvent<HTMLOrSVGElement>) => void;
    onClick?: (e: React.MouseEvent) => void;
    closable?: boolean;
    onSearchOptions?: (value: string) => void;
}
export default class TagGroup extends React.Component<TagGroupProps, TagGroupState> {
    state: {
        searchValue: string;
    };
    private searchRef;
    static defaultProps: TagGroupProps;
    static contextType: React.Context<any>;
    /**内容更新后 */
    componentDidUpdate(): void;
    /**
     * 关闭
     * @param e
     * @param index
     */
    private handleClose;
    /**
     *将输入框置空
     */
    handleClear(e: React.MouseEvent<HTMLElement>): void;
    /**搜索 */
    handleSearchChange(e: React.ChangeEvent<HTMLInputElement>): void;
    /**searchFocusFocus */
    handleSearchInput(type?: string): void;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
