"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _types = require("../../libs/types");

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _util = require("../../libs/utils/util");

var _span = _interopRequireDefault(require("../span"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _FormElement = require("../form/FormElement");

var _ref3 = require("../../libs/ref");

var _FormContext = require("../form/FormContext");

var _excluded = ["disabled", "className", "style", "trim", "value", "title", "bordered", "autoSize", "resize", "fitSize"];

var _dec, _dec2, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var InputResizeTypes = (0, _types.tuple)(
/**不能调整元素的尺寸**/
'none',
/**可调整元素的高度和宽度**/
'both',
/**可调整元素的宽度**/
'horizontal',
/**可调整元素的高度**/
'vertical');
var ResizeConfig = {
  none: 'default',
  both: 'nw-resize',
  horizontal: 'e-resize',
  vertical: 's-resize'
};
var TextArea = (_dec = (0, _ref3.forwardRef)(), _dec2 = (0, _FormElement.createFormElement)(), _dec(_class = _dec2(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TextArea, _React$Component);

  var _super = _createSuper(TextArea);

  /**
   * 构造函数
   * @param props
   */
  function TextArea(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TextArea);
    _this = _super.call(this, props);
    _this.inputRef = void 0;
    _this.drag = {};
    _this.state = void 0;
    _this.textAreaWrapper = void 0;
    _this.limitText = /*#__PURE__*/React.createRef();
    _this.inputRef = (0, _util.combineRef)(props);
    var _props$value = props.value,
        value = _props$value === void 0 ? '' : _props$value,
        _props$defaultValue = props.defaultValue,
        defaultValue = _props$defaultValue === void 0 ? '' : _props$defaultValue;
    _this.state = {
      focus: false,
      passwordType: false,
      placeholderVisible: true,
      valueLength: value.length || defaultValue.length || 0,
      style: props.style
    };
    return _this;
  }

  (0, _createClass2.default)(TextArea, [{
    key: "componentDidMount",
    value:
    /**
     *初次渲染
     */
    function componentDidMount() {
      if (process.env.NODE_ENV !== 'test') {
        (0, _warning.default)((0, _util.isDisplayNone)(this.inputRef.current), 'Input', "Input\u6216\u8005Input\u7684\u7236\u7C7B\u4E0D\u53EF\u89C1 \u5BFC\u81F4\u539F\u56E0\u53EF\u80FD\u662F\u4F60\u5728Input\u6216\u8005Input\u7684\u7236\u7C7B\u4E0A\u8BBE\u7F6E\u4E86display:none");
      }

      this.autoSetRows();
    }
    /**
     * 自动设置rows
     */

  }, {
    key: "autoSetRows",
    value: function autoSetRows() {
      var autoSize = this.props.autoSize;

      if (autoSize) {
        this.inputRef.current.rows = 1;
        var style = getComputedStyle(this.inputRef.current);
        var paddingSize = parseInt(style.paddingTop) + parseInt(style.paddingBottom);
        var contentHeight = this.inputRef.current.getBoundingClientRect().height - paddingSize;
        /**一行的高度**/

        var singleRowHeight = contentHeight / this.inputRef.current.rows;
        var rows = Math.round((this.inputRef.current.scrollHeight - paddingSize) / singleRowHeight);

        if ((0, _util.classType)(autoSize) === 'Object') {
          var _ref = autoSize,
              minRows = _ref.minRows,
              maxRows = _ref.maxRows;

          if (minRows !== null) {
            rows = Math.max(minRows, rows);
          }

          if (maxRows !== null) {
            rows = Math.min(maxRows, rows);
          }
        }

        this.inputRef.current.rows = rows;
      }
    }
    /**
     * 组件更新后
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.autoSetRows();
    }
    /**
     * 处理点击事件
     * @param e
     */

  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var onClick = this.props.onClick;
      e.persist();

      if (onClick) {
        onClick(e);
      }
    }
    /**
     * 键盘落下事件
     * @param e
     */

  }, {
    key: "handleKeyDown",
    value: function handleKeyDown(e) {
      var onKeyDown = this.props.onKeyDown;
      e.persist();

      if (onKeyDown) {
        onKeyDown(e);
      }
    }
    /**
     * 值改变事件
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(e) {
      var onChange = this.props.onChange;
      this.setState({
        valueLength: (e.target.value || '').length
      });
      e.persist();

      if (onChange) {
        onChange(e);
      }
    }
    /**
     * 处理聚焦事件
     * @param e
     */

  }, {
    key: "handleFocus",
    value: function handleFocus(e) {
      this.inputRef.current && this.inputRef.current.focus();
      var _this$props = this.props,
          onFocus = _this$props.onFocus,
          readOnly = _this$props.readOnly;
      this.setState({
        focus: true
      });

      if (e.target.value !== undefined && !readOnly) {
        this.setState({
          placeholderVisible: false
        });
      }

      if (onFocus) {
        onFocus(e);
      }
    }
    /**
     * 处理失去焦点事件
     * @param e
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      var onBlur = this.props.onBlur;
      this.setState({
        focus: false
      });

      if (e.target.value === '') {
        this.setState({
          placeholderVisible: true
        });
      }

      if (onBlur) {
        onBlur(e);
      }
    }
    /**
     * 处理placeholder点击事件
     */

  }, {
    key: "handlePlaceHolderClick",
    value: function handlePlaceHolderClick() {
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          readOnly = _this$props2.readOnly;

      if (disabled || readOnly) {
        return;
      }

      this.inputRef.current.focus();
    }
    /**
     * 渲染placeholder
     * @param otherProps
     */

  }, {
    key: "renderPlaceholder",
    value: function renderPlaceholder(otherProps) {
      var _this$props3 = this.props,
          placeholder = _this$props3.placeholder,
          value = _this$props3.value,
          readOnly = _this$props3.readOnly;
      var placeholderVisible = this.state.placeholderVisible;
      var visible = !(value !== undefined && value !== '' || !placeholderVisible) && placeholder !== undefined && otherProps.defaultValue === undefined;

      if (value === '') {
        visible = true;
      }

      return /*#__PURE__*/React.createElement("span", {
        className: "placeholder",
        style: {
          visibility: visible ? 'visible' : 'hidden'
        },
        unselectable: readOnly ? 'on' : 'off' //ie readonly 一样会有聚焦的表现形式 所以加上这么一句话
        ,
        onClick: this.handlePlaceHolderClick
      }, placeholder);
    }
    /**
     * 拖动结束
     * @param e
     */

  }, {
    key: "dragMove",
    value: function dragMove(e) {
      window.getSelection() && window.getSelection().removeAllRanges();
      var _this$props4 = this.props,
          resize = _this$props4.resize,
          autoSize = _this$props4.autoSize;

      if (autoSize) {
        return;
      }

      var _this$drag = this.drag,
          width = _this$drag.width,
          height = _this$drag.height;
      var diffX = e.clientX - this.drag.startX;
      var diffY = e.clientY - this.drag.startY;
      var _width = width;
      var _height = height;
      var Config = {
        none: function none() {
          _width = width;
          _height = height;
        },
        both: function both() {
          _width = width + diffX;
          _height = height + diffY;
        },
        horizontal: function horizontal() {
          _width = width + diffX;
          _height = height;
        },
        vertical: function vertical() {
          _width = width;
          _height = height + diffY;
        }
      };
      Config[resize]();
      this.inputRef.current.style.width = "".concat(_width, "px");
      this.inputRef.current.style.height = "".concat(_height, "px");
    }
    /**
     * 拖动结束
     */

  }, {
    key: "dragEnd",
    value: function dragEnd() {
      (0, _util.removeEvent)(document, 'mouseup', this.dragEnd);
      (0, _util.removeEvent)(document, 'mousemove', this.dragMove);
    }
    /**
     * 处理鼠标落下事件
     */

  }, {
    key: "handleMouseDown",
    value: function handleMouseDown(e) {
      var _this$props5 = this.props,
          onMouseDown = _this$props5.onMouseDown,
          resize = _this$props5.resize;
      onMouseDown && onMouseDown(e);

      if (resize === 'none') {
        return;
      } else if (resize === 'both' || resize === 'horizontal') {
        var _this$textAreaWrapper = this.textAreaWrapper.getBoundingClientRect(),
            width = _this$textAreaWrapper.width;

        this.textAreaWrapper.style.width = 'auto';
        this.inputRef.current.style.width = "".concat(width, "px");
      }

      this.drag.startX = e.clientX;
      this.drag.startY = e.clientY;
      var wrapperStyle = getComputedStyle(this.inputRef.current);
      this.drag.width = parseFloat(wrapperStyle.width);
      this.drag.height = parseFloat(wrapperStyle.height);
      (0, _util.addEvent)(document, 'mousemove', this.dragMove);
      (0, _util.addEvent)(document, 'mouseup', this.dragEnd);
    }
    /**
     * 计算svg拖动的图标样式
     */

  }, {
    key: "getComputedDragStyle",
    value: function getComputedDragStyle() {
      var resize = this.props.resize;
      var cursor = ResizeConfig[resize];
      return {
        cursor: cursor ? cursor : 'default'
      };
    }
    /**
     * 渲染textarea
     * @param renderProps
     */

  }, {
    key: "renderRealTextArea",
    value: function renderRealTextArea(renderProps) {
      var _this$props6 = this.props,
          rows = _this$props6.rows,
          autoSize = _this$props6.autoSize,
          maxLength = _this$props6.maxLength,
          placeholder = _this$props6.placeholder;
      var valueLength = this.state.valueLength;
      var textarea = /*#__PURE__*/React.createElement("textarea", (0, _extends2.default)({}, renderProps, {
        className: "rd-textarea__inner rd-scroll",
        style: {
          resize: 'none',
          width: '100%'
        },
        placeholder: placeholder,
        rows: autoSize ? 1 : parseInt(rows)
      }));
      return /*#__PURE__*/React.createElement(React.Fragment, null, textarea, maxLength && /*#__PURE__*/React.createElement("div", {
        ref: this.limitText,
        className: 'rd-textarea__limittext'
      }, "".concat(valueLength, "/").concat(maxLength)));
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$context,
          _this2 = this;

      var focus = this.state.focus;
      var _this$props7 = this.props,
          disabled = _this$props7.disabled,
          className = _this$props7.className,
          style = _this$props7.style,
          trim = _this$props7.trim,
          value = _this$props7.value,
          title = _this$props7.title,
          bordered = _this$props7.bordered,
          autoSize = _this$props7.autoSize,
          resize = _this$props7.resize,
          fitSize = _this$props7.fitSize,
          rest = (0, _objectWithoutProperties2.default)(_this$props7, _excluded);
      var size = this.props.size || ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.size);
      var classes = (0, _classnames.default)(className, 'rd-textarea', size && "rd-textarea--".concat(size), {
        'is-disabled': disabled,
        'is-bordered': bordered,
        'is-active': focus,
        'is-full': !fitSize,
        'is-autosize': autoSize
      });
      var otherProps = (0, _omit.default)(rest, ['size', 'forwardRef', 'placeholder', 'rows']);
      var _value = value;

      if (typeof value === 'string') {
        _value = value.trim();
      }

      var renderProps = _objectSpread(_objectSpread({}, otherProps), {}, {
        ref: this.inputRef,
        value: trim ? _value : value,
        disabled: disabled,
        onChange: this.handleChange,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onKeyDown: this.handleKeyDown
      });

      var textarea = /*#__PURE__*/React.createElement(_FormContext.SizeContext.Provider, {
        value: {
          size: size
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: classes,
        ref: function ref(_ref2) {
          return _this2.textAreaWrapper = _ref2;
        },
        onClick: this.handleClick,
        style: _objectSpread({}, style)
      }, (0, _util.isIE9)() && this.renderPlaceholder(otherProps), this.renderRealTextArea(renderProps), resize !== 'none' && !autoSize && /*#__PURE__*/React.createElement("svg", {
        onMouseDown: this.handleMouseDown,
        className: "rd-textarea__resize",
        viewBox: "0 0 1024 1024",
        width: "21",
        height: "21",
        style: this.getComputedDragStyle()
      }, /*#__PURE__*/React.createElement("path", {
        d: "m896.62276,446.03551l69.17723,66.66717l-415.16123,400.09734l-69.17723,-66.66717l415.16123,-400.09734zm-65.85046,-330.03551l69.17723,66.66717l-691.7723,666.76603l-69.17723,-66.66717l691.87015,-666.76603l-0.09785,0z",
        fill: "#999999",
        stroke: "null"
      }))));

      if (title === undefined) {
        return textarea;
      } else {
        return /*#__PURE__*/React.createElement(_span.default, {
          needWrapper: false,
          title: title
        }, textarea);
      }
    }
  }]);
  return TextArea;
}(React.Component), _class2.defaultProps = {
  type: 'text',
  autoSize: false,
  rows: 2,
  disabled: false,
  trim: false,
  resize: 'none',
  autoComplete: 'off',
  fitSize: false,
  size: 'medium',
  bordered: true
}, _class2.contextType = _FormContext.SizeContext, _class2)) || _class) || _class) || _class);
exports.default = TextArea;