import * as React from 'react';
import { PlacementType, PopoverProps } from '../popover/Popover';
declare const ThemeTypes: ["dark", "light"];
export declare type TooltipThemeType = typeof ThemeTypes[number];
export interface TooltipProps extends PopoverProps {
    /**直接子类**/
    children?: React.ReactNode;
    /**样式类名称**/
    className?: string;
    /**样式**/
    style?: React.CSSProperties;
    /**鼠标离开后是否隐藏Popper**/
    hoverLeaveHidden?: boolean;
    /**鼠标离开后隐藏Popper的延迟时间**/
    hoverLeaveDuration?: number;
    /**是否显示箭头**/
    visibleArrow?: boolean;
    /**偏移量**/
    offset?: [number, number];
    /**放置位置**/
    placement?: PlacementType;
    /**是否禁用**/
    disabled?: boolean;
    /**标题**/
    title?: React.ReactNode;
    /**主题**/
    theme?: TooltipThemeType;
    /**边框颜色**/
    borderColor?: string;
    /**boolean
     * true代表弹出框的宽度和children的长度一样
     * false 代表弹出框的宽度由overlay的样式控制
     * minWidth 代表弹出框的最小宽度和children的长度一样
     * **/
    popperWidthSameWithChildren?: boolean | 'minWidth';
    /**当前位置不合适时，是否允许自适应位置 */
    allowedAutoPlacements?: Array<PlacementType>;
    /**portal第一帧渲染什么内容 如果写成null之后getContainer的参数就会为null**/
    firstRender?: React.ReactNode;
}
export default class Tooltip extends React.Component<TooltipProps> {
    static defaultProps: {
        enterAble: boolean;
        hoverLeaveHidden: boolean;
        hoverLeaveDuration: number;
        visibleArrow: boolean;
        disabled: boolean;
        offset: number[];
        placement: string;
        theme: string;
    };
    state: {};
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
