import * as React from 'react';
interface ItemOption {
    key: string | number;
    label: string;
    disabled?: boolean;
}
export interface TransferProps {
    className?: string;
    style?: React.CSSProperties;
    /**数据源，其中的数据将会被渲染到左边一栏中**/
    dataSource?: Array<ItemOption>;
    value?: Array<ItemOption>;
    /**自定义列表标题**/
    titles?: [string, string];
    onChange?: (value: Array<ItemOption>) => void;
}
export interface TransferState {
    _prevProps?: TransferProps;
    dataSource?: Array<ItemOption>;
    value?: Array<ItemOption>;
    leftOptions?: Array<ItemOption>;
    leftChecked?: Array<ItemOption>;
    leftDisabled?: boolean;
    rightOptions?: Array<ItemOption>;
    rightChecked?: Array<ItemOption>;
    rightDisabled?: boolean;
}
export default class Transfer extends React.PureComponent<TransferProps, TransferState> {
    state: TransferState;
    static defaultProps: {
        titles: string[];
    };
    /**
     *
     * @param nextProps
     * @param prevState
     */
    static getDerivedStateFromProps(nextProps: TransferProps, prevState: TransferState): TransferState;
    /**
     * 监听dataSource变化
     */
    watchValue(): void;
    /**
     * 点击图标
     */
    handleToLeft(): void;
    /**
     * 点击图标
     */
    handleToRight(): void;
    /**
     *渲染函数
     */
    render(): React.ReactElement;
}
export {};
