"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _raf = _interopRequireDefault(require("raf"));

var _Transition = require("./Transition");

var _warning = _interopRequireDefault(require("../../libs/warning"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var config = {
  display: {
    init: function init(ref) {
      if (ref.current.style.display === 'none') {
        ref.current.prevDisplay = 'none';
      }
    },
    main: function main(props, value, ref) {
      var _props$displayNone = props.displayNone,
          displayNone = _props$displayNone === void 0 ? {
        setWidthZero: true,
        setHeightZero: true
      } : _props$displayNone;

      if (value === 'none') {
        if (ref.current.prevDisplay !== 'none') {
          value = 'block';

          var _style = window.getComputedStyle(ref.current);

          var origin = {
            overflow: ref.current.style['overflow'],
            width: ref.current.style['width'],
            seeWidth: _style['width'],
            height: ref.current.style['height'],
            seeHeight: _style['height']
          };
          (0, _raf.default)(function () {
            var to = {
              overflow: ref.current.style['overflow'],
              width: ref.current.style['width'],
              seeWidth: 0,
              height: ref.current.style['height'],
              seeHeight: 0
            };
            var transition = ref.current.style.transition;
            var animation = ref.current.style.animation;
            /**为了防止下面设置宽度高度的时候出现动画***/

            ref.current.style['transition'] = '';
            ref.current.style['animation'] = '';
            (0, _raf.default)(function () {
              ref.current.style['display'] = 'block';
              ref.current.style['overflow'] = origin.overflow;
              displayNone.setWidthZero && (ref.current.style['width'] = origin.seeWidth);
              displayNone.setHeightZero && (ref.current.style['height'] = origin.seeHeight);
              (0, _raf.default)(function () {
                ref.current.style['transition'] = transition;
                ref.current.style['animation'] = animation;
                ref.current.style['overflow'] = 'hidden';
                displayNone.setWidthZero && (ref.current.style['width'] = to.seeWidth);
                displayNone.setHeightZero && (ref.current.style['height'] = to.seeHeight);
                (0, _raf.default)(function () {
                  (0, _Transition.whenTransitionEnds)(ref.current, undefined, function () {
                    ref.current.prevDisplay = 'none';
                    ref.current.style['overflow'] = to.overflow;
                    ref.current.style['display'] = 'none';
                    displayNone.setWidthZero && (ref.current.style['width'] = to.width);
                    displayNone.setHeightZero && (ref.current.style['height'] = to.height);
                  });
                });
              });
            });
          });
        }
      } else {
        if (ref.current.prevDisplay === 'none') {
          (0, _raf.default)(function () {
            var _style = window.getComputedStyle(ref.current);

            var to = {
              overflow: ref.current.style['overflow'],
              width: ref.current.style['width'],
              seeWidth: _style['width'],
              height: ref.current.style['height'],
              seeHeight: _style['height']
            };
            var transition = ref.current.style.transition;
            var animation = ref.current.style.animation;
            /**为了防止下面设置宽度高度的时候出现动画***/

            ref.current.style['transition'] = '';
            ref.current.style['animation'] = '';
            ref.current.style['overflow'] = 'hidden';
            displayNone.setWidthZero && (ref.current.style['width'] = '0px');
            displayNone.setHeightZero && (ref.current.style['height'] = '0px');
            (0, _raf.default)(function () {
              ref.current.style['transition'] = transition;
              ref.current.style['animation'] = animation;
              ref.current.style['overflow'] = 'hidden';
              displayNone.setWidthZero && (ref.current.style['width'] = to.seeWidth);
              displayNone.setHeightZero && (ref.current.style['height'] = to.seeHeight);
              (0, _raf.default)(function () {
                (0, _Transition.whenTransitionEnds)(ref.current, undefined, function () {
                  ref.current.style['overflow'] = to.overflow;
                  displayNone.setWidthZero && (ref.current.style['width'] = to.width);
                  displayNone.setHeightZero && (ref.current.style['height'] = to.height);
                });
              });
            });
          });
        }

        ref.current.prevDisplay = value;
      }

      return value;
    }
  },
  visibility: {
    init: function init(ref) {
      if (ref.current.style.visibility === 'hidden') {
        ref.current.prevVisibility = 'hidden';
      }
    },
    main: function main(props, value, ref) {
      if (value === 'hidden') {
        if (ref.current.prevVisibility !== 'hidden') {
          value = 'visible';
          (0, _raf.default)(function () {
            var _ref$current$style = ref.current.style,
                transition = _ref$current$style.transition,
                animation = _ref$current$style.animation,
                opacity = _ref$current$style.opacity;
            /**为了防止下面设置宽度高度的时候出现动画***/

            ref.current.style['transition'] = '';
            ref.current.style['animation'] = '';
            ref.current.style['opacity'] = 1;
            (0, _raf.default)(function () {
              ref.current.style['transition'] = transition;
              ref.current.style['animation'] = animation;
              ref.current.style['opacity'] = 0;
              (0, _Transition.whenTransitionEnds)(ref.current, undefined, function () {
                ref.current.style['transition'] = '';
                ref.current.style['animation'] = '';
                ref.current.style['opacity'] = opacity;
                ref.current.prevVisibility = 'hidden';
                ref.current.style['visibility'] = 'hidden';
                (0, _raf.default)(function () {
                  ref.current.style['transition'] = transition;
                  ref.current.style['animation'] = animation;
                });
              });
            });
          });
        }
      } else {
        if (ref.current.prevVisibility === 'hidden') {
          (0, _raf.default)(function () {
            var _ref$current$style2 = ref.current.style,
                transition = _ref$current$style2.transition,
                animation = _ref$current$style2.animation,
                opacity = _ref$current$style2.opacity;
            /**为了防止下面设置宽度高度的时候出现动画***/

            ref.current.style['transition'] = '';
            ref.current.style['animation'] = '';
            ref.current.style['opacity'] = 0;
            (0, _raf.default)(function () {
              ref.current.style['transition'] = transition;
              ref.current.style['animation'] = animation;
              ref.current.style['opacity'] = 1;
              (0, _Transition.whenTransitionEnds)(ref.current, undefined, function () {
                ref.current.style['transition'] = '';
                ref.current.style['animation'] = '';
                ref.current.style['opacity'] = opacity;
                (0, _raf.default)(function () {
                  ref.current.style['transition'] = transition;
                  ref.current.style['animation'] = animation;
                });
              });
            });
          });
        }

        ref.current.prevVisibility = value;
      }

      return value;
    }
  }
};
/**
 * 属性从有变成没有之类的动画
 * @param props
 * @constructor
 */

function EnableTransition(props) {
  var ref = React.useRef(undefined);
  var st = React.useRef(false);
  var attribute = props.attribute;
  React.useEffect(function () {
    if (!st.current) {
      var _config$attribute;

      if (!(ref.current instanceof HTMLElement)) {
        (0, _warning.default)(false, 'AutoComputedStyle', 'ref必须绑定在HTMLElement上');
        return;
      }

      if (ref.current.style[attribute] === '' || ref.current.style[attribute] === undefined) {
        ref.current.style.setProperty(attribute + '', window.getComputedStyle(ref.current)[attribute]);
      }

      (_config$attribute = config[attribute]) === null || _config$attribute === void 0 ? void 0 : _config$attribute.init(ref);
      var setProperty = ref.current.style.setProperty;

      ref.current.style.setProperty = function (property, value, priority) {
        if (value === undefined || value === '' || value === 'auto') {
          var origin = window.getComputedStyle(ref.current)[attribute];
          (0, _raf.default)(function () {
            var to = window.getComputedStyle(ref.current)[attribute];
            ref.current.style[attribute] = origin;
            (0, _raf.default)(function () {
              ref.current.style[attribute] = to;
            });
          });
          value = '';
        }

        config[attribute] && (value = config[attribute].main(props, value, ref));
        setProperty.call(ref.current.style, property, value, priority);
      };

      Object.defineProperty(ref.current.style, attribute, {
        set: function set(v) {
          ref.current.style.setProperty(attribute, v);
        },
        get: function get() {
          return ref.current.style.getPropertyValue(attribute);
        }
      });
      st.current = true;
    }
  }, [props.children]);
  return props.children(ref);
}

var _default = EnableTransition;
exports.default = _default;