"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.whenTransitionEnds = whenTransitionEnds;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 是否支持动画
 */
var isSupportedAnimation = ('animation' in document.documentElement.style);
var TRANSITION = 'transition';
var ANIMATION = 'animation';
var Status;
/***
 * 取出2个字符数组中的最大值并转成毫秒
 * @param delays
 * @param durations
 */

(function (Status) {
  Status["UNMOUNTED"] = "unmounted";
  Status["ENTERING"] = "entering";
  Status["ENTERED"] = "entered";
  Status["LEAVED"] = "leaved";
  Status["LEAVING"] = "leaving";
})(Status || (Status = {}));

function getTimeout(delays, durations) {
  while (delays.length < durations.length) {
    delays = delays.concat(delays);
  }

  return Math.max.apply(Math, (0, _toConsumableArray2.default)(durations.map(function (d, i) {
    return toMs(d) + toMs(delays[i]);
  })));
}
/**
 * 转成毫秒
 * @param s
 */


function toMs(s) {
  return Number(s.slice(0, -1).replace(',', '.')) * 1000;
}
/**
 *
 * @param el
 */


function getTransitionInfo(el) {
  var styles = window.getComputedStyle(el);
  /***
   * JSDOM may return undefined for transition properties
   * TRANSITION 或者 ANIMATION 是多个属性的时候比如 transition:width 2s ease 5s, height 2s ease 5s;
   * @param key
   */

  var getStyleProperties = function getStyleProperties(key) {
    return (styles[key] || '').split(', ');
  };

  var transitionDelays = getStyleProperties(TRANSITION + 'Delay');
  var transitionDurations = getStyleProperties(TRANSITION + 'Duration');
  var transitionTimeout = getTimeout(transitionDelays, transitionDurations);
  var animationDelays = getStyleProperties(ANIMATION + 'Delay');
  var animationDurations = getStyleProperties(ANIMATION + 'Duration');
  var animationTimeout = getTimeout(animationDelays, animationDurations);
  var timeout = Math.max(transitionTimeout, animationTimeout);
  var type = timeout > 0 ? transitionTimeout > animationTimeout ? TRANSITION : ANIMATION : null;
  var propCount = type ? type === TRANSITION ? transitionDurations.length : animationDurations.length : 0;
  var hasTransform = type === TRANSITION && /\b(transform|all)(,|$)/.test(styles[TRANSITION + 'Property']);
  return {
    type: type,
    timeout: timeout,
    propCount: propCount,
    hasTransform: hasTransform
  };
}
/***
 * 动画结束
 * @param el
 * @param duration
 * @param cb
 */


function whenTransitionEnds(el, duration, cb) {
  if (duration !== undefined) {
    setTimeout(function () {
      cb();
    }, duration);
    return;
  }

  var _getTransitionInfo = getTransitionInfo(el),
      type = _getTransitionInfo.type,
      timeout = _getTransitionInfo.timeout,
      propCount = _getTransitionInfo.propCount;

  if (!type) {
    return cb();
  }

  var ended = 0;

  var end = function end() {
    (0, _util.removeEvent)(el, 'transitionend', onEnd);
    (0, _util.removeEvent)(el, 'animationend', onEnd);
    cb();
  };

  var onEnd = function onEnd(e) {
    if (e.target === el) {
      if (++ended >= propCount) {
        end();
      }
    }
  };

  setTimeout(function () {
    if (ended < propCount) {
      end();
    }
  }, timeout + 1);
  (0, _util.addEvent)(el, 'transitionend', onEnd);
  (0, _util.addEvent)(el, 'animationend', onEnd);
}

var Lifecycle = /*#__PURE__*/function () {
  /**
   * 构造函数
   * @param props
   */
  function Lifecycle() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck2.default)(this, Lifecycle);
    this.props = void 0;
    this.transmit = void 0;
    this.props = props;
    this.transmit = {};
  }
  /**
   * 得到样式类
   */


  (0, _createClass2.default)(Lifecycle, [{
    key: "transitionClass",
    get: function get() {
      if (!isSupportedAnimation) {
        return {};
      }

      var name = this.props.name;
      return {
        enter: "".concat(name, "-enter"),
        enterActive: "".concat(name, "-enter-active"),
        enterTo: "".concat(name, "-enter-to"),
        leave: "".concat(name, "-leave"),
        leaveActive: "".concat(name, "-leave-active"),
        leaveTo: "".concat(name, "-leave-to")
      };
    }
    /**
     * beforeEnter
     */

  }, {
    key: "beforeEnter",
    value: function beforeEnter() {
      var onBeforeEnter = this.props.onBeforeEnter;
      onBeforeEnter && onBeforeEnter(this.transmit);
    }
    /***
     * enter
     * @param dom
     */

  }, {
    key: "enter",
    value: function enter(dom) {
      if (!dom) {
        return;
      }

      var onEnter = this.props.onEnter;
      var enter = this.transitionClass.enter;
      onEnter && onEnter(dom, this.transmit);
      (0, _util.classList)(dom).add(enter);
    }
    /**
     * entering
     * @param dom
     * @param cb
     */

  }, {
    key: "entering",
    value: function entering(dom, cb) {
      var _this = this;

      var _this$props = this.props,
          onEnterTo = _this$props.onEnterTo,
          duration = _this$props.duration;
      var _this$transitionClass = this.transitionClass,
          enter = _this$transitionClass.enter,
          enterActive = _this$transitionClass.enterActive,
          enterTo = _this$transitionClass.enterTo;
      /**这句话不能去掉 该句的作用类似于 flush**/

      /* eslint-disable no-unused-expressions  */

      dom && dom.scrollTop;
      requestAnimationFrame(function () {
        (0, _util.classList)(dom).remove(enter);
        (0, _util.classList)(dom).add(enterActive, enterTo);
        onEnterTo && onEnterTo(dom, _this.transmit);
        whenTransitionEnds(dom, duration, function () {
          (0, _util.classList)(dom).remove(enterActive, enterTo);
          cb && cb(_this.transmit);
        });
      });
    }
    /***
     * beforeLeave
     * @param dom
     */

  }, {
    key: "beforeLeave",
    value: function beforeLeave(dom) {
      var onBeforeLeave = this.props.onBeforeLeave;
      onBeforeLeave && onBeforeLeave(dom, this.transmit);
    }
    /**
     * leave
     * @param dom
     */

  }, {
    key: "leave",
    value: function leave(dom) {
      var onLeave = this.props.onLeave;

      if (!dom) {
        return;
      }

      onLeave && onLeave(dom, this.transmit);
      var leave = this.transitionClass.leave;
      (0, _util.classList)(dom).add(leave);
    }
    /**
     * leaving
     * @param dom
     * @param cb
     */

  }, {
    key: "leaving",
    value: function leaving(dom, cb) {
      var _this2 = this;

      var _this$props2 = this.props,
          onLeaveTo = _this$props2.onLeaveTo,
          duration = _this$props2.duration;
      var _this$transitionClass2 = this.transitionClass,
          leave = _this$transitionClass2.leave,
          leaveActive = _this$transitionClass2.leaveActive,
          leaveTo = _this$transitionClass2.leaveTo;
      /**这句话不能去掉 该句的作用类似于 flush**/

      /* eslint-disable no-unused-expressions  */

      dom && dom.scrollTop;
      requestAnimationFrame(function () {
        (0, _util.classList)(dom).remove(leave);
        (0, _util.classList)(dom).add(leaveActive, leaveTo);
        onLeaveTo && onLeaveTo(dom, _this2.transmit);
        whenTransitionEnds(dom, duration, function () {
          (0, _util.classList)(dom).remove(leaveActive);
          (0, _util.classList)(dom).remove(leaveTo);
          cb && cb();
        });
      });
    }
  }]);
  return Lifecycle;
}();

var Transition = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Transition, _React$Component);

  var _super = _createSuper(Transition);

  /**
   * 构造函数
   * @param props
   */
  function Transition(props) {
    var _this3;

    (0, _classCallCheck2.default)(this, Transition);
    _this3 = _super.call(this, props);
    _this3._isMounted = void 0;
    _this3.state = {
      in: props.in,
      children: props.children,
      status: Status.UNMOUNTED,
      lifecycle: new Lifecycle(props),
      _prevProps: props
    };
    return _this3;
  }
  /**
   * 当state或者props变化的时候
   * @param nextProps
   * @param prevState
   */


  (0, _createClass2.default)(Transition, [{
    key: "componentDidMount",
    value:
    /**
     *
     */
    function componentDidMount() {
      var _this$props3 = this.props,
          appear = _this$props3.appear,
          children = _this$props3.children,
          isIn = _this$props3.in;
      this._isMounted = true;

      if (appear) {
        if (isIn !== undefined) {
          /**之前为false 现在为true**/
          if (isIn) {
            this.enterHook();
            /**之前为true现在为false**/
          } else {
            this.leaveHook();
          }
        } else {
          if (children) {
            this.enterHook();
          } else {
            this.leaveHook();
          }
        }
      }
    }
    /**
     *
     */

  }, {
    key: "enterHook",
    value: function enterHook() {
      var _this4 = this;

      var onAfterEnter = this.props.onAfterEnter;
      var children = this.props.children;
      var lifecycle = this.state.lifecycle;
      var childDOM = (0, _reactDom.findDOMNode)(this);

      if (!childDOM) {
        return;
      }

      lifecycle.enter(childDOM);
      this.safeSetState({
        status: Status.ENTERING
      }, function () {
        var childDOM = (0, _reactDom.findDOMNode)(_this4);
        lifecycle.entering(childDOM, function (transmit) {
          var currChildren = _this4.props.children;

          if (!currChildren && children) {
            var _childDOM = (0, _reactDom.findDOMNode)(_this4);

            onAfterEnter && onAfterEnter(_childDOM, transmit);

            _this4.leaveHook();

            return;
          }
          /**有可能children变化了 那么就用当前变化后的children**/


          if (children && currChildren) {
            children = currChildren;
          }

          _this4.safeSetState({
            children: children,
            status: Status.ENTERED
          }, function () {
            var childDOM = (0, _reactDom.findDOMNode)(_this4);
            onAfterEnter && onAfterEnter(childDOM, transmit);
          });
        });
      });
    }
    /**
     *
     */

  }, {
    key: "leaveHook",
    value: function leaveHook() {
      var _this5 = this;

      var onAfterLeave = this.props.onAfterLeave;
      var lifecycle = this.state.lifecycle;
      var childDOM = (0, _reactDom.findDOMNode)(this);

      if (!childDOM) {
        return;
      }

      lifecycle.beforeLeave(childDOM);
      lifecycle.leave(childDOM);
      this.safeSetState({
        status: Status.LEAVING
      }, function () {
        lifecycle.leaving(childDOM, function () {
          var currChildren = _this5.props.children;

          _this5.safeSetState({
            children: false,
            status: Status.LEAVED
          }, function () {
            onAfterLeave && onAfterLeave();

            if (currChildren) {
              _this5.enterHook();

              return;
            }
          });
        });
      });
    }
    /**
     * 安全的设置sate
     * @param state
     * @param callback
     */

  }, {
    key: "safeSetState",
    value: function safeSetState(state, callback) {
      if (this._isMounted) {
        this.setState(state, callback);
      }
    }
    /**
     * 更新后
     * @param preProps
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps) {
      var children = this.props.children;
      var childChildren = this.state.children;

      if (preProps !== this.props && !Array.isArray(childChildren)) {
        if (!preProps.children && children) {
          this.enterHook();
        }

        if (preProps.children && !children) {
          this.leaveHook();
        }
        /**之前为false 现在为true**/


        if (this.props.in && !preProps.in) {
          this.enterHook();
          /**之前为true现在为false**/
        } else if (!this.props.in && preProps.in) {
          this.leaveHook();
        } //IE，Info组件，content变化，单例模式，内容变化后，css样式不居中，未渲染问题


        if (_util.isIE) {
          var childDOM = (0, _reactDom.findDOMNode)(this);

          if (childDOM) {
            childDOM.scrollTop;
            (0, _util.classList)(childDOM).remove('');
          }
        }
      }
    }
    /**
     *
     */

  }, {
    key: "handleResetChildren",
    value: function handleResetChildren() {
      var children = this.state.children;

      if (Array.isArray(children)) {
        this.safeSetState({
          children: children[1]
        });
      }
    }
    /**
     *组件卸载后
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this6 = this;

      var children = this.state.children;

      if (Array.isArray(children)) {
        return /*#__PURE__*/React.createElement(React.Fragment, null, children.map(function (child, index) {
          var props = _objectSpread({}, _this6.props);

          if (index === 1) {
            props.onAfterEnter = function () {
              var _this6$props;

              _this6.props.onAfterEnter && (_this6$props = _this6.props).onAfterEnter.apply(_this6$props, arguments);

              _this6.handleResetChildren();
            };
          }

          return /*#__PURE__*/React.createElement(Transition, (0, _extends2.default)({
            key: 'transition-' + child.key
          }, props, {
            appear: true,
            in: index === 1
          }), child);
        }));
      }

      return /*#__PURE__*/React.createElement(React.Fragment, null, children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var lifecycle = prevState.lifecycle;
      lifecycle.props = nextProps;

      if (!isSupportedAnimation) {
        return {
          children: nextProps.children,
          _prevProps: nextProps
        };
      }

      if (prevState._prevProps !== nextProps) {
        var prevStateChildren = prevState.children;
        var nextPropsChildren = nextProps.children;
        var children;

        if (nextPropsChildren && prevStateChildren) {
          children = nextPropsChildren;
          /*说明children变化了***/

          if (nextPropsChildren.key !== prevStateChildren.key) {
            lifecycle.beforeEnter();
            children = [prevStateChildren, nextPropsChildren];
          } else {
            /**之前为false 现在为true**/
            if (nextProps.in && !prevState.in) {
              lifecycle.beforeEnter();
              children = prevStateChildren;
              /**之前为true现在为false**/
            } else if (!nextProps.in && prevState.in) {
              children = prevStateChildren;
            }
          }
        } else if (nextPropsChildren && !prevStateChildren) {
          prevState._prevProps && !prevStateChildren && lifecycle.beforeEnter();
          children = nextPropsChildren;
        } else if (prevStateChildren && !nextPropsChildren) {
          children = prevStateChildren;
        } else {
          children = false;
        }

        return {
          in: nextProps.in,
          children: children,
          _prevProps: nextProps
        };
      } else {
        return null;
      }
    }
  }]);
  return Transition;
}(React.Component), _class2.defaultProps = {
  appear: false,
  name: '',
  whenEnterDisplay: 'block'
}, _class2.StyleTransition = void 0, _class2.SwitchTransition = void 0, _class2.EnableTransition = void 0, _class2)) || _class;
/***
 * 属性切换
 * 比如display 切换
 *
 * @param props
 * @constructor
 */


function StyleTransition(props) {
  (0, _warning.default)(props.in !== undefined, 'PropertyTransition', '组件style属性改变必须提供in属性来标识改leave还是enter');
  return /*#__PURE__*/React.createElement(Transition, props);
}
/**
 *组件切换 比如路由切换
 * @constructor
 */


function SwitchTransition(props) {
  var children = props.children;
  (0, _warning.default)(children.key !== undefined, 'SwitchTransition', '组件切换必须提供一个key来标识不同的组件');
  return /*#__PURE__*/React.createElement(Transition, props);
}

Transition.StyleTransition = StyleTransition;
Transition.SwitchTransition = SwitchTransition;
var _default = Transition;
exports.default = _default;