import * as React from 'react';
import { _ItemOption } from "./Tree";
export interface NodeProps {
    className?: string;
    style?: React.CSSProperties;
    disabled?: boolean;
    isLeaf?: boolean;
    expanded?: boolean;
    checked?: boolean;
    indeterminate?: boolean;
    path?: string;
    id?: string | number;
    nodeKey?: 'id' | 'label';
    belongsTo?: Array<string>;
    label?: string;
    options?: Array<_ItemOption>;
    leftGap?: number;
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
}
export interface NodeState {
    _prevProps?: NodeProps;
    options?: Array<_ItemOption>;
    expanded?: boolean;
    checked?: boolean;
    loading?: boolean;
    eventTarget?: EventTarget;
    indeterminate?: boolean;
    childOptions?: {
        [key: string]: boolean;
    };
}
export default class Node extends React.PureComponent<NodeProps, NodeState> {
    /**
     * 构造函数
     * @param props
     */
    constructor(props: NodeProps);
    static defaultProps: NodeProps;
    static contextType: React.Context<any>;
    /**
     * 处理展开事件
     */
    private handleExpand;
    /**
     * 处理点击事件
     * @param e
     */
    private handleClick;
    /**
     *
     * @param value
     * @param e
     */
    handleChange(value: Array<string>, e: React.ChangeEvent<HTMLInputElement>): void;
    /**
     * 得到渲染样式
     */
    getNodeStyle(): React.CSSProperties;
    /**
     *渲染函数
     */
    render(): React.ReactElement;
}
