"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CaretRight = _interopRequireDefault(require("net-design-icons/lib/icons/CaretRight"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _checkbox = _interopRequireDefault(require("../checkbox"));

var _util = require("../../libs/utils/util");

var _TreeContext = require("./TreeContext");

var _spin = _interopRequireDefault(require("../spin"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Node = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Node, _React$PureComponent);

  var _super = _createSuper(Node);

  /**
   * 构造函数
   * @param props
   */
  function Node(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Node);
    _this = _super.call(this, props);
    var expanded = props.expanded;
    _this.state = {
      expanded: expanded
    };
    return _this;
  }

  (0, _createClass2.default)(Node, [{
    key: "handleExpand",
    value:
    /**
     * 处理展开事件
     */
    function handleExpand(e) {
      var _this2 = this;

      e.preventDefault();
      e.stopPropagation();
      var _this$context = this.context,
          onLoadData = _this$context.onLoadData,
          value = _this$context.value;
      var _this$props = this.props,
          id = _this$props.id,
          options = _this$props.options;
      var expanded = this.state.expanded;

      if (!expanded && onLoadData) {
        this.setState({
          loading: true
        });
        onLoadData({
          key: id,
          children: options.length === 0 ? undefined : options,
          value: value
        }).then(function () {
          var expanded = _this2.state.expanded;

          _this2.setState({
            loading: false,
            expanded: !expanded
          });
        });
      } else {
        this.setState({
          expanded: !expanded
        });
      }
    }
    /**
     * 处理点击事件
     * @param e
     */

  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var onNodeClick = this.context.onNodeClick;

      var params = _objectSpread({}, this.props);

      var path = this.props.path;
      onNodeClick && onNodeClick(e, path, params);
    }
    /**
     *
     * @param value
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(value, e) {
      e.stopPropagation();
      e.preventDefault();
      var path = this.props.path;
      var onNodeCheck = this.context.onNodeCheck;
      e.persist();

      var params = _objectSpread({}, this.props);

      onNodeCheck && onNodeCheck(e, path, params);
    }
    /**
     * 得到渲染样式
     */

  }, {
    key: "getNodeStyle",
    value: function getNodeStyle() {
      var _this$props2 = this.props,
          style = _this$props2.style,
          nodeLeftGap = _this$props2.leftGap;

      var _ref = this.context || {},
          leftGap = _ref.leftGap;

      return _objectSpread(_objectSpread({}, style), {}, {
        marginLeft: nodeLeftGap !== undefined ? nodeLeftGap : leftGap
      });
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          className = _this$props3.className,
          label = _this$props3.label,
          options = _this$props3.options,
          nodeIsLeaf = _this$props3.isLeaf,
          nodeKey = _this$props3.nodeKey,
          indeterminate = _this$props3.indeterminate,
          checked = _this$props3.checked,
          path = _this$props3.path,
          disabled = _this$props3.disabled;
      var _this$state = this.state,
          expanded = _this$state.expanded,
          loading = _this$state.loading;

      var _ref2 = this.context || {},
          checkAble = _ref2.checkAble,
          showClickStatus = _ref2.showClickStatus,
          leftGap = _ref2.leftGap;

      var classes = (0, _classnames.default)(className, 'rd-tree-node');
      /**判断是否是叶子节点 如果没有传入isLeaf属性那么默认options的长度为0时为叶子节点**/

      var isLeaf = nodeIsLeaf !== undefined ? nodeIsLeaf : options.length === 0;
      return /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: this.getNodeStyle()
      }, /*#__PURE__*/React.createElement("label", {
        onClick: this.handleClick,
        className: (0, _classnames.default)('rd-tree-node-wrapper', {
          'is-checked': showClickStatus && checked
        })
      }, !isLeaf && !loading && /*#__PURE__*/React.createElement(_CaretRight.default, {
        style: expanded ? (0, _defineProperty2.default)({}, (0, _util.setPrefix)(), 'rotate(90deg)') : {},
        onClick: this.handleExpand
      }), loading && /*#__PURE__*/React.createElement(_spin.default, {
        loading: true
      }), checkAble && /*#__PURE__*/React.createElement(_checkbox.default, {
        disabled: disabled,
        indeterminate: indeterminate,
        checked: checked,
        value: 1,
        onLabelClick: function onLabelClick(e) {
          return e.stopPropagation();
        },
        onChange: this.handleChange
      }), /*#__PURE__*/React.createElement("span", null, label)), expanded && options.map(function (item, index) {
        return /*#__PURE__*/React.createElement(Node, {
          key: item[nodeKey],
          nodeKey: nodeKey,
          id: item[nodeKey],
          path: "".concat(path, ".children.").concat(index),
          expanded: item.expanded,
          disabled: item.disabled,
          checked: item.checked,
          isLeaf: item.isLeaf,
          indeterminate: item.indeterminate,
          label: item.label,
          options: item.children,
          leftGap: leftGap
        });
      }));
    }
  }]);
  return Node;
}(React.PureComponent), _class2.defaultProps = {
  options: [],
  leftGap: 0
}, _class2.contextType = _TreeContext.TreeContext, _class2)) || _class;

exports.default = Node;