"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Node = _interopRequireDefault(require("./Node"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _TreeContext = require("./TreeContext");

var _util = require("../../libs/utils/util");

var _FormElement = require("../form/FormElement");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Tree = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Tree, _React$Component);

  var _super = _createSuper(Tree);

  /**
   * 构造函数
   * @param props
   */
  function Tree(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Tree);
    _this = _super.call(this, props);
    _this.state = {
      value: []
    };
    var defaultExpandedKeys = props.defaultExpandedKeys,
        defaultCheckedKeys = props.defaultCheckedKeys;
    _this.state.value = Tree.getAndSetDefaultChecked(props, defaultExpandedKeys, defaultCheckedKeys);
    return _this;
  }
  /**
   *
   * @param nextProps
   * @param prevState
   */


  (0, _createClass2.default)(Tree, [{
    key: "handleLoadData",
    value:
    /**
     * 动态加载数据
     * @param key
     * @param children
     * @param dataSource
     */
    function () {
      var _handleLoadData = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(_ref) {
        var key, children, value, onLoadData;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                key = _ref.key, children = _ref.children, value = _ref.value;
                onLoadData = this.props.onLoadData;

                if (!onLoadData) {
                  _context.next = 7;
                  break;
                }

                _context.next = 5;
                return onLoadData({
                  key: key,
                  children: children,
                  value: value
                });

              case 5:
                _context.next = 8;
                break;

              case 7:
                return _context.abrupt("return", Promise.resolve());

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleLoadData(_x) {
        return _handleLoadData.apply(this, arguments);
      }

      return handleLoadData;
    }()
    /**
     *节点点击
     */

  }, {
    key: "handleNodeClick",
    value: function handleNodeClick(e, path, params) {
      var onNodeClick = this.props.onNodeClick;
      onNodeClick && onNodeClick(e, path, params);
    }
    /**
     * defineProperty循环定义checked
     * @param baseDataSource
     */

  }, {
    key: "handleNodeCheck",
    value:
    /**
     *节点选中
     */
    function handleNodeCheck(e, path, params) {
      var _this2 = this;

      var paths = path.split('.');
      var baseDataSource;
      var nodeCheckedAndCheckedAllChildren = this.props.nodeCheckedAndCheckedAllChildren;

      var _dataSource = baseDataSource = (0, _util.deepClone)(this.state.value);

      paths.forEach(function (p) {
        _dataSource = _dataSource[p];
      });
      _dataSource.checked = e.target.checked;
      Tree.loopDefinePropertyChecked(baseDataSource);
      Tree.loopSetProperty(_dataSource, nodeCheckedAndCheckedAllChildren, e.target.checked);
      var value = (0, _util.deepClone)(baseDataSource);
      this.setState({
        value: value
      }, function () {
        var onChange = _this2.props.onChange;
        onChange && onChange(value, params, e);
      });
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          nodeKey = _this$props.nodeKey,
          checkAble = _this$props.checkAble,
          showClickStatus = _this$props.showClickStatus,
          leftGap = _this$props.leftGap,
          multiple = _this$props.multiple;
      var value = this.state.value;
      var classes = (0, _classnames.default)(className, 'rd-tree');
      return /*#__PURE__*/React.createElement(_TreeContext.TreeContext.Provider, {
        value: {
          value: value,
          checkAble: checkAble,
          showClickStatus: showClickStatus,
          leftGap: leftGap,
          multiple: multiple,
          onNodeClick: this.handleNodeClick,
          onNodeCheck: this.handleNodeCheck,
          onLoadData: this.handleLoadData
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread({}, style)
      }, value.map(function (item, index) {
        return /*#__PURE__*/React.createElement(_Node.default, {
          key: item[nodeKey],
          nodeKey: nodeKey,
          id: item[nodeKey],
          path: "".concat(index),
          isLeaf: item.isLeaf,
          indeterminate: item.indeterminate,
          checked: item.checked,
          disabled: item.disabled,
          expanded: item.expanded,
          label: item.label,
          options: item.children
        });
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (prevState._prevProps !== undefined && nextProps.value !== prevState.value) {
        /**判断nextProps与之前存的props的值是否有改变**/
        if (prevState._prevProps !== nextProps) {
          /**将本次nextProps的值存在state中去**/
          return {
            _prevProps: nextProps,
            value: Tree.getAndSetDefaultChecked(nextProps, nextProps.expandedKeys, nextProps.checkedKeys)
          };
        } else {
          /**将本次nextProps的值存在state中去**/
          return {
            _prevProps: nextProps,
            value: Tree.getAndSetDefaultChecked(_objectSpread(_objectSpread({}, nextProps), {}, {
              value: prevState.value
            }), nextProps.expandedKeys, nextProps.checkedKeys)
          };
        }
      }

      if (prevState._prevProps === undefined) {
        return {
          _prevProps: nextProps,
          value: Tree.getAndSetDefaultChecked(_objectSpread(_objectSpread({}, nextProps), {}, {
            value: prevState.value
          }), nextProps.expandedKeys, nextProps.checkedKeys)
        };
      }
    }
    /**
     *
     */

  }, {
    key: "getAndSetDefaultChecked",
    value: function getAndSetDefaultChecked(props) {
      var expandedKeys = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var checkedKeys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
      var value = props.value,
          nodeKey = props.nodeKey,
          checkAble = props.checkAble,
          defaultExpandAll = props.defaultExpandAll,
          nodeCheckedAndCheckedAllChildren = props.nodeCheckedAndCheckedAllChildren;

      var _dataSource = (0, _util.deepClone)(value);

      if (checkAble) {
        Tree.loopDefinePropertyChecked(_dataSource);
      }

      var itemLoop = function itemLoop(item) {
        if (item.expanded === undefined) {
          item.expanded = defaultExpandAll ? true : expandedKeys.includes(item[nodeKey]);
        }

        var bool = checkedKeys.includes(item[nodeKey]);

        if (checkAble) {
          if (bool) {
            Tree.loopSetProperty(item, nodeCheckedAndCheckedAllChildren, true);
          }
        } else {
          item.checked = bool;
        }

        if (item.children) {
          item.children.forEach(function (child) {
            return itemLoop(child);
          });
        }
      };

      _dataSource.forEach(function (item) {
        return itemLoop(item);
      });

      return (0, _util.deepClone)(_dataSource);
    }
  }, {
    key: "loopDefinePropertyChecked",
    value: function loopDefinePropertyChecked(baseDataSource) {
      var loop = function loop(option, index, parent) {
        var value = option.checked;
        /**监听option的checked 属性 方便在给node赋值的时候给其父元素也赋值**/

        Object.defineProperty(option, 'checked', {
          configurable: true,
          enumerable: true,
          get: function get() {
            return value;
          },
          set: function set(v) {
            if (option.disabled) {
              value = false;
            } else {
              value = v;
            }

            var checked = true;
            /**arr中存储了代表直接子元素是否选中的boolean值**/

            var arr = [];
            var arrIndeterminate = [];
            parent.children.forEach(function (item) {
              var _checked = item.checked === undefined ? false : item.checked;

              var _indeterminate = item.indeterminate === undefined ? false : item.indeterminate;

              arr.push(_checked);
              arrIndeterminate.push(_indeterminate);

              if (!item.checked) {
                checked = false;
              }
            });
            /**当后台元素只有一个的时候**/

            if (arr.length === 1) {
              /**indeterminate由直接元素的indeterminate决定**/
              parent.indeterminate = parent.children[0].indeterminate;
              parent.checked = checked;
            } else {
              parent.indeterminate = arr.includes(false) && arr.includes(true)
              /**包含有选中的和没有选中的**/
              || arrIndeterminate.includes(true);
              /**包含有半选状态的的**/

              if (parent.indeterminate) {
                parent.checked = false;
              } else {
                parent.checked = v;
              }
            }
          }
        });

        if (option.children) {
          option.children.forEach(function (data, index) {
            loop(data, index, option);
          });
        }
      };

      baseDataSource.forEach(function (data, index) {
        loop(data, index, {
          children: baseDataSource
        });
      });
    }
    /**
     *
     * @param _dataSource
     * @param nodeCheckedAndCheckedAllChildren
     * @param checked
     */

  }, {
    key: "loopSetProperty",
    value: function loopSetProperty(_dataSource, nodeCheckedAndCheckedAllChildren, checked) {
      /**开始直接赋值  由于上面监听了checked属性 赋值的时候其父元素也会赋值**/
      if (_dataSource.children && nodeCheckedAndCheckedAllChildren) {
        var _loop = function _loop(data) {
          for (var i = 0; i < data.children.length; i++) {
            data.children[i].checked = checked;

            if (data.children[i].children) {
              _loop(data.children[i]);
            }
          }
        };

        _loop(_dataSource);
      } else {
        _dataSource.checked = checked;
      }
    }
  }]);
  return Tree;
}(React.Component), _class2.defaultProps = {
  nodeKey: 'id',
  value: [],
  leftGap: 20,
  checkAble: false,
  showClickStatus: false,
  nodeCheckedAndCheckedAllChildren: true,
  defaultExpandedKeys: [],
  defaultCheckedKeys: []
}, _class2)) || _class) || _class);
exports.default = Tree;