import * as React from 'react';
export interface CoverProps {
    id?: string;
    children?: React.ReactNode;
    name?: string;
    className?: string;
    type?: 'card' | 'list' | 'drag';
    style?: React.CSSProperties;
    hint?: React.ReactNode;
    customCard?: React.ReactNode;
    onFile?: (files?: FileList) => void;
    onClick?: React.MouseEventHandler<HTMLDivElement>;
    onChange?: React.ChangeEventHandler<HTMLInputElement>;
}
interface CoverStates {
    dragOver?: boolean;
}
export default class Cover extends React.Component<CoverProps, CoverStates> {
    state: CoverStates;
    static defaultProps: {
        type: string;
    };
    /**
     * 处理拖动
     * @param e
     */
    handleDrop(e: React.DragEvent<HTMLDivElement>): void;
    /**
     * 处理拖动经过其上面
     * @param e
     */
    handleDragOver(e: React.DragEvent<HTMLDivElement>): void;
    /**
     * 处理拖动结束
     * @param e
     */
    handleDragleave(e: React.DragEvent<HTMLDivElement>): void;
    /**
     * 文件选择后
     */
    handleFileChange(e: React.ChangeEvent<HTMLInputElement>): void;
    /**
     *
     * @param e
     */
    static handleClick(e: any): void;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
