"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Add = _interopRequireDefault(require("net-design-icons/lib/icons/Add"));

var _CloudUpload = _interopRequireDefault(require("net-design-icons/lib/icons/CloudUpload"));

var _util = require("../../libs/utils/util");

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _locale = _interopRequireDefault(require("../locale"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Cover = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Cover, _React$Component);

  var _super = _createSuper(Cover);

  function Cover() {
    var _this;

    (0, _classCallCheck2.default)(this, Cover);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(Cover, [{
    key: "handleDrop",
    value:
    /**
     * 处理拖动
     * @param e
     */
    function handleDrop(e) {
      var onFile = this.props.onFile;
      e.preventDefault();
      this.setState({
        dragOver: false
      });
      var files = e.dataTransfer.files;

      if (!files) {
        (0, _warning.default)(false, 'Upload', '该浏览器不支持拖动上传');
        return;
      }

      onFile && onFile(files);
    }
    /**
     * 处理拖动经过其上面
     * @param e
     */

  }, {
    key: "handleDragOver",
    value: function handleDragOver(e) {
      e.preventDefault();
      this.setState({
        dragOver: true
      });
    }
    /**
     * 处理拖动结束
     * @param e
     */

  }, {
    key: "handleDragleave",
    value: function handleDragleave(e) {
      e.preventDefault();
      this.setState({
        dragOver: false
      });
    }
    /**
     * 文件选择后
     */

  }, {
    key: "handleFileChange",
    value: function handleFileChange(e) {
      var onChange = this.props.onChange;
      onChange && onChange(e);
    }
    /**
     *
     * @param e
     */

  }, {
    key: "render",
    value:
    /**
     * 渲染函数
     */
    function render() {
      var _this$props = this.props,
          children = _this$props.children,
          onClick = _this$props.onClick,
          onChange = _this$props.onChange,
          id = _this$props.id,
          name = _this$props.name,
          hint = _this$props.hint,
          type = _this$props.type,
          customCard = _this$props.customCard;
      var dragOver = this.state.dragOver;
      var realFileInput = /*#__PURE__*/React.createElement("input", {
        type: "file",
        id: id,
        name: name,
        style: {
          opacity: 0,
          width: '100%',
          height: '100%',
          position: 'absolute',
          left: 0,
          top: 0,
          cursor: 'pointer',
          fontSize: 9999
        },
        onClick: Cover.handleClick,
        onChange: this.handleFileChange
      });
      var Config = {
        card: function card() {
          return /*#__PURE__*/React.createElement("div", {
            className: "rd-upload__card",
            onClick: onClick
          }, /*#__PURE__*/React.createElement("div", null, customCard || /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Add.default, {
            width: '1.5em'
          }), /*#__PURE__*/React.createElement("span", {
            className: "hint"
          }, _locale.default.t('rd.upload.uploadImg')))), onChange && realFileInput);
        },
        list: function list() {
          return /*#__PURE__*/React.createElement("div", {
            className: "rd-upload__trigger",
            onClick: onClick
          }, /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
            style: {
              position: 'relative',
              display: 'inline-block'
            }
          }, children, onChange && realFileInput), hint && /*#__PURE__*/React.createElement("span", {
            className: "support"
          }, hint)));
        },
        drag: function drag() {
          return /*#__PURE__*/React.createElement("div", {
            className: (0, _classnames.default)('rd-upload__cover', {
              'is-dragover': dragOver
            }),
            onClick: onClick,
            onDrop: this.handleDrop,
            onDragOver: this.handleDragOver,
            onDragLeave: this.handleDragleave
          }, /*#__PURE__*/React.createElement("div", {
            className: "rd-upload__hint"
          }, /*#__PURE__*/React.createElement(_CloudUpload.default, {
            width: 36
          }), (0, _util.isIE9)() ? /*#__PURE__*/React.createElement("span", {
            className: "hint"
          }, _locale.default.t('rd.upload.clickToUpload')) : /*#__PURE__*/React.createElement("span", {
            className: "hint"
          }, _locale.default.t('rd.upload.dragToUpload')), hint && /*#__PURE__*/React.createElement("span", {
            className: "support"
          }, hint)), onChange && realFileInput);
        }
      };
      return Config[type].apply(this, []);
    }
  }], [{
    key: "handleClick",
    value: function handleClick(e) {
      e.target.value = '';
      e.stopPropagation();
    }
  }]);
  return Cover;
}(React.Component), _class2.defaultProps = {
  type: 'list'
}, _class2)) || _class;

exports.default = Cover;