import * as React from 'react';
import { Base64String, UploadError } from "./Upload";
import { ProgressEvent } from "./ajax";
interface PreviewProps {
    type?: 'card' | 'list' | 'drag';
    name?: string;
    url: URL | Base64String;
    reloadUrl?: string;
    percent?: number;
    maxWidth?: number;
    onDelete?: () => void;
    onReloaded?: (res: any) => void;
    onProgress?: (e: ProgressEvent, files: Array<File>) => void;
    onError?: (err: UploadError) => void;
}
declare class Preview extends React.Component<PreviewProps> {
    state: {
        visible: boolean;
        percent?: number;
    };
    static defaultProps: {
        type: string;
    };
    /**
     * 监视percent变化
     */
    watchValue(): void;
    /**
     *关闭
     */
    handleDelete(): void;
    /**
     *
     */
    handleErrImage(): void;
    /**
     * 查看
     */
    handleView(): void;
    /**
     * 关闭dialog
     */
    handleCloseDialog(): void;
    /**
     * 渲染函数
     */
    render(): React.ReactElement;
}
/**
 *
 * @constructor
 */
export default Preview;
