"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = upload;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * 获取错误
 * @param url
 * @param option
 * @param xhr
 */

/**
 *
 * @param url
 * @param option
 * @param xhr
 */
function getError(url, option, xhr) {
  var msg;

  if (xhr.statusText) {
    msg = "".concat(xhr.status, " ").concat(xhr.statusText);
  } else if (xhr.response) {
    msg = "".concat(xhr.status, " ").concat(xhr.response.error || xhr.response);
  } else if (xhr.responseText) {
    msg = "".concat(xhr.status, " ").concat(xhr.responseText);
  } else {
    msg = "fail to post ".concat(url, " ").concat(xhr.status);
  }

  return _objectSpread(_objectSpread({}, new Error(msg)), {}, {
    status: xhr.status,
    msg: msg,
    method: 'post',
    url: url
  });
}
/**
 *获取返回文本
 * @param xhr
 */


function getBody(xhr) {
  var text = xhr.responseText || xhr.response;

  if (!text) {
    return text;
  }

  try {
    return JSON.parse(text);
  } catch (e) {
    return text;
  }
}

/**
 * 上传文件的方法
 */
function upload(option) {
  return new Promise(function (resolve, reject) {
    if (typeof XMLHttpRequest === 'undefined') {
      return;
    }

    var xhr = new XMLHttpRequest();
    var url = option.url,
        withCredentials = option.withCredentials;
    var headers = option.headers;
    var timeout = option.timeout;

    if (xhr.upload) {
      xhr.upload.onprogress = function progress(e) {
        if (e.total > 0) {
          e.percent = e.loaded / e.total * 100;
        }

        option.onProgress(e);
      };
    }

    var formData = new FormData();

    if (option.data) {
      Object.entries(option.data).forEach(function (_ref) {
        var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        if (Array.isArray(value)) {
          value.forEach(function (item) {
            formData.append(key, item);
          });
        } else {
          formData.append(key, value);
        }
      });
    }

    xhr.onerror = function (e) {
      option.onProgress({
        percent: 0
      });
      var error = getError(url, option, xhr);
      reject(_objectSpread(_objectSpread({}, error), {}, {
        detail: e
      }));
    };

    xhr.onload = function onload() {
      if (xhr.status < 200 || xhr.status >= 300) {
        option.onProgress({
          percent: 0
        });
        return reject(getError(url, option, xhr));
      }

      resolve(getBody(xhr));
    };

    xhr.open('post', url, true); // 超时时间，单位是毫秒，ie中只能在open方法之后，send方法之前调用
    // xhr.ontimeout超时时的回调

    if (timeout) {
      xhr.timeout = timeout;
    }

    if (withCredentials && 'withCredentials' in xhr) {
      xhr.withCredentials = true;
    }

    headers = headers || {};

    for (var item in headers) {
      if (headers.hasOwnProperty(item) && headers[item] !== null) {
        xhr.setRequestHeader(item, headers[item]);
      }
    }

    xhr.send(formData);
    return xhr;
  });
}